package com.tanpu.fund.controller;

import com.tanpu.common.model.product.resp.Net;
import com.tanpu.common.resp.CommonResp;
import com.tanpu.fund.api.ProductForPcApi;
import com.tanpu.fund.service.ProductForPcService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@RestController
@Slf4j
public class ProductForPcController implements ProductForPcApi {
    @Resource
    private ProductForPcService productForPcService;

    @Override
    public CommonResp<List<Net>> getFundNewnet(List<String> list) {
        return CommonResp.success(productForPcService.getFundNewnet(list));
    }

    @Override
    public CommonResp<List<Net>> getPrivatefundNewnet(List<String> list) {
        return CommonResp.success(productForPcService.getPrivatefundNewnet(list));
    }
}
