package com.tanpu.fund.entity.generator;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class FundCompanyInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundCompanyInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(String value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(String value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(String value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(String value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(String value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(String value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLike(String value) {
            addCriterion("company_id like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotLike(String value) {
            addCriterion("company_id not like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<String> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<String> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(String value1, String value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(String value1, String value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIIsNull() {
            addCriterion("p_company_i is null");
            return (Criteria) this;
        }

        public Criteria andPCompanyIIsNotNull() {
            addCriterion("p_company_i is not null");
            return (Criteria) this;
        }

        public Criteria andPCompanyIEqualTo(String value) {
            addCriterion("p_company_i =", value, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyINotEqualTo(String value) {
            addCriterion("p_company_i <>", value, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyIGreaterThan(String value) {
            addCriterion("p_company_i >", value, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyIGreaterThanOrEqualTo(String value) {
            addCriterion("p_company_i >=", value, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyILessThan(String value) {
            addCriterion("p_company_i <", value, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyILessThanOrEqualTo(String value) {
            addCriterion("p_company_i <=", value, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyILike(String value) {
            addCriterion("p_company_i like", value, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyINotLike(String value) {
            addCriterion("p_company_i not like", value, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyIIn(List<String> values) {
            addCriterion("p_company_i in", values, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyINotIn(List<String> values) {
            addCriterion("p_company_i not in", values, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyIBetween(String value1, String value2) {
            addCriterion("p_company_i between", value1, value2, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andPCompanyINotBetween(String value1, String value2) {
            addCriterion("p_company_i not between", value1, value2, "pCompanyI");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyShoIsNull() {
            addCriterion("company_sho is null");
            return (Criteria) this;
        }

        public Criteria andCompanyShoIsNotNull() {
            addCriterion("company_sho is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyShoEqualTo(String value) {
            addCriterion("company_sho =", value, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoNotEqualTo(String value) {
            addCriterion("company_sho <>", value, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoGreaterThan(String value) {
            addCriterion("company_sho >", value, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoGreaterThanOrEqualTo(String value) {
            addCriterion("company_sho >=", value, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoLessThan(String value) {
            addCriterion("company_sho <", value, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoLessThanOrEqualTo(String value) {
            addCriterion("company_sho <=", value, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoLike(String value) {
            addCriterion("company_sho like", value, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoNotLike(String value) {
            addCriterion("company_sho not like", value, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoIn(List<String> values) {
            addCriterion("company_sho in", values, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoNotIn(List<String> values) {
            addCriterion("company_sho not in", values, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoBetween(String value1, String value2) {
            addCriterion("company_sho between", value1, value2, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyShoNotBetween(String value1, String value2) {
            addCriterion("company_sho not between", value1, value2, "companySho");
            return (Criteria) this;
        }

        public Criteria andCompanyEngIsNull() {
            addCriterion("company_eng is null");
            return (Criteria) this;
        }

        public Criteria andCompanyEngIsNotNull() {
            addCriterion("company_eng is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyEngEqualTo(String value) {
            addCriterion("company_eng =", value, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngNotEqualTo(String value) {
            addCriterion("company_eng <>", value, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngGreaterThan(String value) {
            addCriterion("company_eng >", value, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngGreaterThanOrEqualTo(String value) {
            addCriterion("company_eng >=", value, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngLessThan(String value) {
            addCriterion("company_eng <", value, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngLessThanOrEqualTo(String value) {
            addCriterion("company_eng <=", value, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngLike(String value) {
            addCriterion("company_eng like", value, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngNotLike(String value) {
            addCriterion("company_eng not like", value, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngIn(List<String> values) {
            addCriterion("company_eng in", values, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngNotIn(List<String> values) {
            addCriterion("company_eng not in", values, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngBetween(String value1, String value2) {
            addCriterion("company_eng between", value1, value2, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyEngNotBetween(String value1, String value2) {
            addCriterion("company_eng not between", value1, value2, "companyEng");
            return (Criteria) this;
        }

        public Criteria andCompanyTypIsNull() {
            addCriterion("company_typ is null");
            return (Criteria) this;
        }

        public Criteria andCompanyTypIsNotNull() {
            addCriterion("company_typ is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyTypEqualTo(Integer value) {
            addCriterion("company_typ =", value, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypNotEqualTo(Integer value) {
            addCriterion("company_typ <>", value, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypGreaterThan(Integer value) {
            addCriterion("company_typ >", value, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypGreaterThanOrEqualTo(Integer value) {
            addCriterion("company_typ >=", value, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypLessThan(Integer value) {
            addCriterion("company_typ <", value, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypLessThanOrEqualTo(Integer value) {
            addCriterion("company_typ <=", value, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypIn(List<Integer> values) {
            addCriterion("company_typ in", values, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypNotIn(List<Integer> values) {
            addCriterion("company_typ not in", values, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypBetween(Integer value1, Integer value2) {
            addCriterion("company_typ between", value1, value2, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andCompanyTypNotBetween(Integer value1, Integer value2) {
            addCriterion("company_typ not between", value1, value2, "companyTyp");
            return (Criteria) this;
        }

        public Criteria andEstablishDIsNull() {
            addCriterion("establish_d is null");
            return (Criteria) this;
        }

        public Criteria andEstablishDIsNotNull() {
            addCriterion("establish_d is not null");
            return (Criteria) this;
        }

        public Criteria andEstablishDEqualTo(Date value) {
            addCriterionForJDBCDate("establish_d =", value, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDNotEqualTo(Date value) {
            addCriterionForJDBCDate("establish_d <>", value, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDGreaterThan(Date value) {
            addCriterionForJDBCDate("establish_d >", value, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("establish_d >=", value, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDLessThan(Date value) {
            addCriterionForJDBCDate("establish_d <", value, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("establish_d <=", value, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDIn(List<Date> values) {
            addCriterionForJDBCDate("establish_d in", values, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDNotIn(List<Date> values) {
            addCriterionForJDBCDate("establish_d not in", values, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("establish_d between", value1, value2, "establishD");
            return (Criteria) this;
        }

        public Criteria andEstablishDNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("establish_d not between", value1, value2, "establishD");
            return (Criteria) this;
        }

        public Criteria andOrganizatioIsNull() {
            addCriterion("organizatio is null");
            return (Criteria) this;
        }

        public Criteria andOrganizatioIsNotNull() {
            addCriterion("organizatio is not null");
            return (Criteria) this;
        }

        public Criteria andOrganizatioEqualTo(String value) {
            addCriterion("organizatio =", value, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioNotEqualTo(String value) {
            addCriterion("organizatio <>", value, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioGreaterThan(String value) {
            addCriterion("organizatio >", value, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioGreaterThanOrEqualTo(String value) {
            addCriterion("organizatio >=", value, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioLessThan(String value) {
            addCriterion("organizatio <", value, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioLessThanOrEqualTo(String value) {
            addCriterion("organizatio <=", value, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioLike(String value) {
            addCriterion("organizatio like", value, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioNotLike(String value) {
            addCriterion("organizatio not like", value, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioIn(List<String> values) {
            addCriterion("organizatio in", values, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioNotIn(List<String> values) {
            addCriterion("organizatio not in", values, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioBetween(String value1, String value2) {
            addCriterion("organizatio between", value1, value2, "organizatio");
            return (Criteria) this;
        }

        public Criteria andOrganizatioNotBetween(String value1, String value2) {
            addCriterion("organizatio not between", value1, value2, "organizatio");
            return (Criteria) this;
        }

        public Criteria andCreditCodeIsNull() {
            addCriterion("credit_code is null");
            return (Criteria) this;
        }

        public Criteria andCreditCodeIsNotNull() {
            addCriterion("credit_code is not null");
            return (Criteria) this;
        }

        public Criteria andCreditCodeEqualTo(String value) {
            addCriterion("credit_code =", value, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeNotEqualTo(String value) {
            addCriterion("credit_code <>", value, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeGreaterThan(String value) {
            addCriterion("credit_code >", value, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeGreaterThanOrEqualTo(String value) {
            addCriterion("credit_code >=", value, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeLessThan(String value) {
            addCriterion("credit_code <", value, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeLessThanOrEqualTo(String value) {
            addCriterion("credit_code <=", value, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeLike(String value) {
            addCriterion("credit_code like", value, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeNotLike(String value) {
            addCriterion("credit_code not like", value, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeIn(List<String> values) {
            addCriterion("credit_code in", values, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeNotIn(List<String> values) {
            addCriterion("credit_code not in", values, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeBetween(String value1, String value2) {
            addCriterion("credit_code between", value1, value2, "creditCode");
            return (Criteria) this;
        }

        public Criteria andCreditCodeNotBetween(String value1, String value2) {
            addCriterion("credit_code not between", value1, value2, "creditCode");
            return (Criteria) this;
        }

        public Criteria andHasConsultIsNull() {
            addCriterion("has_consult is null");
            return (Criteria) this;
        }

        public Criteria andHasConsultIsNotNull() {
            addCriterion("has_consult is not null");
            return (Criteria) this;
        }

        public Criteria andHasConsultEqualTo(Integer value) {
            addCriterion("has_consult =", value, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultNotEqualTo(Integer value) {
            addCriterion("has_consult <>", value, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultGreaterThan(Integer value) {
            addCriterion("has_consult >", value, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultGreaterThanOrEqualTo(Integer value) {
            addCriterion("has_consult >=", value, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultLessThan(Integer value) {
            addCriterion("has_consult <", value, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultLessThanOrEqualTo(Integer value) {
            addCriterion("has_consult <=", value, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultIn(List<Integer> values) {
            addCriterion("has_consult in", values, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultNotIn(List<Integer> values) {
            addCriterion("has_consult not in", values, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultBetween(Integer value1, Integer value2) {
            addCriterion("has_consult between", value1, value2, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andHasConsultNotBetween(Integer value1, Integer value2) {
            addCriterion("has_consult not between", value1, value2, "hasConsult");
            return (Criteria) this;
        }

        public Criteria andDomicileIdIsNull() {
            addCriterion("domicile_id is null");
            return (Criteria) this;
        }

        public Criteria andDomicileIdIsNotNull() {
            addCriterion("domicile_id is not null");
            return (Criteria) this;
        }

        public Criteria andDomicileIdEqualTo(Integer value) {
            addCriterion("domicile_id =", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdNotEqualTo(Integer value) {
            addCriterion("domicile_id <>", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdGreaterThan(Integer value) {
            addCriterion("domicile_id >", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("domicile_id >=", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdLessThan(Integer value) {
            addCriterion("domicile_id <", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdLessThanOrEqualTo(Integer value) {
            addCriterion("domicile_id <=", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdIn(List<Integer> values) {
            addCriterion("domicile_id in", values, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdNotIn(List<Integer> values) {
            addCriterion("domicile_id not in", values, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdBetween(Integer value1, Integer value2) {
            addCriterion("domicile_id between", value1, value2, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdNotBetween(Integer value1, Integer value2) {
            addCriterion("domicile_id not between", value1, value2, "domicileId");
            return (Criteria) this;
        }

        public Criteria andCompanyAddIsNull() {
            addCriterion("company_add is null");
            return (Criteria) this;
        }

        public Criteria andCompanyAddIsNotNull() {
            addCriterion("company_add is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyAddEqualTo(String value) {
            addCriterion("company_add =", value, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddNotEqualTo(String value) {
            addCriterion("company_add <>", value, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddGreaterThan(String value) {
            addCriterion("company_add >", value, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddGreaterThanOrEqualTo(String value) {
            addCriterion("company_add >=", value, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddLessThan(String value) {
            addCriterion("company_add <", value, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddLessThanOrEqualTo(String value) {
            addCriterion("company_add <=", value, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddLike(String value) {
            addCriterion("company_add like", value, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddNotLike(String value) {
            addCriterion("company_add not like", value, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddIn(List<String> values) {
            addCriterion("company_add in", values, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddNotIn(List<String> values) {
            addCriterion("company_add not in", values, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddBetween(String value1, String value2) {
            addCriterion("company_add between", value1, value2, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAddNotBetween(String value1, String value2) {
            addCriterion("company_add not between", value1, value2, "companyAdd");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1IsNull() {
            addCriterion("company_add1 is null");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1IsNotNull() {
            addCriterion("company_add1 is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1EqualTo(String value) {
            addCriterion("company_add1 =", value, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1NotEqualTo(String value) {
            addCriterion("company_add1 <>", value, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1GreaterThan(String value) {
            addCriterion("company_add1 >", value, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1GreaterThanOrEqualTo(String value) {
            addCriterion("company_add1 >=", value, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1LessThan(String value) {
            addCriterion("company_add1 <", value, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1LessThanOrEqualTo(String value) {
            addCriterion("company_add1 <=", value, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1Like(String value) {
            addCriterion("company_add1 like", value, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1NotLike(String value) {
            addCriterion("company_add1 not like", value, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1In(List<String> values) {
            addCriterion("company_add1 in", values, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1NotIn(List<String> values) {
            addCriterion("company_add1 not in", values, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1Between(String value1, String value2) {
            addCriterion("company_add1 between", value1, value2, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCompanyAdd1NotBetween(String value1, String value2) {
            addCriterion("company_add1 not between", value1, value2, "companyAdd1");
            return (Criteria) this;
        }

        public Criteria andCityIsNull() {
            addCriterion("city is null");
            return (Criteria) this;
        }

        public Criteria andCityIsNotNull() {
            addCriterion("city is not null");
            return (Criteria) this;
        }

        public Criteria andCityEqualTo(String value) {
            addCriterion("city =", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityNotEqualTo(String value) {
            addCriterion("city <>", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityGreaterThan(String value) {
            addCriterion("city >", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityGreaterThanOrEqualTo(String value) {
            addCriterion("city >=", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityLessThan(String value) {
            addCriterion("city <", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityLessThanOrEqualTo(String value) {
            addCriterion("city <=", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityLike(String value) {
            addCriterion("city like", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityNotLike(String value) {
            addCriterion("city not like", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityIn(List<String> values) {
            addCriterion("city in", values, "city");
            return (Criteria) this;
        }

        public Criteria andCityNotIn(List<String> values) {
            addCriterion("city not in", values, "city");
            return (Criteria) this;
        }

        public Criteria andCityBetween(String value1, String value2) {
            addCriterion("city between", value1, value2, "city");
            return (Criteria) this;
        }

        public Criteria andCityNotBetween(String value1, String value2) {
            addCriterion("city not between", value1, value2, "city");
            return (Criteria) this;
        }

        public Criteria andProvinceIsNull() {
            addCriterion("province is null");
            return (Criteria) this;
        }

        public Criteria andProvinceIsNotNull() {
            addCriterion("province is not null");
            return (Criteria) this;
        }

        public Criteria andProvinceEqualTo(String value) {
            addCriterion("province =", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceNotEqualTo(String value) {
            addCriterion("province <>", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceGreaterThan(String value) {
            addCriterion("province >", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceGreaterThanOrEqualTo(String value) {
            addCriterion("province >=", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceLessThan(String value) {
            addCriterion("province <", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceLessThanOrEqualTo(String value) {
            addCriterion("province <=", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceLike(String value) {
            addCriterion("province like", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceNotLike(String value) {
            addCriterion("province not like", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceIn(List<String> values) {
            addCriterion("province in", values, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceNotIn(List<String> values) {
            addCriterion("province not in", values, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceBetween(String value1, String value2) {
            addCriterion("province between", value1, value2, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceNotBetween(String value1, String value2) {
            addCriterion("province not between", value1, value2, "province");
            return (Criteria) this;
        }

        public Criteria andCountryIsNull() {
            addCriterion("country is null");
            return (Criteria) this;
        }

        public Criteria andCountryIsNotNull() {
            addCriterion("country is not null");
            return (Criteria) this;
        }

        public Criteria andCountryEqualTo(String value) {
            addCriterion("country =", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryNotEqualTo(String value) {
            addCriterion("country <>", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryGreaterThan(String value) {
            addCriterion("country >", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryGreaterThanOrEqualTo(String value) {
            addCriterion("country >=", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryLessThan(String value) {
            addCriterion("country <", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryLessThanOrEqualTo(String value) {
            addCriterion("country <=", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryLike(String value) {
            addCriterion("country like", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryNotLike(String value) {
            addCriterion("country not like", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryIn(List<String> values) {
            addCriterion("country in", values, "country");
            return (Criteria) this;
        }

        public Criteria andCountryNotIn(List<String> values) {
            addCriterion("country not in", values, "country");
            return (Criteria) this;
        }

        public Criteria andCountryBetween(String value1, String value2) {
            addCriterion("country between", value1, value2, "country");
            return (Criteria) this;
        }

        public Criteria andCountryNotBetween(String value1, String value2) {
            addCriterion("country not between", value1, value2, "country");
            return (Criteria) this;
        }

        public Criteria andRegCityIsNull() {
            addCriterion("reg_city is null");
            return (Criteria) this;
        }

        public Criteria andRegCityIsNotNull() {
            addCriterion("reg_city is not null");
            return (Criteria) this;
        }

        public Criteria andRegCityEqualTo(String value) {
            addCriterion("reg_city =", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityNotEqualTo(String value) {
            addCriterion("reg_city <>", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityGreaterThan(String value) {
            addCriterion("reg_city >", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityGreaterThanOrEqualTo(String value) {
            addCriterion("reg_city >=", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityLessThan(String value) {
            addCriterion("reg_city <", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityLessThanOrEqualTo(String value) {
            addCriterion("reg_city <=", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityLike(String value) {
            addCriterion("reg_city like", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityNotLike(String value) {
            addCriterion("reg_city not like", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityIn(List<String> values) {
            addCriterion("reg_city in", values, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityNotIn(List<String> values) {
            addCriterion("reg_city not in", values, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityBetween(String value1, String value2) {
            addCriterion("reg_city between", value1, value2, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityNotBetween(String value1, String value2) {
            addCriterion("reg_city not between", value1, value2, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegProvincIsNull() {
            addCriterion("reg_provinc is null");
            return (Criteria) this;
        }

        public Criteria andRegProvincIsNotNull() {
            addCriterion("reg_provinc is not null");
            return (Criteria) this;
        }

        public Criteria andRegProvincEqualTo(String value) {
            addCriterion("reg_provinc =", value, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincNotEqualTo(String value) {
            addCriterion("reg_provinc <>", value, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincGreaterThan(String value) {
            addCriterion("reg_provinc >", value, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincGreaterThanOrEqualTo(String value) {
            addCriterion("reg_provinc >=", value, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincLessThan(String value) {
            addCriterion("reg_provinc <", value, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincLessThanOrEqualTo(String value) {
            addCriterion("reg_provinc <=", value, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincLike(String value) {
            addCriterion("reg_provinc like", value, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincNotLike(String value) {
            addCriterion("reg_provinc not like", value, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincIn(List<String> values) {
            addCriterion("reg_provinc in", values, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincNotIn(List<String> values) {
            addCriterion("reg_provinc not in", values, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincBetween(String value1, String value2) {
            addCriterion("reg_provinc between", value1, value2, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegProvincNotBetween(String value1, String value2) {
            addCriterion("reg_provinc not between", value1, value2, "regProvinc");
            return (Criteria) this;
        }

        public Criteria andRegCountryIsNull() {
            addCriterion("reg_country is null");
            return (Criteria) this;
        }

        public Criteria andRegCountryIsNotNull() {
            addCriterion("reg_country is not null");
            return (Criteria) this;
        }

        public Criteria andRegCountryEqualTo(String value) {
            addCriterion("reg_country =", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryNotEqualTo(String value) {
            addCriterion("reg_country <>", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryGreaterThan(String value) {
            addCriterion("reg_country >", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryGreaterThanOrEqualTo(String value) {
            addCriterion("reg_country >=", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryLessThan(String value) {
            addCriterion("reg_country <", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryLessThanOrEqualTo(String value) {
            addCriterion("reg_country <=", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryLike(String value) {
            addCriterion("reg_country like", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryNotLike(String value) {
            addCriterion("reg_country not like", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryIn(List<String> values) {
            addCriterion("reg_country in", values, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryNotIn(List<String> values) {
            addCriterion("reg_country not in", values, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryBetween(String value1, String value2) {
            addCriterion("reg_country between", value1, value2, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryNotBetween(String value1, String value2) {
            addCriterion("reg_country not between", value1, value2, "regCountry");
            return (Criteria) this;
        }

        public Criteria andContactPhoIsNull() {
            addCriterion("contact_pho is null");
            return (Criteria) this;
        }

        public Criteria andContactPhoIsNotNull() {
            addCriterion("contact_pho is not null");
            return (Criteria) this;
        }

        public Criteria andContactPhoEqualTo(String value) {
            addCriterion("contact_pho =", value, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoNotEqualTo(String value) {
            addCriterion("contact_pho <>", value, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoGreaterThan(String value) {
            addCriterion("contact_pho >", value, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoGreaterThanOrEqualTo(String value) {
            addCriterion("contact_pho >=", value, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoLessThan(String value) {
            addCriterion("contact_pho <", value, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoLessThanOrEqualTo(String value) {
            addCriterion("contact_pho <=", value, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoLike(String value) {
            addCriterion("contact_pho like", value, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoNotLike(String value) {
            addCriterion("contact_pho not like", value, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoIn(List<String> values) {
            addCriterion("contact_pho in", values, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoNotIn(List<String> values) {
            addCriterion("contact_pho not in", values, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoBetween(String value1, String value2) {
            addCriterion("contact_pho between", value1, value2, "contactPho");
            return (Criteria) this;
        }

        public Criteria andContactPhoNotBetween(String value1, String value2) {
            addCriterion("contact_pho not between", value1, value2, "contactPho");
            return (Criteria) this;
        }

        public Criteria andPostCodeIsNull() {
            addCriterion("post_code is null");
            return (Criteria) this;
        }

        public Criteria andPostCodeIsNotNull() {
            addCriterion("post_code is not null");
            return (Criteria) this;
        }

        public Criteria andPostCodeEqualTo(String value) {
            addCriterion("post_code =", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeNotEqualTo(String value) {
            addCriterion("post_code <>", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeGreaterThan(String value) {
            addCriterion("post_code >", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeGreaterThanOrEqualTo(String value) {
            addCriterion("post_code >=", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeLessThan(String value) {
            addCriterion("post_code <", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeLessThanOrEqualTo(String value) {
            addCriterion("post_code <=", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeLike(String value) {
            addCriterion("post_code like", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeNotLike(String value) {
            addCriterion("post_code not like", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeIn(List<String> values) {
            addCriterion("post_code in", values, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeNotIn(List<String> values) {
            addCriterion("post_code not in", values, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeBetween(String value1, String value2) {
            addCriterion("post_code between", value1, value2, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeNotBetween(String value1, String value2) {
            addCriterion("post_code not between", value1, value2, "postCode");
            return (Criteria) this;
        }

        public Criteria andFaxIsNull() {
            addCriterion("fax is null");
            return (Criteria) this;
        }

        public Criteria andFaxIsNotNull() {
            addCriterion("fax is not null");
            return (Criteria) this;
        }

        public Criteria andFaxEqualTo(String value) {
            addCriterion("fax =", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxNotEqualTo(String value) {
            addCriterion("fax <>", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxGreaterThan(String value) {
            addCriterion("fax >", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxGreaterThanOrEqualTo(String value) {
            addCriterion("fax >=", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxLessThan(String value) {
            addCriterion("fax <", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxLessThanOrEqualTo(String value) {
            addCriterion("fax <=", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxLike(String value) {
            addCriterion("fax like", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxNotLike(String value) {
            addCriterion("fax not like", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxIn(List<String> values) {
            addCriterion("fax in", values, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxNotIn(List<String> values) {
            addCriterion("fax not in", values, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxBetween(String value1, String value2) {
            addCriterion("fax between", value1, value2, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxNotBetween(String value1, String value2) {
            addCriterion("fax not between", value1, value2, "fax");
            return (Criteria) this;
        }

        public Criteria andEmailIsNull() {
            addCriterion("email is null");
            return (Criteria) this;
        }

        public Criteria andEmailIsNotNull() {
            addCriterion("email is not null");
            return (Criteria) this;
        }

        public Criteria andEmailEqualTo(String value) {
            addCriterion("email =", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailNotEqualTo(String value) {
            addCriterion("email <>", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailGreaterThan(String value) {
            addCriterion("email >", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailGreaterThanOrEqualTo(String value) {
            addCriterion("email >=", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailLessThan(String value) {
            addCriterion("email <", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailLessThanOrEqualTo(String value) {
            addCriterion("email <=", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailLike(String value) {
            addCriterion("email like", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailNotLike(String value) {
            addCriterion("email not like", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailIn(List<String> values) {
            addCriterion("email in", values, "email");
            return (Criteria) this;
        }

        public Criteria andEmailNotIn(List<String> values) {
            addCriterion("email not in", values, "email");
            return (Criteria) this;
        }

        public Criteria andEmailBetween(String value1, String value2) {
            addCriterion("email between", value1, value2, "email");
            return (Criteria) this;
        }

        public Criteria andEmailNotBetween(String value1, String value2) {
            addCriterion("email not between", value1, value2, "email");
            return (Criteria) this;
        }

        public Criteria andWebsiteIsNull() {
            addCriterion("website is null");
            return (Criteria) this;
        }

        public Criteria andWebsiteIsNotNull() {
            addCriterion("website is not null");
            return (Criteria) this;
        }

        public Criteria andWebsiteEqualTo(String value) {
            addCriterion("website =", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteNotEqualTo(String value) {
            addCriterion("website <>", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteGreaterThan(String value) {
            addCriterion("website >", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteGreaterThanOrEqualTo(String value) {
            addCriterion("website >=", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteLessThan(String value) {
            addCriterion("website <", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteLessThanOrEqualTo(String value) {
            addCriterion("website <=", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteLike(String value) {
            addCriterion("website like", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteNotLike(String value) {
            addCriterion("website not like", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteIn(List<String> values) {
            addCriterion("website in", values, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteNotIn(List<String> values) {
            addCriterion("website not in", values, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteBetween(String value1, String value2) {
            addCriterion("website between", value1, value2, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteNotBetween(String value1, String value2) {
            addCriterion("website not between", value1, value2, "website");
            return (Criteria) this;
        }

        public Criteria andRegisteredIsNull() {
            addCriterion("registered_ is null");
            return (Criteria) this;
        }

        public Criteria andRegisteredIsNotNull() {
            addCriterion("registered_ is not null");
            return (Criteria) this;
        }

        public Criteria andRegisteredEqualTo(Double value) {
            addCriterion("registered_ =", value, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredNotEqualTo(Double value) {
            addCriterion("registered_ <>", value, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredGreaterThan(Double value) {
            addCriterion("registered_ >", value, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredGreaterThanOrEqualTo(Double value) {
            addCriterion("registered_ >=", value, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredLessThan(Double value) {
            addCriterion("registered_ <", value, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredLessThanOrEqualTo(Double value) {
            addCriterion("registered_ <=", value, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredIn(List<Double> values) {
            addCriterion("registered_ in", values, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredNotIn(List<Double> values) {
            addCriterion("registered_ not in", values, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredBetween(Double value1, Double value2) {
            addCriterion("registered_ between", value1, value2, "registered");
            return (Criteria) this;
        }

        public Criteria andRegisteredNotBetween(Double value1, Double value2) {
            addCriterion("registered_ not between", value1, value2, "registered");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuIsNull() {
            addCriterion("offshore_fu is null");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuIsNotNull() {
            addCriterion("offshore_fu is not null");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuEqualTo(Integer value) {
            addCriterion("offshore_fu =", value, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuNotEqualTo(Integer value) {
            addCriterion("offshore_fu <>", value, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuGreaterThan(Integer value) {
            addCriterion("offshore_fu >", value, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuGreaterThanOrEqualTo(Integer value) {
            addCriterion("offshore_fu >=", value, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuLessThan(Integer value) {
            addCriterion("offshore_fu <", value, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuLessThanOrEqualTo(Integer value) {
            addCriterion("offshore_fu <=", value, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuIn(List<Integer> values) {
            addCriterion("offshore_fu in", values, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuNotIn(List<Integer> values) {
            addCriterion("offshore_fu not in", values, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuBetween(Integer value1, Integer value2) {
            addCriterion("offshore_fu between", value1, value2, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andOffshoreFuNotBetween(Integer value1, Integer value2) {
            addCriterion("offshore_fu not between", value1, value2, "offshoreFu");
            return (Criteria) this;
        }

        public Criteria andCompanyStaIsNull() {
            addCriterion("company_sta is null");
            return (Criteria) this;
        }

        public Criteria andCompanyStaIsNotNull() {
            addCriterion("company_sta is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyStaEqualTo(Integer value) {
            addCriterion("company_sta =", value, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaNotEqualTo(Integer value) {
            addCriterion("company_sta <>", value, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaGreaterThan(Integer value) {
            addCriterion("company_sta >", value, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaGreaterThanOrEqualTo(Integer value) {
            addCriterion("company_sta >=", value, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaLessThan(Integer value) {
            addCriterion("company_sta <", value, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaLessThanOrEqualTo(Integer value) {
            addCriterion("company_sta <=", value, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaIn(List<Integer> values) {
            addCriterion("company_sta in", values, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaNotIn(List<Integer> values) {
            addCriterion("company_sta not in", values, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaBetween(Integer value1, Integer value2) {
            addCriterion("company_sta between", value1, value2, "companySta");
            return (Criteria) this;
        }

        public Criteria andCompanyStaNotBetween(Integer value1, Integer value2) {
            addCriterion("company_sta not between", value1, value2, "companySta");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenIsNull() {
            addCriterion("base_curren is null");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenIsNotNull() {
            addCriterion("base_curren is not null");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenEqualTo(Integer value) {
            addCriterion("base_curren =", value, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenNotEqualTo(Integer value) {
            addCriterion("base_curren <>", value, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenGreaterThan(Integer value) {
            addCriterion("base_curren >", value, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenGreaterThanOrEqualTo(Integer value) {
            addCriterion("base_curren >=", value, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenLessThan(Integer value) {
            addCriterion("base_curren <", value, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenLessThanOrEqualTo(Integer value) {
            addCriterion("base_curren <=", value, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenIn(List<Integer> values) {
            addCriterion("base_curren in", values, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenNotIn(List<Integer> values) {
            addCriterion("base_curren not in", values, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenBetween(Integer value1, Integer value2) {
            addCriterion("base_curren between", value1, value2, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andBaseCurrenNotBetween(Integer value1, Integer value2) {
            addCriterion("base_curren not between", value1, value2, "baseCurren");
            return (Criteria) this;
        }

        public Criteria andRegisterNuIsNull() {
            addCriterion("register_nu is null");
            return (Criteria) this;
        }

        public Criteria andRegisterNuIsNotNull() {
            addCriterion("register_nu is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterNuEqualTo(String value) {
            addCriterion("register_nu =", value, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuNotEqualTo(String value) {
            addCriterion("register_nu <>", value, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuGreaterThan(String value) {
            addCriterion("register_nu >", value, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuGreaterThanOrEqualTo(String value) {
            addCriterion("register_nu >=", value, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuLessThan(String value) {
            addCriterion("register_nu <", value, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuLessThanOrEqualTo(String value) {
            addCriterion("register_nu <=", value, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuLike(String value) {
            addCriterion("register_nu like", value, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuNotLike(String value) {
            addCriterion("register_nu not like", value, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuIn(List<String> values) {
            addCriterion("register_nu in", values, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuNotIn(List<String> values) {
            addCriterion("register_nu not in", values, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuBetween(String value1, String value2) {
            addCriterion("register_nu between", value1, value2, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterNuNotBetween(String value1, String value2) {
            addCriterion("register_nu not between", value1, value2, "registerNu");
            return (Criteria) this;
        }

        public Criteria andRegisterStIsNull() {
            addCriterion("register_st is null");
            return (Criteria) this;
        }

        public Criteria andRegisterStIsNotNull() {
            addCriterion("register_st is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterStEqualTo(Integer value) {
            addCriterion("register_st =", value, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStNotEqualTo(Integer value) {
            addCriterion("register_st <>", value, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStGreaterThan(Integer value) {
            addCriterion("register_st >", value, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStGreaterThanOrEqualTo(Integer value) {
            addCriterion("register_st >=", value, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStLessThan(Integer value) {
            addCriterion("register_st <", value, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStLessThanOrEqualTo(Integer value) {
            addCriterion("register_st <=", value, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStIn(List<Integer> values) {
            addCriterion("register_st in", values, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStNotIn(List<Integer> values) {
            addCriterion("register_st not in", values, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStBetween(Integer value1, Integer value2) {
            addCriterion("register_st between", value1, value2, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterStNotBetween(Integer value1, Integer value2) {
            addCriterion("register_st not between", value1, value2, "registerSt");
            return (Criteria) this;
        }

        public Criteria andRegisterDaIsNull() {
            addCriterion("register_da is null");
            return (Criteria) this;
        }

        public Criteria andRegisterDaIsNotNull() {
            addCriterion("register_da is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterDaEqualTo(Date value) {
            addCriterionForJDBCDate("register_da =", value, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaNotEqualTo(Date value) {
            addCriterionForJDBCDate("register_da <>", value, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaGreaterThan(Date value) {
            addCriterionForJDBCDate("register_da >", value, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("register_da >=", value, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaLessThan(Date value) {
            addCriterionForJDBCDate("register_da <", value, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("register_da <=", value, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaIn(List<Date> values) {
            addCriterionForJDBCDate("register_da in", values, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaNotIn(List<Date> values) {
            addCriterionForJDBCDate("register_da not in", values, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("register_da between", value1, value2, "registerDa");
            return (Criteria) this;
        }

        public Criteria andRegisterDaNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("register_da not between", value1, value2, "registerDa");
            return (Criteria) this;
        }

        public Criteria andIsMemberIsNull() {
            addCriterion("is_member is null");
            return (Criteria) this;
        }

        public Criteria andIsMemberIsNotNull() {
            addCriterion("is_member is not null");
            return (Criteria) this;
        }

        public Criteria andIsMemberEqualTo(Integer value) {
            addCriterion("is_member =", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberNotEqualTo(Integer value) {
            addCriterion("is_member <>", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberGreaterThan(Integer value) {
            addCriterion("is_member >", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_member >=", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberLessThan(Integer value) {
            addCriterion("is_member <", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberLessThanOrEqualTo(Integer value) {
            addCriterion("is_member <=", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberIn(List<Integer> values) {
            addCriterion("is_member in", values, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberNotIn(List<Integer> values) {
            addCriterion("is_member not in", values, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberBetween(Integer value1, Integer value2) {
            addCriterion("is_member between", value1, value2, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberNotBetween(Integer value1, Integer value2) {
            addCriterion("is_member not between", value1, value2, "isMember");
            return (Criteria) this;
        }

        public Criteria andJoinDateIsNull() {
            addCriterion("join_date is null");
            return (Criteria) this;
        }

        public Criteria andJoinDateIsNotNull() {
            addCriterion("join_date is not null");
            return (Criteria) this;
        }

        public Criteria andJoinDateEqualTo(Date value) {
            addCriterionForJDBCDate("join_date =", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("join_date <>", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateGreaterThan(Date value) {
            addCriterionForJDBCDate("join_date >", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("join_date >=", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateLessThan(Date value) {
            addCriterionForJDBCDate("join_date <", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("join_date <=", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateIn(List<Date> values) {
            addCriterionForJDBCDate("join_date in", values, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("join_date not in", values, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("join_date between", value1, value2, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("join_date not between", value1, value2, "joinDate");
            return (Criteria) this;
        }

        public Criteria andMemberTypeIsNull() {
            addCriterion("member_type is null");
            return (Criteria) this;
        }

        public Criteria andMemberTypeIsNotNull() {
            addCriterion("member_type is not null");
            return (Criteria) this;
        }

        public Criteria andMemberTypeEqualTo(Integer value) {
            addCriterion("member_type =", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeNotEqualTo(Integer value) {
            addCriterion("member_type <>", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeGreaterThan(Integer value) {
            addCriterion("member_type >", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("member_type >=", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeLessThan(Integer value) {
            addCriterion("member_type <", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeLessThanOrEqualTo(Integer value) {
            addCriterion("member_type <=", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeIn(List<Integer> values) {
            addCriterion("member_type in", values, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeNotIn(List<Integer> values) {
            addCriterion("member_type not in", values, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeBetween(Integer value1, Integer value2) {
            addCriterion("member_type between", value1, value2, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("member_type not between", value1, value2, "memberType");
            return (Criteria) this;
        }

        public Criteria andFundCategoIsNull() {
            addCriterion("fund_catego is null");
            return (Criteria) this;
        }

        public Criteria andFundCategoIsNotNull() {
            addCriterion("fund_catego is not null");
            return (Criteria) this;
        }

        public Criteria andFundCategoEqualTo(String value) {
            addCriterion("fund_catego =", value, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoNotEqualTo(String value) {
            addCriterion("fund_catego <>", value, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoGreaterThan(String value) {
            addCriterion("fund_catego >", value, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoGreaterThanOrEqualTo(String value) {
            addCriterion("fund_catego >=", value, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoLessThan(String value) {
            addCriterion("fund_catego <", value, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoLessThanOrEqualTo(String value) {
            addCriterion("fund_catego <=", value, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoLike(String value) {
            addCriterion("fund_catego like", value, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoNotLike(String value) {
            addCriterion("fund_catego not like", value, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoIn(List<String> values) {
            addCriterion("fund_catego in", values, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoNotIn(List<String> values) {
            addCriterion("fund_catego not in", values, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoBetween(String value1, String value2) {
            addCriterion("fund_catego between", value1, value2, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andFundCategoNotBetween(String value1, String value2) {
            addCriterion("fund_catego not between", value1, value2, "fundCatego");
            return (Criteria) this;
        }

        public Criteria andBusinessTyIsNull() {
            addCriterion("business_ty is null");
            return (Criteria) this;
        }

        public Criteria andBusinessTyIsNotNull() {
            addCriterion("business_ty is not null");
            return (Criteria) this;
        }

        public Criteria andBusinessTyEqualTo(String value) {
            addCriterion("business_ty =", value, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyNotEqualTo(String value) {
            addCriterion("business_ty <>", value, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyGreaterThan(String value) {
            addCriterion("business_ty >", value, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyGreaterThanOrEqualTo(String value) {
            addCriterion("business_ty >=", value, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyLessThan(String value) {
            addCriterion("business_ty <", value, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyLessThanOrEqualTo(String value) {
            addCriterion("business_ty <=", value, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyLike(String value) {
            addCriterion("business_ty like", value, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyNotLike(String value) {
            addCriterion("business_ty not like", value, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyIn(List<String> values) {
            addCriterion("business_ty in", values, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyNotIn(List<String> values) {
            addCriterion("business_ty not in", values, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyBetween(String value1, String value2) {
            addCriterion("business_ty between", value1, value2, "businessTy");
            return (Criteria) this;
        }

        public Criteria andBusinessTyNotBetween(String value1, String value2) {
            addCriterion("business_ty not between", value1, value2, "businessTy");
            return (Criteria) this;
        }

        public Criteria andNatureBusiIsNull() {
            addCriterion("nature_busi is null");
            return (Criteria) this;
        }

        public Criteria andNatureBusiIsNotNull() {
            addCriterion("nature_busi is not null");
            return (Criteria) this;
        }

        public Criteria andNatureBusiEqualTo(Integer value) {
            addCriterion("nature_busi =", value, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiNotEqualTo(Integer value) {
            addCriterion("nature_busi <>", value, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiGreaterThan(Integer value) {
            addCriterion("nature_busi >", value, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiGreaterThanOrEqualTo(Integer value) {
            addCriterion("nature_busi >=", value, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiLessThan(Integer value) {
            addCriterion("nature_busi <", value, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiLessThanOrEqualTo(Integer value) {
            addCriterion("nature_busi <=", value, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiIn(List<Integer> values) {
            addCriterion("nature_busi in", values, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiNotIn(List<Integer> values) {
            addCriterion("nature_busi not in", values, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiBetween(Integer value1, Integer value2) {
            addCriterion("nature_busi between", value1, value2, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andNatureBusiNotBetween(Integer value1, Integer value2) {
            addCriterion("nature_busi not between", value1, value2, "natureBusi");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiIsNull() {
            addCriterion("capital_pai is null");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiIsNotNull() {
            addCriterion("capital_pai is not null");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiEqualTo(Double value) {
            addCriterion("capital_pai =", value, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiNotEqualTo(Double value) {
            addCriterion("capital_pai <>", value, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiGreaterThan(Double value) {
            addCriterion("capital_pai >", value, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiGreaterThanOrEqualTo(Double value) {
            addCriterion("capital_pai >=", value, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiLessThan(Double value) {
            addCriterion("capital_pai <", value, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiLessThanOrEqualTo(Double value) {
            addCriterion("capital_pai <=", value, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiIn(List<Double> values) {
            addCriterion("capital_pai in", values, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiNotIn(List<Double> values) {
            addCriterion("capital_pai not in", values, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiBetween(Double value1, Double value2) {
            addCriterion("capital_pai between", value1, value2, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andCapitalPaiNotBetween(Double value1, Double value2) {
            addCriterion("capital_pai not between", value1, value2, "capitalPai");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1IsNull() {
            addCriterion("register_nu1 is null");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1IsNotNull() {
            addCriterion("register_nu1 is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1EqualTo(String value) {
            addCriterion("register_nu1 =", value, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1NotEqualTo(String value) {
            addCriterion("register_nu1 <>", value, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1GreaterThan(String value) {
            addCriterion("register_nu1 >", value, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1GreaterThanOrEqualTo(String value) {
            addCriterion("register_nu1 >=", value, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1LessThan(String value) {
            addCriterion("register_nu1 <", value, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1LessThanOrEqualTo(String value) {
            addCriterion("register_nu1 <=", value, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1Like(String value) {
            addCriterion("register_nu1 like", value, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1NotLike(String value) {
            addCriterion("register_nu1 not like", value, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1In(List<String> values) {
            addCriterion("register_nu1 in", values, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1NotIn(List<String> values) {
            addCriterion("register_nu1 not in", values, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1Between(String value1, String value2) {
            addCriterion("register_nu1 between", value1, value2, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andRegisterNu1NotBetween(String value1, String value2) {
            addCriterion("register_nu1 not between", value1, value2, "registerNu1");
            return (Criteria) this;
        }

        public Criteria andLogoIsNull() {
            addCriterion("logo is null");
            return (Criteria) this;
        }

        public Criteria andLogoIsNotNull() {
            addCriterion("logo is not null");
            return (Criteria) this;
        }

        public Criteria andLogoEqualTo(String value) {
            addCriterion("logo =", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoNotEqualTo(String value) {
            addCriterion("logo <>", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoGreaterThan(String value) {
            addCriterion("logo >", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoGreaterThanOrEqualTo(String value) {
            addCriterion("logo >=", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoLessThan(String value) {
            addCriterion("logo <", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoLessThanOrEqualTo(String value) {
            addCriterion("logo <=", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoLike(String value) {
            addCriterion("logo like", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoNotLike(String value) {
            addCriterion("logo not like", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoIn(List<String> values) {
            addCriterion("logo in", values, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoNotIn(List<String> values) {
            addCriterion("logo not in", values, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoBetween(String value1, String value2) {
            addCriterion("logo between", value1, value2, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoNotBetween(String value1, String value2) {
            addCriterion("logo not between", value1, value2, "logo");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIsNull() {
            addCriterion("isvisible is null");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIsNotNull() {
            addCriterion("isvisible is not null");
            return (Criteria) this;
        }

        public Criteria andIsvisibleEqualTo(Integer value) {
            addCriterion("isvisible =", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotEqualTo(Integer value) {
            addCriterion("isvisible <>", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleGreaterThan(Integer value) {
            addCriterion("isvisible >", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleGreaterThanOrEqualTo(Integer value) {
            addCriterion("isvisible >=", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleLessThan(Integer value) {
            addCriterion("isvisible <", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleLessThanOrEqualTo(Integer value) {
            addCriterion("isvisible <=", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIn(List<Integer> values) {
            addCriterion("isvisible in", values, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotIn(List<Integer> values) {
            addCriterion("isvisible not in", values, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleBetween(Integer value1, Integer value2) {
            addCriterion("isvisible between", value1, value2, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotBetween(Integer value1, Integer value2) {
            addCriterion("isvisible not between", value1, value2, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvalidIsNull() {
            addCriterion("isvalid is null");
            return (Criteria) this;
        }

        public Criteria andIsvalidIsNotNull() {
            addCriterion("isvalid is not null");
            return (Criteria) this;
        }

        public Criteria andIsvalidEqualTo(Integer value) {
            addCriterion("isvalid =", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotEqualTo(Integer value) {
            addCriterion("isvalid <>", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidGreaterThan(Integer value) {
            addCriterion("isvalid >", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidGreaterThanOrEqualTo(Integer value) {
            addCriterion("isvalid >=", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidLessThan(Integer value) {
            addCriterion("isvalid <", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidLessThanOrEqualTo(Integer value) {
            addCriterion("isvalid <=", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidIn(List<Integer> values) {
            addCriterion("isvalid in", values, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotIn(List<Integer> values) {
            addCriterion("isvalid not in", values, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidBetween(Integer value1, Integer value2) {
            addCriterion("isvalid between", value1, value2, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotBetween(Integer value1, Integer value2) {
            addCriterion("isvalid not between", value1, value2, "isvalid");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNull() {
            addCriterion("updatetime is null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNotNull() {
            addCriterion("updatetime is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeEqualTo(Date value) {
            addCriterionForJDBCDate("updatetime =", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotEqualTo(Date value) {
            addCriterionForJDBCDate("updatetime <>", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThan(Date value) {
            addCriterionForJDBCDate("updatetime >", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("updatetime >=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThan(Date value) {
            addCriterionForJDBCDate("updatetime <", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("updatetime <=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIn(List<Date> values) {
            addCriterionForJDBCDate("updatetime in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotIn(List<Date> values) {
            addCriterionForJDBCDate("updatetime not in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("updatetime between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("updatetime not between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaIsNull() {
            addCriterion("paid_capita is null");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaIsNotNull() {
            addCriterion("paid_capita is not null");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaEqualTo(Double value) {
            addCriterion("paid_capita =", value, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaNotEqualTo(Double value) {
            addCriterion("paid_capita <>", value, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaGreaterThan(Double value) {
            addCriterion("paid_capita >", value, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaGreaterThanOrEqualTo(Double value) {
            addCriterion("paid_capita >=", value, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaLessThan(Double value) {
            addCriterion("paid_capita <", value, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaLessThanOrEqualTo(Double value) {
            addCriterion("paid_capita <=", value, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaIn(List<Double> values) {
            addCriterion("paid_capita in", values, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaNotIn(List<Double> values) {
            addCriterion("paid_capita not in", values, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaBetween(Double value1, Double value2) {
            addCriterion("paid_capita between", value1, value2, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andPaidCapitaNotBetween(Double value1, Double value2) {
            addCriterion("paid_capita not between", value1, value2, "paidCapita");
            return (Criteria) this;
        }

        public Criteria andCompanyAssIsNull() {
            addCriterion("company_ass is null");
            return (Criteria) this;
        }

        public Criteria andCompanyAssIsNotNull() {
            addCriterion("company_ass is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyAssEqualTo(Integer value) {
            addCriterion("company_ass =", value, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssNotEqualTo(Integer value) {
            addCriterion("company_ass <>", value, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssGreaterThan(Integer value) {
            addCriterion("company_ass >", value, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssGreaterThanOrEqualTo(Integer value) {
            addCriterion("company_ass >=", value, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssLessThan(Integer value) {
            addCriterion("company_ass <", value, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssLessThanOrEqualTo(Integer value) {
            addCriterion("company_ass <=", value, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssIn(List<Integer> values) {
            addCriterion("company_ass in", values, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssNotIn(List<Integer> values) {
            addCriterion("company_ass not in", values, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssBetween(Integer value1, Integer value2) {
            addCriterion("company_ass between", value1, value2, "companyAss");
            return (Criteria) this;
        }

        public Criteria andCompanyAssNotBetween(Integer value1, Integer value2) {
            addCriterion("company_ass not between", value1, value2, "companyAss");
            return (Criteria) this;
        }

        public Criteria andFundscaleIsNull() {
            addCriterion("fundscale is null");
            return (Criteria) this;
        }

        public Criteria andFundscaleIsNotNull() {
            addCriterion("fundscale is not null");
            return (Criteria) this;
        }

        public Criteria andFundscaleEqualTo(Double value) {
            addCriterion("fundscale =", value, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleNotEqualTo(Double value) {
            addCriterion("fundscale <>", value, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleGreaterThan(Double value) {
            addCriterion("fundscale >", value, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleGreaterThanOrEqualTo(Double value) {
            addCriterion("fundscale >=", value, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleLessThan(Double value) {
            addCriterion("fundscale <", value, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleLessThanOrEqualTo(Double value) {
            addCriterion("fundscale <=", value, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleIn(List<Double> values) {
            addCriterion("fundscale in", values, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleNotIn(List<Double> values) {
            addCriterion("fundscale not in", values, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleBetween(Double value1, Double value2) {
            addCriterion("fundscale between", value1, value2, "fundscale");
            return (Criteria) this;
        }

        public Criteria andFundscaleNotBetween(Double value1, Double value2) {
            addCriterion("fundscale not between", value1, value2, "fundscale");
            return (Criteria) this;
        }

        public Criteria andLegalRepreIsNull() {
            addCriterion("legal_repre is null");
            return (Criteria) this;
        }

        public Criteria andLegalRepreIsNotNull() {
            addCriterion("legal_repre is not null");
            return (Criteria) this;
        }

        public Criteria andLegalRepreEqualTo(String value) {
            addCriterion("legal_repre =", value, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreNotEqualTo(String value) {
            addCriterion("legal_repre <>", value, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreGreaterThan(String value) {
            addCriterion("legal_repre >", value, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreGreaterThanOrEqualTo(String value) {
            addCriterion("legal_repre >=", value, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreLessThan(String value) {
            addCriterion("legal_repre <", value, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreLessThanOrEqualTo(String value) {
            addCriterion("legal_repre <=", value, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreLike(String value) {
            addCriterion("legal_repre like", value, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreNotLike(String value) {
            addCriterion("legal_repre not like", value, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreIn(List<String> values) {
            addCriterion("legal_repre in", values, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreNotIn(List<String> values) {
            addCriterion("legal_repre not in", values, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreBetween(String value1, String value2) {
            addCriterion("legal_repre between", value1, value2, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andLegalRepreNotBetween(String value1, String value2) {
            addCriterion("legal_repre not between", value1, value2, "legalRepre");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIsNull() {
            addCriterion("is_qualify is null");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIsNotNull() {
            addCriterion("is_qualify is not null");
            return (Criteria) this;
        }

        public Criteria andIsQualifyEqualTo(String value) {
            addCriterion("is_qualify =", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotEqualTo(String value) {
            addCriterion("is_qualify <>", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyGreaterThan(String value) {
            addCriterion("is_qualify >", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyGreaterThanOrEqualTo(String value) {
            addCriterion("is_qualify >=", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyLessThan(String value) {
            addCriterion("is_qualify <", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyLessThanOrEqualTo(String value) {
            addCriterion("is_qualify <=", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyLike(String value) {
            addCriterion("is_qualify like", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotLike(String value) {
            addCriterion("is_qualify not like", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIn(List<String> values) {
            addCriterion("is_qualify in", values, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotIn(List<String> values) {
            addCriterion("is_qualify not in", values, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyBetween(String value1, String value2) {
            addCriterion("is_qualify between", value1, value2, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotBetween(String value1, String value2) {
            addCriterion("is_qualify not between", value1, value2, "isQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyIsNull() {
            addCriterion("get_qualify is null");
            return (Criteria) this;
        }

        public Criteria andGetQualifyIsNotNull() {
            addCriterion("get_qualify is not null");
            return (Criteria) this;
        }

        public Criteria andGetQualifyEqualTo(String value) {
            addCriterion("get_qualify =", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyNotEqualTo(String value) {
            addCriterion("get_qualify <>", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyGreaterThan(String value) {
            addCriterion("get_qualify >", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyGreaterThanOrEqualTo(String value) {
            addCriterion("get_qualify >=", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyLessThan(String value) {
            addCriterion("get_qualify <", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyLessThanOrEqualTo(String value) {
            addCriterion("get_qualify <=", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyLike(String value) {
            addCriterion("get_qualify like", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyNotLike(String value) {
            addCriterion("get_qualify not like", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyIn(List<String> values) {
            addCriterion("get_qualify in", values, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyNotIn(List<String> values) {
            addCriterion("get_qualify not in", values, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyBetween(String value1, String value2) {
            addCriterion("get_qualify between", value1, value2, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyNotBetween(String value1, String value2) {
            addCriterion("get_qualify not between", value1, value2, "getQualify");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnIsNull() {
            addCriterion("employee_cn is null");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnIsNotNull() {
            addCriterion("employee_cn is not null");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnEqualTo(Integer value) {
            addCriterion("employee_cn =", value, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnNotEqualTo(Integer value) {
            addCriterion("employee_cn <>", value, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnGreaterThan(Integer value) {
            addCriterion("employee_cn >", value, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnGreaterThanOrEqualTo(Integer value) {
            addCriterion("employee_cn >=", value, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnLessThan(Integer value) {
            addCriterion("employee_cn <", value, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnLessThanOrEqualTo(Integer value) {
            addCriterion("employee_cn <=", value, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnIn(List<Integer> values) {
            addCriterion("employee_cn in", values, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnNotIn(List<Integer> values) {
            addCriterion("employee_cn not in", values, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnBetween(Integer value1, Integer value2) {
            addCriterion("employee_cn between", value1, value2, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andEmployeeCnNotBetween(Integer value1, Integer value2) {
            addCriterion("employee_cn not between", value1, value2, "employeeCn");
            return (Criteria) this;
        }

        public Criteria andIntegrityIIsNull() {
            addCriterion("integrity_i is null");
            return (Criteria) this;
        }

        public Criteria andIntegrityIIsNotNull() {
            addCriterion("integrity_i is not null");
            return (Criteria) this;
        }

        public Criteria andIntegrityIEqualTo(String value) {
            addCriterion("integrity_i =", value, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityINotEqualTo(String value) {
            addCriterion("integrity_i <>", value, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityIGreaterThan(String value) {
            addCriterion("integrity_i >", value, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityIGreaterThanOrEqualTo(String value) {
            addCriterion("integrity_i >=", value, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityILessThan(String value) {
            addCriterion("integrity_i <", value, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityILessThanOrEqualTo(String value) {
            addCriterion("integrity_i <=", value, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityILike(String value) {
            addCriterion("integrity_i like", value, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityINotLike(String value) {
            addCriterion("integrity_i not like", value, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityIIn(List<String> values) {
            addCriterion("integrity_i in", values, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityINotIn(List<String> values) {
            addCriterion("integrity_i not in", values, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityIBetween(String value1, String value2) {
            addCriterion("integrity_i between", value1, value2, "integrityI");
            return (Criteria) this;
        }

        public Criteria andIntegrityINotBetween(String value1, String value2) {
            addCriterion("integrity_i not between", value1, value2, "integrityI");
            return (Criteria) this;
        }

        public Criteria andSpecialTipIsNull() {
            addCriterion("special_tip is null");
            return (Criteria) this;
        }

        public Criteria andSpecialTipIsNotNull() {
            addCriterion("special_tip is not null");
            return (Criteria) this;
        }

        public Criteria andSpecialTipEqualTo(String value) {
            addCriterion("special_tip =", value, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipNotEqualTo(String value) {
            addCriterion("special_tip <>", value, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipGreaterThan(String value) {
            addCriterion("special_tip >", value, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipGreaterThanOrEqualTo(String value) {
            addCriterion("special_tip >=", value, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipLessThan(String value) {
            addCriterion("special_tip <", value, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipLessThanOrEqualTo(String value) {
            addCriterion("special_tip <=", value, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipLike(String value) {
            addCriterion("special_tip like", value, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipNotLike(String value) {
            addCriterion("special_tip not like", value, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipIn(List<String> values) {
            addCriterion("special_tip in", values, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipNotIn(List<String> values) {
            addCriterion("special_tip not in", values, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipBetween(String value1, String value2) {
            addCriterion("special_tip between", value1, value2, "specialTip");
            return (Criteria) this;
        }

        public Criteria andSpecialTipNotBetween(String value1, String value2) {
            addCriterion("special_tip not between", value1, value2, "specialTip");
            return (Criteria) this;
        }

        public Criteria andAmacLinkIsNull() {
            addCriterion("amac_link is null");
            return (Criteria) this;
        }

        public Criteria andAmacLinkIsNotNull() {
            addCriterion("amac_link is not null");
            return (Criteria) this;
        }

        public Criteria andAmacLinkEqualTo(String value) {
            addCriterion("amac_link =", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkNotEqualTo(String value) {
            addCriterion("amac_link <>", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkGreaterThan(String value) {
            addCriterion("amac_link >", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkGreaterThanOrEqualTo(String value) {
            addCriterion("amac_link >=", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkLessThan(String value) {
            addCriterion("amac_link <", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkLessThanOrEqualTo(String value) {
            addCriterion("amac_link <=", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkLike(String value) {
            addCriterion("amac_link like", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkNotLike(String value) {
            addCriterion("amac_link not like", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkIn(List<String> values) {
            addCriterion("amac_link in", values, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkNotIn(List<String> values) {
            addCriterion("amac_link not in", values, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkBetween(String value1, String value2) {
            addCriterion("amac_link between", value1, value2, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkNotBetween(String value1, String value2) {
            addCriterion("amac_link not between", value1, value2, "amacLink");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIsNull() {
            addCriterion("createtime is null");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIsNotNull() {
            addCriterion("createtime is not null");
            return (Criteria) this;
        }

        public Criteria andCreatetimeEqualTo(Date value) {
            addCriterionForJDBCDate("createtime =", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotEqualTo(Date value) {
            addCriterionForJDBCDate("createtime <>", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeGreaterThan(Date value) {
            addCriterionForJDBCDate("createtime >", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("createtime >=", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeLessThan(Date value) {
            addCriterionForJDBCDate("createtime <", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("createtime <=", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIn(List<Date> values) {
            addCriterionForJDBCDate("createtime in", values, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotIn(List<Date> values) {
            addCriterionForJDBCDate("createtime not in", values, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("createtime between", value1, value2, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("createtime not between", value1, value2, "createtime");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniIsNull() {
            addCriterion("legal_opini is null");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniIsNotNull() {
            addCriterion("legal_opini is not null");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniEqualTo(String value) {
            addCriterion("legal_opini =", value, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniNotEqualTo(String value) {
            addCriterion("legal_opini <>", value, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniGreaterThan(String value) {
            addCriterion("legal_opini >", value, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniGreaterThanOrEqualTo(String value) {
            addCriterion("legal_opini >=", value, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniLessThan(String value) {
            addCriterion("legal_opini <", value, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniLessThanOrEqualTo(String value) {
            addCriterion("legal_opini <=", value, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniLike(String value) {
            addCriterion("legal_opini like", value, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniNotLike(String value) {
            addCriterion("legal_opini not like", value, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniIn(List<String> values) {
            addCriterion("legal_opini in", values, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniNotIn(List<String> values) {
            addCriterion("legal_opini not in", values, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniBetween(String value1, String value2) {
            addCriterion("legal_opini between", value1, value2, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andLegalOpiniNotBetween(String value1, String value2) {
            addCriterion("legal_opini not between", value1, value2, "legalOpini");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}