package com.tanpu.fund.entity.generator;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class FundInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andPFundIdIsNull() {
            addCriterion("p_fund_id is null");
            return (Criteria) this;
        }

        public Criteria andPFundIdIsNotNull() {
            addCriterion("p_fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andPFundIdEqualTo(String value) {
            addCriterion("p_fund_id =", value, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdNotEqualTo(String value) {
            addCriterion("p_fund_id <>", value, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdGreaterThan(String value) {
            addCriterion("p_fund_id >", value, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("p_fund_id >=", value, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdLessThan(String value) {
            addCriterion("p_fund_id <", value, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdLessThanOrEqualTo(String value) {
            addCriterion("p_fund_id <=", value, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdLike(String value) {
            addCriterion("p_fund_id like", value, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdNotLike(String value) {
            addCriterion("p_fund_id not like", value, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdIn(List<String> values) {
            addCriterion("p_fund_id in", values, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdNotIn(List<String> values) {
            addCriterion("p_fund_id not in", values, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdBetween(String value1, String value2) {
            addCriterion("p_fund_id between", value1, value2, "pFundId");
            return (Criteria) this;
        }

        public Criteria andPFundIdNotBetween(String value1, String value2) {
            addCriterion("p_fund_id not between", value1, value2, "pFundId");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNull() {
            addCriterion("fund_name is null");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNotNull() {
            addCriterion("fund_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundNameEqualTo(String value) {
            addCriterion("fund_name =", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotEqualTo(String value) {
            addCriterion("fund_name <>", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThan(String value) {
            addCriterion("fund_name >", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_name >=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThan(String value) {
            addCriterion("fund_name <", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThanOrEqualTo(String value) {
            addCriterion("fund_name <=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLike(String value) {
            addCriterion("fund_name like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotLike(String value) {
            addCriterion("fund_name not like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameIn(List<String> values) {
            addCriterion("fund_name in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotIn(List<String> values) {
            addCriterion("fund_name not in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameBetween(String value1, String value2) {
            addCriterion("fund_name between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotBetween(String value1, String value2) {
            addCriterion("fund_name not between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIsNull() {
            addCriterion("fund_short_name is null");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIsNotNull() {
            addCriterion("fund_short_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundShortNameEqualTo(String value) {
            addCriterion("fund_short_name =", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotEqualTo(String value) {
            addCriterion("fund_short_name <>", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameGreaterThan(String value) {
            addCriterion("fund_short_name >", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_short_name >=", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLessThan(String value) {
            addCriterion("fund_short_name <", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLessThanOrEqualTo(String value) {
            addCriterion("fund_short_name <=", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLike(String value) {
            addCriterion("fund_short_name like", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotLike(String value) {
            addCriterion("fund_short_name not like", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIn(List<String> values) {
            addCriterion("fund_short_name in", values, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotIn(List<String> values) {
            addCriterion("fund_short_name not in", values, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameBetween(String value1, String value2) {
            addCriterion("fund_short_name between", value1, value2, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotBetween(String value1, String value2) {
            addCriterion("fund_short_name not between", value1, value2, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundStructureIsNull() {
            addCriterion("fund_structure is null");
            return (Criteria) this;
        }

        public Criteria andFundStructureIsNotNull() {
            addCriterion("fund_structure is not null");
            return (Criteria) this;
        }

        public Criteria andFundStructureEqualTo(Integer value) {
            addCriterion("fund_structure =", value, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureNotEqualTo(Integer value) {
            addCriterion("fund_structure <>", value, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureGreaterThan(Integer value) {
            addCriterion("fund_structure >", value, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureGreaterThanOrEqualTo(Integer value) {
            addCriterion("fund_structure >=", value, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureLessThan(Integer value) {
            addCriterion("fund_structure <", value, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureLessThanOrEqualTo(Integer value) {
            addCriterion("fund_structure <=", value, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureIn(List<Integer> values) {
            addCriterion("fund_structure in", values, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureNotIn(List<Integer> values) {
            addCriterion("fund_structure not in", values, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureBetween(Integer value1, Integer value2) {
            addCriterion("fund_structure between", value1, value2, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundStructureNotBetween(Integer value1, Integer value2) {
            addCriterion("fund_structure not between", value1, value2, "fundStructure");
            return (Criteria) this;
        }

        public Criteria andFundTypeIsNull() {
            addCriterion("fund_type is null");
            return (Criteria) this;
        }

        public Criteria andFundTypeIsNotNull() {
            addCriterion("fund_type is not null");
            return (Criteria) this;
        }

        public Criteria andFundTypeEqualTo(Integer value) {
            addCriterion("fund_type =", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeNotEqualTo(Integer value) {
            addCriterion("fund_type <>", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeGreaterThan(Integer value) {
            addCriterion("fund_type >", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("fund_type >=", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeLessThan(Integer value) {
            addCriterion("fund_type <", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeLessThanOrEqualTo(Integer value) {
            addCriterion("fund_type <=", value, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeIn(List<Integer> values) {
            addCriterion("fund_type in", values, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeNotIn(List<Integer> values) {
            addCriterion("fund_type not in", values, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeBetween(Integer value1, Integer value2) {
            addCriterion("fund_type between", value1, value2, "fundType");
            return (Criteria) this;
        }

        public Criteria andFundTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("fund_type not between", value1, value2, "fundType");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("`type` is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("`type` is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(Integer value) {
            addCriterion("`type` =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(Integer value) {
            addCriterion("`type` <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(Integer value) {
            addCriterion("`type` >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("`type` >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(Integer value) {
            addCriterion("`type` <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(Integer value) {
            addCriterion("`type` <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<Integer> values) {
            addCriterion("`type` in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<Integer> values) {
            addCriterion("`type` not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(Integer value1, Integer value2) {
            addCriterion("`type` between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("`type` not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeIsNull() {
            addCriterion("raise_type is null");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeIsNotNull() {
            addCriterion("raise_type is not null");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeEqualTo(Integer value) {
            addCriterion("raise_type =", value, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeNotEqualTo(Integer value) {
            addCriterion("raise_type <>", value, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeGreaterThan(Integer value) {
            addCriterion("raise_type >", value, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("raise_type >=", value, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeLessThan(Integer value) {
            addCriterion("raise_type <", value, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeLessThanOrEqualTo(Integer value) {
            addCriterion("raise_type <=", value, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeIn(List<Integer> values) {
            addCriterion("raise_type in", values, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeNotIn(List<Integer> values) {
            addCriterion("raise_type not in", values, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeBetween(Integer value1, Integer value2) {
            addCriterion("raise_type between", value1, value2, "raiseType");
            return (Criteria) this;
        }

        public Criteria andRaiseTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("raise_type not between", value1, value2, "raiseType");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyIsNull() {
            addCriterion("base_currency is null");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyIsNotNull() {
            addCriterion("base_currency is not null");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyEqualTo(Integer value) {
            addCriterion("base_currency =", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyNotEqualTo(Integer value) {
            addCriterion("base_currency <>", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyGreaterThan(Integer value) {
            addCriterion("base_currency >", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyGreaterThanOrEqualTo(Integer value) {
            addCriterion("base_currency >=", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyLessThan(Integer value) {
            addCriterion("base_currency <", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyLessThanOrEqualTo(Integer value) {
            addCriterion("base_currency <=", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyIn(List<Integer> values) {
            addCriterion("base_currency in", values, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyNotIn(List<Integer> values) {
            addCriterion("base_currency not in", values, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyBetween(Integer value1, Integer value2) {
            addCriterion("base_currency between", value1, value2, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyNotBetween(Integer value1, Integer value2) {
            addCriterion("base_currency not between", value1, value2, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIsNull() {
            addCriterion("inception_date is null");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIsNotNull() {
            addCriterion("inception_date is not null");
            return (Criteria) this;
        }

        public Criteria andInceptionDateEqualTo(Date value) {
            addCriterionForJDBCDate("inception_date =", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("inception_date <>", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateGreaterThan(Date value) {
            addCriterionForJDBCDate("inception_date >", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("inception_date >=", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateLessThan(Date value) {
            addCriterionForJDBCDate("inception_date <", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("inception_date <=", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIn(List<Date> values) {
            addCriterionForJDBCDate("inception_date in", values, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("inception_date not in", values, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("inception_date between", value1, value2, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("inception_date not between", value1, value2, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andDomicileIsNull() {
            addCriterion("domicile is null");
            return (Criteria) this;
        }

        public Criteria andDomicileIsNotNull() {
            addCriterion("domicile is not null");
            return (Criteria) this;
        }

        public Criteria andDomicileEqualTo(Integer value) {
            addCriterion("domicile =", value, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileNotEqualTo(Integer value) {
            addCriterion("domicile <>", value, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileGreaterThan(Integer value) {
            addCriterion("domicile >", value, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileGreaterThanOrEqualTo(Integer value) {
            addCriterion("domicile >=", value, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileLessThan(Integer value) {
            addCriterion("domicile <", value, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileLessThanOrEqualTo(Integer value) {
            addCriterion("domicile <=", value, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileIn(List<Integer> values) {
            addCriterion("domicile in", values, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileNotIn(List<Integer> values) {
            addCriterion("domicile not in", values, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileBetween(Integer value1, Integer value2) {
            addCriterion("domicile between", value1, value2, "domicile");
            return (Criteria) this;
        }

        public Criteria andDomicileNotBetween(Integer value1, Integer value2) {
            addCriterion("domicile not between", value1, value2, "domicile");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdIsNull() {
            addCriterion("primary_benchmark_id is null");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdIsNotNull() {
            addCriterion("primary_benchmark_id is not null");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdEqualTo(String value) {
            addCriterion("primary_benchmark_id =", value, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdNotEqualTo(String value) {
            addCriterion("primary_benchmark_id <>", value, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdGreaterThan(String value) {
            addCriterion("primary_benchmark_id >", value, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdGreaterThanOrEqualTo(String value) {
            addCriterion("primary_benchmark_id >=", value, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdLessThan(String value) {
            addCriterion("primary_benchmark_id <", value, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdLessThanOrEqualTo(String value) {
            addCriterion("primary_benchmark_id <=", value, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdLike(String value) {
            addCriterion("primary_benchmark_id like", value, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdNotLike(String value) {
            addCriterion("primary_benchmark_id not like", value, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdIn(List<String> values) {
            addCriterion("primary_benchmark_id in", values, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdNotIn(List<String> values) {
            addCriterion("primary_benchmark_id not in", values, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdBetween(String value1, String value2) {
            addCriterion("primary_benchmark_id between", value1, value2, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andPrimaryBenchmarkIdNotBetween(String value1, String value2) {
            addCriterion("primary_benchmark_id not between", value1, value2, "primaryBenchmarkId");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodIsNull() {
            addCriterion("lockup_period is null");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodIsNotNull() {
            addCriterion("lockup_period is not null");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodEqualTo(Integer value) {
            addCriterion("lockup_period =", value, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodNotEqualTo(Integer value) {
            addCriterion("lockup_period <>", value, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodGreaterThan(Integer value) {
            addCriterion("lockup_period >", value, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodGreaterThanOrEqualTo(Integer value) {
            addCriterion("lockup_period >=", value, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodLessThan(Integer value) {
            addCriterion("lockup_period <", value, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodLessThanOrEqualTo(Integer value) {
            addCriterion("lockup_period <=", value, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodIn(List<Integer> values) {
            addCriterion("lockup_period in", values, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodNotIn(List<Integer> values) {
            addCriterion("lockup_period not in", values, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodBetween(Integer value1, Integer value2) {
            addCriterion("lockup_period between", value1, value2, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andLockupPeriodNotBetween(Integer value1, Integer value2) {
            addCriterion("lockup_period not between", value1, value2, "lockupPeriod");
            return (Criteria) this;
        }

        public Criteria andOpenDayIsNull() {
            addCriterion("open_day is null");
            return (Criteria) this;
        }

        public Criteria andOpenDayIsNotNull() {
            addCriterion("open_day is not null");
            return (Criteria) this;
        }

        public Criteria andOpenDayEqualTo(String value) {
            addCriterion("open_day =", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotEqualTo(String value) {
            addCriterion("open_day <>", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayGreaterThan(String value) {
            addCriterion("open_day >", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayGreaterThanOrEqualTo(String value) {
            addCriterion("open_day >=", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLessThan(String value) {
            addCriterion("open_day <", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLessThanOrEqualTo(String value) {
            addCriterion("open_day <=", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLike(String value) {
            addCriterion("open_day like", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotLike(String value) {
            addCriterion("open_day not like", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayIn(List<String> values) {
            addCriterion("open_day in", values, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotIn(List<String> values) {
            addCriterion("open_day not in", values, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayBetween(String value1, String value2) {
            addCriterion("open_day between", value1, value2, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotBetween(String value1, String value2) {
            addCriterion("open_day not between", value1, value2, "openDay");
            return (Criteria) this;
        }

        public Criteria andDurationIsNull() {
            addCriterion("duration is null");
            return (Criteria) this;
        }

        public Criteria andDurationIsNotNull() {
            addCriterion("duration is not null");
            return (Criteria) this;
        }

        public Criteria andDurationEqualTo(Integer value) {
            addCriterion("duration =", value, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationNotEqualTo(Integer value) {
            addCriterion("duration <>", value, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationGreaterThan(Integer value) {
            addCriterion("duration >", value, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationGreaterThanOrEqualTo(Integer value) {
            addCriterion("duration >=", value, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationLessThan(Integer value) {
            addCriterion("duration <", value, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationLessThanOrEqualTo(Integer value) {
            addCriterion("duration <=", value, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationIn(List<Integer> values) {
            addCriterion("duration in", values, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationNotIn(List<Integer> values) {
            addCriterion("duration not in", values, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationBetween(Integer value1, Integer value2) {
            addCriterion("duration between", value1, value2, "duration");
            return (Criteria) this;
        }

        public Criteria andDurationNotBetween(Integer value1, Integer value2) {
            addCriterion("duration not between", value1, value2, "duration");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdIsNull() {
            addCriterion("advisor_id is null");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdIsNotNull() {
            addCriterion("advisor_id is not null");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdEqualTo(String value) {
            addCriterion("advisor_id =", value, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdNotEqualTo(String value) {
            addCriterion("advisor_id <>", value, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdGreaterThan(String value) {
            addCriterion("advisor_id >", value, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdGreaterThanOrEqualTo(String value) {
            addCriterion("advisor_id >=", value, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdLessThan(String value) {
            addCriterion("advisor_id <", value, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdLessThanOrEqualTo(String value) {
            addCriterion("advisor_id <=", value, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdLike(String value) {
            addCriterion("advisor_id like", value, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdNotLike(String value) {
            addCriterion("advisor_id not like", value, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdIn(List<String> values) {
            addCriterion("advisor_id in", values, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdNotIn(List<String> values) {
            addCriterion("advisor_id not in", values, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdBetween(String value1, String value2) {
            addCriterion("advisor_id between", value1, value2, "advisorId");
            return (Criteria) this;
        }

        public Criteria andAdvisorIdNotBetween(String value1, String value2) {
            addCriterion("advisor_id not between", value1, value2, "advisorId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdIsNull() {
            addCriterion("custodian_id is null");
            return (Criteria) this;
        }

        public Criteria andCustodianIdIsNotNull() {
            addCriterion("custodian_id is not null");
            return (Criteria) this;
        }

        public Criteria andCustodianIdEqualTo(String value) {
            addCriterion("custodian_id =", value, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdNotEqualTo(String value) {
            addCriterion("custodian_id <>", value, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdGreaterThan(String value) {
            addCriterion("custodian_id >", value, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdGreaterThanOrEqualTo(String value) {
            addCriterion("custodian_id >=", value, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdLessThan(String value) {
            addCriterion("custodian_id <", value, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdLessThanOrEqualTo(String value) {
            addCriterion("custodian_id <=", value, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdLike(String value) {
            addCriterion("custodian_id like", value, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdNotLike(String value) {
            addCriterion("custodian_id not like", value, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdIn(List<String> values) {
            addCriterion("custodian_id in", values, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdNotIn(List<String> values) {
            addCriterion("custodian_id not in", values, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdBetween(String value1, String value2) {
            addCriterion("custodian_id between", value1, value2, "custodianId");
            return (Criteria) this;
        }

        public Criteria andCustodianIdNotBetween(String value1, String value2) {
            addCriterion("custodian_id not between", value1, value2, "custodianId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdIsNull() {
            addCriterion("broker_id is null");
            return (Criteria) this;
        }

        public Criteria andBrokerIdIsNotNull() {
            addCriterion("broker_id is not null");
            return (Criteria) this;
        }

        public Criteria andBrokerIdEqualTo(String value) {
            addCriterion("broker_id =", value, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdNotEqualTo(String value) {
            addCriterion("broker_id <>", value, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdGreaterThan(String value) {
            addCriterion("broker_id >", value, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdGreaterThanOrEqualTo(String value) {
            addCriterion("broker_id >=", value, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdLessThan(String value) {
            addCriterion("broker_id <", value, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdLessThanOrEqualTo(String value) {
            addCriterion("broker_id <=", value, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdLike(String value) {
            addCriterion("broker_id like", value, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdNotLike(String value) {
            addCriterion("broker_id not like", value, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdIn(List<String> values) {
            addCriterion("broker_id in", values, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdNotIn(List<String> values) {
            addCriterion("broker_id not in", values, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdBetween(String value1, String value2) {
            addCriterion("broker_id between", value1, value2, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerIdNotBetween(String value1, String value2) {
            addCriterion("broker_id not between", value1, value2, "brokerId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdIsNull() {
            addCriterion("broker_future_id is null");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdIsNotNull() {
            addCriterion("broker_future_id is not null");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdEqualTo(String value) {
            addCriterion("broker_future_id =", value, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdNotEqualTo(String value) {
            addCriterion("broker_future_id <>", value, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdGreaterThan(String value) {
            addCriterion("broker_future_id >", value, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdGreaterThanOrEqualTo(String value) {
            addCriterion("broker_future_id >=", value, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdLessThan(String value) {
            addCriterion("broker_future_id <", value, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdLessThanOrEqualTo(String value) {
            addCriterion("broker_future_id <=", value, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdLike(String value) {
            addCriterion("broker_future_id like", value, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdNotLike(String value) {
            addCriterion("broker_future_id not like", value, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdIn(List<String> values) {
            addCriterion("broker_future_id in", values, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdNotIn(List<String> values) {
            addCriterion("broker_future_id not in", values, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdBetween(String value1, String value2) {
            addCriterion("broker_future_id between", value1, value2, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andBrokerFutureIdNotBetween(String value1, String value2) {
            addCriterion("broker_future_id not between", value1, value2, "brokerFutureId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdIsNull() {
            addCriterion("liquidation_agency_id is null");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdIsNotNull() {
            addCriterion("liquidation_agency_id is not null");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdEqualTo(String value) {
            addCriterion("liquidation_agency_id =", value, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdNotEqualTo(String value) {
            addCriterion("liquidation_agency_id <>", value, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdGreaterThan(String value) {
            addCriterion("liquidation_agency_id >", value, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdGreaterThanOrEqualTo(String value) {
            addCriterion("liquidation_agency_id >=", value, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdLessThan(String value) {
            addCriterion("liquidation_agency_id <", value, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdLessThanOrEqualTo(String value) {
            addCriterion("liquidation_agency_id <=", value, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdLike(String value) {
            addCriterion("liquidation_agency_id like", value, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdNotLike(String value) {
            addCriterion("liquidation_agency_id not like", value, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdIn(List<String> values) {
            addCriterion("liquidation_agency_id in", values, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdNotIn(List<String> values) {
            addCriterion("liquidation_agency_id not in", values, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdBetween(String value1, String value2) {
            addCriterion("liquidation_agency_id between", value1, value2, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andLiquidationAgencyIdNotBetween(String value1, String value2) {
            addCriterion("liquidation_agency_id not between", value1, value2, "liquidationAgencyId");
            return (Criteria) this;
        }

        public Criteria andTrustIdIsNull() {
            addCriterion("trust_id is null");
            return (Criteria) this;
        }

        public Criteria andTrustIdIsNotNull() {
            addCriterion("trust_id is not null");
            return (Criteria) this;
        }

        public Criteria andTrustIdEqualTo(String value) {
            addCriterion("trust_id =", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdNotEqualTo(String value) {
            addCriterion("trust_id <>", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdGreaterThan(String value) {
            addCriterion("trust_id >", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdGreaterThanOrEqualTo(String value) {
            addCriterion("trust_id >=", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdLessThan(String value) {
            addCriterion("trust_id <", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdLessThanOrEqualTo(String value) {
            addCriterion("trust_id <=", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdLike(String value) {
            addCriterion("trust_id like", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdNotLike(String value) {
            addCriterion("trust_id not like", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdIn(List<String> values) {
            addCriterion("trust_id in", values, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdNotIn(List<String> values) {
            addCriterion("trust_id not in", values, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdBetween(String value1, String value2) {
            addCriterion("trust_id between", value1, value2, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdNotBetween(String value1, String value2) {
            addCriterion("trust_id not between", value1, value2, "trustId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdIsNull() {
            addCriterion("investment_consultant_id is null");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdIsNotNull() {
            addCriterion("investment_consultant_id is not null");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdEqualTo(String value) {
            addCriterion("investment_consultant_id =", value, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdNotEqualTo(String value) {
            addCriterion("investment_consultant_id <>", value, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdGreaterThan(String value) {
            addCriterion("investment_consultant_id >", value, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdGreaterThanOrEqualTo(String value) {
            addCriterion("investment_consultant_id >=", value, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdLessThan(String value) {
            addCriterion("investment_consultant_id <", value, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdLessThanOrEqualTo(String value) {
            addCriterion("investment_consultant_id <=", value, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdLike(String value) {
            addCriterion("investment_consultant_id like", value, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdNotLike(String value) {
            addCriterion("investment_consultant_id not like", value, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdIn(List<String> values) {
            addCriterion("investment_consultant_id in", values, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdNotIn(List<String> values) {
            addCriterion("investment_consultant_id not in", values, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdBetween(String value1, String value2) {
            addCriterion("investment_consultant_id between", value1, value2, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andInvestmentConsultantIdNotBetween(String value1, String value2) {
            addCriterion("investment_consultant_id not between", value1, value2, "investmentConsultantId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdIsNull() {
            addCriterion("administrator_id is null");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdIsNotNull() {
            addCriterion("administrator_id is not null");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdEqualTo(String value) {
            addCriterion("administrator_id =", value, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdNotEqualTo(String value) {
            addCriterion("administrator_id <>", value, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdGreaterThan(String value) {
            addCriterion("administrator_id >", value, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdGreaterThanOrEqualTo(String value) {
            addCriterion("administrator_id >=", value, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdLessThan(String value) {
            addCriterion("administrator_id <", value, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdLessThanOrEqualTo(String value) {
            addCriterion("administrator_id <=", value, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdLike(String value) {
            addCriterion("administrator_id like", value, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdNotLike(String value) {
            addCriterion("administrator_id not like", value, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdIn(List<String> values) {
            addCriterion("administrator_id in", values, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdNotIn(List<String> values) {
            addCriterion("administrator_id not in", values, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdBetween(String value1, String value2) {
            addCriterion("administrator_id between", value1, value2, "administratorId");
            return (Criteria) this;
        }

        public Criteria andAdministratorIdNotBetween(String value1, String value2) {
            addCriterion("administrator_id not between", value1, value2, "administratorId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdIsNull() {
            addCriterion("legal_counsel_id is null");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdIsNotNull() {
            addCriterion("legal_counsel_id is not null");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdEqualTo(String value) {
            addCriterion("legal_counsel_id =", value, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdNotEqualTo(String value) {
            addCriterion("legal_counsel_id <>", value, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdGreaterThan(String value) {
            addCriterion("legal_counsel_id >", value, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdGreaterThanOrEqualTo(String value) {
            addCriterion("legal_counsel_id >=", value, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdLessThan(String value) {
            addCriterion("legal_counsel_id <", value, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdLessThanOrEqualTo(String value) {
            addCriterion("legal_counsel_id <=", value, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdLike(String value) {
            addCriterion("legal_counsel_id like", value, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdNotLike(String value) {
            addCriterion("legal_counsel_id not like", value, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdIn(List<String> values) {
            addCriterion("legal_counsel_id in", values, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdNotIn(List<String> values) {
            addCriterion("legal_counsel_id not in", values, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdBetween(String value1, String value2) {
            addCriterion("legal_counsel_id between", value1, value2, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andLegalCounselIdNotBetween(String value1, String value2) {
            addCriterion("legal_counsel_id not between", value1, value2, "legalCounselId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdIsNull() {
            addCriterion("auditor_id is null");
            return (Criteria) this;
        }

        public Criteria andAuditorIdIsNotNull() {
            addCriterion("auditor_id is not null");
            return (Criteria) this;
        }

        public Criteria andAuditorIdEqualTo(String value) {
            addCriterion("auditor_id =", value, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdNotEqualTo(String value) {
            addCriterion("auditor_id <>", value, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdGreaterThan(String value) {
            addCriterion("auditor_id >", value, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdGreaterThanOrEqualTo(String value) {
            addCriterion("auditor_id >=", value, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdLessThan(String value) {
            addCriterion("auditor_id <", value, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdLessThanOrEqualTo(String value) {
            addCriterion("auditor_id <=", value, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdLike(String value) {
            addCriterion("auditor_id like", value, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdNotLike(String value) {
            addCriterion("auditor_id not like", value, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdIn(List<String> values) {
            addCriterion("auditor_id in", values, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdNotIn(List<String> values) {
            addCriterion("auditor_id not in", values, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdBetween(String value1, String value2) {
            addCriterion("auditor_id between", value1, value2, "auditorId");
            return (Criteria) this;
        }

        public Criteria andAuditorIdNotBetween(String value1, String value2) {
            addCriterion("auditor_id not between", value1, value2, "auditorId");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyIsNull() {
            addCriterion("nav_frequency is null");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyIsNotNull() {
            addCriterion("nav_frequency is not null");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyEqualTo(Integer value) {
            addCriterion("nav_frequency =", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyNotEqualTo(Integer value) {
            addCriterion("nav_frequency <>", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyGreaterThan(Integer value) {
            addCriterion("nav_frequency >", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyGreaterThanOrEqualTo(Integer value) {
            addCriterion("nav_frequency >=", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyLessThan(Integer value) {
            addCriterion("nav_frequency <", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyLessThanOrEqualTo(Integer value) {
            addCriterion("nav_frequency <=", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyIn(List<Integer> values) {
            addCriterion("nav_frequency in", values, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyNotIn(List<Integer> values) {
            addCriterion("nav_frequency not in", values, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyBetween(Integer value1, Integer value2) {
            addCriterion("nav_frequency between", value1, value2, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyNotBetween(Integer value1, Integer value2) {
            addCriterion("nav_frequency not between", value1, value2, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkIsNull() {
            addCriterion("performance_disclosure_mark is null");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkIsNotNull() {
            addCriterion("performance_disclosure_mark is not null");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkEqualTo(Integer value) {
            addCriterion("performance_disclosure_mark =", value, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkNotEqualTo(Integer value) {
            addCriterion("performance_disclosure_mark <>", value, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkGreaterThan(Integer value) {
            addCriterion("performance_disclosure_mark >", value, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkGreaterThanOrEqualTo(Integer value) {
            addCriterion("performance_disclosure_mark >=", value, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkLessThan(Integer value) {
            addCriterion("performance_disclosure_mark <", value, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkLessThanOrEqualTo(Integer value) {
            addCriterion("performance_disclosure_mark <=", value, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkIn(List<Integer> values) {
            addCriterion("performance_disclosure_mark in", values, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkNotIn(List<Integer> values) {
            addCriterion("performance_disclosure_mark not in", values, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkBetween(Integer value1, Integer value2) {
            addCriterion("performance_disclosure_mark between", value1, value2, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andPerformanceDisclosureMarkNotBetween(Integer value1, Integer value2) {
            addCriterion("performance_disclosure_mark not between", value1, value2, "performanceDisclosureMark");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIsNull() {
            addCriterion("register_number is null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIsNotNull() {
            addCriterion("register_number is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberEqualTo(String value) {
            addCriterion("register_number =", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotEqualTo(String value) {
            addCriterion("register_number <>", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberGreaterThan(String value) {
            addCriterion("register_number >", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberGreaterThanOrEqualTo(String value) {
            addCriterion("register_number >=", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLessThan(String value) {
            addCriterion("register_number <", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLessThanOrEqualTo(String value) {
            addCriterion("register_number <=", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLike(String value) {
            addCriterion("register_number like", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotLike(String value) {
            addCriterion("register_number not like", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIn(List<String> values) {
            addCriterion("register_number in", values, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotIn(List<String> values) {
            addCriterion("register_number not in", values, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberBetween(String value1, String value2) {
            addCriterion("register_number between", value1, value2, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotBetween(String value1, String value2) {
            addCriterion("register_number not between", value1, value2, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIsNull() {
            addCriterion("register_date is null");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIsNotNull() {
            addCriterion("register_date is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterDateEqualTo(Date value) {
            addCriterionForJDBCDate("register_date =", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("register_date <>", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateGreaterThan(Date value) {
            addCriterionForJDBCDate("register_date >", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("register_date >=", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateLessThan(Date value) {
            addCriterionForJDBCDate("register_date <", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("register_date <=", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIn(List<Date> values) {
            addCriterionForJDBCDate("register_date in", values, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("register_date not in", values, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("register_date between", value1, value2, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("register_date not between", value1, value2, "registerDate");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIsNull() {
            addCriterion("isvisible is null");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIsNotNull() {
            addCriterion("isvisible is not null");
            return (Criteria) this;
        }

        public Criteria andIsvisibleEqualTo(Integer value) {
            addCriterion("isvisible =", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotEqualTo(Integer value) {
            addCriterion("isvisible <>", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleGreaterThan(Integer value) {
            addCriterion("isvisible >", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleGreaterThanOrEqualTo(Integer value) {
            addCriterion("isvisible >=", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleLessThan(Integer value) {
            addCriterion("isvisible <", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleLessThanOrEqualTo(Integer value) {
            addCriterion("isvisible <=", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIn(List<Integer> values) {
            addCriterion("isvisible in", values, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotIn(List<Integer> values) {
            addCriterion("isvisible not in", values, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleBetween(Integer value1, Integer value2) {
            addCriterion("isvisible between", value1, value2, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotBetween(Integer value1, Integer value2) {
            addCriterion("isvisible not between", value1, value2, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIstieredIsNull() {
            addCriterion("istiered is null");
            return (Criteria) this;
        }

        public Criteria andIstieredIsNotNull() {
            addCriterion("istiered is not null");
            return (Criteria) this;
        }

        public Criteria andIstieredEqualTo(Integer value) {
            addCriterion("istiered =", value, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredNotEqualTo(Integer value) {
            addCriterion("istiered <>", value, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredGreaterThan(Integer value) {
            addCriterion("istiered >", value, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredGreaterThanOrEqualTo(Integer value) {
            addCriterion("istiered >=", value, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredLessThan(Integer value) {
            addCriterion("istiered <", value, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredLessThanOrEqualTo(Integer value) {
            addCriterion("istiered <=", value, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredIn(List<Integer> values) {
            addCriterion("istiered in", values, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredNotIn(List<Integer> values) {
            addCriterion("istiered not in", values, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredBetween(Integer value1, Integer value2) {
            addCriterion("istiered between", value1, value2, "istiered");
            return (Criteria) this;
        }

        public Criteria andIstieredNotBetween(Integer value1, Integer value2) {
            addCriterion("istiered not between", value1, value2, "istiered");
            return (Criteria) this;
        }

        public Criteria andIsRankingIsNull() {
            addCriterion("is_ranking is null");
            return (Criteria) this;
        }

        public Criteria andIsRankingIsNotNull() {
            addCriterion("is_ranking is not null");
            return (Criteria) this;
        }

        public Criteria andIsRankingEqualTo(Integer value) {
            addCriterion("is_ranking =", value, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingNotEqualTo(Integer value) {
            addCriterion("is_ranking <>", value, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingGreaterThan(Integer value) {
            addCriterion("is_ranking >", value, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_ranking >=", value, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingLessThan(Integer value) {
            addCriterion("is_ranking <", value, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingLessThanOrEqualTo(Integer value) {
            addCriterion("is_ranking <=", value, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingIn(List<Integer> values) {
            addCriterion("is_ranking in", values, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingNotIn(List<Integer> values) {
            addCriterion("is_ranking not in", values, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingBetween(Integer value1, Integer value2) {
            addCriterion("is_ranking between", value1, value2, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRankingNotBetween(Integer value1, Integer value2) {
            addCriterion("is_ranking not between", value1, value2, "isRanking");
            return (Criteria) this;
        }

        public Criteria andIsRatingIsNull() {
            addCriterion("is_rating is null");
            return (Criteria) this;
        }

        public Criteria andIsRatingIsNotNull() {
            addCriterion("is_rating is not null");
            return (Criteria) this;
        }

        public Criteria andIsRatingEqualTo(Integer value) {
            addCriterion("is_rating =", value, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingNotEqualTo(Integer value) {
            addCriterion("is_rating <>", value, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingGreaterThan(Integer value) {
            addCriterion("is_rating >", value, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_rating >=", value, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingLessThan(Integer value) {
            addCriterion("is_rating <", value, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingLessThanOrEqualTo(Integer value) {
            addCriterion("is_rating <=", value, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingIn(List<Integer> values) {
            addCriterion("is_rating in", values, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingNotIn(List<Integer> values) {
            addCriterion("is_rating not in", values, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingBetween(Integer value1, Integer value2) {
            addCriterion("is_rating between", value1, value2, "isRating");
            return (Criteria) this;
        }

        public Criteria andIsRatingNotBetween(Integer value1, Integer value2) {
            addCriterion("is_rating not between", value1, value2, "isRating");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsIsNull() {
            addCriterion("special_tips is null");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsIsNotNull() {
            addCriterion("special_tips is not null");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsEqualTo(String value) {
            addCriterion("special_tips =", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsNotEqualTo(String value) {
            addCriterion("special_tips <>", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsGreaterThan(String value) {
            addCriterion("special_tips >", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsGreaterThanOrEqualTo(String value) {
            addCriterion("special_tips >=", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsLessThan(String value) {
            addCriterion("special_tips <", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsLessThanOrEqualTo(String value) {
            addCriterion("special_tips <=", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsLike(String value) {
            addCriterion("special_tips like", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsNotLike(String value) {
            addCriterion("special_tips not like", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsIn(List<String> values) {
            addCriterion("special_tips in", values, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsNotIn(List<String> values) {
            addCriterion("special_tips not in", values, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsBetween(String value1, String value2) {
            addCriterion("special_tips between", value1, value2, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsNotBetween(String value1, String value2) {
            addCriterion("special_tips not between", value1, value2, "specialTips");
            return (Criteria) this;
        }

        public Criteria andAmacUrlIsNull() {
            addCriterion("amac_url is null");
            return (Criteria) this;
        }

        public Criteria andAmacUrlIsNotNull() {
            addCriterion("amac_url is not null");
            return (Criteria) this;
        }

        public Criteria andAmacUrlEqualTo(String value) {
            addCriterion("amac_url =", value, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlNotEqualTo(String value) {
            addCriterion("amac_url <>", value, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlGreaterThan(String value) {
            addCriterion("amac_url >", value, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlGreaterThanOrEqualTo(String value) {
            addCriterion("amac_url >=", value, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlLessThan(String value) {
            addCriterion("amac_url <", value, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlLessThanOrEqualTo(String value) {
            addCriterion("amac_url <=", value, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlLike(String value) {
            addCriterion("amac_url like", value, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlNotLike(String value) {
            addCriterion("amac_url not like", value, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlIn(List<String> values) {
            addCriterion("amac_url in", values, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlNotIn(List<String> values) {
            addCriterion("amac_url not in", values, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlBetween(String value1, String value2) {
            addCriterion("amac_url between", value1, value2, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andAmacUrlNotBetween(String value1, String value2) {
            addCriterion("amac_url not between", value1, value2, "amacUrl");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeIsNull() {
            addCriterion("nav_source_type is null");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeIsNotNull() {
            addCriterion("nav_source_type is not null");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeEqualTo(Integer value) {
            addCriterion("nav_source_type =", value, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeNotEqualTo(Integer value) {
            addCriterion("nav_source_type <>", value, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeGreaterThan(Integer value) {
            addCriterion("nav_source_type >", value, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("nav_source_type >=", value, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeLessThan(Integer value) {
            addCriterion("nav_source_type <", value, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeLessThanOrEqualTo(Integer value) {
            addCriterion("nav_source_type <=", value, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeIn(List<Integer> values) {
            addCriterion("nav_source_type in", values, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeNotIn(List<Integer> values) {
            addCriterion("nav_source_type not in", values, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeBetween(Integer value1, Integer value2) {
            addCriterion("nav_source_type between", value1, value2, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andNavSourceTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("nav_source_type not between", value1, value2, "navSourceType");
            return (Criteria) this;
        }

        public Criteria andDescInfoIsNull() {
            addCriterion("desc_info is null");
            return (Criteria) this;
        }

        public Criteria andDescInfoIsNotNull() {
            addCriterion("desc_info is not null");
            return (Criteria) this;
        }

        public Criteria andDescInfoEqualTo(String value) {
            addCriterion("desc_info =", value, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoNotEqualTo(String value) {
            addCriterion("desc_info <>", value, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoGreaterThan(String value) {
            addCriterion("desc_info >", value, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoGreaterThanOrEqualTo(String value) {
            addCriterion("desc_info >=", value, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoLessThan(String value) {
            addCriterion("desc_info <", value, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoLessThanOrEqualTo(String value) {
            addCriterion("desc_info <=", value, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoLike(String value) {
            addCriterion("desc_info like", value, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoNotLike(String value) {
            addCriterion("desc_info not like", value, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoIn(List<String> values) {
            addCriterion("desc_info in", values, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoNotIn(List<String> values) {
            addCriterion("desc_info not in", values, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoBetween(String value1, String value2) {
            addCriterion("desc_info between", value1, value2, "descInfo");
            return (Criteria) this;
        }

        public Criteria andDescInfoNotBetween(String value1, String value2) {
            addCriterion("desc_info not between", value1, value2, "descInfo");
            return (Criteria) this;
        }

        public Criteria andStrategyIsNull() {
            addCriterion("strategy is null");
            return (Criteria) this;
        }

        public Criteria andStrategyIsNotNull() {
            addCriterion("strategy is not null");
            return (Criteria) this;
        }

        public Criteria andStrategyEqualTo(Integer value) {
            addCriterion("strategy =", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotEqualTo(Integer value) {
            addCriterion("strategy <>", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyGreaterThan(Integer value) {
            addCriterion("strategy >", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyGreaterThanOrEqualTo(Integer value) {
            addCriterion("strategy >=", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyLessThan(Integer value) {
            addCriterion("strategy <", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyLessThanOrEqualTo(Integer value) {
            addCriterion("strategy <=", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyIn(List<Integer> values) {
            addCriterion("strategy in", values, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotIn(List<Integer> values) {
            addCriterion("strategy not in", values, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyBetween(Integer value1, Integer value2) {
            addCriterion("strategy between", value1, value2, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotBetween(Integer value1, Integer value2) {
            addCriterion("strategy not between", value1, value2, "strategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNull() {
            addCriterion("substrategy is null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNotNull() {
            addCriterion("substrategy is not null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyEqualTo(Integer value) {
            addCriterion("substrategy =", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotEqualTo(Integer value) {
            addCriterion("substrategy <>", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThan(Integer value) {
            addCriterion("substrategy >", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThanOrEqualTo(Integer value) {
            addCriterion("substrategy >=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThan(Integer value) {
            addCriterion("substrategy <", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThanOrEqualTo(Integer value) {
            addCriterion("substrategy <=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIn(List<Integer> values) {
            addCriterion("substrategy in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotIn(List<Integer> values) {
            addCriterion("substrategy not in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyBetween(Integer value1, Integer value2) {
            addCriterion("substrategy between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotBetween(Integer value1, Integer value2) {
            addCriterion("substrategy not between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIsNull() {
            addCriterion("risk_level is null");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIsNotNull() {
            addCriterion("risk_level is not null");
            return (Criteria) this;
        }

        public Criteria andRiskLevelEqualTo(Integer value) {
            addCriterion("risk_level =", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotEqualTo(Integer value) {
            addCriterion("risk_level <>", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelGreaterThan(Integer value) {
            addCriterion("risk_level >", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelGreaterThanOrEqualTo(Integer value) {
            addCriterion("risk_level >=", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLessThan(Integer value) {
            addCriterion("risk_level <", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLessThanOrEqualTo(Integer value) {
            addCriterion("risk_level <=", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIn(List<Integer> values) {
            addCriterion("risk_level in", values, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotIn(List<Integer> values) {
            addCriterion("risk_level not in", values, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelBetween(Integer value1, Integer value2) {
            addCriterion("risk_level between", value1, value2, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotBetween(Integer value1, Integer value2) {
            addCriterion("risk_level not between", value1, value2, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andDataSourcesIsNull() {
            addCriterion("data_sources is null");
            return (Criteria) this;
        }

        public Criteria andDataSourcesIsNotNull() {
            addCriterion("data_sources is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourcesEqualTo(Integer value) {
            addCriterion("data_sources =", value, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesNotEqualTo(Integer value) {
            addCriterion("data_sources <>", value, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesGreaterThan(Integer value) {
            addCriterion("data_sources >", value, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesGreaterThanOrEqualTo(Integer value) {
            addCriterion("data_sources >=", value, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesLessThan(Integer value) {
            addCriterion("data_sources <", value, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesLessThanOrEqualTo(Integer value) {
            addCriterion("data_sources <=", value, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesIn(List<Integer> values) {
            addCriterion("data_sources in", values, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesNotIn(List<Integer> values) {
            addCriterion("data_sources not in", values, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesBetween(Integer value1, Integer value2) {
            addCriterion("data_sources between", value1, value2, "dataSources");
            return (Criteria) this;
        }

        public Criteria andDataSourcesNotBetween(Integer value1, Integer value2) {
            addCriterion("data_sources not between", value1, value2, "dataSources");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andSortIsNull() {
            addCriterion("sort is null");
            return (Criteria) this;
        }

        public Criteria andSortIsNotNull() {
            addCriterion("sort is not null");
            return (Criteria) this;
        }

        public Criteria andSortEqualTo(Integer value) {
            addCriterion("sort =", value, "sort");
            return (Criteria) this;
        }

        public Criteria andSortNotEqualTo(Integer value) {
            addCriterion("sort <>", value, "sort");
            return (Criteria) this;
        }

        public Criteria andSortGreaterThan(Integer value) {
            addCriterion("sort >", value, "sort");
            return (Criteria) this;
        }

        public Criteria andSortGreaterThanOrEqualTo(Integer value) {
            addCriterion("sort >=", value, "sort");
            return (Criteria) this;
        }

        public Criteria andSortLessThan(Integer value) {
            addCriterion("sort <", value, "sort");
            return (Criteria) this;
        }

        public Criteria andSortLessThanOrEqualTo(Integer value) {
            addCriterion("sort <=", value, "sort");
            return (Criteria) this;
        }

        public Criteria andSortIn(List<Integer> values) {
            addCriterion("sort in", values, "sort");
            return (Criteria) this;
        }

        public Criteria andSortNotIn(List<Integer> values) {
            addCriterion("sort not in", values, "sort");
            return (Criteria) this;
        }

        public Criteria andSortBetween(Integer value1, Integer value2) {
            addCriterion("sort between", value1, value2, "sort");
            return (Criteria) this;
        }

        public Criteria andSortNotBetween(Integer value1, Integer value2) {
            addCriterion("sort not between", value1, value2, "sort");
            return (Criteria) this;
        }

        public Criteria andApplyDayIsNull() {
            addCriterion("apply_day is null");
            return (Criteria) this;
        }

        public Criteria andApplyDayIsNotNull() {
            addCriterion("apply_day is not null");
            return (Criteria) this;
        }

        public Criteria andApplyDayEqualTo(String value) {
            addCriterion("apply_day =", value, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayNotEqualTo(String value) {
            addCriterion("apply_day <>", value, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayGreaterThan(String value) {
            addCriterion("apply_day >", value, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayGreaterThanOrEqualTo(String value) {
            addCriterion("apply_day >=", value, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayLessThan(String value) {
            addCriterion("apply_day <", value, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayLessThanOrEqualTo(String value) {
            addCriterion("apply_day <=", value, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayLike(String value) {
            addCriterion("apply_day like", value, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayNotLike(String value) {
            addCriterion("apply_day not like", value, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayIn(List<String> values) {
            addCriterion("apply_day in", values, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayNotIn(List<String> values) {
            addCriterion("apply_day not in", values, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayBetween(String value1, String value2) {
            addCriterion("apply_day between", value1, value2, "applyDay");
            return (Criteria) this;
        }

        public Criteria andApplyDayNotBetween(String value1, String value2) {
            addCriterion("apply_day not between", value1, value2, "applyDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayIsNull() {
            addCriterion("redeem_day is null");
            return (Criteria) this;
        }

        public Criteria andRedeemDayIsNotNull() {
            addCriterion("redeem_day is not null");
            return (Criteria) this;
        }

        public Criteria andRedeemDayEqualTo(String value) {
            addCriterion("redeem_day =", value, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayNotEqualTo(String value) {
            addCriterion("redeem_day <>", value, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayGreaterThan(String value) {
            addCriterion("redeem_day >", value, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayGreaterThanOrEqualTo(String value) {
            addCriterion("redeem_day >=", value, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayLessThan(String value) {
            addCriterion("redeem_day <", value, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayLessThanOrEqualTo(String value) {
            addCriterion("redeem_day <=", value, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayLike(String value) {
            addCriterion("redeem_day like", value, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayNotLike(String value) {
            addCriterion("redeem_day not like", value, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayIn(List<String> values) {
            addCriterion("redeem_day in", values, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayNotIn(List<String> values) {
            addCriterion("redeem_day not in", values, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayBetween(String value1, String value2) {
            addCriterion("redeem_day between", value1, value2, "redeemDay");
            return (Criteria) this;
        }

        public Criteria andRedeemDayNotBetween(String value1, String value2) {
            addCriterion("redeem_day not between", value1, value2, "redeemDay");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}