package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class FundInfoPerformanceOldExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundInfoPerformanceOldExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNull() {
            addCriterion("fund_name is null");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNotNull() {
            addCriterion("fund_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundNameEqualTo(String value) {
            addCriterion("fund_name =", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotEqualTo(String value) {
            addCriterion("fund_name <>", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThan(String value) {
            addCriterion("fund_name >", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_name >=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThan(String value) {
            addCriterion("fund_name <", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThanOrEqualTo(String value) {
            addCriterion("fund_name <=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLike(String value) {
            addCriterion("fund_name like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotLike(String value) {
            addCriterion("fund_name not like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameIn(List<String> values) {
            addCriterion("fund_name in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotIn(List<String> values) {
            addCriterion("fund_name not in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameBetween(String value1, String value2) {
            addCriterion("fund_name between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotBetween(String value1, String value2) {
            addCriterion("fund_name not between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIsNull() {
            addCriterion("fund_short_name is null");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIsNotNull() {
            addCriterion("fund_short_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundShortNameEqualTo(String value) {
            addCriterion("fund_short_name =", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotEqualTo(String value) {
            addCriterion("fund_short_name <>", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameGreaterThan(String value) {
            addCriterion("fund_short_name >", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_short_name >=", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLessThan(String value) {
            addCriterion("fund_short_name <", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLessThanOrEqualTo(String value) {
            addCriterion("fund_short_name <=", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLike(String value) {
            addCriterion("fund_short_name like", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotLike(String value) {
            addCriterion("fund_short_name not like", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIn(List<String> values) {
            addCriterion("fund_short_name in", values, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotIn(List<String> values) {
            addCriterion("fund_short_name not in", values, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameBetween(String value1, String value2) {
            addCriterion("fund_short_name between", value1, value2, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotBetween(String value1, String value2) {
            addCriterion("fund_short_name not between", value1, value2, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIsNull() {
            addCriterion("risk_level is null");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIsNotNull() {
            addCriterion("risk_level is not null");
            return (Criteria) this;
        }

        public Criteria andRiskLevelEqualTo(Integer value) {
            addCriterion("risk_level =", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotEqualTo(Integer value) {
            addCriterion("risk_level <>", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelGreaterThan(Integer value) {
            addCriterion("risk_level >", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelGreaterThanOrEqualTo(Integer value) {
            addCriterion("risk_level >=", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLessThan(Integer value) {
            addCriterion("risk_level <", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLessThanOrEqualTo(Integer value) {
            addCriterion("risk_level <=", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIn(List<Integer> values) {
            addCriterion("risk_level in", values, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotIn(List<Integer> values) {
            addCriterion("risk_level not in", values, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelBetween(Integer value1, Integer value2) {
            addCriterion("risk_level between", value1, value2, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotBetween(Integer value1, Integer value2) {
            addCriterion("risk_level not between", value1, value2, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andTrustIdIsNull() {
            addCriterion("trust_id is null");
            return (Criteria) this;
        }

        public Criteria andTrustIdIsNotNull() {
            addCriterion("trust_id is not null");
            return (Criteria) this;
        }

        public Criteria andTrustIdEqualTo(String value) {
            addCriterion("trust_id =", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdNotEqualTo(String value) {
            addCriterion("trust_id <>", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdGreaterThan(String value) {
            addCriterion("trust_id >", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdGreaterThanOrEqualTo(String value) {
            addCriterion("trust_id >=", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdLessThan(String value) {
            addCriterion("trust_id <", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdLessThanOrEqualTo(String value) {
            addCriterion("trust_id <=", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdLike(String value) {
            addCriterion("trust_id like", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdNotLike(String value) {
            addCriterion("trust_id not like", value, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdIn(List<String> values) {
            addCriterion("trust_id in", values, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdNotIn(List<String> values) {
            addCriterion("trust_id not in", values, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdBetween(String value1, String value2) {
            addCriterion("trust_id between", value1, value2, "trustId");
            return (Criteria) this;
        }

        public Criteria andTrustIdNotBetween(String value1, String value2) {
            addCriterion("trust_id not between", value1, value2, "trustId");
            return (Criteria) this;
        }

        public Criteria andNetNavIsNull() {
            addCriterion("net_nav is null");
            return (Criteria) this;
        }

        public Criteria andNetNavIsNotNull() {
            addCriterion("net_nav is not null");
            return (Criteria) this;
        }

        public Criteria andNetNavEqualTo(BigDecimal value) {
            addCriterion("net_nav =", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavNotEqualTo(BigDecimal value) {
            addCriterion("net_nav <>", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavGreaterThan(BigDecimal value) {
            addCriterion("net_nav >", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("net_nav >=", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavLessThan(BigDecimal value) {
            addCriterion("net_nav <", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavLessThanOrEqualTo(BigDecimal value) {
            addCriterion("net_nav <=", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavIn(List<BigDecimal> values) {
            addCriterion("net_nav in", values, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavNotIn(List<BigDecimal> values) {
            addCriterion("net_nav not in", values, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("net_nav between", value1, value2, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("net_nav not between", value1, value2, "netNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNull() {
            addCriterion("cumulative_nav is null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNotNull() {
            addCriterion("cumulative_nav is not null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav =", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav <>", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThan(BigDecimal value) {
            addCriterion("cumulative_nav >", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav >=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThan(BigDecimal value) {
            addCriterion("cumulative_nav <", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav <=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIn(List<BigDecimal> values) {
            addCriterion("cumulative_nav in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotIn(List<BigDecimal> values) {
            addCriterion("cumulative_nav not in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cumulative_nav between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cumulative_nav not between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("end_date is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("end_date is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("end_date =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("end_date >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(Date value) {
            addCriterionForJDBCDate("end_date <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("end_date in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("end_date not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNull() {
            addCriterion("price_date is null");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNotNull() {
            addCriterion("price_date is not null");
            return (Criteria) this;
        }

        public Criteria andPriceDateEqualTo(Date value) {
            addCriterionForJDBCDate("price_date =", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <>", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThan(Date value) {
            addCriterionForJDBCDate("price_date >", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date >=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThan(Date value) {
            addCriterionForJDBCDate("price_date <", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateIn(List<Date> values) {
            addCriterionForJDBCDate("price_date in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("price_date not in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date not between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andStrategyIsNull() {
            addCriterion("strategy is null");
            return (Criteria) this;
        }

        public Criteria andStrategyIsNotNull() {
            addCriterion("strategy is not null");
            return (Criteria) this;
        }

        public Criteria andStrategyEqualTo(Integer value) {
            addCriterion("strategy =", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotEqualTo(Integer value) {
            addCriterion("strategy <>", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyGreaterThan(Integer value) {
            addCriterion("strategy >", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyGreaterThanOrEqualTo(Integer value) {
            addCriterion("strategy >=", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyLessThan(Integer value) {
            addCriterion("strategy <", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyLessThanOrEqualTo(Integer value) {
            addCriterion("strategy <=", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyIn(List<Integer> values) {
            addCriterion("strategy in", values, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotIn(List<Integer> values) {
            addCriterion("strategy not in", values, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyBetween(Integer value1, Integer value2) {
            addCriterion("strategy between", value1, value2, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotBetween(Integer value1, Integer value2) {
            addCriterion("strategy not between", value1, value2, "strategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNull() {
            addCriterion("substrategy is null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNotNull() {
            addCriterion("substrategy is not null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyEqualTo(Integer value) {
            addCriterion("substrategy =", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotEqualTo(Integer value) {
            addCriterion("substrategy <>", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThan(Integer value) {
            addCriterion("substrategy >", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThanOrEqualTo(Integer value) {
            addCriterion("substrategy >=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThan(Integer value) {
            addCriterion("substrategy <", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThanOrEqualTo(Integer value) {
            addCriterion("substrategy <=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIn(List<Integer> values) {
            addCriterion("substrategy in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotIn(List<Integer> values) {
            addCriterion("substrategy not in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyBetween(Integer value1, Integer value2) {
            addCriterion("substrategy between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotBetween(Integer value1, Integer value2) {
            addCriterion("substrategy not between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andRet1wIsNull() {
            addCriterion("ret_1w is null");
            return (Criteria) this;
        }

        public Criteria andRet1wIsNotNull() {
            addCriterion("ret_1w is not null");
            return (Criteria) this;
        }

        public Criteria andRet1wEqualTo(BigDecimal value) {
            addCriterion("ret_1w =", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotEqualTo(BigDecimal value) {
            addCriterion("ret_1w <>", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wGreaterThan(BigDecimal value) {
            addCriterion("ret_1w >", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w >=", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wLessThan(BigDecimal value) {
            addCriterion("ret_1w <", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w <=", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wIn(List<BigDecimal> values) {
            addCriterion("ret_1w in", values, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotIn(List<BigDecimal> values) {
            addCriterion("ret_1w not in", values, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w between", value1, value2, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w not between", value1, value2, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNull() {
            addCriterion("ret_1m is null");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNotNull() {
            addCriterion("ret_1m is not null");
            return (Criteria) this;
        }

        public Criteria andRet1mEqualTo(BigDecimal value) {
            addCriterion("ret_1m =", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotEqualTo(BigDecimal value) {
            addCriterion("ret_1m <>", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThan(BigDecimal value) {
            addCriterion("ret_1m >", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m >=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThan(BigDecimal value) {
            addCriterion("ret_1m <", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m <=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mIn(List<BigDecimal> values) {
            addCriterion("ret_1m in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotIn(List<BigDecimal> values) {
            addCriterion("ret_1m not in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m not between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNull() {
            addCriterion("ret_6m is null");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNotNull() {
            addCriterion("ret_6m is not null");
            return (Criteria) this;
        }

        public Criteria andRet6mEqualTo(BigDecimal value) {
            addCriterion("ret_6m =", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotEqualTo(BigDecimal value) {
            addCriterion("ret_6m <>", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThan(BigDecimal value) {
            addCriterion("ret_6m >", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m >=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThan(BigDecimal value) {
            addCriterion("ret_6m <", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m <=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mIn(List<BigDecimal> values) {
            addCriterion("ret_6m in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotIn(List<BigDecimal> values) {
            addCriterion("ret_6m not in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m not between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNull() {
            addCriterion("ret_1y is null");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNotNull() {
            addCriterion("ret_1y is not null");
            return (Criteria) this;
        }

        public Criteria andRet1yEqualTo(BigDecimal value) {
            addCriterion("ret_1y =", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotEqualTo(BigDecimal value) {
            addCriterion("ret_1y <>", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThan(BigDecimal value) {
            addCriterion("ret_1y >", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y >=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThan(BigDecimal value) {
            addCriterion("ret_1y <", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y <=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yIn(List<BigDecimal> values) {
            addCriterion("ret_1y in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotIn(List<BigDecimal> values) {
            addCriterion("ret_1y not in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y not between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNull() {
            addCriterion("ret_incep is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNotNull() {
            addCriterion("ret_incep is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepEqualTo(BigDecimal value) {
            addCriterion("ret_incep =", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotEqualTo(BigDecimal value) {
            addCriterion("ret_incep <>", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThan(BigDecimal value) {
            addCriterion("ret_incep >", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep >=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThan(BigDecimal value) {
            addCriterion("ret_incep <", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep <=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepIn(List<BigDecimal> values) {
            addCriterion("ret_incep in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotIn(List<BigDecimal> values) {
            addCriterion("ret_incep not in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep not between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIsNull() {
            addCriterion("sharperatio_incep is null");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIsNotNull() {
            addCriterion("sharperatio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep =", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep <>", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_incep >", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep >=", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepLessThan(BigDecimal value) {
            addCriterion("sharperatio_incep <", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep <=", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIn(List<BigDecimal> values) {
            addCriterion("sharperatio_incep in", values, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_incep not in", values, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_incep between", value1, value2, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_incep not between", value1, value2, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIsNull() {
            addCriterion("sharperatio_1y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIsNotNull() {
            addCriterion("sharperatio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y =", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y <>", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_1y >", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y >=", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yLessThan(BigDecimal value) {
            addCriterion("sharperatio_1y <", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y <=", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_1y in", values, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_1y not in", values, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_1y between", value1, value2, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_1y not between", value1, value2, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIsNull() {
            addCriterion("sharperatio_2y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIsNotNull() {
            addCriterion("sharperatio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y =", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y <>", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_2y >", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y >=", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yLessThan(BigDecimal value) {
            addCriterion("sharperatio_2y <", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y <=", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_2y in", values, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_2y not in", values, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_2y between", value1, value2, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_2y not between", value1, value2, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIsNull() {
            addCriterion("sharperatio_3y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIsNotNull() {
            addCriterion("sharperatio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y =", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y <>", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_3y >", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y >=", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yLessThan(BigDecimal value) {
            addCriterion("sharperatio_3y <", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y <=", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_3y in", values, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_3y not in", values, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_3y between", value1, value2, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_3y not between", value1, value2, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIsNull() {
            addCriterion("sharperatio_4y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIsNotNull() {
            addCriterion("sharperatio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y =", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y <>", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_4y >", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y >=", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yLessThan(BigDecimal value) {
            addCriterion("sharperatio_4y <", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y <=", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_4y in", values, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_4y not in", values, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_4y between", value1, value2, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_4y not between", value1, value2, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIsNull() {
            addCriterion("sharperatio_5y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIsNotNull() {
            addCriterion("sharperatio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y =", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y <>", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_5y >", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y >=", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yLessThan(BigDecimal value) {
            addCriterion("sharperatio_5y <", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y <=", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_5y in", values, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_5y not in", values, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_5y between", value1, value2, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_5y not between", value1, value2, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andStddev1yIsNull() {
            addCriterion("stddev_1y is null");
            return (Criteria) this;
        }

        public Criteria andStddev1yIsNotNull() {
            addCriterion("stddev_1y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev1yEqualTo(BigDecimal value) {
            addCriterion("stddev_1y =", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_1y <>", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yGreaterThan(BigDecimal value) {
            addCriterion("stddev_1y >", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_1y >=", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yLessThan(BigDecimal value) {
            addCriterion("stddev_1y <", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_1y <=", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yIn(List<BigDecimal> values) {
            addCriterion("stddev_1y in", values, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_1y not in", values, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_1y between", value1, value2, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_1y not between", value1, value2, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev2yIsNull() {
            addCriterion("stddev_2y is null");
            return (Criteria) this;
        }

        public Criteria andStddev2yIsNotNull() {
            addCriterion("stddev_2y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev2yEqualTo(BigDecimal value) {
            addCriterion("stddev_2y =", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_2y <>", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yGreaterThan(BigDecimal value) {
            addCriterion("stddev_2y >", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_2y >=", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yLessThan(BigDecimal value) {
            addCriterion("stddev_2y <", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_2y <=", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yIn(List<BigDecimal> values) {
            addCriterion("stddev_2y in", values, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_2y not in", values, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_2y between", value1, value2, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_2y not between", value1, value2, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev3yIsNull() {
            addCriterion("stddev_3y is null");
            return (Criteria) this;
        }

        public Criteria andStddev3yIsNotNull() {
            addCriterion("stddev_3y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev3yEqualTo(BigDecimal value) {
            addCriterion("stddev_3y =", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_3y <>", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yGreaterThan(BigDecimal value) {
            addCriterion("stddev_3y >", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_3y >=", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yLessThan(BigDecimal value) {
            addCriterion("stddev_3y <", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_3y <=", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yIn(List<BigDecimal> values) {
            addCriterion("stddev_3y in", values, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_3y not in", values, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_3y between", value1, value2, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_3y not between", value1, value2, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev4yIsNull() {
            addCriterion("stddev_4y is null");
            return (Criteria) this;
        }

        public Criteria andStddev4yIsNotNull() {
            addCriterion("stddev_4y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev4yEqualTo(BigDecimal value) {
            addCriterion("stddev_4y =", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_4y <>", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yGreaterThan(BigDecimal value) {
            addCriterion("stddev_4y >", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_4y >=", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yLessThan(BigDecimal value) {
            addCriterion("stddev_4y <", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_4y <=", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yIn(List<BigDecimal> values) {
            addCriterion("stddev_4y in", values, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_4y not in", values, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_4y between", value1, value2, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_4y not between", value1, value2, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev5yIsNull() {
            addCriterion("stddev_5y is null");
            return (Criteria) this;
        }

        public Criteria andStddev5yIsNotNull() {
            addCriterion("stddev_5y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev5yEqualTo(BigDecimal value) {
            addCriterion("stddev_5y =", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_5y <>", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yGreaterThan(BigDecimal value) {
            addCriterion("stddev_5y >", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_5y >=", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yLessThan(BigDecimal value) {
            addCriterion("stddev_5y <", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_5y <=", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yIn(List<BigDecimal> values) {
            addCriterion("stddev_5y in", values, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_5y not in", values, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_5y between", value1, value2, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_5y not between", value1, value2, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIsNull() {
            addCriterion("stddev_incep is null");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIsNotNull() {
            addCriterion("stddev_incep is not null");
            return (Criteria) this;
        }

        public Criteria andStddevIncepEqualTo(BigDecimal value) {
            addCriterion("stddev_incep =", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotEqualTo(BigDecimal value) {
            addCriterion("stddev_incep <>", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepGreaterThan(BigDecimal value) {
            addCriterion("stddev_incep >", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_incep >=", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepLessThan(BigDecimal value) {
            addCriterion("stddev_incep <", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_incep <=", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIn(List<BigDecimal> values) {
            addCriterion("stddev_incep in", values, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotIn(List<BigDecimal> values) {
            addCriterion("stddev_incep not in", values, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_incep between", value1, value2, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_incep not between", value1, value2, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIsNull() {
            addCriterion("maxdrawdown_1y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIsNotNull() {
            addCriterion("maxdrawdown_1y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y =", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y <>", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_1y >", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y >=", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_1y <", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y <=", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_1y in", values, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_1y not in", values, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_1y between", value1, value2, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_1y not between", value1, value2, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIsNull() {
            addCriterion("maxdrawdown_2y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIsNotNull() {
            addCriterion("maxdrawdown_2y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y =", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y <>", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_2y >", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y >=", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_2y <", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y <=", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_2y in", values, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_2y not in", values, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_2y between", value1, value2, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_2y not between", value1, value2, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIsNull() {
            addCriterion("maxdrawdown_3y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIsNotNull() {
            addCriterion("maxdrawdown_3y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y =", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y <>", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_3y >", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y >=", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_3y <", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y <=", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_3y in", values, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_3y not in", values, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_3y between", value1, value2, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_3y not between", value1, value2, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIsNull() {
            addCriterion("maxdrawdown_4y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIsNotNull() {
            addCriterion("maxdrawdown_4y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y =", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y <>", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_4y >", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y >=", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_4y <", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y <=", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_4y in", values, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_4y not in", values, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_4y between", value1, value2, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_4y not between", value1, value2, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIsNull() {
            addCriterion("maxdrawdown_5y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIsNotNull() {
            addCriterion("maxdrawdown_5y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y =", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y <>", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_5y >", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y >=", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_5y <", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y <=", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_5y in", values, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_5y not in", values, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_5y between", value1, value2, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_5y not between", value1, value2, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIsNull() {
            addCriterion("maxdrawdown_incep is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIsNotNull() {
            addCriterion("maxdrawdown_incep is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep =", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep <>", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_incep >", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep >=", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_incep <", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep <=", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_incep in", values, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_incep not in", values, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_incep between", value1, value2, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_incep not between", value1, value2, "maxdrawdownIncep");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}