package com.tanpu.fund.entity.generator;

import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundPersonnelInfo {
    private String personnelId;

    private String personnelName;

    private Integer personnelT;

    private Integer profession;

    private Integer keyFigure;

    private String companyId;

    private String position;

    private String careerStar;

    private Integer investment;

    private Integer sex;

    private String graduatesch;

    private Integer education;

    private String major;

    private Integer order;

    private Integer ifinclude;

    private Integer isvisible;

    private Long isvalid;

    private String updatetime;

    private Integer isQualify;

    private String topic;

    private Date createtime;

    private String getQualify;

    /**
     * 机构id
     */
    private String orgId;

    private String avatar;

    private String profile;
}