package com.tanpu.fund.entity.generator;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class FundPersonnelInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundPersonnelInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andPersonnelIdIsNull() {
            addCriterion("personnel_id is null");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdIsNotNull() {
            addCriterion("personnel_id is not null");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdEqualTo(String value) {
            addCriterion("personnel_id =", value, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdNotEqualTo(String value) {
            addCriterion("personnel_id <>", value, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdGreaterThan(String value) {
            addCriterion("personnel_id >", value, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdGreaterThanOrEqualTo(String value) {
            addCriterion("personnel_id >=", value, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdLessThan(String value) {
            addCriterion("personnel_id <", value, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdLessThanOrEqualTo(String value) {
            addCriterion("personnel_id <=", value, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdLike(String value) {
            addCriterion("personnel_id like", value, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdNotLike(String value) {
            addCriterion("personnel_id not like", value, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdIn(List<String> values) {
            addCriterion("personnel_id in", values, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdNotIn(List<String> values) {
            addCriterion("personnel_id not in", values, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdBetween(String value1, String value2) {
            addCriterion("personnel_id between", value1, value2, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelIdNotBetween(String value1, String value2) {
            addCriterion("personnel_id not between", value1, value2, "personnelId");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameIsNull() {
            addCriterion("personnel_name is null");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameIsNotNull() {
            addCriterion("personnel_name is not null");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameEqualTo(String value) {
            addCriterion("personnel_name =", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameNotEqualTo(String value) {
            addCriterion("personnel_name <>", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameGreaterThan(String value) {
            addCriterion("personnel_name >", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameGreaterThanOrEqualTo(String value) {
            addCriterion("personnel_name >=", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameLessThan(String value) {
            addCriterion("personnel_name <", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameLessThanOrEqualTo(String value) {
            addCriterion("personnel_name <=", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameLike(String value) {
            addCriterion("personnel_name like", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameNotLike(String value) {
            addCriterion("personnel_name not like", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameIn(List<String> values) {
            addCriterion("personnel_name in", values, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameNotIn(List<String> values) {
            addCriterion("personnel_name not in", values, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameBetween(String value1, String value2) {
            addCriterion("personnel_name between", value1, value2, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameNotBetween(String value1, String value2) {
            addCriterion("personnel_name not between", value1, value2, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelTIsNull() {
            addCriterion("personnel_t is null");
            return (Criteria) this;
        }

        public Criteria andPersonnelTIsNotNull() {
            addCriterion("personnel_t is not null");
            return (Criteria) this;
        }

        public Criteria andPersonnelTEqualTo(Integer value) {
            addCriterion("personnel_t =", value, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTNotEqualTo(Integer value) {
            addCriterion("personnel_t <>", value, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTGreaterThan(Integer value) {
            addCriterion("personnel_t >", value, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTGreaterThanOrEqualTo(Integer value) {
            addCriterion("personnel_t >=", value, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTLessThan(Integer value) {
            addCriterion("personnel_t <", value, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTLessThanOrEqualTo(Integer value) {
            addCriterion("personnel_t <=", value, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTIn(List<Integer> values) {
            addCriterion("personnel_t in", values, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTNotIn(List<Integer> values) {
            addCriterion("personnel_t not in", values, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTBetween(Integer value1, Integer value2) {
            addCriterion("personnel_t between", value1, value2, "personnelT");
            return (Criteria) this;
        }

        public Criteria andPersonnelTNotBetween(Integer value1, Integer value2) {
            addCriterion("personnel_t not between", value1, value2, "personnelT");
            return (Criteria) this;
        }

        public Criteria andProfessionIsNull() {
            addCriterion("profession_ is null");
            return (Criteria) this;
        }

        public Criteria andProfessionIsNotNull() {
            addCriterion("profession_ is not null");
            return (Criteria) this;
        }

        public Criteria andProfessionEqualTo(Integer value) {
            addCriterion("profession_ =", value, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionNotEqualTo(Integer value) {
            addCriterion("profession_ <>", value, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionGreaterThan(Integer value) {
            addCriterion("profession_ >", value, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionGreaterThanOrEqualTo(Integer value) {
            addCriterion("profession_ >=", value, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionLessThan(Integer value) {
            addCriterion("profession_ <", value, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionLessThanOrEqualTo(Integer value) {
            addCriterion("profession_ <=", value, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionIn(List<Integer> values) {
            addCriterion("profession_ in", values, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionNotIn(List<Integer> values) {
            addCriterion("profession_ not in", values, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionBetween(Integer value1, Integer value2) {
            addCriterion("profession_ between", value1, value2, "profession");
            return (Criteria) this;
        }

        public Criteria andProfessionNotBetween(Integer value1, Integer value2) {
            addCriterion("profession_ not between", value1, value2, "profession");
            return (Criteria) this;
        }

        public Criteria andKeyFigureIsNull() {
            addCriterion("key_figure is null");
            return (Criteria) this;
        }

        public Criteria andKeyFigureIsNotNull() {
            addCriterion("key_figure is not null");
            return (Criteria) this;
        }

        public Criteria andKeyFigureEqualTo(Integer value) {
            addCriterion("key_figure =", value, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureNotEqualTo(Integer value) {
            addCriterion("key_figure <>", value, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureGreaterThan(Integer value) {
            addCriterion("key_figure >", value, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureGreaterThanOrEqualTo(Integer value) {
            addCriterion("key_figure >=", value, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureLessThan(Integer value) {
            addCriterion("key_figure <", value, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureLessThanOrEqualTo(Integer value) {
            addCriterion("key_figure <=", value, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureIn(List<Integer> values) {
            addCriterion("key_figure in", values, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureNotIn(List<Integer> values) {
            addCriterion("key_figure not in", values, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureBetween(Integer value1, Integer value2) {
            addCriterion("key_figure between", value1, value2, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andKeyFigureNotBetween(Integer value1, Integer value2) {
            addCriterion("key_figure not between", value1, value2, "keyFigure");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(String value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(String value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(String value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(String value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(String value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(String value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLike(String value) {
            addCriterion("company_id like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotLike(String value) {
            addCriterion("company_id not like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<String> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<String> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(String value1, String value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(String value1, String value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andPositionIsNull() {
            addCriterion("`position` is null");
            return (Criteria) this;
        }

        public Criteria andPositionIsNotNull() {
            addCriterion("`position` is not null");
            return (Criteria) this;
        }

        public Criteria andPositionEqualTo(String value) {
            addCriterion("`position` =", value, "position");
            return (Criteria) this;
        }

        public Criteria andPositionNotEqualTo(String value) {
            addCriterion("`position` <>", value, "position");
            return (Criteria) this;
        }

        public Criteria andPositionGreaterThan(String value) {
            addCriterion("`position` >", value, "position");
            return (Criteria) this;
        }

        public Criteria andPositionGreaterThanOrEqualTo(String value) {
            addCriterion("`position` >=", value, "position");
            return (Criteria) this;
        }

        public Criteria andPositionLessThan(String value) {
            addCriterion("`position` <", value, "position");
            return (Criteria) this;
        }

        public Criteria andPositionLessThanOrEqualTo(String value) {
            addCriterion("`position` <=", value, "position");
            return (Criteria) this;
        }

        public Criteria andPositionLike(String value) {
            addCriterion("`position` like", value, "position");
            return (Criteria) this;
        }

        public Criteria andPositionNotLike(String value) {
            addCriterion("`position` not like", value, "position");
            return (Criteria) this;
        }

        public Criteria andPositionIn(List<String> values) {
            addCriterion("`position` in", values, "position");
            return (Criteria) this;
        }

        public Criteria andPositionNotIn(List<String> values) {
            addCriterion("`position` not in", values, "position");
            return (Criteria) this;
        }

        public Criteria andPositionBetween(String value1, String value2) {
            addCriterion("`position` between", value1, value2, "position");
            return (Criteria) this;
        }

        public Criteria andPositionNotBetween(String value1, String value2) {
            addCriterion("`position` not between", value1, value2, "position");
            return (Criteria) this;
        }

        public Criteria andCareerStarIsNull() {
            addCriterion("career_star is null");
            return (Criteria) this;
        }

        public Criteria andCareerStarIsNotNull() {
            addCriterion("career_star is not null");
            return (Criteria) this;
        }

        public Criteria andCareerStarEqualTo(String value) {
            addCriterion("career_star =", value, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarNotEqualTo(String value) {
            addCriterion("career_star <>", value, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarGreaterThan(String value) {
            addCriterion("career_star >", value, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarGreaterThanOrEqualTo(String value) {
            addCriterion("career_star >=", value, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarLessThan(String value) {
            addCriterion("career_star <", value, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarLessThanOrEqualTo(String value) {
            addCriterion("career_star <=", value, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarLike(String value) {
            addCriterion("career_star like", value, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarNotLike(String value) {
            addCriterion("career_star not like", value, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarIn(List<String> values) {
            addCriterion("career_star in", values, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarNotIn(List<String> values) {
            addCriterion("career_star not in", values, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarBetween(String value1, String value2) {
            addCriterion("career_star between", value1, value2, "careerStar");
            return (Criteria) this;
        }

        public Criteria andCareerStarNotBetween(String value1, String value2) {
            addCriterion("career_star not between", value1, value2, "careerStar");
            return (Criteria) this;
        }

        public Criteria andInvestmentIsNull() {
            addCriterion("investment_ is null");
            return (Criteria) this;
        }

        public Criteria andInvestmentIsNotNull() {
            addCriterion("investment_ is not null");
            return (Criteria) this;
        }

        public Criteria andInvestmentEqualTo(Integer value) {
            addCriterion("investment_ =", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentNotEqualTo(Integer value) {
            addCriterion("investment_ <>", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentGreaterThan(Integer value) {
            addCriterion("investment_ >", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentGreaterThanOrEqualTo(Integer value) {
            addCriterion("investment_ >=", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentLessThan(Integer value) {
            addCriterion("investment_ <", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentLessThanOrEqualTo(Integer value) {
            addCriterion("investment_ <=", value, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentIn(List<Integer> values) {
            addCriterion("investment_ in", values, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentNotIn(List<Integer> values) {
            addCriterion("investment_ not in", values, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentBetween(Integer value1, Integer value2) {
            addCriterion("investment_ between", value1, value2, "investment");
            return (Criteria) this;
        }

        public Criteria andInvestmentNotBetween(Integer value1, Integer value2) {
            addCriterion("investment_ not between", value1, value2, "investment");
            return (Criteria) this;
        }

        public Criteria andSexIsNull() {
            addCriterion("sex is null");
            return (Criteria) this;
        }

        public Criteria andSexIsNotNull() {
            addCriterion("sex is not null");
            return (Criteria) this;
        }

        public Criteria andSexEqualTo(Integer value) {
            addCriterion("sex =", value, "sex");
            return (Criteria) this;
        }

        public Criteria andSexNotEqualTo(Integer value) {
            addCriterion("sex <>", value, "sex");
            return (Criteria) this;
        }

        public Criteria andSexGreaterThan(Integer value) {
            addCriterion("sex >", value, "sex");
            return (Criteria) this;
        }

        public Criteria andSexGreaterThanOrEqualTo(Integer value) {
            addCriterion("sex >=", value, "sex");
            return (Criteria) this;
        }

        public Criteria andSexLessThan(Integer value) {
            addCriterion("sex <", value, "sex");
            return (Criteria) this;
        }

        public Criteria andSexLessThanOrEqualTo(Integer value) {
            addCriterion("sex <=", value, "sex");
            return (Criteria) this;
        }

        public Criteria andSexIn(List<Integer> values) {
            addCriterion("sex in", values, "sex");
            return (Criteria) this;
        }

        public Criteria andSexNotIn(List<Integer> values) {
            addCriterion("sex not in", values, "sex");
            return (Criteria) this;
        }

        public Criteria andSexBetween(Integer value1, Integer value2) {
            addCriterion("sex between", value1, value2, "sex");
            return (Criteria) this;
        }

        public Criteria andSexNotBetween(Integer value1, Integer value2) {
            addCriterion("sex not between", value1, value2, "sex");
            return (Criteria) this;
        }

        public Criteria andGraduateschIsNull() {
            addCriterion("graduatesch is null");
            return (Criteria) this;
        }

        public Criteria andGraduateschIsNotNull() {
            addCriterion("graduatesch is not null");
            return (Criteria) this;
        }

        public Criteria andGraduateschEqualTo(String value) {
            addCriterion("graduatesch =", value, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschNotEqualTo(String value) {
            addCriterion("graduatesch <>", value, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschGreaterThan(String value) {
            addCriterion("graduatesch >", value, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschGreaterThanOrEqualTo(String value) {
            addCriterion("graduatesch >=", value, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschLessThan(String value) {
            addCriterion("graduatesch <", value, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschLessThanOrEqualTo(String value) {
            addCriterion("graduatesch <=", value, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschLike(String value) {
            addCriterion("graduatesch like", value, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschNotLike(String value) {
            addCriterion("graduatesch not like", value, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschIn(List<String> values) {
            addCriterion("graduatesch in", values, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschNotIn(List<String> values) {
            addCriterion("graduatesch not in", values, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschBetween(String value1, String value2) {
            addCriterion("graduatesch between", value1, value2, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andGraduateschNotBetween(String value1, String value2) {
            addCriterion("graduatesch not between", value1, value2, "graduatesch");
            return (Criteria) this;
        }

        public Criteria andEducationIsNull() {
            addCriterion("education is null");
            return (Criteria) this;
        }

        public Criteria andEducationIsNotNull() {
            addCriterion("education is not null");
            return (Criteria) this;
        }

        public Criteria andEducationEqualTo(Integer value) {
            addCriterion("education =", value, "education");
            return (Criteria) this;
        }

        public Criteria andEducationNotEqualTo(Integer value) {
            addCriterion("education <>", value, "education");
            return (Criteria) this;
        }

        public Criteria andEducationGreaterThan(Integer value) {
            addCriterion("education >", value, "education");
            return (Criteria) this;
        }

        public Criteria andEducationGreaterThanOrEqualTo(Integer value) {
            addCriterion("education >=", value, "education");
            return (Criteria) this;
        }

        public Criteria andEducationLessThan(Integer value) {
            addCriterion("education <", value, "education");
            return (Criteria) this;
        }

        public Criteria andEducationLessThanOrEqualTo(Integer value) {
            addCriterion("education <=", value, "education");
            return (Criteria) this;
        }

        public Criteria andEducationIn(List<Integer> values) {
            addCriterion("education in", values, "education");
            return (Criteria) this;
        }

        public Criteria andEducationNotIn(List<Integer> values) {
            addCriterion("education not in", values, "education");
            return (Criteria) this;
        }

        public Criteria andEducationBetween(Integer value1, Integer value2) {
            addCriterion("education between", value1, value2, "education");
            return (Criteria) this;
        }

        public Criteria andEducationNotBetween(Integer value1, Integer value2) {
            addCriterion("education not between", value1, value2, "education");
            return (Criteria) this;
        }

        public Criteria andMajorIsNull() {
            addCriterion("major is null");
            return (Criteria) this;
        }

        public Criteria andMajorIsNotNull() {
            addCriterion("major is not null");
            return (Criteria) this;
        }

        public Criteria andMajorEqualTo(String value) {
            addCriterion("major =", value, "major");
            return (Criteria) this;
        }

        public Criteria andMajorNotEqualTo(String value) {
            addCriterion("major <>", value, "major");
            return (Criteria) this;
        }

        public Criteria andMajorGreaterThan(String value) {
            addCriterion("major >", value, "major");
            return (Criteria) this;
        }

        public Criteria andMajorGreaterThanOrEqualTo(String value) {
            addCriterion("major >=", value, "major");
            return (Criteria) this;
        }

        public Criteria andMajorLessThan(String value) {
            addCriterion("major <", value, "major");
            return (Criteria) this;
        }

        public Criteria andMajorLessThanOrEqualTo(String value) {
            addCriterion("major <=", value, "major");
            return (Criteria) this;
        }

        public Criteria andMajorLike(String value) {
            addCriterion("major like", value, "major");
            return (Criteria) this;
        }

        public Criteria andMajorNotLike(String value) {
            addCriterion("major not like", value, "major");
            return (Criteria) this;
        }

        public Criteria andMajorIn(List<String> values) {
            addCriterion("major in", values, "major");
            return (Criteria) this;
        }

        public Criteria andMajorNotIn(List<String> values) {
            addCriterion("major not in", values, "major");
            return (Criteria) this;
        }

        public Criteria andMajorBetween(String value1, String value2) {
            addCriterion("major between", value1, value2, "major");
            return (Criteria) this;
        }

        public Criteria andMajorNotBetween(String value1, String value2) {
            addCriterion("major not between", value1, value2, "major");
            return (Criteria) this;
        }

        public Criteria andOrderIsNull() {
            addCriterion("`order` is null");
            return (Criteria) this;
        }

        public Criteria andOrderIsNotNull() {
            addCriterion("`order` is not null");
            return (Criteria) this;
        }

        public Criteria andOrderEqualTo(Integer value) {
            addCriterion("`order` =", value, "order");
            return (Criteria) this;
        }

        public Criteria andOrderNotEqualTo(Integer value) {
            addCriterion("`order` <>", value, "order");
            return (Criteria) this;
        }

        public Criteria andOrderGreaterThan(Integer value) {
            addCriterion("`order` >", value, "order");
            return (Criteria) this;
        }

        public Criteria andOrderGreaterThanOrEqualTo(Integer value) {
            addCriterion("`order` >=", value, "order");
            return (Criteria) this;
        }

        public Criteria andOrderLessThan(Integer value) {
            addCriterion("`order` <", value, "order");
            return (Criteria) this;
        }

        public Criteria andOrderLessThanOrEqualTo(Integer value) {
            addCriterion("`order` <=", value, "order");
            return (Criteria) this;
        }

        public Criteria andOrderIn(List<Integer> values) {
            addCriterion("`order` in", values, "order");
            return (Criteria) this;
        }

        public Criteria andOrderNotIn(List<Integer> values) {
            addCriterion("`order` not in", values, "order");
            return (Criteria) this;
        }

        public Criteria andOrderBetween(Integer value1, Integer value2) {
            addCriterion("`order` between", value1, value2, "order");
            return (Criteria) this;
        }

        public Criteria andOrderNotBetween(Integer value1, Integer value2) {
            addCriterion("`order` not between", value1, value2, "order");
            return (Criteria) this;
        }

        public Criteria andIfincludeIsNull() {
            addCriterion("ifinclude is null");
            return (Criteria) this;
        }

        public Criteria andIfincludeIsNotNull() {
            addCriterion("ifinclude is not null");
            return (Criteria) this;
        }

        public Criteria andIfincludeEqualTo(Integer value) {
            addCriterion("ifinclude =", value, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeNotEqualTo(Integer value) {
            addCriterion("ifinclude <>", value, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeGreaterThan(Integer value) {
            addCriterion("ifinclude >", value, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeGreaterThanOrEqualTo(Integer value) {
            addCriterion("ifinclude >=", value, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeLessThan(Integer value) {
            addCriterion("ifinclude <", value, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeLessThanOrEqualTo(Integer value) {
            addCriterion("ifinclude <=", value, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeIn(List<Integer> values) {
            addCriterion("ifinclude in", values, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeNotIn(List<Integer> values) {
            addCriterion("ifinclude not in", values, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeBetween(Integer value1, Integer value2) {
            addCriterion("ifinclude between", value1, value2, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIfincludeNotBetween(Integer value1, Integer value2) {
            addCriterion("ifinclude not between", value1, value2, "ifinclude");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIsNull() {
            addCriterion("isvisible is null");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIsNotNull() {
            addCriterion("isvisible is not null");
            return (Criteria) this;
        }

        public Criteria andIsvisibleEqualTo(Integer value) {
            addCriterion("isvisible =", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotEqualTo(Integer value) {
            addCriterion("isvisible <>", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleGreaterThan(Integer value) {
            addCriterion("isvisible >", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleGreaterThanOrEqualTo(Integer value) {
            addCriterion("isvisible >=", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleLessThan(Integer value) {
            addCriterion("isvisible <", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleLessThanOrEqualTo(Integer value) {
            addCriterion("isvisible <=", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIn(List<Integer> values) {
            addCriterion("isvisible in", values, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotIn(List<Integer> values) {
            addCriterion("isvisible not in", values, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleBetween(Integer value1, Integer value2) {
            addCriterion("isvisible between", value1, value2, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotBetween(Integer value1, Integer value2) {
            addCriterion("isvisible not between", value1, value2, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvalidIsNull() {
            addCriterion("isvalid is null");
            return (Criteria) this;
        }

        public Criteria andIsvalidIsNotNull() {
            addCriterion("isvalid is not null");
            return (Criteria) this;
        }

        public Criteria andIsvalidEqualTo(Long value) {
            addCriterion("isvalid =", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotEqualTo(Long value) {
            addCriterion("isvalid <>", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidGreaterThan(Long value) {
            addCriterion("isvalid >", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidGreaterThanOrEqualTo(Long value) {
            addCriterion("isvalid >=", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidLessThan(Long value) {
            addCriterion("isvalid <", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidLessThanOrEqualTo(Long value) {
            addCriterion("isvalid <=", value, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidIn(List<Long> values) {
            addCriterion("isvalid in", values, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotIn(List<Long> values) {
            addCriterion("isvalid not in", values, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidBetween(Long value1, Long value2) {
            addCriterion("isvalid between", value1, value2, "isvalid");
            return (Criteria) this;
        }

        public Criteria andIsvalidNotBetween(Long value1, Long value2) {
            addCriterion("isvalid not between", value1, value2, "isvalid");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNull() {
            addCriterion("updatetime is null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNotNull() {
            addCriterion("updatetime is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeEqualTo(String value) {
            addCriterion("updatetime =", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotEqualTo(String value) {
            addCriterion("updatetime <>", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThan(String value) {
            addCriterion("updatetime >", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThanOrEqualTo(String value) {
            addCriterion("updatetime >=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThan(String value) {
            addCriterion("updatetime <", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThanOrEqualTo(String value) {
            addCriterion("updatetime <=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLike(String value) {
            addCriterion("updatetime like", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotLike(String value) {
            addCriterion("updatetime not like", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIn(List<String> values) {
            addCriterion("updatetime in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotIn(List<String> values) {
            addCriterion("updatetime not in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeBetween(String value1, String value2) {
            addCriterion("updatetime between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotBetween(String value1, String value2) {
            addCriterion("updatetime not between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIsNull() {
            addCriterion("is_qualify is null");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIsNotNull() {
            addCriterion("is_qualify is not null");
            return (Criteria) this;
        }

        public Criteria andIsQualifyEqualTo(Integer value) {
            addCriterion("is_qualify =", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotEqualTo(Integer value) {
            addCriterion("is_qualify <>", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyGreaterThan(Integer value) {
            addCriterion("is_qualify >", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_qualify >=", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyLessThan(Integer value) {
            addCriterion("is_qualify <", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyLessThanOrEqualTo(Integer value) {
            addCriterion("is_qualify <=", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIn(List<Integer> values) {
            addCriterion("is_qualify in", values, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotIn(List<Integer> values) {
            addCriterion("is_qualify not in", values, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyBetween(Integer value1, Integer value2) {
            addCriterion("is_qualify between", value1, value2, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotBetween(Integer value1, Integer value2) {
            addCriterion("is_qualify not between", value1, value2, "isQualify");
            return (Criteria) this;
        }

        public Criteria andTopicIsNull() {
            addCriterion("topic is null");
            return (Criteria) this;
        }

        public Criteria andTopicIsNotNull() {
            addCriterion("topic is not null");
            return (Criteria) this;
        }

        public Criteria andTopicEqualTo(String value) {
            addCriterion("topic =", value, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicNotEqualTo(String value) {
            addCriterion("topic <>", value, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicGreaterThan(String value) {
            addCriterion("topic >", value, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicGreaterThanOrEqualTo(String value) {
            addCriterion("topic >=", value, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicLessThan(String value) {
            addCriterion("topic <", value, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicLessThanOrEqualTo(String value) {
            addCriterion("topic <=", value, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicLike(String value) {
            addCriterion("topic like", value, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicNotLike(String value) {
            addCriterion("topic not like", value, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicIn(List<String> values) {
            addCriterion("topic in", values, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicNotIn(List<String> values) {
            addCriterion("topic not in", values, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicBetween(String value1, String value2) {
            addCriterion("topic between", value1, value2, "topic");
            return (Criteria) this;
        }

        public Criteria andTopicNotBetween(String value1, String value2) {
            addCriterion("topic not between", value1, value2, "topic");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIsNull() {
            addCriterion("createtime is null");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIsNotNull() {
            addCriterion("createtime is not null");
            return (Criteria) this;
        }

        public Criteria andCreatetimeEqualTo(Date value) {
            addCriterionForJDBCDate("createtime =", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotEqualTo(Date value) {
            addCriterionForJDBCDate("createtime <>", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeGreaterThan(Date value) {
            addCriterionForJDBCDate("createtime >", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("createtime >=", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeLessThan(Date value) {
            addCriterionForJDBCDate("createtime <", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("createtime <=", value, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeIn(List<Date> values) {
            addCriterionForJDBCDate("createtime in", values, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotIn(List<Date> values) {
            addCriterionForJDBCDate("createtime not in", values, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("createtime between", value1, value2, "createtime");
            return (Criteria) this;
        }

        public Criteria andCreatetimeNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("createtime not between", value1, value2, "createtime");
            return (Criteria) this;
        }

        public Criteria andGetQualifyIsNull() {
            addCriterion("get_qualify is null");
            return (Criteria) this;
        }

        public Criteria andGetQualifyIsNotNull() {
            addCriterion("get_qualify is not null");
            return (Criteria) this;
        }

        public Criteria andGetQualifyEqualTo(String value) {
            addCriterion("get_qualify =", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyNotEqualTo(String value) {
            addCriterion("get_qualify <>", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyGreaterThan(String value) {
            addCriterion("get_qualify >", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyGreaterThanOrEqualTo(String value) {
            addCriterion("get_qualify >=", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyLessThan(String value) {
            addCriterion("get_qualify <", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyLessThanOrEqualTo(String value) {
            addCriterion("get_qualify <=", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyLike(String value) {
            addCriterion("get_qualify like", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyNotLike(String value) {
            addCriterion("get_qualify not like", value, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyIn(List<String> values) {
            addCriterion("get_qualify in", values, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyNotIn(List<String> values) {
            addCriterion("get_qualify not in", values, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyBetween(String value1, String value2) {
            addCriterion("get_qualify between", value1, value2, "getQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyNotBetween(String value1, String value2) {
            addCriterion("get_qualify not between", value1, value2, "getQualify");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}