package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class IfaImportedFundInfoViewOldExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public IfaImportedFundInfoViewOldExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("`type` is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("`type` is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(Integer value) {
            addCriterion("`type` =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(Integer value) {
            addCriterion("`type` <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(Integer value) {
            addCriterion("`type` >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("`type` >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(Integer value) {
            addCriterion("`type` <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(Integer value) {
            addCriterion("`type` <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<Integer> values) {
            addCriterion("`type` in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<Integer> values) {
            addCriterion("`type` not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(Integer value1, Integer value2) {
            addCriterion("`type` between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("`type` not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNull() {
            addCriterion("fund_name is null");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNotNull() {
            addCriterion("fund_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundNameEqualTo(String value) {
            addCriterion("fund_name =", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotEqualTo(String value) {
            addCriterion("fund_name <>", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThan(String value) {
            addCriterion("fund_name >", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_name >=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThan(String value) {
            addCriterion("fund_name <", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThanOrEqualTo(String value) {
            addCriterion("fund_name <=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLike(String value) {
            addCriterion("fund_name like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotLike(String value) {
            addCriterion("fund_name not like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameIn(List<String> values) {
            addCriterion("fund_name in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotIn(List<String> values) {
            addCriterion("fund_name not in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameBetween(String value1, String value2) {
            addCriterion("fund_name between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotBetween(String value1, String value2) {
            addCriterion("fund_name not between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNull() {
            addCriterion("substrategy is null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNotNull() {
            addCriterion("substrategy is not null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyEqualTo(Integer value) {
            addCriterion("substrategy =", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotEqualTo(Integer value) {
            addCriterion("substrategy <>", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThan(Integer value) {
            addCriterion("substrategy >", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThanOrEqualTo(Integer value) {
            addCriterion("substrategy >=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThan(Integer value) {
            addCriterion("substrategy <", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThanOrEqualTo(Integer value) {
            addCriterion("substrategy <=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIn(List<Integer> values) {
            addCriterion("substrategy in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotIn(List<Integer> values) {
            addCriterion("substrategy not in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyBetween(Integer value1, Integer value2) {
            addCriterion("substrategy between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotBetween(Integer value1, Integer value2) {
            addCriterion("substrategy not between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andStrategyIsNull() {
            addCriterion("strategy is null");
            return (Criteria) this;
        }

        public Criteria andStrategyIsNotNull() {
            addCriterion("strategy is not null");
            return (Criteria) this;
        }

        public Criteria andStrategyEqualTo(Integer value) {
            addCriterion("strategy =", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotEqualTo(Integer value) {
            addCriterion("strategy <>", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyGreaterThan(Integer value) {
            addCriterion("strategy >", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyGreaterThanOrEqualTo(Integer value) {
            addCriterion("strategy >=", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyLessThan(Integer value) {
            addCriterion("strategy <", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyLessThanOrEqualTo(Integer value) {
            addCriterion("strategy <=", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyIn(List<Integer> values) {
            addCriterion("strategy in", values, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotIn(List<Integer> values) {
            addCriterion("strategy not in", values, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyBetween(Integer value1, Integer value2) {
            addCriterion("strategy between", value1, value2, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotBetween(Integer value1, Integer value2) {
            addCriterion("strategy not between", value1, value2, "strategy");
            return (Criteria) this;
        }

        public Criteria andManageNameIsNull() {
            addCriterion("manage_name is null");
            return (Criteria) this;
        }

        public Criteria andManageNameIsNotNull() {
            addCriterion("manage_name is not null");
            return (Criteria) this;
        }

        public Criteria andManageNameEqualTo(String value) {
            addCriterion("manage_name =", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameNotEqualTo(String value) {
            addCriterion("manage_name <>", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameGreaterThan(String value) {
            addCriterion("manage_name >", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameGreaterThanOrEqualTo(String value) {
            addCriterion("manage_name >=", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameLessThan(String value) {
            addCriterion("manage_name <", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameLessThanOrEqualTo(String value) {
            addCriterion("manage_name <=", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameLike(String value) {
            addCriterion("manage_name like", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameNotLike(String value) {
            addCriterion("manage_name not like", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameIn(List<String> values) {
            addCriterion("manage_name in", values, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameNotIn(List<String> values) {
            addCriterion("manage_name not in", values, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameBetween(String value1, String value2) {
            addCriterion("manage_name between", value1, value2, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameNotBetween(String value1, String value2) {
            addCriterion("manage_name not between", value1, value2, "manageName");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIsNull() {
            addCriterion("risk_level is null");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIsNotNull() {
            addCriterion("risk_level is not null");
            return (Criteria) this;
        }

        public Criteria andRiskLevelEqualTo(String value) {
            addCriterion("risk_level =", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotEqualTo(String value) {
            addCriterion("risk_level <>", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelGreaterThan(String value) {
            addCriterion("risk_level >", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelGreaterThanOrEqualTo(String value) {
            addCriterion("risk_level >=", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLessThan(String value) {
            addCriterion("risk_level <", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLessThanOrEqualTo(String value) {
            addCriterion("risk_level <=", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLike(String value) {
            addCriterion("risk_level like", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotLike(String value) {
            addCriterion("risk_level not like", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIn(List<String> values) {
            addCriterion("risk_level in", values, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotIn(List<String> values) {
            addCriterion("risk_level not in", values, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelBetween(String value1, String value2) {
            addCriterion("risk_level between", value1, value2, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotBetween(String value1, String value2) {
            addCriterion("risk_level not between", value1, value2, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIsNull() {
            addCriterion("inception_date is null");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIsNotNull() {
            addCriterion("inception_date is not null");
            return (Criteria) this;
        }

        public Criteria andInceptionDateEqualTo(Date value) {
            addCriterion("inception_date =", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotEqualTo(Date value) {
            addCriterion("inception_date <>", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateGreaterThan(Date value) {
            addCriterion("inception_date >", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateGreaterThanOrEqualTo(Date value) {
            addCriterion("inception_date >=", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateLessThan(Date value) {
            addCriterion("inception_date <", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateLessThanOrEqualTo(Date value) {
            addCriterion("inception_date <=", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIn(List<Date> values) {
            addCriterion("inception_date in", values, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotIn(List<Date> values) {
            addCriterion("inception_date not in", values, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateBetween(Date value1, Date value2) {
            addCriterion("inception_date between", value1, value2, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotBetween(Date value1, Date value2) {
            addCriterion("inception_date not between", value1, value2, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIsNull() {
            addCriterion("register_number is null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIsNotNull() {
            addCriterion("register_number is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberEqualTo(String value) {
            addCriterion("register_number =", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotEqualTo(String value) {
            addCriterion("register_number <>", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberGreaterThan(String value) {
            addCriterion("register_number >", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberGreaterThanOrEqualTo(String value) {
            addCriterion("register_number >=", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLessThan(String value) {
            addCriterion("register_number <", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLessThanOrEqualTo(String value) {
            addCriterion("register_number <=", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLike(String value) {
            addCriterion("register_number like", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotLike(String value) {
            addCriterion("register_number not like", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIn(List<String> values) {
            addCriterion("register_number in", values, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotIn(List<String> values) {
            addCriterion("register_number not in", values, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberBetween(String value1, String value2) {
            addCriterion("register_number between", value1, value2, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotBetween(String value1, String value2) {
            addCriterion("register_number not between", value1, value2, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andOpenDayIsNull() {
            addCriterion("open_day is null");
            return (Criteria) this;
        }

        public Criteria andOpenDayIsNotNull() {
            addCriterion("open_day is not null");
            return (Criteria) this;
        }

        public Criteria andOpenDayEqualTo(String value) {
            addCriterion("open_day =", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotEqualTo(String value) {
            addCriterion("open_day <>", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayGreaterThan(String value) {
            addCriterion("open_day >", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayGreaterThanOrEqualTo(String value) {
            addCriterion("open_day >=", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLessThan(String value) {
            addCriterion("open_day <", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLessThanOrEqualTo(String value) {
            addCriterion("open_day <=", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLike(String value) {
            addCriterion("open_day like", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotLike(String value) {
            addCriterion("open_day not like", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayIn(List<String> values) {
            addCriterion("open_day in", values, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotIn(List<String> values) {
            addCriterion("open_day not in", values, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayBetween(String value1, String value2) {
            addCriterion("open_day between", value1, value2, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotBetween(String value1, String value2) {
            addCriterion("open_day not between", value1, value2, "openDay");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIsNull() {
            addCriterion("min_investment_share is null");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIsNotNull() {
            addCriterion("min_investment_share is not null");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareEqualTo(BigDecimal value) {
            addCriterion("min_investment_share =", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotEqualTo(BigDecimal value) {
            addCriterion("min_investment_share <>", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareGreaterThan(BigDecimal value) {
            addCriterion("min_investment_share >", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("min_investment_share >=", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareLessThan(BigDecimal value) {
            addCriterion("min_investment_share <", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("min_investment_share <=", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIn(List<BigDecimal> values) {
            addCriterion("min_investment_share in", values, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotIn(List<BigDecimal> values) {
            addCriterion("min_investment_share not in", values, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("min_investment_share between", value1, value2, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("min_investment_share not between", value1, value2, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIsNull() {
            addCriterion("subsequent_investment_share is null");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIsNotNull() {
            addCriterion("subsequent_investment_share is not null");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share =", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share <>", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareGreaterThan(BigDecimal value) {
            addCriterion("subsequent_investment_share >", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share >=", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareLessThan(BigDecimal value) {
            addCriterion("subsequent_investment_share <", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share <=", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIn(List<BigDecimal> values) {
            addCriterion("subsequent_investment_share in", values, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotIn(List<BigDecimal> values) {
            addCriterion("subsequent_investment_share not in", values, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subsequent_investment_share between", value1, value2, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subsequent_investment_share not between", value1, value2, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIsNull() {
            addCriterion("subscription_fee is null");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIsNotNull() {
            addCriterion("subscription_fee is not null");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeEqualTo(BigDecimal value) {
            addCriterion("subscription_fee =", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotEqualTo(BigDecimal value) {
            addCriterion("subscription_fee <>", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeGreaterThan(BigDecimal value) {
            addCriterion("subscription_fee >", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("subscription_fee >=", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeLessThan(BigDecimal value) {
            addCriterion("subscription_fee <", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("subscription_fee <=", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIn(List<BigDecimal> values) {
            addCriterion("subscription_fee in", values, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotIn(List<BigDecimal> values) {
            addCriterion("subscription_fee not in", values, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subscription_fee between", value1, value2, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subscription_fee not between", value1, value2, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIsNull() {
            addCriterion("redemption_fee is null");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIsNotNull() {
            addCriterion("redemption_fee is not null");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeEqualTo(BigDecimal value) {
            addCriterion("redemption_fee =", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotEqualTo(BigDecimal value) {
            addCriterion("redemption_fee <>", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeGreaterThan(BigDecimal value) {
            addCriterion("redemption_fee >", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("redemption_fee >=", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeLessThan(BigDecimal value) {
            addCriterion("redemption_fee <", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("redemption_fee <=", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIn(List<BigDecimal> values) {
            addCriterion("redemption_fee in", values, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotIn(List<BigDecimal> values) {
            addCriterion("redemption_fee not in", values, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("redemption_fee between", value1, value2, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("redemption_fee not between", value1, value2, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeIsNull() {
            addCriterion("management_fee is null");
            return (Criteria) this;
        }

        public Criteria andManagementFeeIsNotNull() {
            addCriterion("management_fee is not null");
            return (Criteria) this;
        }

        public Criteria andManagementFeeEqualTo(BigDecimal value) {
            addCriterion("management_fee =", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeNotEqualTo(BigDecimal value) {
            addCriterion("management_fee <>", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeGreaterThan(BigDecimal value) {
            addCriterion("management_fee >", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("management_fee >=", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeLessThan(BigDecimal value) {
            addCriterion("management_fee <", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("management_fee <=", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeIn(List<BigDecimal> values) {
            addCriterion("management_fee in", values, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeNotIn(List<BigDecimal> values) {
            addCriterion("management_fee not in", values, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("management_fee between", value1, value2, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("management_fee not between", value1, value2, "managementFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIsNull() {
            addCriterion("performance_fee is null");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIsNotNull() {
            addCriterion("performance_fee is not null");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeEqualTo(BigDecimal value) {
            addCriterion("performance_fee =", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotEqualTo(BigDecimal value) {
            addCriterion("performance_fee <>", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeGreaterThan(BigDecimal value) {
            addCriterion("performance_fee >", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("performance_fee >=", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeLessThan(BigDecimal value) {
            addCriterion("performance_fee <", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("performance_fee <=", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIn(List<BigDecimal> values) {
            addCriterion("performance_fee in", values, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotIn(List<BigDecimal> values) {
            addCriterion("performance_fee not in", values, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("performance_fee between", value1, value2, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("performance_fee not between", value1, value2, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodIsNull() {
            addCriterion("performance_calculate_method is null");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodIsNotNull() {
            addCriterion("performance_calculate_method is not null");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodEqualTo(String value) {
            addCriterion("performance_calculate_method =", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodNotEqualTo(String value) {
            addCriterion("performance_calculate_method <>", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodGreaterThan(String value) {
            addCriterion("performance_calculate_method >", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodGreaterThanOrEqualTo(String value) {
            addCriterion("performance_calculate_method >=", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodLessThan(String value) {
            addCriterion("performance_calculate_method <", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodLessThanOrEqualTo(String value) {
            addCriterion("performance_calculate_method <=", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodLike(String value) {
            addCriterion("performance_calculate_method like", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodNotLike(String value) {
            addCriterion("performance_calculate_method not like", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodIn(List<String> values) {
            addCriterion("performance_calculate_method in", values, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodNotIn(List<String> values) {
            addCriterion("performance_calculate_method not in", values, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodBetween(String value1, String value2) {
            addCriterion("performance_calculate_method between", value1, value2, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodNotBetween(String value1, String value2) {
            addCriterion("performance_calculate_method not between", value1, value2, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andIfaIdIsNull() {
            addCriterion("ifa_id is null");
            return (Criteria) this;
        }

        public Criteria andIfaIdIsNotNull() {
            addCriterion("ifa_id is not null");
            return (Criteria) this;
        }

        public Criteria andIfaIdEqualTo(String value) {
            addCriterion("ifa_id =", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdNotEqualTo(String value) {
            addCriterion("ifa_id <>", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdGreaterThan(String value) {
            addCriterion("ifa_id >", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdGreaterThanOrEqualTo(String value) {
            addCriterion("ifa_id >=", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdLessThan(String value) {
            addCriterion("ifa_id <", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdLessThanOrEqualTo(String value) {
            addCriterion("ifa_id <=", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdLike(String value) {
            addCriterion("ifa_id like", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdNotLike(String value) {
            addCriterion("ifa_id not like", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdIn(List<String> values) {
            addCriterion("ifa_id in", values, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdNotIn(List<String> values) {
            addCriterion("ifa_id not in", values, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdBetween(String value1, String value2) {
            addCriterion("ifa_id between", value1, value2, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdNotBetween(String value1, String value2) {
            addCriterion("ifa_id not between", value1, value2, "ifaId");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNull() {
            addCriterion("price_date is null");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNotNull() {
            addCriterion("price_date is not null");
            return (Criteria) this;
        }

        public Criteria andPriceDateEqualTo(Date value) {
            addCriterionForJDBCDate("price_date =", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <>", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThan(Date value) {
            addCriterionForJDBCDate("price_date >", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date >=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThan(Date value) {
            addCriterionForJDBCDate("price_date <", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateIn(List<Date> values) {
            addCriterionForJDBCDate("price_date in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("price_date not in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date not between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andNetNavIsNull() {
            addCriterion("net_nav is null");
            return (Criteria) this;
        }

        public Criteria andNetNavIsNotNull() {
            addCriterion("net_nav is not null");
            return (Criteria) this;
        }

        public Criteria andNetNavEqualTo(BigDecimal value) {
            addCriterion("net_nav =", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavNotEqualTo(BigDecimal value) {
            addCriterion("net_nav <>", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavGreaterThan(BigDecimal value) {
            addCriterion("net_nav >", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("net_nav >=", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavLessThan(BigDecimal value) {
            addCriterion("net_nav <", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavLessThanOrEqualTo(BigDecimal value) {
            addCriterion("net_nav <=", value, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavIn(List<BigDecimal> values) {
            addCriterion("net_nav in", values, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavNotIn(List<BigDecimal> values) {
            addCriterion("net_nav not in", values, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("net_nav between", value1, value2, "netNav");
            return (Criteria) this;
        }

        public Criteria andNetNavNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("net_nav not between", value1, value2, "netNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNull() {
            addCriterion("cumulative_nav is null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNotNull() {
            addCriterion("cumulative_nav is not null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav =", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav <>", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThan(BigDecimal value) {
            addCriterion("cumulative_nav >", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav >=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThan(BigDecimal value) {
            addCriterion("cumulative_nav <", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav <=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIn(List<BigDecimal> values) {
            addCriterion("cumulative_nav in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotIn(List<BigDecimal> values) {
            addCriterion("cumulative_nav not in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cumulative_nav between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cumulative_nav not between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andRet1wIsNull() {
            addCriterion("ret_1w is null");
            return (Criteria) this;
        }

        public Criteria andRet1wIsNotNull() {
            addCriterion("ret_1w is not null");
            return (Criteria) this;
        }

        public Criteria andRet1wEqualTo(BigDecimal value) {
            addCriterion("ret_1w =", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotEqualTo(BigDecimal value) {
            addCriterion("ret_1w <>", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wGreaterThan(BigDecimal value) {
            addCriterion("ret_1w >", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w >=", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wLessThan(BigDecimal value) {
            addCriterion("ret_1w <", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w <=", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wIn(List<BigDecimal> values) {
            addCriterion("ret_1w in", values, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotIn(List<BigDecimal> values) {
            addCriterion("ret_1w not in", values, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w between", value1, value2, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w not between", value1, value2, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNull() {
            addCriterion("ret_1m is null");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNotNull() {
            addCriterion("ret_1m is not null");
            return (Criteria) this;
        }

        public Criteria andRet1mEqualTo(BigDecimal value) {
            addCriterion("ret_1m =", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotEqualTo(BigDecimal value) {
            addCriterion("ret_1m <>", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThan(BigDecimal value) {
            addCriterion("ret_1m >", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m >=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThan(BigDecimal value) {
            addCriterion("ret_1m <", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m <=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mIn(List<BigDecimal> values) {
            addCriterion("ret_1m in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotIn(List<BigDecimal> values) {
            addCriterion("ret_1m not in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m not between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNull() {
            addCriterion("ret_6m is null");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNotNull() {
            addCriterion("ret_6m is not null");
            return (Criteria) this;
        }

        public Criteria andRet6mEqualTo(BigDecimal value) {
            addCriterion("ret_6m =", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotEqualTo(BigDecimal value) {
            addCriterion("ret_6m <>", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThan(BigDecimal value) {
            addCriterion("ret_6m >", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m >=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThan(BigDecimal value) {
            addCriterion("ret_6m <", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m <=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mIn(List<BigDecimal> values) {
            addCriterion("ret_6m in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotIn(List<BigDecimal> values) {
            addCriterion("ret_6m not in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m not between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNull() {
            addCriterion("ret_1y is null");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNotNull() {
            addCriterion("ret_1y is not null");
            return (Criteria) this;
        }

        public Criteria andRet1yEqualTo(BigDecimal value) {
            addCriterion("ret_1y =", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotEqualTo(BigDecimal value) {
            addCriterion("ret_1y <>", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThan(BigDecimal value) {
            addCriterion("ret_1y >", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y >=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThan(BigDecimal value) {
            addCriterion("ret_1y <", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y <=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yIn(List<BigDecimal> values) {
            addCriterion("ret_1y in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotIn(List<BigDecimal> values) {
            addCriterion("ret_1y not in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y not between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNull() {
            addCriterion("ret_incep is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNotNull() {
            addCriterion("ret_incep is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepEqualTo(BigDecimal value) {
            addCriterion("ret_incep =", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotEqualTo(BigDecimal value) {
            addCriterion("ret_incep <>", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThan(BigDecimal value) {
            addCriterion("ret_incep >", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep >=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThan(BigDecimal value) {
            addCriterion("ret_incep <", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep <=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepIn(List<BigDecimal> values) {
            addCriterion("ret_incep in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotIn(List<BigDecimal> values) {
            addCriterion("ret_incep not in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep not between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIsNull() {
            addCriterion("sharperatio_incep is null");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIsNotNull() {
            addCriterion("sharperatio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep =", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep <>", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_incep >", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep >=", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepLessThan(BigDecimal value) {
            addCriterion("sharperatio_incep <", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep <=", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIn(List<BigDecimal> values) {
            addCriterion("sharperatio_incep in", values, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_incep not in", values, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_incep between", value1, value2, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_incep not between", value1, value2, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIsNull() {
            addCriterion("sharperatio_1y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIsNotNull() {
            addCriterion("sharperatio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y =", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y <>", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_1y >", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y >=", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yLessThan(BigDecimal value) {
            addCriterion("sharperatio_1y <", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y <=", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_1y in", values, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_1y not in", values, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_1y between", value1, value2, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_1y not between", value1, value2, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIsNull() {
            addCriterion("sharperatio_2y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIsNotNull() {
            addCriterion("sharperatio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y =", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y <>", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_2y >", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y >=", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yLessThan(BigDecimal value) {
            addCriterion("sharperatio_2y <", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y <=", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_2y in", values, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_2y not in", values, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_2y between", value1, value2, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_2y not between", value1, value2, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIsNull() {
            addCriterion("sharperatio_3y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIsNotNull() {
            addCriterion("sharperatio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y =", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y <>", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_3y >", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y >=", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yLessThan(BigDecimal value) {
            addCriterion("sharperatio_3y <", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y <=", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_3y in", values, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_3y not in", values, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_3y between", value1, value2, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_3y not between", value1, value2, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIsNull() {
            addCriterion("sharperatio_4y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIsNotNull() {
            addCriterion("sharperatio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y =", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y <>", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_4y >", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y >=", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yLessThan(BigDecimal value) {
            addCriterion("sharperatio_4y <", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y <=", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_4y in", values, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_4y not in", values, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_4y between", value1, value2, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_4y not between", value1, value2, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIsNull() {
            addCriterion("sharperatio_5y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIsNotNull() {
            addCriterion("sharperatio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y =", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y <>", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_5y >", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y >=", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yLessThan(BigDecimal value) {
            addCriterion("sharperatio_5y <", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y <=", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_5y in", values, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_5y not in", values, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_5y between", value1, value2, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_5y not between", value1, value2, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andStddev1yIsNull() {
            addCriterion("stddev_1y is null");
            return (Criteria) this;
        }

        public Criteria andStddev1yIsNotNull() {
            addCriterion("stddev_1y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev1yEqualTo(BigDecimal value) {
            addCriterion("stddev_1y =", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_1y <>", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yGreaterThan(BigDecimal value) {
            addCriterion("stddev_1y >", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_1y >=", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yLessThan(BigDecimal value) {
            addCriterion("stddev_1y <", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_1y <=", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yIn(List<BigDecimal> values) {
            addCriterion("stddev_1y in", values, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_1y not in", values, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_1y between", value1, value2, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_1y not between", value1, value2, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev2yIsNull() {
            addCriterion("stddev_2y is null");
            return (Criteria) this;
        }

        public Criteria andStddev2yIsNotNull() {
            addCriterion("stddev_2y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev2yEqualTo(BigDecimal value) {
            addCriterion("stddev_2y =", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_2y <>", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yGreaterThan(BigDecimal value) {
            addCriterion("stddev_2y >", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_2y >=", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yLessThan(BigDecimal value) {
            addCriterion("stddev_2y <", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_2y <=", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yIn(List<BigDecimal> values) {
            addCriterion("stddev_2y in", values, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_2y not in", values, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_2y between", value1, value2, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_2y not between", value1, value2, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev3yIsNull() {
            addCriterion("stddev_3y is null");
            return (Criteria) this;
        }

        public Criteria andStddev3yIsNotNull() {
            addCriterion("stddev_3y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev3yEqualTo(BigDecimal value) {
            addCriterion("stddev_3y =", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_3y <>", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yGreaterThan(BigDecimal value) {
            addCriterion("stddev_3y >", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_3y >=", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yLessThan(BigDecimal value) {
            addCriterion("stddev_3y <", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_3y <=", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yIn(List<BigDecimal> values) {
            addCriterion("stddev_3y in", values, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_3y not in", values, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_3y between", value1, value2, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_3y not between", value1, value2, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev4yIsNull() {
            addCriterion("stddev_4y is null");
            return (Criteria) this;
        }

        public Criteria andStddev4yIsNotNull() {
            addCriterion("stddev_4y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev4yEqualTo(BigDecimal value) {
            addCriterion("stddev_4y =", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_4y <>", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yGreaterThan(BigDecimal value) {
            addCriterion("stddev_4y >", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_4y >=", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yLessThan(BigDecimal value) {
            addCriterion("stddev_4y <", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_4y <=", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yIn(List<BigDecimal> values) {
            addCriterion("stddev_4y in", values, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_4y not in", values, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_4y between", value1, value2, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_4y not between", value1, value2, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev5yIsNull() {
            addCriterion("stddev_5y is null");
            return (Criteria) this;
        }

        public Criteria andStddev5yIsNotNull() {
            addCriterion("stddev_5y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev5yEqualTo(BigDecimal value) {
            addCriterion("stddev_5y =", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_5y <>", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yGreaterThan(BigDecimal value) {
            addCriterion("stddev_5y >", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_5y >=", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yLessThan(BigDecimal value) {
            addCriterion("stddev_5y <", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_5y <=", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yIn(List<BigDecimal> values) {
            addCriterion("stddev_5y in", values, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_5y not in", values, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_5y between", value1, value2, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_5y not between", value1, value2, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIsNull() {
            addCriterion("stddev_incep is null");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIsNotNull() {
            addCriterion("stddev_incep is not null");
            return (Criteria) this;
        }

        public Criteria andStddevIncepEqualTo(BigDecimal value) {
            addCriterion("stddev_incep =", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotEqualTo(BigDecimal value) {
            addCriterion("stddev_incep <>", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepGreaterThan(BigDecimal value) {
            addCriterion("stddev_incep >", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_incep >=", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepLessThan(BigDecimal value) {
            addCriterion("stddev_incep <", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_incep <=", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIn(List<BigDecimal> values) {
            addCriterion("stddev_incep in", values, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotIn(List<BigDecimal> values) {
            addCriterion("stddev_incep not in", values, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_incep between", value1, value2, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_incep not between", value1, value2, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIsNull() {
            addCriterion("maxdrawdown_1y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIsNotNull() {
            addCriterion("maxdrawdown_1y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y =", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y <>", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_1y >", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y >=", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_1y <", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y <=", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_1y in", values, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_1y not in", values, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_1y between", value1, value2, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_1y not between", value1, value2, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIsNull() {
            addCriterion("maxdrawdown_2y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIsNotNull() {
            addCriterion("maxdrawdown_2y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y =", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y <>", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_2y >", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y >=", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_2y <", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y <=", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_2y in", values, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_2y not in", values, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_2y between", value1, value2, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_2y not between", value1, value2, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIsNull() {
            addCriterion("maxdrawdown_3y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIsNotNull() {
            addCriterion("maxdrawdown_3y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y =", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y <>", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_3y >", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y >=", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_3y <", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y <=", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_3y in", values, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_3y not in", values, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_3y between", value1, value2, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_3y not between", value1, value2, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIsNull() {
            addCriterion("maxdrawdown_4y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIsNotNull() {
            addCriterion("maxdrawdown_4y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y =", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y <>", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_4y >", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y >=", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_4y <", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y <=", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_4y in", values, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_4y not in", values, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_4y between", value1, value2, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_4y not between", value1, value2, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIsNull() {
            addCriterion("maxdrawdown_5y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIsNotNull() {
            addCriterion("maxdrawdown_5y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y =", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y <>", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_5y >", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y >=", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_5y <", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y <=", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_5y in", values, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_5y not in", values, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_5y between", value1, value2, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_5y not between", value1, value2, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIsNull() {
            addCriterion("maxdrawdown_incep is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIsNotNull() {
            addCriterion("maxdrawdown_incep is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep =", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep <>", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_incep >", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep >=", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_incep <", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep <=", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_incep in", values, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_incep not in", values, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_incep between", value1, value2, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_incep not between", value1, value2, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andZScoreIsNull() {
            addCriterion("z_score is null");
            return (Criteria) this;
        }

        public Criteria andZScoreIsNotNull() {
            addCriterion("z_score is not null");
            return (Criteria) this;
        }

        public Criteria andZScoreEqualTo(Double value) {
            addCriterion("z_score =", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreNotEqualTo(Double value) {
            addCriterion("z_score <>", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreGreaterThan(Double value) {
            addCriterion("z_score >", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreGreaterThanOrEqualTo(Double value) {
            addCriterion("z_score >=", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreLessThan(Double value) {
            addCriterion("z_score <", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreLessThanOrEqualTo(Double value) {
            addCriterion("z_score <=", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreIn(List<Double> values) {
            addCriterion("z_score in", values, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreNotIn(List<Double> values) {
            addCriterion("z_score not in", values, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreBetween(Double value1, Double value2) {
            addCriterion("z_score between", value1, value2, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreNotBetween(Double value1, Double value2) {
            addCriterion("z_score not between", value1, value2, "zScore");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}