package com.tanpu.fund.entity.generator;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class IndexDaily {
    private Double close;

    private Double open;

    private Double high;

    private Double low;

    private Double preClose;

    private Double change;

    private Double pctChg;

    private Double vol;

    private Double amount;

    /**
    * 机构id
    */
    private String orgId;

    private String tsCode;

    private String tradeDate;
}