package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class IndexesProfileExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public IndexesProfileExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIndexIdIsNull() {
            addCriterion("index_id is null");
            return (Criteria) this;
        }

        public Criteria andIndexIdIsNotNull() {
            addCriterion("index_id is not null");
            return (Criteria) this;
        }

        public Criteria andIndexIdEqualTo(String value) {
            addCriterion("index_id =", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotEqualTo(String value) {
            addCriterion("index_id <>", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdGreaterThan(String value) {
            addCriterion("index_id >", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdGreaterThanOrEqualTo(String value) {
            addCriterion("index_id >=", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdLessThan(String value) {
            addCriterion("index_id <", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdLessThanOrEqualTo(String value) {
            addCriterion("index_id <=", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdLike(String value) {
            addCriterion("index_id like", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotLike(String value) {
            addCriterion("index_id not like", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdIn(List<String> values) {
            addCriterion("index_id in", values, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotIn(List<String> values) {
            addCriterion("index_id not in", values, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdBetween(String value1, String value2) {
            addCriterion("index_id between", value1, value2, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotBetween(String value1, String value2) {
            addCriterion("index_id not between", value1, value2, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdIsNull() {
            addCriterion("index_type_id is null");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdIsNotNull() {
            addCriterion("index_type_id is not null");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdEqualTo(Integer value) {
            addCriterion("index_type_id =", value, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdNotEqualTo(Integer value) {
            addCriterion("index_type_id <>", value, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdGreaterThan(Integer value) {
            addCriterion("index_type_id >", value, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("index_type_id >=", value, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdLessThan(Integer value) {
            addCriterion("index_type_id <", value, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdLessThanOrEqualTo(Integer value) {
            addCriterion("index_type_id <=", value, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdIn(List<Integer> values) {
            addCriterion("index_type_id in", values, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdNotIn(List<Integer> values) {
            addCriterion("index_type_id not in", values, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdBetween(Integer value1, Integer value2) {
            addCriterion("index_type_id between", value1, value2, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexTypeIdNotBetween(Integer value1, Integer value2) {
            addCriterion("index_type_id not between", value1, value2, "indexTypeId");
            return (Criteria) this;
        }

        public Criteria andIndexCodeIsNull() {
            addCriterion("index_code is null");
            return (Criteria) this;
        }

        public Criteria andIndexCodeIsNotNull() {
            addCriterion("index_code is not null");
            return (Criteria) this;
        }

        public Criteria andIndexCodeEqualTo(String value) {
            addCriterion("index_code =", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeNotEqualTo(String value) {
            addCriterion("index_code <>", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeGreaterThan(String value) {
            addCriterion("index_code >", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeGreaterThanOrEqualTo(String value) {
            addCriterion("index_code >=", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeLessThan(String value) {
            addCriterion("index_code <", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeLessThanOrEqualTo(String value) {
            addCriterion("index_code <=", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeLike(String value) {
            addCriterion("index_code like", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeNotLike(String value) {
            addCriterion("index_code not like", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeIn(List<String> values) {
            addCriterion("index_code in", values, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeNotIn(List<String> values) {
            addCriterion("index_code not in", values, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeBetween(String value1, String value2) {
            addCriterion("index_code between", value1, value2, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeNotBetween(String value1, String value2) {
            addCriterion("index_code not between", value1, value2, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexNameIsNull() {
            addCriterion("index_name is null");
            return (Criteria) this;
        }

        public Criteria andIndexNameIsNotNull() {
            addCriterion("index_name is not null");
            return (Criteria) this;
        }

        public Criteria andIndexNameEqualTo(String value) {
            addCriterion("index_name =", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameNotEqualTo(String value) {
            addCriterion("index_name <>", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameGreaterThan(String value) {
            addCriterion("index_name >", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameGreaterThanOrEqualTo(String value) {
            addCriterion("index_name >=", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameLessThan(String value) {
            addCriterion("index_name <", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameLessThanOrEqualTo(String value) {
            addCriterion("index_name <=", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameLike(String value) {
            addCriterion("index_name like", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameNotLike(String value) {
            addCriterion("index_name not like", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameIn(List<String> values) {
            addCriterion("index_name in", values, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameNotIn(List<String> values) {
            addCriterion("index_name not in", values, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameBetween(String value1, String value2) {
            addCriterion("index_name between", value1, value2, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameNotBetween(String value1, String value2) {
            addCriterion("index_name not between", value1, value2, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameIsNull() {
            addCriterion("index_short_name is null");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameIsNotNull() {
            addCriterion("index_short_name is not null");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameEqualTo(String value) {
            addCriterion("index_short_name =", value, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameNotEqualTo(String value) {
            addCriterion("index_short_name <>", value, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameGreaterThan(String value) {
            addCriterion("index_short_name >", value, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameGreaterThanOrEqualTo(String value) {
            addCriterion("index_short_name >=", value, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameLessThan(String value) {
            addCriterion("index_short_name <", value, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameLessThanOrEqualTo(String value) {
            addCriterion("index_short_name <=", value, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameLike(String value) {
            addCriterion("index_short_name like", value, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameNotLike(String value) {
            addCriterion("index_short_name not like", value, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameIn(List<String> values) {
            addCriterion("index_short_name in", values, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameNotIn(List<String> values) {
            addCriterion("index_short_name not in", values, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameBetween(String value1, String value2) {
            addCriterion("index_short_name between", value1, value2, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexShortNameNotBetween(String value1, String value2) {
            addCriterion("index_short_name not between", value1, value2, "indexShortName");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagIsNull() {
            addCriterion("index_area_flag is null");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagIsNotNull() {
            addCriterion("index_area_flag is not null");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagEqualTo(Integer value) {
            addCriterion("index_area_flag =", value, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagNotEqualTo(Integer value) {
            addCriterion("index_area_flag <>", value, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagGreaterThan(Integer value) {
            addCriterion("index_area_flag >", value, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagGreaterThanOrEqualTo(Integer value) {
            addCriterion("index_area_flag >=", value, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagLessThan(Integer value) {
            addCriterion("index_area_flag <", value, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagLessThanOrEqualTo(Integer value) {
            addCriterion("index_area_flag <=", value, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagIn(List<Integer> values) {
            addCriterion("index_area_flag in", values, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagNotIn(List<Integer> values) {
            addCriterion("index_area_flag not in", values, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagBetween(Integer value1, Integer value2) {
            addCriterion("index_area_flag between", value1, value2, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexAreaFlagNotBetween(Integer value1, Integer value2) {
            addCriterion("index_area_flag not between", value1, value2, "indexAreaFlag");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdIsNull() {
            addCriterion("index_family_id is null");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdIsNotNull() {
            addCriterion("index_family_id is not null");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdEqualTo(String value) {
            addCriterion("index_family_id =", value, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdNotEqualTo(String value) {
            addCriterion("index_family_id <>", value, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdGreaterThan(String value) {
            addCriterion("index_family_id >", value, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdGreaterThanOrEqualTo(String value) {
            addCriterion("index_family_id >=", value, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdLessThan(String value) {
            addCriterion("index_family_id <", value, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdLessThanOrEqualTo(String value) {
            addCriterion("index_family_id <=", value, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdLike(String value) {
            addCriterion("index_family_id like", value, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdNotLike(String value) {
            addCriterion("index_family_id not like", value, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdIn(List<String> values) {
            addCriterion("index_family_id in", values, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdNotIn(List<String> values) {
            addCriterion("index_family_id not in", values, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdBetween(String value1, String value2) {
            addCriterion("index_family_id between", value1, value2, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andIndexFamilyIdNotBetween(String value1, String value2) {
            addCriterion("index_family_id not between", value1, value2, "indexFamilyId");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyIsNull() {
            addCriterion("pricing_frequency is null");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyIsNotNull() {
            addCriterion("pricing_frequency is not null");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyEqualTo(Integer value) {
            addCriterion("pricing_frequency =", value, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyNotEqualTo(Integer value) {
            addCriterion("pricing_frequency <>", value, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyGreaterThan(Integer value) {
            addCriterion("pricing_frequency >", value, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyGreaterThanOrEqualTo(Integer value) {
            addCriterion("pricing_frequency >=", value, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyLessThan(Integer value) {
            addCriterion("pricing_frequency <", value, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyLessThanOrEqualTo(Integer value) {
            addCriterion("pricing_frequency <=", value, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyIn(List<Integer> values) {
            addCriterion("pricing_frequency in", values, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyNotIn(List<Integer> values) {
            addCriterion("pricing_frequency not in", values, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyBetween(Integer value1, Integer value2) {
            addCriterion("pricing_frequency between", value1, value2, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andPricingFrequencyNotBetween(Integer value1, Integer value2) {
            addCriterion("pricing_frequency not between", value1, value2, "pricingFrequency");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIsNull() {
            addCriterion("inception_date is null");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIsNotNull() {
            addCriterion("inception_date is not null");
            return (Criteria) this;
        }

        public Criteria andInceptionDateEqualTo(Date value) {
            addCriterionForJDBCDate("inception_date =", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("inception_date <>", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateGreaterThan(Date value) {
            addCriterionForJDBCDate("inception_date >", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("inception_date >=", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateLessThan(Date value) {
            addCriterionForJDBCDate("inception_date <", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("inception_date <=", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIn(List<Date> values) {
            addCriterionForJDBCDate("inception_date in", values, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("inception_date not in", values, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("inception_date between", value1, value2, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("inception_date not between", value1, value2, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueIsNull() {
            addCriterion("index_initial_value is null");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueIsNotNull() {
            addCriterion("index_initial_value is not null");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueEqualTo(BigDecimal value) {
            addCriterion("index_initial_value =", value, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueNotEqualTo(BigDecimal value) {
            addCriterion("index_initial_value <>", value, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueGreaterThan(BigDecimal value) {
            addCriterion("index_initial_value >", value, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("index_initial_value >=", value, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueLessThan(BigDecimal value) {
            addCriterion("index_initial_value <", value, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("index_initial_value <=", value, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueIn(List<BigDecimal> values) {
            addCriterion("index_initial_value in", values, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueNotIn(List<BigDecimal> values) {
            addCriterion("index_initial_value not in", values, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("index_initial_value between", value1, value2, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andIndexInitialValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("index_initial_value not between", value1, value2, "indexInitialValue");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyIsNull() {
            addCriterion("base_currency is null");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyIsNotNull() {
            addCriterion("base_currency is not null");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyEqualTo(Integer value) {
            addCriterion("base_currency =", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyNotEqualTo(Integer value) {
            addCriterion("base_currency <>", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyGreaterThan(Integer value) {
            addCriterion("base_currency >", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyGreaterThanOrEqualTo(Integer value) {
            addCriterion("base_currency >=", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyLessThan(Integer value) {
            addCriterion("base_currency <", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyLessThanOrEqualTo(Integer value) {
            addCriterion("base_currency <=", value, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyIn(List<Integer> values) {
            addCriterion("base_currency in", values, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyNotIn(List<Integer> values) {
            addCriterion("base_currency not in", values, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyBetween(Integer value1, Integer value2) {
            addCriterion("base_currency between", value1, value2, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyNotBetween(Integer value1, Integer value2) {
            addCriterion("base_currency not between", value1, value2, "baseCurrency");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodIsNull() {
            addCriterion("calculation_method is null");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodIsNotNull() {
            addCriterion("calculation_method is not null");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodEqualTo(String value) {
            addCriterion("calculation_method =", value, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodNotEqualTo(String value) {
            addCriterion("calculation_method <>", value, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodGreaterThan(String value) {
            addCriterion("calculation_method >", value, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodGreaterThanOrEqualTo(String value) {
            addCriterion("calculation_method >=", value, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodLessThan(String value) {
            addCriterion("calculation_method <", value, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodLessThanOrEqualTo(String value) {
            addCriterion("calculation_method <=", value, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodLike(String value) {
            addCriterion("calculation_method like", value, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodNotLike(String value) {
            addCriterion("calculation_method not like", value, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodIn(List<String> values) {
            addCriterion("calculation_method in", values, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodNotIn(List<String> values) {
            addCriterion("calculation_method not in", values, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodBetween(String value1, String value2) {
            addCriterion("calculation_method between", value1, value2, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andCalculationMethodNotBetween(String value1, String value2) {
            addCriterion("calculation_method not between", value1, value2, "calculationMethod");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeIsNull() {
            addCriterion("weighting_scheme is null");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeIsNotNull() {
            addCriterion("weighting_scheme is not null");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeEqualTo(String value) {
            addCriterion("weighting_scheme =", value, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeNotEqualTo(String value) {
            addCriterion("weighting_scheme <>", value, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeGreaterThan(String value) {
            addCriterion("weighting_scheme >", value, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeGreaterThanOrEqualTo(String value) {
            addCriterion("weighting_scheme >=", value, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeLessThan(String value) {
            addCriterion("weighting_scheme <", value, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeLessThanOrEqualTo(String value) {
            addCriterion("weighting_scheme <=", value, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeLike(String value) {
            addCriterion("weighting_scheme like", value, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeNotLike(String value) {
            addCriterion("weighting_scheme not like", value, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeIn(List<String> values) {
            addCriterion("weighting_scheme in", values, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeNotIn(List<String> values) {
            addCriterion("weighting_scheme not in", values, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeBetween(String value1, String value2) {
            addCriterion("weighting_scheme between", value1, value2, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andWeightingSchemeNotBetween(String value1, String value2) {
            addCriterion("weighting_scheme not between", value1, value2, "weightingScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeIsNull() {
            addCriterion("selection_scheme is null");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeIsNotNull() {
            addCriterion("selection_scheme is not null");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeEqualTo(String value) {
            addCriterion("selection_scheme =", value, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeNotEqualTo(String value) {
            addCriterion("selection_scheme <>", value, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeGreaterThan(String value) {
            addCriterion("selection_scheme >", value, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeGreaterThanOrEqualTo(String value) {
            addCriterion("selection_scheme >=", value, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeLessThan(String value) {
            addCriterion("selection_scheme <", value, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeLessThanOrEqualTo(String value) {
            addCriterion("selection_scheme <=", value, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeLike(String value) {
            addCriterion("selection_scheme like", value, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeNotLike(String value) {
            addCriterion("selection_scheme not like", value, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeIn(List<String> values) {
            addCriterion("selection_scheme in", values, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeNotIn(List<String> values) {
            addCriterion("selection_scheme not in", values, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeBetween(String value1, String value2) {
            addCriterion("selection_scheme between", value1, value2, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andSelectionSchemeNotBetween(String value1, String value2) {
            addCriterion("selection_scheme not between", value1, value2, "selectionScheme");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}