package com.tanpu.fund.entity.generator;

import java.util.ArrayList;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class NewFundRankExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public NewFundRankExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andIndexIsNull() {
            addCriterion("`index` is null");
            return (Criteria) this;
        }

        public Criteria andIndexIsNotNull() {
            addCriterion("`index` is not null");
            return (Criteria) this;
        }

        public Criteria andIndexEqualTo(Long value) {
            addCriterion("`index` =", value, "index");
            return (Criteria) this;
        }

        public Criteria andIndexNotEqualTo(Long value) {
            addCriterion("`index` <>", value, "index");
            return (Criteria) this;
        }

        public Criteria andIndexGreaterThan(Long value) {
            addCriterion("`index` >", value, "index");
            return (Criteria) this;
        }

        public Criteria andIndexGreaterThanOrEqualTo(Long value) {
            addCriterion("`index` >=", value, "index");
            return (Criteria) this;
        }

        public Criteria andIndexLessThan(Long value) {
            addCriterion("`index` <", value, "index");
            return (Criteria) this;
        }

        public Criteria andIndexLessThanOrEqualTo(Long value) {
            addCriterion("`index` <=", value, "index");
            return (Criteria) this;
        }

        public Criteria andIndexIn(List<Long> values) {
            addCriterion("`index` in", values, "index");
            return (Criteria) this;
        }

        public Criteria andIndexNotIn(List<Long> values) {
            addCriterion("`index` not in", values, "index");
            return (Criteria) this;
        }

        public Criteria andIndexBetween(Long value1, Long value2) {
            addCriterion("`index` between", value1, value2, "index");
            return (Criteria) this;
        }

        public Criteria andIndexNotBetween(Long value1, Long value2) {
            addCriterion("`index` not between", value1, value2, "index");
            return (Criteria) this;
        }

        public Criteria andRangeReturnIsNull() {
            addCriterion("range_return is null");
            return (Criteria) this;
        }

        public Criteria andRangeReturnIsNotNull() {
            addCriterion("range_return is not null");
            return (Criteria) this;
        }

        public Criteria andRangeReturnEqualTo(Double value) {
            addCriterion("range_return =", value, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnNotEqualTo(Double value) {
            addCriterion("range_return <>", value, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnGreaterThan(Double value) {
            addCriterion("range_return >", value, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnGreaterThanOrEqualTo(Double value) {
            addCriterion("range_return >=", value, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnLessThan(Double value) {
            addCriterion("range_return <", value, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnLessThanOrEqualTo(Double value) {
            addCriterion("range_return <=", value, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnIn(List<Double> values) {
            addCriterion("range_return in", values, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnNotIn(List<Double> values) {
            addCriterion("range_return not in", values, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnBetween(Double value1, Double value2) {
            addCriterion("range_return between", value1, value2, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andRangeReturnNotBetween(Double value1, Double value2) {
            addCriterion("range_return not between", value1, value2, "rangeReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnIsNull() {
            addCriterion("annual_return is null");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnIsNotNull() {
            addCriterion("annual_return is not null");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnEqualTo(Double value) {
            addCriterion("annual_return =", value, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnNotEqualTo(Double value) {
            addCriterion("annual_return <>", value, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnGreaterThan(Double value) {
            addCriterion("annual_return >", value, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnGreaterThanOrEqualTo(Double value) {
            addCriterion("annual_return >=", value, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnLessThan(Double value) {
            addCriterion("annual_return <", value, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnLessThanOrEqualTo(Double value) {
            addCriterion("annual_return <=", value, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnIn(List<Double> values) {
            addCriterion("annual_return in", values, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnNotIn(List<Double> values) {
            addCriterion("annual_return not in", values, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnBetween(Double value1, Double value2) {
            addCriterion("annual_return between", value1, value2, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnNotBetween(Double value1, Double value2) {
            addCriterion("annual_return not between", value1, value2, "annualReturn");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownIsNull() {
            addCriterion("max_drawdown is null");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownIsNotNull() {
            addCriterion("max_drawdown is not null");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownEqualTo(Double value) {
            addCriterion("max_drawdown =", value, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownNotEqualTo(Double value) {
            addCriterion("max_drawdown <>", value, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownGreaterThan(Double value) {
            addCriterion("max_drawdown >", value, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownGreaterThanOrEqualTo(Double value) {
            addCriterion("max_drawdown >=", value, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownLessThan(Double value) {
            addCriterion("max_drawdown <", value, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownLessThanOrEqualTo(Double value) {
            addCriterion("max_drawdown <=", value, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownIn(List<Double> values) {
            addCriterion("max_drawdown in", values, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownNotIn(List<Double> values) {
            addCriterion("max_drawdown not in", values, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownBetween(Double value1, Double value2) {
            addCriterion("max_drawdown between", value1, value2, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownNotBetween(Double value1, Double value2) {
            addCriterion("max_drawdown not between", value1, value2, "maxDrawdown");
            return (Criteria) this;
        }

        public Criteria andVolatilityIsNull() {
            addCriterion("volatility is null");
            return (Criteria) this;
        }

        public Criteria andVolatilityIsNotNull() {
            addCriterion("volatility is not null");
            return (Criteria) this;
        }

        public Criteria andVolatilityEqualTo(Double value) {
            addCriterion("volatility =", value, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityNotEqualTo(Double value) {
            addCriterion("volatility <>", value, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityGreaterThan(Double value) {
            addCriterion("volatility >", value, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityGreaterThanOrEqualTo(Double value) {
            addCriterion("volatility >=", value, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityLessThan(Double value) {
            addCriterion("volatility <", value, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityLessThanOrEqualTo(Double value) {
            addCriterion("volatility <=", value, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityIn(List<Double> values) {
            addCriterion("volatility in", values, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityNotIn(List<Double> values) {
            addCriterion("volatility not in", values, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityBetween(Double value1, Double value2) {
            addCriterion("volatility between", value1, value2, "volatility");
            return (Criteria) this;
        }

        public Criteria andVolatilityNotBetween(Double value1, Double value2) {
            addCriterion("volatility not between", value1, value2, "volatility");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioIsNull() {
            addCriterion("sortino_ratio is null");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioIsNotNull() {
            addCriterion("sortino_ratio is not null");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioEqualTo(Double value) {
            addCriterion("sortino_ratio =", value, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioNotEqualTo(Double value) {
            addCriterion("sortino_ratio <>", value, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioGreaterThan(Double value) {
            addCriterion("sortino_ratio >", value, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioGreaterThanOrEqualTo(Double value) {
            addCriterion("sortino_ratio >=", value, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioLessThan(Double value) {
            addCriterion("sortino_ratio <", value, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioLessThanOrEqualTo(Double value) {
            addCriterion("sortino_ratio <=", value, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioIn(List<Double> values) {
            addCriterion("sortino_ratio in", values, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioNotIn(List<Double> values) {
            addCriterion("sortino_ratio not in", values, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioBetween(Double value1, Double value2) {
            addCriterion("sortino_ratio between", value1, value2, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andSortinoRatioNotBetween(Double value1, Double value2) {
            addCriterion("sortino_ratio not between", value1, value2, "sortinoRatio");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskIsNull() {
            addCriterion("downside_risk is null");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskIsNotNull() {
            addCriterion("downside_risk is not null");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskEqualTo(Double value) {
            addCriterion("downside_risk =", value, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskNotEqualTo(Double value) {
            addCriterion("downside_risk <>", value, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskGreaterThan(Double value) {
            addCriterion("downside_risk >", value, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskGreaterThanOrEqualTo(Double value) {
            addCriterion("downside_risk >=", value, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskLessThan(Double value) {
            addCriterion("downside_risk <", value, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskLessThanOrEqualTo(Double value) {
            addCriterion("downside_risk <=", value, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskIn(List<Double> values) {
            addCriterion("downside_risk in", values, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskNotIn(List<Double> values) {
            addCriterion("downside_risk not in", values, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskBetween(Double value1, Double value2) {
            addCriterion("downside_risk between", value1, value2, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskNotBetween(Double value1, Double value2) {
            addCriterion("downside_risk not between", value1, value2, "downsideRisk");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNull() {
            addCriterion("substrategy is null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNotNull() {
            addCriterion("substrategy is not null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyEqualTo(Long value) {
            addCriterion("substrategy =", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotEqualTo(Long value) {
            addCriterion("substrategy <>", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThan(Long value) {
            addCriterion("substrategy >", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThanOrEqualTo(Long value) {
            addCriterion("substrategy >=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThan(Long value) {
            addCriterion("substrategy <", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThanOrEqualTo(Long value) {
            addCriterion("substrategy <=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIn(List<Long> values) {
            addCriterion("substrategy in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotIn(List<Long> values) {
            addCriterion("substrategy not in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyBetween(Long value1, Long value2) {
            addCriterion("substrategy between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotBetween(Long value1, Long value2) {
            addCriterion("substrategy not between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankIsNull() {
            addCriterion("annual_return_rank is null");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankIsNotNull() {
            addCriterion("annual_return_rank is not null");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankEqualTo(Double value) {
            addCriterion("annual_return_rank =", value, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankNotEqualTo(Double value) {
            addCriterion("annual_return_rank <>", value, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankGreaterThan(Double value) {
            addCriterion("annual_return_rank >", value, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankGreaterThanOrEqualTo(Double value) {
            addCriterion("annual_return_rank >=", value, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankLessThan(Double value) {
            addCriterion("annual_return_rank <", value, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankLessThanOrEqualTo(Double value) {
            addCriterion("annual_return_rank <=", value, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankIn(List<Double> values) {
            addCriterion("annual_return_rank in", values, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankNotIn(List<Double> values) {
            addCriterion("annual_return_rank not in", values, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankBetween(Double value1, Double value2) {
            addCriterion("annual_return_rank between", value1, value2, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andAnnualReturnRankNotBetween(Double value1, Double value2) {
            addCriterion("annual_return_rank not between", value1, value2, "annualReturnRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankIsNull() {
            addCriterion("downside_risk_rank is null");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankIsNotNull() {
            addCriterion("downside_risk_rank is not null");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankEqualTo(Double value) {
            addCriterion("downside_risk_rank =", value, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankNotEqualTo(Double value) {
            addCriterion("downside_risk_rank <>", value, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankGreaterThan(Double value) {
            addCriterion("downside_risk_rank >", value, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankGreaterThanOrEqualTo(Double value) {
            addCriterion("downside_risk_rank >=", value, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankLessThan(Double value) {
            addCriterion("downside_risk_rank <", value, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankLessThanOrEqualTo(Double value) {
            addCriterion("downside_risk_rank <=", value, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankIn(List<Double> values) {
            addCriterion("downside_risk_rank in", values, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankNotIn(List<Double> values) {
            addCriterion("downside_risk_rank not in", values, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankBetween(Double value1, Double value2) {
            addCriterion("downside_risk_rank between", value1, value2, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andDownsideRiskRankNotBetween(Double value1, Double value2) {
            addCriterion("downside_risk_rank not between", value1, value2, "downsideRiskRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankIsNull() {
            addCriterion("max_drawdown_rank is null");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankIsNotNull() {
            addCriterion("max_drawdown_rank is not null");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankEqualTo(Double value) {
            addCriterion("max_drawdown_rank =", value, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankNotEqualTo(Double value) {
            addCriterion("max_drawdown_rank <>", value, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankGreaterThan(Double value) {
            addCriterion("max_drawdown_rank >", value, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankGreaterThanOrEqualTo(Double value) {
            addCriterion("max_drawdown_rank >=", value, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankLessThan(Double value) {
            addCriterion("max_drawdown_rank <", value, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankLessThanOrEqualTo(Double value) {
            addCriterion("max_drawdown_rank <=", value, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankIn(List<Double> values) {
            addCriterion("max_drawdown_rank in", values, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankNotIn(List<Double> values) {
            addCriterion("max_drawdown_rank not in", values, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankBetween(Double value1, Double value2) {
            addCriterion("max_drawdown_rank between", value1, value2, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andMaxDrawdownRankNotBetween(Double value1, Double value2) {
            addCriterion("max_drawdown_rank not between", value1, value2, "maxDrawdownRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankIsNull() {
            addCriterion("sharp_ratio_rank is null");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankIsNotNull() {
            addCriterion("sharp_ratio_rank is not null");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankEqualTo(Double value) {
            addCriterion("sharp_ratio_rank =", value, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankNotEqualTo(Double value) {
            addCriterion("sharp_ratio_rank <>", value, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankGreaterThan(Double value) {
            addCriterion("sharp_ratio_rank >", value, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankGreaterThanOrEqualTo(Double value) {
            addCriterion("sharp_ratio_rank >=", value, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankLessThan(Double value) {
            addCriterion("sharp_ratio_rank <", value, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankLessThanOrEqualTo(Double value) {
            addCriterion("sharp_ratio_rank <=", value, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankIn(List<Double> values) {
            addCriterion("sharp_ratio_rank in", values, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankNotIn(List<Double> values) {
            addCriterion("sharp_ratio_rank not in", values, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankBetween(Double value1, Double value2) {
            addCriterion("sharp_ratio_rank between", value1, value2, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andSharpRatioRankNotBetween(Double value1, Double value2) {
            addCriterion("sharp_ratio_rank not between", value1, value2, "sharpRatioRank");
            return (Criteria) this;
        }

        public Criteria andZScoreIsNull() {
            addCriterion("z_score is null");
            return (Criteria) this;
        }

        public Criteria andZScoreIsNotNull() {
            addCriterion("z_score is not null");
            return (Criteria) this;
        }

        public Criteria andZScoreEqualTo(Double value) {
            addCriterion("z_score =", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreNotEqualTo(Double value) {
            addCriterion("z_score <>", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreGreaterThan(Double value) {
            addCriterion("z_score >", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreGreaterThanOrEqualTo(Double value) {
            addCriterion("z_score >=", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreLessThan(Double value) {
            addCriterion("z_score <", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreLessThanOrEqualTo(Double value) {
            addCriterion("z_score <=", value, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreIn(List<Double> values) {
            addCriterion("z_score in", values, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreNotIn(List<Double> values) {
            addCriterion("z_score not in", values, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreBetween(Double value1, Double value2) {
            addCriterion("z_score between", value1, value2, "zScore");
            return (Criteria) this;
        }

        public Criteria andZScoreNotBetween(Double value1, Double value2) {
            addCriterion("z_score not between", value1, value2, "zScore");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}