package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TxCompanyInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TxCompanyInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdIsNull() {
            addCriterion("p_company_id is null");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdIsNotNull() {
            addCriterion("p_company_id is not null");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdEqualTo(String value) {
            addCriterion("p_company_id =", value, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdNotEqualTo(String value) {
            addCriterion("p_company_id <>", value, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdGreaterThan(String value) {
            addCriterion("p_company_id >", value, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdGreaterThanOrEqualTo(String value) {
            addCriterion("p_company_id >=", value, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdLessThan(String value) {
            addCriterion("p_company_id <", value, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdLessThanOrEqualTo(String value) {
            addCriterion("p_company_id <=", value, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdLike(String value) {
            addCriterion("p_company_id like", value, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdNotLike(String value) {
            addCriterion("p_company_id not like", value, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdIn(List<String> values) {
            addCriterion("p_company_id in", values, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdNotIn(List<String> values) {
            addCriterion("p_company_id not in", values, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdBetween(String value1, String value2) {
            addCriterion("p_company_id between", value1, value2, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andPCompanyIdNotBetween(String value1, String value2) {
            addCriterion("p_company_id not between", value1, value2, "pCompanyId");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameIsNull() {
            addCriterion("company_short_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameIsNotNull() {
            addCriterion("company_short_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameEqualTo(String value) {
            addCriterion("company_short_name =", value, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameNotEqualTo(String value) {
            addCriterion("company_short_name <>", value, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameGreaterThan(String value) {
            addCriterion("company_short_name >", value, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_short_name >=", value, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameLessThan(String value) {
            addCriterion("company_short_name <", value, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameLessThanOrEqualTo(String value) {
            addCriterion("company_short_name <=", value, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameLike(String value) {
            addCriterion("company_short_name like", value, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameNotLike(String value) {
            addCriterion("company_short_name not like", value, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameIn(List<String> values) {
            addCriterion("company_short_name in", values, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameNotIn(List<String> values) {
            addCriterion("company_short_name not in", values, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameBetween(String value1, String value2) {
            addCriterion("company_short_name between", value1, value2, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyShortNameNotBetween(String value1, String value2) {
            addCriterion("company_short_name not between", value1, value2, "companyShortName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameIsNull() {
            addCriterion("company_english_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameIsNotNull() {
            addCriterion("company_english_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameEqualTo(String value) {
            addCriterion("company_english_name =", value, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameNotEqualTo(String value) {
            addCriterion("company_english_name <>", value, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameGreaterThan(String value) {
            addCriterion("company_english_name >", value, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_english_name >=", value, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameLessThan(String value) {
            addCriterion("company_english_name <", value, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameLessThanOrEqualTo(String value) {
            addCriterion("company_english_name <=", value, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameLike(String value) {
            addCriterion("company_english_name like", value, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameNotLike(String value) {
            addCriterion("company_english_name not like", value, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameIn(List<String> values) {
            addCriterion("company_english_name in", values, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameNotIn(List<String> values) {
            addCriterion("company_english_name not in", values, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameBetween(String value1, String value2) {
            addCriterion("company_english_name between", value1, value2, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyEnglishNameNotBetween(String value1, String value2) {
            addCriterion("company_english_name not between", value1, value2, "companyEnglishName");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeIsNull() {
            addCriterion("company_type is null");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeIsNotNull() {
            addCriterion("company_type is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeEqualTo(Integer value) {
            addCriterion("company_type =", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeNotEqualTo(Integer value) {
            addCriterion("company_type <>", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeGreaterThan(Integer value) {
            addCriterion("company_type >", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("company_type >=", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeLessThan(Integer value) {
            addCriterion("company_type <", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeLessThanOrEqualTo(Integer value) {
            addCriterion("company_type <=", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeIn(List<Integer> values) {
            addCriterion("company_type in", values, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeNotIn(List<Integer> values) {
            addCriterion("company_type not in", values, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeBetween(Integer value1, Integer value2) {
            addCriterion("company_type between", value1, value2, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("company_type not between", value1, value2, "companyType");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberIsNull() {
            addCriterion("organization_number is null");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberIsNotNull() {
            addCriterion("organization_number is not null");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberEqualTo(String value) {
            addCriterion("organization_number =", value, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberNotEqualTo(String value) {
            addCriterion("organization_number <>", value, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberGreaterThan(String value) {
            addCriterion("organization_number >", value, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberGreaterThanOrEqualTo(String value) {
            addCriterion("organization_number >=", value, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberLessThan(String value) {
            addCriterion("organization_number <", value, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberLessThanOrEqualTo(String value) {
            addCriterion("organization_number <=", value, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberLike(String value) {
            addCriterion("organization_number like", value, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberNotLike(String value) {
            addCriterion("organization_number not like", value, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberIn(List<String> values) {
            addCriterion("organization_number in", values, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberNotIn(List<String> values) {
            addCriterion("organization_number not in", values, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberBetween(String value1, String value2) {
            addCriterion("organization_number between", value1, value2, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andOrganizationNumberNotBetween(String value1, String value2) {
            addCriterion("organization_number not between", value1, value2, "organizationNumber");
            return (Criteria) this;
        }

        public Criteria andEstablishDateIsNull() {
            addCriterion("establish_date is null");
            return (Criteria) this;
        }

        public Criteria andEstablishDateIsNotNull() {
            addCriterion("establish_date is not null");
            return (Criteria) this;
        }

        public Criteria andEstablishDateEqualTo(Date value) {
            addCriterionForJDBCDate("establish_date =", value, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("establish_date <>", value, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateGreaterThan(Date value) {
            addCriterionForJDBCDate("establish_date >", value, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("establish_date >=", value, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateLessThan(Date value) {
            addCriterionForJDBCDate("establish_date <", value, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("establish_date <=", value, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateIn(List<Date> values) {
            addCriterionForJDBCDate("establish_date in", values, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("establish_date not in", values, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("establish_date between", value1, value2, "establishDate");
            return (Criteria) this;
        }

        public Criteria andEstablishDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("establish_date not between", value1, value2, "establishDate");
            return (Criteria) this;
        }

        public Criteria andDomicileIdIsNull() {
            addCriterion("domicile_id is null");
            return (Criteria) this;
        }

        public Criteria andDomicileIdIsNotNull() {
            addCriterion("domicile_id is not null");
            return (Criteria) this;
        }

        public Criteria andDomicileIdEqualTo(Integer value) {
            addCriterion("domicile_id =", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdNotEqualTo(Integer value) {
            addCriterion("domicile_id <>", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdGreaterThan(Integer value) {
            addCriterion("domicile_id >", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("domicile_id >=", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdLessThan(Integer value) {
            addCriterion("domicile_id <", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdLessThanOrEqualTo(Integer value) {
            addCriterion("domicile_id <=", value, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdIn(List<Integer> values) {
            addCriterion("domicile_id in", values, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdNotIn(List<Integer> values) {
            addCriterion("domicile_id not in", values, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdBetween(Integer value1, Integer value2) {
            addCriterion("domicile_id between", value1, value2, "domicileId");
            return (Criteria) this;
        }

        public Criteria andDomicileIdNotBetween(Integer value1, Integer value2) {
            addCriterion("domicile_id not between", value1, value2, "domicileId");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressIsNull() {
            addCriterion("company_address is null");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressIsNotNull() {
            addCriterion("company_address is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressEqualTo(String value) {
            addCriterion("company_address =", value, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressNotEqualTo(String value) {
            addCriterion("company_address <>", value, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressGreaterThan(String value) {
            addCriterion("company_address >", value, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressGreaterThanOrEqualTo(String value) {
            addCriterion("company_address >=", value, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressLessThan(String value) {
            addCriterion("company_address <", value, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressLessThanOrEqualTo(String value) {
            addCriterion("company_address <=", value, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressLike(String value) {
            addCriterion("company_address like", value, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressNotLike(String value) {
            addCriterion("company_address not like", value, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressIn(List<String> values) {
            addCriterion("company_address in", values, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressNotIn(List<String> values) {
            addCriterion("company_address not in", values, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressBetween(String value1, String value2) {
            addCriterion("company_address between", value1, value2, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddressNotBetween(String value1, String value2) {
            addCriterion("company_address not between", value1, value2, "companyAddress");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2IsNull() {
            addCriterion("company_address2 is null");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2IsNotNull() {
            addCriterion("company_address2 is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2EqualTo(String value) {
            addCriterion("company_address2 =", value, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2NotEqualTo(String value) {
            addCriterion("company_address2 <>", value, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2GreaterThan(String value) {
            addCriterion("company_address2 >", value, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2GreaterThanOrEqualTo(String value) {
            addCriterion("company_address2 >=", value, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2LessThan(String value) {
            addCriterion("company_address2 <", value, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2LessThanOrEqualTo(String value) {
            addCriterion("company_address2 <=", value, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2Like(String value) {
            addCriterion("company_address2 like", value, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2NotLike(String value) {
            addCriterion("company_address2 not like", value, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2In(List<String> values) {
            addCriterion("company_address2 in", values, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2NotIn(List<String> values) {
            addCriterion("company_address2 not in", values, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2Between(String value1, String value2) {
            addCriterion("company_address2 between", value1, value2, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCompanyAddress2NotBetween(String value1, String value2) {
            addCriterion("company_address2 not between", value1, value2, "companyAddress2");
            return (Criteria) this;
        }

        public Criteria andCityIsNull() {
            addCriterion("city is null");
            return (Criteria) this;
        }

        public Criteria andCityIsNotNull() {
            addCriterion("city is not null");
            return (Criteria) this;
        }

        public Criteria andCityEqualTo(String value) {
            addCriterion("city =", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityNotEqualTo(String value) {
            addCriterion("city <>", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityGreaterThan(String value) {
            addCriterion("city >", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityGreaterThanOrEqualTo(String value) {
            addCriterion("city >=", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityLessThan(String value) {
            addCriterion("city <", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityLessThanOrEqualTo(String value) {
            addCriterion("city <=", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityLike(String value) {
            addCriterion("city like", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityNotLike(String value) {
            addCriterion("city not like", value, "city");
            return (Criteria) this;
        }

        public Criteria andCityIn(List<String> values) {
            addCriterion("city in", values, "city");
            return (Criteria) this;
        }

        public Criteria andCityNotIn(List<String> values) {
            addCriterion("city not in", values, "city");
            return (Criteria) this;
        }

        public Criteria andCityBetween(String value1, String value2) {
            addCriterion("city between", value1, value2, "city");
            return (Criteria) this;
        }

        public Criteria andCityNotBetween(String value1, String value2) {
            addCriterion("city not between", value1, value2, "city");
            return (Criteria) this;
        }

        public Criteria andProvinceIsNull() {
            addCriterion("province is null");
            return (Criteria) this;
        }

        public Criteria andProvinceIsNotNull() {
            addCriterion("province is not null");
            return (Criteria) this;
        }

        public Criteria andProvinceEqualTo(String value) {
            addCriterion("province =", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceNotEqualTo(String value) {
            addCriterion("province <>", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceGreaterThan(String value) {
            addCriterion("province >", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceGreaterThanOrEqualTo(String value) {
            addCriterion("province >=", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceLessThan(String value) {
            addCriterion("province <", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceLessThanOrEqualTo(String value) {
            addCriterion("province <=", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceLike(String value) {
            addCriterion("province like", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceNotLike(String value) {
            addCriterion("province not like", value, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceIn(List<String> values) {
            addCriterion("province in", values, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceNotIn(List<String> values) {
            addCriterion("province not in", values, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceBetween(String value1, String value2) {
            addCriterion("province between", value1, value2, "province");
            return (Criteria) this;
        }

        public Criteria andProvinceNotBetween(String value1, String value2) {
            addCriterion("province not between", value1, value2, "province");
            return (Criteria) this;
        }

        public Criteria andCountryIsNull() {
            addCriterion("country is null");
            return (Criteria) this;
        }

        public Criteria andCountryIsNotNull() {
            addCriterion("country is not null");
            return (Criteria) this;
        }

        public Criteria andCountryEqualTo(String value) {
            addCriterion("country =", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryNotEqualTo(String value) {
            addCriterion("country <>", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryGreaterThan(String value) {
            addCriterion("country >", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryGreaterThanOrEqualTo(String value) {
            addCriterion("country >=", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryLessThan(String value) {
            addCriterion("country <", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryLessThanOrEqualTo(String value) {
            addCriterion("country <=", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryLike(String value) {
            addCriterion("country like", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryNotLike(String value) {
            addCriterion("country not like", value, "country");
            return (Criteria) this;
        }

        public Criteria andCountryIn(List<String> values) {
            addCriterion("country in", values, "country");
            return (Criteria) this;
        }

        public Criteria andCountryNotIn(List<String> values) {
            addCriterion("country not in", values, "country");
            return (Criteria) this;
        }

        public Criteria andCountryBetween(String value1, String value2) {
            addCriterion("country between", value1, value2, "country");
            return (Criteria) this;
        }

        public Criteria andCountryNotBetween(String value1, String value2) {
            addCriterion("country not between", value1, value2, "country");
            return (Criteria) this;
        }

        public Criteria andRegCityIsNull() {
            addCriterion("reg_city is null");
            return (Criteria) this;
        }

        public Criteria andRegCityIsNotNull() {
            addCriterion("reg_city is not null");
            return (Criteria) this;
        }

        public Criteria andRegCityEqualTo(String value) {
            addCriterion("reg_city =", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityNotEqualTo(String value) {
            addCriterion("reg_city <>", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityGreaterThan(String value) {
            addCriterion("reg_city >", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityGreaterThanOrEqualTo(String value) {
            addCriterion("reg_city >=", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityLessThan(String value) {
            addCriterion("reg_city <", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityLessThanOrEqualTo(String value) {
            addCriterion("reg_city <=", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityLike(String value) {
            addCriterion("reg_city like", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityNotLike(String value) {
            addCriterion("reg_city not like", value, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityIn(List<String> values) {
            addCriterion("reg_city in", values, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityNotIn(List<String> values) {
            addCriterion("reg_city not in", values, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityBetween(String value1, String value2) {
            addCriterion("reg_city between", value1, value2, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegCityNotBetween(String value1, String value2) {
            addCriterion("reg_city not between", value1, value2, "regCity");
            return (Criteria) this;
        }

        public Criteria andRegProvinceIsNull() {
            addCriterion("reg_province is null");
            return (Criteria) this;
        }

        public Criteria andRegProvinceIsNotNull() {
            addCriterion("reg_province is not null");
            return (Criteria) this;
        }

        public Criteria andRegProvinceEqualTo(String value) {
            addCriterion("reg_province =", value, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceNotEqualTo(String value) {
            addCriterion("reg_province <>", value, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceGreaterThan(String value) {
            addCriterion("reg_province >", value, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceGreaterThanOrEqualTo(String value) {
            addCriterion("reg_province >=", value, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceLessThan(String value) {
            addCriterion("reg_province <", value, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceLessThanOrEqualTo(String value) {
            addCriterion("reg_province <=", value, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceLike(String value) {
            addCriterion("reg_province like", value, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceNotLike(String value) {
            addCriterion("reg_province not like", value, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceIn(List<String> values) {
            addCriterion("reg_province in", values, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceNotIn(List<String> values) {
            addCriterion("reg_province not in", values, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceBetween(String value1, String value2) {
            addCriterion("reg_province between", value1, value2, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegProvinceNotBetween(String value1, String value2) {
            addCriterion("reg_province not between", value1, value2, "regProvince");
            return (Criteria) this;
        }

        public Criteria andRegCountryIsNull() {
            addCriterion("reg_country is null");
            return (Criteria) this;
        }

        public Criteria andRegCountryIsNotNull() {
            addCriterion("reg_country is not null");
            return (Criteria) this;
        }

        public Criteria andRegCountryEqualTo(String value) {
            addCriterion("reg_country =", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryNotEqualTo(String value) {
            addCriterion("reg_country <>", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryGreaterThan(String value) {
            addCriterion("reg_country >", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryGreaterThanOrEqualTo(String value) {
            addCriterion("reg_country >=", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryLessThan(String value) {
            addCriterion("reg_country <", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryLessThanOrEqualTo(String value) {
            addCriterion("reg_country <=", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryLike(String value) {
            addCriterion("reg_country like", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryNotLike(String value) {
            addCriterion("reg_country not like", value, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryIn(List<String> values) {
            addCriterion("reg_country in", values, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryNotIn(List<String> values) {
            addCriterion("reg_country not in", values, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryBetween(String value1, String value2) {
            addCriterion("reg_country between", value1, value2, "regCountry");
            return (Criteria) this;
        }

        public Criteria andRegCountryNotBetween(String value1, String value2) {
            addCriterion("reg_country not between", value1, value2, "regCountry");
            return (Criteria) this;
        }

        public Criteria andContactPhoneIsNull() {
            addCriterion("contact_phone is null");
            return (Criteria) this;
        }

        public Criteria andContactPhoneIsNotNull() {
            addCriterion("contact_phone is not null");
            return (Criteria) this;
        }

        public Criteria andContactPhoneEqualTo(String value) {
            addCriterion("contact_phone =", value, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneNotEqualTo(String value) {
            addCriterion("contact_phone <>", value, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneGreaterThan(String value) {
            addCriterion("contact_phone >", value, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("contact_phone >=", value, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneLessThan(String value) {
            addCriterion("contact_phone <", value, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneLessThanOrEqualTo(String value) {
            addCriterion("contact_phone <=", value, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneLike(String value) {
            addCriterion("contact_phone like", value, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneNotLike(String value) {
            addCriterion("contact_phone not like", value, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneIn(List<String> values) {
            addCriterion("contact_phone in", values, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneNotIn(List<String> values) {
            addCriterion("contact_phone not in", values, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneBetween(String value1, String value2) {
            addCriterion("contact_phone between", value1, value2, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andContactPhoneNotBetween(String value1, String value2) {
            addCriterion("contact_phone not between", value1, value2, "contactPhone");
            return (Criteria) this;
        }

        public Criteria andPostCodeIsNull() {
            addCriterion("post_code is null");
            return (Criteria) this;
        }

        public Criteria andPostCodeIsNotNull() {
            addCriterion("post_code is not null");
            return (Criteria) this;
        }

        public Criteria andPostCodeEqualTo(String value) {
            addCriterion("post_code =", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeNotEqualTo(String value) {
            addCriterion("post_code <>", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeGreaterThan(String value) {
            addCriterion("post_code >", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeGreaterThanOrEqualTo(String value) {
            addCriterion("post_code >=", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeLessThan(String value) {
            addCriterion("post_code <", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeLessThanOrEqualTo(String value) {
            addCriterion("post_code <=", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeLike(String value) {
            addCriterion("post_code like", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeNotLike(String value) {
            addCriterion("post_code not like", value, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeIn(List<String> values) {
            addCriterion("post_code in", values, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeNotIn(List<String> values) {
            addCriterion("post_code not in", values, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeBetween(String value1, String value2) {
            addCriterion("post_code between", value1, value2, "postCode");
            return (Criteria) this;
        }

        public Criteria andPostCodeNotBetween(String value1, String value2) {
            addCriterion("post_code not between", value1, value2, "postCode");
            return (Criteria) this;
        }

        public Criteria andFaxIsNull() {
            addCriterion("fax is null");
            return (Criteria) this;
        }

        public Criteria andFaxIsNotNull() {
            addCriterion("fax is not null");
            return (Criteria) this;
        }

        public Criteria andFaxEqualTo(String value) {
            addCriterion("fax =", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxNotEqualTo(String value) {
            addCriterion("fax <>", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxGreaterThan(String value) {
            addCriterion("fax >", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxGreaterThanOrEqualTo(String value) {
            addCriterion("fax >=", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxLessThan(String value) {
            addCriterion("fax <", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxLessThanOrEqualTo(String value) {
            addCriterion("fax <=", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxLike(String value) {
            addCriterion("fax like", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxNotLike(String value) {
            addCriterion("fax not like", value, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxIn(List<String> values) {
            addCriterion("fax in", values, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxNotIn(List<String> values) {
            addCriterion("fax not in", values, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxBetween(String value1, String value2) {
            addCriterion("fax between", value1, value2, "fax");
            return (Criteria) this;
        }

        public Criteria andFaxNotBetween(String value1, String value2) {
            addCriterion("fax not between", value1, value2, "fax");
            return (Criteria) this;
        }

        public Criteria andEmailIsNull() {
            addCriterion("email is null");
            return (Criteria) this;
        }

        public Criteria andEmailIsNotNull() {
            addCriterion("email is not null");
            return (Criteria) this;
        }

        public Criteria andEmailEqualTo(String value) {
            addCriterion("email =", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailNotEqualTo(String value) {
            addCriterion("email <>", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailGreaterThan(String value) {
            addCriterion("email >", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailGreaterThanOrEqualTo(String value) {
            addCriterion("email >=", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailLessThan(String value) {
            addCriterion("email <", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailLessThanOrEqualTo(String value) {
            addCriterion("email <=", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailLike(String value) {
            addCriterion("email like", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailNotLike(String value) {
            addCriterion("email not like", value, "email");
            return (Criteria) this;
        }

        public Criteria andEmailIn(List<String> values) {
            addCriterion("email in", values, "email");
            return (Criteria) this;
        }

        public Criteria andEmailNotIn(List<String> values) {
            addCriterion("email not in", values, "email");
            return (Criteria) this;
        }

        public Criteria andEmailBetween(String value1, String value2) {
            addCriterion("email between", value1, value2, "email");
            return (Criteria) this;
        }

        public Criteria andEmailNotBetween(String value1, String value2) {
            addCriterion("email not between", value1, value2, "email");
            return (Criteria) this;
        }

        public Criteria andWebsiteIsNull() {
            addCriterion("website is null");
            return (Criteria) this;
        }

        public Criteria andWebsiteIsNotNull() {
            addCriterion("website is not null");
            return (Criteria) this;
        }

        public Criteria andWebsiteEqualTo(String value) {
            addCriterion("website =", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteNotEqualTo(String value) {
            addCriterion("website <>", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteGreaterThan(String value) {
            addCriterion("website >", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteGreaterThanOrEqualTo(String value) {
            addCriterion("website >=", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteLessThan(String value) {
            addCriterion("website <", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteLessThanOrEqualTo(String value) {
            addCriterion("website <=", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteLike(String value) {
            addCriterion("website like", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteNotLike(String value) {
            addCriterion("website not like", value, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteIn(List<String> values) {
            addCriterion("website in", values, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteNotIn(List<String> values) {
            addCriterion("website not in", values, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteBetween(String value1, String value2) {
            addCriterion("website between", value1, value2, "website");
            return (Criteria) this;
        }

        public Criteria andWebsiteNotBetween(String value1, String value2) {
            addCriterion("website not between", value1, value2, "website");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalIsNull() {
            addCriterion("registered_capital is null");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalIsNotNull() {
            addCriterion("registered_capital is not null");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalEqualTo(BigDecimal value) {
            addCriterion("registered_capital =", value, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalNotEqualTo(BigDecimal value) {
            addCriterion("registered_capital <>", value, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalGreaterThan(BigDecimal value) {
            addCriterion("registered_capital >", value, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("registered_capital >=", value, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalLessThan(BigDecimal value) {
            addCriterion("registered_capital <", value, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("registered_capital <=", value, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalIn(List<BigDecimal> values) {
            addCriterion("registered_capital in", values, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalNotIn(List<BigDecimal> values) {
            addCriterion("registered_capital not in", values, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("registered_capital between", value1, value2, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andRegisteredCapitalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("registered_capital not between", value1, value2, "registeredCapital");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundIsNull() {
            addCriterion("offshore_fund is null");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundIsNotNull() {
            addCriterion("offshore_fund is not null");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundEqualTo(Integer value) {
            addCriterion("offshore_fund =", value, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundNotEqualTo(Integer value) {
            addCriterion("offshore_fund <>", value, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundGreaterThan(Integer value) {
            addCriterion("offshore_fund >", value, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundGreaterThanOrEqualTo(Integer value) {
            addCriterion("offshore_fund >=", value, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundLessThan(Integer value) {
            addCriterion("offshore_fund <", value, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundLessThanOrEqualTo(Integer value) {
            addCriterion("offshore_fund <=", value, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundIn(List<Integer> values) {
            addCriterion("offshore_fund in", values, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundNotIn(List<Integer> values) {
            addCriterion("offshore_fund not in", values, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundBetween(Integer value1, Integer value2) {
            addCriterion("offshore_fund between", value1, value2, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundNotBetween(Integer value1, Integer value2) {
            addCriterion("offshore_fund not between", value1, value2, "offshoreFund");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusIsNull() {
            addCriterion("company_status is null");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusIsNotNull() {
            addCriterion("company_status is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusEqualTo(Integer value) {
            addCriterion("company_status =", value, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusNotEqualTo(Integer value) {
            addCriterion("company_status <>", value, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusGreaterThan(Integer value) {
            addCriterion("company_status >", value, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("company_status >=", value, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusLessThan(Integer value) {
            addCriterion("company_status <", value, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusLessThanOrEqualTo(Integer value) {
            addCriterion("company_status <=", value, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusIn(List<Integer> values) {
            addCriterion("company_status in", values, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusNotIn(List<Integer> values) {
            addCriterion("company_status not in", values, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusBetween(Integer value1, Integer value2) {
            addCriterion("company_status between", value1, value2, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andCompanyStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("company_status not between", value1, value2, "companyStatus");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcIsNull() {
            addCriterion("base_currency_crc is null");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcIsNotNull() {
            addCriterion("base_currency_crc is not null");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcEqualTo(Integer value) {
            addCriterion("base_currency_crc =", value, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcNotEqualTo(Integer value) {
            addCriterion("base_currency_crc <>", value, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcGreaterThan(Integer value) {
            addCriterion("base_currency_crc >", value, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcGreaterThanOrEqualTo(Integer value) {
            addCriterion("base_currency_crc >=", value, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcLessThan(Integer value) {
            addCriterion("base_currency_crc <", value, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcLessThanOrEqualTo(Integer value) {
            addCriterion("base_currency_crc <=", value, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcIn(List<Integer> values) {
            addCriterion("base_currency_crc in", values, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcNotIn(List<Integer> values) {
            addCriterion("base_currency_crc not in", values, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcBetween(Integer value1, Integer value2) {
            addCriterion("base_currency_crc between", value1, value2, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andBaseCurrencyCrcNotBetween(Integer value1, Integer value2) {
            addCriterion("base_currency_crc not between", value1, value2, "baseCurrencyCrc");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIsNull() {
            addCriterion("register_number is null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIsNotNull() {
            addCriterion("register_number is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberEqualTo(String value) {
            addCriterion("register_number =", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotEqualTo(String value) {
            addCriterion("register_number <>", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberGreaterThan(String value) {
            addCriterion("register_number >", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberGreaterThanOrEqualTo(String value) {
            addCriterion("register_number >=", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLessThan(String value) {
            addCriterion("register_number <", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLessThanOrEqualTo(String value) {
            addCriterion("register_number <=", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLike(String value) {
            addCriterion("register_number like", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotLike(String value) {
            addCriterion("register_number not like", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIn(List<String> values) {
            addCriterion("register_number in", values, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotIn(List<String> values) {
            addCriterion("register_number not in", values, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberBetween(String value1, String value2) {
            addCriterion("register_number between", value1, value2, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotBetween(String value1, String value2) {
            addCriterion("register_number not between", value1, value2, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusIsNull() {
            addCriterion("register_status is null");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusIsNotNull() {
            addCriterion("register_status is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusEqualTo(Integer value) {
            addCriterion("register_status =", value, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusNotEqualTo(Integer value) {
            addCriterion("register_status <>", value, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusGreaterThan(Integer value) {
            addCriterion("register_status >", value, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("register_status >=", value, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusLessThan(Integer value) {
            addCriterion("register_status <", value, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusLessThanOrEqualTo(Integer value) {
            addCriterion("register_status <=", value, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusIn(List<Integer> values) {
            addCriterion("register_status in", values, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusNotIn(List<Integer> values) {
            addCriterion("register_status not in", values, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusBetween(Integer value1, Integer value2) {
            addCriterion("register_status between", value1, value2, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("register_status not between", value1, value2, "registerStatus");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIsNull() {
            addCriterion("register_date is null");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIsNotNull() {
            addCriterion("register_date is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterDateEqualTo(Date value) {
            addCriterionForJDBCDate("register_date =", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("register_date <>", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateGreaterThan(Date value) {
            addCriterionForJDBCDate("register_date >", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("register_date >=", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateLessThan(Date value) {
            addCriterionForJDBCDate("register_date <", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("register_date <=", value, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateIn(List<Date> values) {
            addCriterionForJDBCDate("register_date in", values, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("register_date not in", values, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("register_date between", value1, value2, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("register_date not between", value1, value2, "registerDate");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressIsNull() {
            addCriterion("register_number_address is null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressIsNotNull() {
            addCriterion("register_number_address is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressEqualTo(String value) {
            addCriterion("register_number_address =", value, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressNotEqualTo(String value) {
            addCriterion("register_number_address <>", value, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressGreaterThan(String value) {
            addCriterion("register_number_address >", value, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressGreaterThanOrEqualTo(String value) {
            addCriterion("register_number_address >=", value, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressLessThan(String value) {
            addCriterion("register_number_address <", value, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressLessThanOrEqualTo(String value) {
            addCriterion("register_number_address <=", value, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressLike(String value) {
            addCriterion("register_number_address like", value, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressNotLike(String value) {
            addCriterion("register_number_address not like", value, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressIn(List<String> values) {
            addCriterion("register_number_address in", values, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressNotIn(List<String> values) {
            addCriterion("register_number_address not in", values, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressBetween(String value1, String value2) {
            addCriterion("register_number_address between", value1, value2, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberAddressNotBetween(String value1, String value2) {
            addCriterion("register_number_address not between", value1, value2, "registerNumberAddress");
            return (Criteria) this;
        }

        public Criteria andIsMemberIsNull() {
            addCriterion("is_member is null");
            return (Criteria) this;
        }

        public Criteria andIsMemberIsNotNull() {
            addCriterion("is_member is not null");
            return (Criteria) this;
        }

        public Criteria andIsMemberEqualTo(Byte value) {
            addCriterion("is_member =", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberNotEqualTo(Byte value) {
            addCriterion("is_member <>", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberGreaterThan(Byte value) {
            addCriterion("is_member >", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberGreaterThanOrEqualTo(Byte value) {
            addCriterion("is_member >=", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberLessThan(Byte value) {
            addCriterion("is_member <", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberLessThanOrEqualTo(Byte value) {
            addCriterion("is_member <=", value, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberIn(List<Byte> values) {
            addCriterion("is_member in", values, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberNotIn(List<Byte> values) {
            addCriterion("is_member not in", values, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberBetween(Byte value1, Byte value2) {
            addCriterion("is_member between", value1, value2, "isMember");
            return (Criteria) this;
        }

        public Criteria andIsMemberNotBetween(Byte value1, Byte value2) {
            addCriterion("is_member not between", value1, value2, "isMember");
            return (Criteria) this;
        }

        public Criteria andJoinDateIsNull() {
            addCriterion("join_date is null");
            return (Criteria) this;
        }

        public Criteria andJoinDateIsNotNull() {
            addCriterion("join_date is not null");
            return (Criteria) this;
        }

        public Criteria andJoinDateEqualTo(Date value) {
            addCriterionForJDBCDate("join_date =", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("join_date <>", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateGreaterThan(Date value) {
            addCriterionForJDBCDate("join_date >", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("join_date >=", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateLessThan(Date value) {
            addCriterionForJDBCDate("join_date <", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("join_date <=", value, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateIn(List<Date> values) {
            addCriterionForJDBCDate("join_date in", values, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("join_date not in", values, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("join_date between", value1, value2, "joinDate");
            return (Criteria) this;
        }

        public Criteria andJoinDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("join_date not between", value1, value2, "joinDate");
            return (Criteria) this;
        }

        public Criteria andMemberTypeIsNull() {
            addCriterion("member_type is null");
            return (Criteria) this;
        }

        public Criteria andMemberTypeIsNotNull() {
            addCriterion("member_type is not null");
            return (Criteria) this;
        }

        public Criteria andMemberTypeEqualTo(Integer value) {
            addCriterion("member_type =", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeNotEqualTo(Integer value) {
            addCriterion("member_type <>", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeGreaterThan(Integer value) {
            addCriterion("member_type >", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("member_type >=", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeLessThan(Integer value) {
            addCriterion("member_type <", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeLessThanOrEqualTo(Integer value) {
            addCriterion("member_type <=", value, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeIn(List<Integer> values) {
            addCriterion("member_type in", values, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeNotIn(List<Integer> values) {
            addCriterion("member_type not in", values, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeBetween(Integer value1, Integer value2) {
            addCriterion("member_type between", value1, value2, "memberType");
            return (Criteria) this;
        }

        public Criteria andMemberTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("member_type not between", value1, value2, "memberType");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriIsNull() {
            addCriterion("fund_category_ori is null");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriIsNotNull() {
            addCriterion("fund_category_ori is not null");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriEqualTo(String value) {
            addCriterion("fund_category_ori =", value, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriNotEqualTo(String value) {
            addCriterion("fund_category_ori <>", value, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriGreaterThan(String value) {
            addCriterion("fund_category_ori >", value, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriGreaterThanOrEqualTo(String value) {
            addCriterion("fund_category_ori >=", value, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriLessThan(String value) {
            addCriterion("fund_category_ori <", value, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriLessThanOrEqualTo(String value) {
            addCriterion("fund_category_ori <=", value, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriLike(String value) {
            addCriterion("fund_category_ori like", value, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriNotLike(String value) {
            addCriterion("fund_category_ori not like", value, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriIn(List<String> values) {
            addCriterion("fund_category_ori in", values, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriNotIn(List<String> values) {
            addCriterion("fund_category_ori not in", values, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriBetween(String value1, String value2) {
            addCriterion("fund_category_ori between", value1, value2, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andFundCategoryOriNotBetween(String value1, String value2) {
            addCriterion("fund_category_ori not between", value1, value2, "fundCategoryOri");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeIsNull() {
            addCriterion("business_type is null");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeIsNotNull() {
            addCriterion("business_type is not null");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeEqualTo(String value) {
            addCriterion("business_type =", value, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeNotEqualTo(String value) {
            addCriterion("business_type <>", value, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeGreaterThan(String value) {
            addCriterion("business_type >", value, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeGreaterThanOrEqualTo(String value) {
            addCriterion("business_type >=", value, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeLessThan(String value) {
            addCriterion("business_type <", value, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeLessThanOrEqualTo(String value) {
            addCriterion("business_type <=", value, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeLike(String value) {
            addCriterion("business_type like", value, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeNotLike(String value) {
            addCriterion("business_type not like", value, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeIn(List<String> values) {
            addCriterion("business_type in", values, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeNotIn(List<String> values) {
            addCriterion("business_type not in", values, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeBetween(String value1, String value2) {
            addCriterion("business_type between", value1, value2, "businessType");
            return (Criteria) this;
        }

        public Criteria andBusinessTypeNotBetween(String value1, String value2) {
            addCriterion("business_type not between", value1, value2, "businessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeIsNull() {
            addCriterion("nature_business_type is null");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeIsNotNull() {
            addCriterion("nature_business_type is not null");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeEqualTo(Integer value) {
            addCriterion("nature_business_type =", value, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeNotEqualTo(Integer value) {
            addCriterion("nature_business_type <>", value, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeGreaterThan(Integer value) {
            addCriterion("nature_business_type >", value, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("nature_business_type >=", value, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeLessThan(Integer value) {
            addCriterion("nature_business_type <", value, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeLessThanOrEqualTo(Integer value) {
            addCriterion("nature_business_type <=", value, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeIn(List<Integer> values) {
            addCriterion("nature_business_type in", values, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeNotIn(List<Integer> values) {
            addCriterion("nature_business_type not in", values, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeBetween(Integer value1, Integer value2) {
            addCriterion("nature_business_type between", value1, value2, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andNatureBusinessTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("nature_business_type not between", value1, value2, "natureBusinessType");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateIsNull() {
            addCriterion("capital_paid_rate is null");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateIsNotNull() {
            addCriterion("capital_paid_rate is not null");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateEqualTo(BigDecimal value) {
            addCriterion("capital_paid_rate =", value, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateNotEqualTo(BigDecimal value) {
            addCriterion("capital_paid_rate <>", value, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateGreaterThan(BigDecimal value) {
            addCriterion("capital_paid_rate >", value, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("capital_paid_rate >=", value, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateLessThan(BigDecimal value) {
            addCriterion("capital_paid_rate <", value, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("capital_paid_rate <=", value, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateIn(List<BigDecimal> values) {
            addCriterion("capital_paid_rate in", values, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateNotIn(List<BigDecimal> values) {
            addCriterion("capital_paid_rate not in", values, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("capital_paid_rate between", value1, value2, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andCapitalPaidRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("capital_paid_rate not between", value1, value2, "capitalPaidRate");
            return (Criteria) this;
        }

        public Criteria andLogoIsNull() {
            addCriterion("logo is null");
            return (Criteria) this;
        }

        public Criteria andLogoIsNotNull() {
            addCriterion("logo is not null");
            return (Criteria) this;
        }

        public Criteria andLogoEqualTo(String value) {
            addCriterion("logo =", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoNotEqualTo(String value) {
            addCriterion("logo <>", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoGreaterThan(String value) {
            addCriterion("logo >", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoGreaterThanOrEqualTo(String value) {
            addCriterion("logo >=", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoLessThan(String value) {
            addCriterion("logo <", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoLessThanOrEqualTo(String value) {
            addCriterion("logo <=", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoLike(String value) {
            addCriterion("logo like", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoNotLike(String value) {
            addCriterion("logo not like", value, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoIn(List<String> values) {
            addCriterion("logo in", values, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoNotIn(List<String> values) {
            addCriterion("logo not in", values, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoBetween(String value1, String value2) {
            addCriterion("logo between", value1, value2, "logo");
            return (Criteria) this;
        }

        public Criteria andLogoNotBetween(String value1, String value2) {
            addCriterion("logo not between", value1, value2, "logo");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIsNull() {
            addCriterion("isvisible is null");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIsNotNull() {
            addCriterion("isvisible is not null");
            return (Criteria) this;
        }

        public Criteria andIsvisibleEqualTo(Integer value) {
            addCriterion("isvisible =", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotEqualTo(Integer value) {
            addCriterion("isvisible <>", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleGreaterThan(Integer value) {
            addCriterion("isvisible >", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleGreaterThanOrEqualTo(Integer value) {
            addCriterion("isvisible >=", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleLessThan(Integer value) {
            addCriterion("isvisible <", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleLessThanOrEqualTo(Integer value) {
            addCriterion("isvisible <=", value, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleIn(List<Integer> values) {
            addCriterion("isvisible in", values, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotIn(List<Integer> values) {
            addCriterion("isvisible not in", values, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleBetween(Integer value1, Integer value2) {
            addCriterion("isvisible between", value1, value2, "isvisible");
            return (Criteria) this;
        }

        public Criteria andIsvisibleNotBetween(Integer value1, Integer value2) {
            addCriterion("isvisible not between", value1, value2, "isvisible");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalIsNull() {
            addCriterion("paid_capital is null");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalIsNotNull() {
            addCriterion("paid_capital is not null");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalEqualTo(BigDecimal value) {
            addCriterion("paid_capital =", value, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalNotEqualTo(BigDecimal value) {
            addCriterion("paid_capital <>", value, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalGreaterThan(BigDecimal value) {
            addCriterion("paid_capital >", value, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("paid_capital >=", value, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalLessThan(BigDecimal value) {
            addCriterion("paid_capital <", value, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("paid_capital <=", value, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalIn(List<BigDecimal> values) {
            addCriterion("paid_capital in", values, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalNotIn(List<BigDecimal> values) {
            addCriterion("paid_capital not in", values, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("paid_capital between", value1, value2, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andPaidCapitalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("paid_capital not between", value1, value2, "paidCapital");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeIsNull() {
            addCriterion("company_asset_size is null");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeIsNotNull() {
            addCriterion("company_asset_size is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeEqualTo(Integer value) {
            addCriterion("company_asset_size =", value, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeNotEqualTo(Integer value) {
            addCriterion("company_asset_size <>", value, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeGreaterThan(Integer value) {
            addCriterion("company_asset_size >", value, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeGreaterThanOrEqualTo(Integer value) {
            addCriterion("company_asset_size >=", value, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeLessThan(Integer value) {
            addCriterion("company_asset_size <", value, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeLessThanOrEqualTo(Integer value) {
            addCriterion("company_asset_size <=", value, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeIn(List<Integer> values) {
            addCriterion("company_asset_size in", values, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeNotIn(List<Integer> values) {
            addCriterion("company_asset_size not in", values, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeBetween(Integer value1, Integer value2) {
            addCriterion("company_asset_size between", value1, value2, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andCompanyAssetSizeNotBetween(Integer value1, Integer value2) {
            addCriterion("company_asset_size not between", value1, value2, "companyAssetSize");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeIsNull() {
            addCriterion("legal_representative is null");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeIsNotNull() {
            addCriterion("legal_representative is not null");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeEqualTo(String value) {
            addCriterion("legal_representative =", value, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeNotEqualTo(String value) {
            addCriterion("legal_representative <>", value, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeGreaterThan(String value) {
            addCriterion("legal_representative >", value, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeGreaterThanOrEqualTo(String value) {
            addCriterion("legal_representative >=", value, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeLessThan(String value) {
            addCriterion("legal_representative <", value, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeLessThanOrEqualTo(String value) {
            addCriterion("legal_representative <=", value, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeLike(String value) {
            addCriterion("legal_representative like", value, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeNotLike(String value) {
            addCriterion("legal_representative not like", value, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeIn(List<String> values) {
            addCriterion("legal_representative in", values, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeNotIn(List<String> values) {
            addCriterion("legal_representative not in", values, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeBetween(String value1, String value2) {
            addCriterion("legal_representative between", value1, value2, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andLegalRepresentativeNotBetween(String value1, String value2) {
            addCriterion("legal_representative not between", value1, value2, "legalRepresentative");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIsNull() {
            addCriterion("is_qualify is null");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIsNotNull() {
            addCriterion("is_qualify is not null");
            return (Criteria) this;
        }

        public Criteria andIsQualifyEqualTo(Integer value) {
            addCriterion("is_qualify =", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotEqualTo(Integer value) {
            addCriterion("is_qualify <>", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyGreaterThan(Integer value) {
            addCriterion("is_qualify >", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_qualify >=", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyLessThan(Integer value) {
            addCriterion("is_qualify <", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyLessThanOrEqualTo(Integer value) {
            addCriterion("is_qualify <=", value, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyIn(List<Integer> values) {
            addCriterion("is_qualify in", values, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotIn(List<Integer> values) {
            addCriterion("is_qualify not in", values, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyBetween(Integer value1, Integer value2) {
            addCriterion("is_qualify between", value1, value2, "isQualify");
            return (Criteria) this;
        }

        public Criteria andIsQualifyNotBetween(Integer value1, Integer value2) {
            addCriterion("is_qualify not between", value1, value2, "isQualify");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodIsNull() {
            addCriterion("get_qualify_method is null");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodIsNotNull() {
            addCriterion("get_qualify_method is not null");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodEqualTo(String value) {
            addCriterion("get_qualify_method =", value, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodNotEqualTo(String value) {
            addCriterion("get_qualify_method <>", value, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodGreaterThan(String value) {
            addCriterion("get_qualify_method >", value, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodGreaterThanOrEqualTo(String value) {
            addCriterion("get_qualify_method >=", value, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodLessThan(String value) {
            addCriterion("get_qualify_method <", value, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodLessThanOrEqualTo(String value) {
            addCriterion("get_qualify_method <=", value, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodLike(String value) {
            addCriterion("get_qualify_method like", value, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodNotLike(String value) {
            addCriterion("get_qualify_method not like", value, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodIn(List<String> values) {
            addCriterion("get_qualify_method in", values, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodNotIn(List<String> values) {
            addCriterion("get_qualify_method not in", values, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodBetween(String value1, String value2) {
            addCriterion("get_qualify_method between", value1, value2, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andGetQualifyMethodNotBetween(String value1, String value2) {
            addCriterion("get_qualify_method not between", value1, value2, "getQualifyMethod");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsIsNull() {
            addCriterion("employee_cnts is null");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsIsNotNull() {
            addCriterion("employee_cnts is not null");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsEqualTo(Integer value) {
            addCriterion("employee_cnts =", value, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsNotEqualTo(Integer value) {
            addCriterion("employee_cnts <>", value, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsGreaterThan(Integer value) {
            addCriterion("employee_cnts >", value, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsGreaterThanOrEqualTo(Integer value) {
            addCriterion("employee_cnts >=", value, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsLessThan(Integer value) {
            addCriterion("employee_cnts <", value, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsLessThanOrEqualTo(Integer value) {
            addCriterion("employee_cnts <=", value, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsIn(List<Integer> values) {
            addCriterion("employee_cnts in", values, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsNotIn(List<Integer> values) {
            addCriterion("employee_cnts not in", values, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsBetween(Integer value1, Integer value2) {
            addCriterion("employee_cnts between", value1, value2, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andEmployeeCntsNotBetween(Integer value1, Integer value2) {
            addCriterion("employee_cnts not between", value1, value2, "employeeCnts");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoIsNull() {
            addCriterion("integrity_info is null");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoIsNotNull() {
            addCriterion("integrity_info is not null");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoEqualTo(String value) {
            addCriterion("integrity_info =", value, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoNotEqualTo(String value) {
            addCriterion("integrity_info <>", value, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoGreaterThan(String value) {
            addCriterion("integrity_info >", value, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoGreaterThanOrEqualTo(String value) {
            addCriterion("integrity_info >=", value, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoLessThan(String value) {
            addCriterion("integrity_info <", value, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoLessThanOrEqualTo(String value) {
            addCriterion("integrity_info <=", value, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoLike(String value) {
            addCriterion("integrity_info like", value, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoNotLike(String value) {
            addCriterion("integrity_info not like", value, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoIn(List<String> values) {
            addCriterion("integrity_info in", values, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoNotIn(List<String> values) {
            addCriterion("integrity_info not in", values, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoBetween(String value1, String value2) {
            addCriterion("integrity_info between", value1, value2, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andIntegrityInfoNotBetween(String value1, String value2) {
            addCriterion("integrity_info not between", value1, value2, "integrityInfo");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsIsNull() {
            addCriterion("special_tips is null");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsIsNotNull() {
            addCriterion("special_tips is not null");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsEqualTo(String value) {
            addCriterion("special_tips =", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsNotEqualTo(String value) {
            addCriterion("special_tips <>", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsGreaterThan(String value) {
            addCriterion("special_tips >", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsGreaterThanOrEqualTo(String value) {
            addCriterion("special_tips >=", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsLessThan(String value) {
            addCriterion("special_tips <", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsLessThanOrEqualTo(String value) {
            addCriterion("special_tips <=", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsLike(String value) {
            addCriterion("special_tips like", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsNotLike(String value) {
            addCriterion("special_tips not like", value, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsIn(List<String> values) {
            addCriterion("special_tips in", values, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsNotIn(List<String> values) {
            addCriterion("special_tips not in", values, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsBetween(String value1, String value2) {
            addCriterion("special_tips between", value1, value2, "specialTips");
            return (Criteria) this;
        }

        public Criteria andSpecialTipsNotBetween(String value1, String value2) {
            addCriterion("special_tips not between", value1, value2, "specialTips");
            return (Criteria) this;
        }

        public Criteria andAmacLinkIsNull() {
            addCriterion("amac_link is null");
            return (Criteria) this;
        }

        public Criteria andAmacLinkIsNotNull() {
            addCriterion("amac_link is not null");
            return (Criteria) this;
        }

        public Criteria andAmacLinkEqualTo(String value) {
            addCriterion("amac_link =", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkNotEqualTo(String value) {
            addCriterion("amac_link <>", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkGreaterThan(String value) {
            addCriterion("amac_link >", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkGreaterThanOrEqualTo(String value) {
            addCriterion("amac_link >=", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkLessThan(String value) {
            addCriterion("amac_link <", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkLessThanOrEqualTo(String value) {
            addCriterion("amac_link <=", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkLike(String value) {
            addCriterion("amac_link like", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkNotLike(String value) {
            addCriterion("amac_link not like", value, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkIn(List<String> values) {
            addCriterion("amac_link in", values, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkNotIn(List<String> values) {
            addCriterion("amac_link not in", values, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkBetween(String value1, String value2) {
            addCriterion("amac_link between", value1, value2, "amacLink");
            return (Criteria) this;
        }

        public Criteria andAmacLinkNotBetween(String value1, String value2) {
            addCriterion("amac_link not between", value1, value2, "amacLink");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}