package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TxFundPerformanceExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TxFundPerformanceExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("end_date is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("end_date is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("end_date =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("end_date >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(Date value) {
            addCriterionForJDBCDate("end_date <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("end_date in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("end_date not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNull() {
            addCriterion("price_date is null");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNotNull() {
            addCriterion("price_date is not null");
            return (Criteria) this;
        }

        public Criteria andPriceDateEqualTo(Date value) {
            addCriterionForJDBCDate("price_date =", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <>", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThan(Date value) {
            addCriterionForJDBCDate("price_date >", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date >=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThan(Date value) {
            addCriterionForJDBCDate("price_date <", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateIn(List<Date> values) {
            addCriterionForJDBCDate("price_date in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("price_date not in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date not between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNull() {
            addCriterion("cumulative_nav is null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNotNull() {
            addCriterion("cumulative_nav is not null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav =", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav <>", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThan(BigDecimal value) {
            addCriterion("cumulative_nav >", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav >=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThan(BigDecimal value) {
            addCriterion("cumulative_nav <", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav <=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIn(List<BigDecimal> values) {
            addCriterion("cumulative_nav in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotIn(List<BigDecimal> values) {
            addCriterion("cumulative_nav not in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cumulative_nav between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cumulative_nav not between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andRet1dayIsNull() {
            addCriterion("ret_1day is null");
            return (Criteria) this;
        }

        public Criteria andRet1dayIsNotNull() {
            addCriterion("ret_1day is not null");
            return (Criteria) this;
        }

        public Criteria andRet1dayEqualTo(BigDecimal value) {
            addCriterion("ret_1day =", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayNotEqualTo(BigDecimal value) {
            addCriterion("ret_1day <>", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayGreaterThan(BigDecimal value) {
            addCriterion("ret_1day >", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1day >=", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayLessThan(BigDecimal value) {
            addCriterion("ret_1day <", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1day <=", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayIn(List<BigDecimal> values) {
            addCriterion("ret_1day in", values, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayNotIn(List<BigDecimal> values) {
            addCriterion("ret_1day not in", values, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1day between", value1, value2, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1day not between", value1, value2, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1IsNull() {
            addCriterion("ret_1day_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1IsNotNull() {
            addCriterion("ret_1day_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1EqualTo(BigDecimal value) {
            addCriterion("ret_1day_bm1 =", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_1day_bm1 <>", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_1day_bm1 >", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1day_bm1 >=", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1LessThan(BigDecimal value) {
            addCriterion("ret_1day_bm1 <", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1day_bm1 <=", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1In(List<BigDecimal> values) {
            addCriterion("ret_1day_bm1 in", values, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_1day_bm1 not in", values, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1day_bm1 between", value1, value2, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1day_bm1 not between", value1, value2, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wIsNull() {
            addCriterion("ret_1w is null");
            return (Criteria) this;
        }

        public Criteria andRet1wIsNotNull() {
            addCriterion("ret_1w is not null");
            return (Criteria) this;
        }

        public Criteria andRet1wEqualTo(BigDecimal value) {
            addCriterion("ret_1w =", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotEqualTo(BigDecimal value) {
            addCriterion("ret_1w <>", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wGreaterThan(BigDecimal value) {
            addCriterion("ret_1w >", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w >=", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wLessThan(BigDecimal value) {
            addCriterion("ret_1w <", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w <=", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wIn(List<BigDecimal> values) {
            addCriterion("ret_1w in", values, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotIn(List<BigDecimal> values) {
            addCriterion("ret_1w not in", values, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w between", value1, value2, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w not between", value1, value2, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1IsNull() {
            addCriterion("ret_1w_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1IsNotNull() {
            addCriterion("ret_1w_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1EqualTo(BigDecimal value) {
            addCriterion("ret_1w_bm1 =", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_1w_bm1 <>", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_1w_bm1 >", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w_bm1 >=", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1LessThan(BigDecimal value) {
            addCriterion("ret_1w_bm1 <", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w_bm1 <=", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1In(List<BigDecimal> values) {
            addCriterion("ret_1w_bm1 in", values, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_1w_bm1 not in", values, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w_bm1 between", value1, value2, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w_bm1 not between", value1, value2, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNull() {
            addCriterion("ret_1m is null");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNotNull() {
            addCriterion("ret_1m is not null");
            return (Criteria) this;
        }

        public Criteria andRet1mEqualTo(BigDecimal value) {
            addCriterion("ret_1m =", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotEqualTo(BigDecimal value) {
            addCriterion("ret_1m <>", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThan(BigDecimal value) {
            addCriterion("ret_1m >", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m >=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThan(BigDecimal value) {
            addCriterion("ret_1m <", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m <=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mIn(List<BigDecimal> values) {
            addCriterion("ret_1m in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotIn(List<BigDecimal> values) {
            addCriterion("ret_1m not in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m not between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mIsNull() {
            addCriterion("ret_cum_1m is null");
            return (Criteria) this;
        }

        public Criteria andRetCum1mIsNotNull() {
            addCriterion("ret_cum_1m is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum1mEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1m =", value, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1m <>", value, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_1m >", value, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1m >=", value, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mLessThan(BigDecimal value) {
            addCriterion("ret_cum_1m <", value, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1m <=", value, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mIn(List<BigDecimal> values) {
            addCriterion("ret_cum_1m in", values, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_1m not in", values, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_1m between", value1, value2, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRetCum1mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_1m not between", value1, value2, "retCum1m");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1IsNull() {
            addCriterion("ret_1m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1IsNotNull() {
            addCriterion("ret_1m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_1m_bm1 =", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_1m_bm1 <>", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_1m_bm1 >", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m_bm1 >=", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1LessThan(BigDecimal value) {
            addCriterion("ret_1m_bm1 <", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m_bm1 <=", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1In(List<BigDecimal> values) {
            addCriterion("ret_1m_bm1 in", values, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_1m_bm1 not in", values, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m_bm1 between", value1, value2, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m_bm1 not between", value1, value2, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1IsNull() {
            addCriterion("ret_cum_1m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1IsNotNull() {
            addCriterion("ret_cum_1m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_1m_bm1 =", value, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1m_bm1 <>", value, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_1m_bm1 >", value, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1m_bm1 >=", value, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_1m_bm1 <", value, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1m_bm1 <=", value, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_1m_bm1 in", values, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_1m_bm1 not in", values, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_1m_bm1 between", value1, value2, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_1m_bm1 not between", value1, value2, "retCum1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mIsNull() {
            addCriterion("ret_3m is null");
            return (Criteria) this;
        }

        public Criteria andRet3mIsNotNull() {
            addCriterion("ret_3m is not null");
            return (Criteria) this;
        }

        public Criteria andRet3mEqualTo(BigDecimal value) {
            addCriterion("ret_3m =", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotEqualTo(BigDecimal value) {
            addCriterion("ret_3m <>", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mGreaterThan(BigDecimal value) {
            addCriterion("ret_3m >", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3m >=", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mLessThan(BigDecimal value) {
            addCriterion("ret_3m <", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3m <=", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mIn(List<BigDecimal> values) {
            addCriterion("ret_3m in", values, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotIn(List<BigDecimal> values) {
            addCriterion("ret_3m not in", values, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3m between", value1, value2, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3m not between", value1, value2, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1IsNull() {
            addCriterion("ret_3m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1IsNotNull() {
            addCriterion("ret_3m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_3m_bm1 =", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_3m_bm1 <>", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_3m_bm1 >", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3m_bm1 >=", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1LessThan(BigDecimal value) {
            addCriterion("ret_3m_bm1 <", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3m_bm1 <=", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1In(List<BigDecimal> values) {
            addCriterion("ret_3m_bm1 in", values, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_3m_bm1 not in", values, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3m_bm1 between", value1, value2, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3m_bm1 not between", value1, value2, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mIsNull() {
            addCriterion("ret_cum_3m is null");
            return (Criteria) this;
        }

        public Criteria andRetCum3mIsNotNull() {
            addCriterion("ret_cum_3m is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum3mEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3m =", value, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3m <>", value, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_3m >", value, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3m >=", value, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mLessThan(BigDecimal value) {
            addCriterion("ret_cum_3m <", value, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3m <=", value, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mIn(List<BigDecimal> values) {
            addCriterion("ret_cum_3m in", values, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_3m not in", values, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_3m between", value1, value2, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_3m not between", value1, value2, "retCum3m");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1IsNull() {
            addCriterion("ret_cum_3m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1IsNotNull() {
            addCriterion("ret_cum_3m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_3m_bm1 =", value, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3m_bm1 <>", value, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_3m_bm1 >", value, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3m_bm1 >=", value, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_3m_bm1 <", value, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3m_bm1 <=", value, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_3m_bm1 in", values, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_3m_bm1 not in", values, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_3m_bm1 between", value1, value2, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_3m_bm1 not between", value1, value2, "retCum3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNull() {
            addCriterion("ret_6m is null");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNotNull() {
            addCriterion("ret_6m is not null");
            return (Criteria) this;
        }

        public Criteria andRet6mEqualTo(BigDecimal value) {
            addCriterion("ret_6m =", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotEqualTo(BigDecimal value) {
            addCriterion("ret_6m <>", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThan(BigDecimal value) {
            addCriterion("ret_6m >", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m >=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThan(BigDecimal value) {
            addCriterion("ret_6m <", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m <=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mIn(List<BigDecimal> values) {
            addCriterion("ret_6m in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotIn(List<BigDecimal> values) {
            addCriterion("ret_6m not in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m not between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mIsNull() {
            addCriterion("ret_cum_6m is null");
            return (Criteria) this;
        }

        public Criteria andRetCum6mIsNotNull() {
            addCriterion("ret_cum_6m is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum6mEqualTo(BigDecimal value) {
            addCriterion("ret_cum_6m =", value, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_6m <>", value, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_6m >", value, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_6m >=", value, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mLessThan(BigDecimal value) {
            addCriterion("ret_cum_6m <", value, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_6m <=", value, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mIn(List<BigDecimal> values) {
            addCriterion("ret_cum_6m in", values, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_6m not in", values, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_6m between", value1, value2, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRetCum6mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_6m not between", value1, value2, "retCum6m");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1IsNull() {
            addCriterion("ret_6m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1IsNotNull() {
            addCriterion("ret_6m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_6m_bm1 =", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_6m_bm1 <>", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_6m_bm1 >", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m_bm1 >=", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1LessThan(BigDecimal value) {
            addCriterion("ret_6m_bm1 <", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m_bm1 <=", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1In(List<BigDecimal> values) {
            addCriterion("ret_6m_bm1 in", values, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_6m_bm1 not in", values, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m_bm1 between", value1, value2, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m_bm1 not between", value1, value2, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1IsNull() {
            addCriterion("ret_cum_6m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1IsNotNull() {
            addCriterion("ret_cum_6m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_6m_bm1 =", value, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_6m_bm1 <>", value, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_6m_bm1 >", value, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_6m_bm1 >=", value, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_6m_bm1 <", value, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_6m_bm1 <=", value, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_6m_bm1 in", values, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_6m_bm1 not in", values, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_6m_bm1 between", value1, value2, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum6mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_6m_bm1 not between", value1, value2, "retCum6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNull() {
            addCriterion("ret_1y is null");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNotNull() {
            addCriterion("ret_1y is not null");
            return (Criteria) this;
        }

        public Criteria andRet1yEqualTo(BigDecimal value) {
            addCriterion("ret_1y =", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotEqualTo(BigDecimal value) {
            addCriterion("ret_1y <>", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThan(BigDecimal value) {
            addCriterion("ret_1y >", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y >=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThan(BigDecimal value) {
            addCriterion("ret_1y <", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y <=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yIn(List<BigDecimal> values) {
            addCriterion("ret_1y in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotIn(List<BigDecimal> values) {
            addCriterion("ret_1y not in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y not between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yIsNull() {
            addCriterion("ret_cum_1y is null");
            return (Criteria) this;
        }

        public Criteria andRetCum1yIsNotNull() {
            addCriterion("ret_cum_1y is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum1yEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1y =", value, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1y <>", value, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_1y >", value, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1y >=", value, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yLessThan(BigDecimal value) {
            addCriterion("ret_cum_1y <", value, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1y <=", value, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yIn(List<BigDecimal> values) {
            addCriterion("ret_cum_1y in", values, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_1y not in", values, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_1y between", value1, value2, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRetCum1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_1y not between", value1, value2, "retCum1y");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1IsNull() {
            addCriterion("ret_1y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1IsNotNull() {
            addCriterion("ret_1y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_1y_bm1 =", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_1y_bm1 <>", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_1y_bm1 >", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y_bm1 >=", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1LessThan(BigDecimal value) {
            addCriterion("ret_1y_bm1 <", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y_bm1 <=", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1In(List<BigDecimal> values) {
            addCriterion("ret_1y_bm1 in", values, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_1y_bm1 not in", values, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y_bm1 between", value1, value2, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y_bm1 not between", value1, value2, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1IsNull() {
            addCriterion("ret_cum_1y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1IsNotNull() {
            addCriterion("ret_cum_1y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_1y_bm1 =", value, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1y_bm1 <>", value, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_1y_bm1 >", value, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1y_bm1 >=", value, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_1y_bm1 <", value, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_1y_bm1 <=", value, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_1y_bm1 in", values, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_1y_bm1 not in", values, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_1y_bm1 between", value1, value2, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum1yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_1y_bm1 not between", value1, value2, "retCum1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yIsNull() {
            addCriterion("ret_2y is null");
            return (Criteria) this;
        }

        public Criteria andRet2yIsNotNull() {
            addCriterion("ret_2y is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yEqualTo(BigDecimal value) {
            addCriterion("ret_2y =", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotEqualTo(BigDecimal value) {
            addCriterion("ret_2y <>", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yGreaterThan(BigDecimal value) {
            addCriterion("ret_2y >", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y >=", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yLessThan(BigDecimal value) {
            addCriterion("ret_2y <", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y <=", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yIn(List<BigDecimal> values) {
            addCriterion("ret_2y in", values, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotIn(List<BigDecimal> values) {
            addCriterion("ret_2y not in", values, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y between", value1, value2, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y not between", value1, value2, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yIsNull() {
            addCriterion("ret_cum_2y is null");
            return (Criteria) this;
        }

        public Criteria andRetCum2yIsNotNull() {
            addCriterion("ret_cum_2y is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum2yEqualTo(BigDecimal value) {
            addCriterion("ret_cum_2y =", value, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_2y <>", value, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_2y >", value, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_2y >=", value, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yLessThan(BigDecimal value) {
            addCriterion("ret_cum_2y <", value, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_2y <=", value, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yIn(List<BigDecimal> values) {
            addCriterion("ret_cum_2y in", values, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_2y not in", values, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_2y between", value1, value2, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRetCum2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_2y not between", value1, value2, "retCum2y");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1IsNull() {
            addCriterion("ret_2y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1IsNotNull() {
            addCriterion("ret_2y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1 =", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1 <>", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_2y_bm1 >", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1 >=", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1LessThan(BigDecimal value) {
            addCriterion("ret_2y_bm1 <", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1 <=", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1In(List<BigDecimal> values) {
            addCriterion("ret_2y_bm1 in", values, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_2y_bm1 not in", values, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_bm1 between", value1, value2, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_bm1 not between", value1, value2, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1IsNull() {
            addCriterion("ret_cum_2y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1IsNotNull() {
            addCriterion("ret_cum_2y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_2y_bm1 =", value, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_2y_bm1 <>", value, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_2y_bm1 >", value, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_2y_bm1 >=", value, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_2y_bm1 <", value, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_2y_bm1 <=", value, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_2y_bm1 in", values, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_2y_bm1 not in", values, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_2y_bm1 between", value1, value2, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum2yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_2y_bm1 not between", value1, value2, "retCum2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yAIsNull() {
            addCriterion("ret_2y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet2yAIsNotNull() {
            addCriterion("ret_2y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yAEqualTo(BigDecimal value) {
            addCriterion("ret_2y_a =", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotEqualTo(BigDecimal value) {
            addCriterion("ret_2y_a <>", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAGreaterThan(BigDecimal value) {
            addCriterion("ret_2y_a >", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_a >=", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yALessThan(BigDecimal value) {
            addCriterion("ret_2y_a <", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_a <=", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAIn(List<BigDecimal> values) {
            addCriterion("ret_2y_a in", values, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotIn(List<BigDecimal> values) {
            addCriterion("ret_2y_a not in", values, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_a between", value1, value2, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_a not between", value1, value2, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AIsNull() {
            addCriterion("ret_2y_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AIsNotNull() {
            addCriterion("ret_2y_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1_a =", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1_a <>", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_2y_bm1_a >", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1_a >=", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ALessThan(BigDecimal value) {
            addCriterion("ret_2y_bm1_a <", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1_a <=", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_2y_bm1_a in", values, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_2y_bm1_a not in", values, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_bm1_a between", value1, value2, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_bm1_a not between", value1, value2, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yIsNull() {
            addCriterion("ret_3y is null");
            return (Criteria) this;
        }

        public Criteria andRet3yIsNotNull() {
            addCriterion("ret_3y is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yEqualTo(BigDecimal value) {
            addCriterion("ret_3y =", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotEqualTo(BigDecimal value) {
            addCriterion("ret_3y <>", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yGreaterThan(BigDecimal value) {
            addCriterion("ret_3y >", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y >=", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yLessThan(BigDecimal value) {
            addCriterion("ret_3y <", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y <=", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yIn(List<BigDecimal> values) {
            addCriterion("ret_3y in", values, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotIn(List<BigDecimal> values) {
            addCriterion("ret_3y not in", values, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y between", value1, value2, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y not between", value1, value2, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yIsNull() {
            addCriterion("ret_cum_3y is null");
            return (Criteria) this;
        }

        public Criteria andRetCum3yIsNotNull() {
            addCriterion("ret_cum_3y is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum3yEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3y =", value, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3y <>", value, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_3y >", value, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3y >=", value, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yLessThan(BigDecimal value) {
            addCriterion("ret_cum_3y <", value, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3y <=", value, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yIn(List<BigDecimal> values) {
            addCriterion("ret_cum_3y in", values, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_3y not in", values, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_3y between", value1, value2, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRetCum3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_3y not between", value1, value2, "retCum3y");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1IsNull() {
            addCriterion("ret_3y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1IsNotNull() {
            addCriterion("ret_3y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1 =", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1 <>", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_3y_bm1 >", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1 >=", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1LessThan(BigDecimal value) {
            addCriterion("ret_3y_bm1 <", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1 <=", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1In(List<BigDecimal> values) {
            addCriterion("ret_3y_bm1 in", values, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_3y_bm1 not in", values, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_bm1 between", value1, value2, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_bm1 not between", value1, value2, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1IsNull() {
            addCriterion("ret_cum_3y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1IsNotNull() {
            addCriterion("ret_cum_3y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_3y_bm1 =", value, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3y_bm1 <>", value, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_3y_bm1 >", value, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3y_bm1 >=", value, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_3y_bm1 <", value, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_3y_bm1 <=", value, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_3y_bm1 in", values, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_3y_bm1 not in", values, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_3y_bm1 between", value1, value2, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum3yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_3y_bm1 not between", value1, value2, "retCum3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yAIsNull() {
            addCriterion("ret_3y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet3yAIsNotNull() {
            addCriterion("ret_3y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yAEqualTo(BigDecimal value) {
            addCriterion("ret_3y_a =", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotEqualTo(BigDecimal value) {
            addCriterion("ret_3y_a <>", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAGreaterThan(BigDecimal value) {
            addCriterion("ret_3y_a >", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_a >=", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yALessThan(BigDecimal value) {
            addCriterion("ret_3y_a <", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_a <=", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAIn(List<BigDecimal> values) {
            addCriterion("ret_3y_a in", values, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotIn(List<BigDecimal> values) {
            addCriterion("ret_3y_a not in", values, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_a between", value1, value2, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_a not between", value1, value2, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AIsNull() {
            addCriterion("ret_3y_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AIsNotNull() {
            addCriterion("ret_3y_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1_a =", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1_a <>", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_3y_bm1_a >", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1_a >=", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ALessThan(BigDecimal value) {
            addCriterion("ret_3y_bm1_a <", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1_a <=", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_3y_bm1_a in", values, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_3y_bm1_a not in", values, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_bm1_a between", value1, value2, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_bm1_a not between", value1, value2, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yIsNull() {
            addCriterion("ret_4y is null");
            return (Criteria) this;
        }

        public Criteria andRet4yIsNotNull() {
            addCriterion("ret_4y is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yEqualTo(BigDecimal value) {
            addCriterion("ret_4y =", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotEqualTo(BigDecimal value) {
            addCriterion("ret_4y <>", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yGreaterThan(BigDecimal value) {
            addCriterion("ret_4y >", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y >=", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yLessThan(BigDecimal value) {
            addCriterion("ret_4y <", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y <=", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yIn(List<BigDecimal> values) {
            addCriterion("ret_4y in", values, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotIn(List<BigDecimal> values) {
            addCriterion("ret_4y not in", values, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y between", value1, value2, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y not between", value1, value2, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yIsNull() {
            addCriterion("ret_cum_4y is null");
            return (Criteria) this;
        }

        public Criteria andRetCum4yIsNotNull() {
            addCriterion("ret_cum_4y is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum4yEqualTo(BigDecimal value) {
            addCriterion("ret_cum_4y =", value, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_4y <>", value, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_4y >", value, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_4y >=", value, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yLessThan(BigDecimal value) {
            addCriterion("ret_cum_4y <", value, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_4y <=", value, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yIn(List<BigDecimal> values) {
            addCriterion("ret_cum_4y in", values, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_4y not in", values, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_4y between", value1, value2, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRetCum4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_4y not between", value1, value2, "retCum4y");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1IsNull() {
            addCriterion("ret_4y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1IsNotNull() {
            addCriterion("ret_4y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1 =", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1 <>", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_4y_bm1 >", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1 >=", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1LessThan(BigDecimal value) {
            addCriterion("ret_4y_bm1 <", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1 <=", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1In(List<BigDecimal> values) {
            addCriterion("ret_4y_bm1 in", values, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_4y_bm1 not in", values, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_bm1 between", value1, value2, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_bm1 not between", value1, value2, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1IsNull() {
            addCriterion("ret_cum_4y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1IsNotNull() {
            addCriterion("ret_cum_4y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_4y_bm1 =", value, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_4y_bm1 <>", value, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_4y_bm1 >", value, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_4y_bm1 >=", value, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_4y_bm1 <", value, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_4y_bm1 <=", value, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_4y_bm1 in", values, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_4y_bm1 not in", values, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_4y_bm1 between", value1, value2, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum4yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_4y_bm1 not between", value1, value2, "retCum4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yAIsNull() {
            addCriterion("ret_4y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet4yAIsNotNull() {
            addCriterion("ret_4y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yAEqualTo(BigDecimal value) {
            addCriterion("ret_4y_a =", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotEqualTo(BigDecimal value) {
            addCriterion("ret_4y_a <>", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAGreaterThan(BigDecimal value) {
            addCriterion("ret_4y_a >", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_a >=", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yALessThan(BigDecimal value) {
            addCriterion("ret_4y_a <", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_a <=", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAIn(List<BigDecimal> values) {
            addCriterion("ret_4y_a in", values, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotIn(List<BigDecimal> values) {
            addCriterion("ret_4y_a not in", values, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_a between", value1, value2, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_a not between", value1, value2, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AIsNull() {
            addCriterion("ret_4y_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AIsNotNull() {
            addCriterion("ret_4y_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1_a =", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1_a <>", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_4y_bm1_a >", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1_a >=", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ALessThan(BigDecimal value) {
            addCriterion("ret_4y_bm1_a <", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1_a <=", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_4y_bm1_a in", values, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_4y_bm1_a not in", values, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_bm1_a between", value1, value2, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_bm1_a not between", value1, value2, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yIsNull() {
            addCriterion("ret_5y is null");
            return (Criteria) this;
        }

        public Criteria andRet5yIsNotNull() {
            addCriterion("ret_5y is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yEqualTo(BigDecimal value) {
            addCriterion("ret_5y =", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotEqualTo(BigDecimal value) {
            addCriterion("ret_5y <>", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yGreaterThan(BigDecimal value) {
            addCriterion("ret_5y >", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y >=", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yLessThan(BigDecimal value) {
            addCriterion("ret_5y <", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y <=", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yIn(List<BigDecimal> values) {
            addCriterion("ret_5y in", values, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotIn(List<BigDecimal> values) {
            addCriterion("ret_5y not in", values, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y between", value1, value2, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y not between", value1, value2, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yIsNull() {
            addCriterion("ret_cum_5y is null");
            return (Criteria) this;
        }

        public Criteria andRetCum5yIsNotNull() {
            addCriterion("ret_cum_5y is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum5yEqualTo(BigDecimal value) {
            addCriterion("ret_cum_5y =", value, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_5y <>", value, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_5y >", value, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_5y >=", value, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yLessThan(BigDecimal value) {
            addCriterion("ret_cum_5y <", value, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_5y <=", value, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yIn(List<BigDecimal> values) {
            addCriterion("ret_cum_5y in", values, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_5y not in", values, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_5y between", value1, value2, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRetCum5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_5y not between", value1, value2, "retCum5y");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1IsNull() {
            addCriterion("ret_5y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1IsNotNull() {
            addCriterion("ret_5y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1 =", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1 <>", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_5y_bm1 >", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1 >=", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1LessThan(BigDecimal value) {
            addCriterion("ret_5y_bm1 <", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1 <=", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1In(List<BigDecimal> values) {
            addCriterion("ret_5y_bm1 in", values, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_5y_bm1 not in", values, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_bm1 between", value1, value2, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_bm1 not between", value1, value2, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1IsNull() {
            addCriterion("ret_cum_5y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1IsNotNull() {
            addCriterion("ret_cum_5y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_5y_bm1 =", value, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_5y_bm1 <>", value, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_5y_bm1 >", value, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_5y_bm1 >=", value, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_5y_bm1 <", value, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_5y_bm1 <=", value, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_5y_bm1 in", values, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_5y_bm1 not in", values, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_5y_bm1 between", value1, value2, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRetCum5yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_5y_bm1 not between", value1, value2, "retCum5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yAIsNull() {
            addCriterion("ret_5y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet5yAIsNotNull() {
            addCriterion("ret_5y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yAEqualTo(BigDecimal value) {
            addCriterion("ret_5y_a =", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotEqualTo(BigDecimal value) {
            addCriterion("ret_5y_a <>", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAGreaterThan(BigDecimal value) {
            addCriterion("ret_5y_a >", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_a >=", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yALessThan(BigDecimal value) {
            addCriterion("ret_5y_a <", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_a <=", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAIn(List<BigDecimal> values) {
            addCriterion("ret_5y_a in", values, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotIn(List<BigDecimal> values) {
            addCriterion("ret_5y_a not in", values, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_a between", value1, value2, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_a not between", value1, value2, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AIsNull() {
            addCriterion("ret_5y_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AIsNotNull() {
            addCriterion("ret_5y_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1_a =", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1_a <>", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_5y_bm1_a >", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1_a >=", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ALessThan(BigDecimal value) {
            addCriterion("ret_5y_bm1_a <", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1_a <=", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_5y_bm1_a in", values, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_5y_bm1_a not in", values, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_bm1_a between", value1, value2, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_bm1_a not between", value1, value2, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRetYtdIsNull() {
            addCriterion("ret_ytd is null");
            return (Criteria) this;
        }

        public Criteria andRetYtdIsNotNull() {
            addCriterion("ret_ytd is not null");
            return (Criteria) this;
        }

        public Criteria andRetYtdEqualTo(BigDecimal value) {
            addCriterion("ret_ytd =", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotEqualTo(BigDecimal value) {
            addCriterion("ret_ytd <>", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdGreaterThan(BigDecimal value) {
            addCriterion("ret_ytd >", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_ytd >=", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdLessThan(BigDecimal value) {
            addCriterion("ret_ytd <", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_ytd <=", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdIn(List<BigDecimal> values) {
            addCriterion("ret_ytd in", values, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotIn(List<BigDecimal> values) {
            addCriterion("ret_ytd not in", values, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_ytd between", value1, value2, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_ytd not between", value1, value2, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdIsNull() {
            addCriterion("ret_cum_ytd is null");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdIsNotNull() {
            addCriterion("ret_cum_ytd is not null");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdEqualTo(BigDecimal value) {
            addCriterion("ret_cum_ytd =", value, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_ytd <>", value, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_ytd >", value, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_ytd >=", value, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdLessThan(BigDecimal value) {
            addCriterion("ret_cum_ytd <", value, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_ytd <=", value, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdIn(List<BigDecimal> values) {
            addCriterion("ret_cum_ytd in", values, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_ytd not in", values, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_ytd between", value1, value2, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_ytd not between", value1, value2, "retCumYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1IsNull() {
            addCriterion("ret_ytd_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1IsNotNull() {
            addCriterion("ret_ytd_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1EqualTo(BigDecimal value) {
            addCriterion("ret_ytd_bm1 =", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_ytd_bm1 <>", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_ytd_bm1 >", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_ytd_bm1 >=", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1LessThan(BigDecimal value) {
            addCriterion("ret_ytd_bm1 <", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_ytd_bm1 <=", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1In(List<BigDecimal> values) {
            addCriterion("ret_ytd_bm1 in", values, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_ytd_bm1 not in", values, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_ytd_bm1 between", value1, value2, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_ytd_bm1 not between", value1, value2, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1IsNull() {
            addCriterion("ret_cum_ytd_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1IsNotNull() {
            addCriterion("ret_cum_ytd_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_ytd_bm1 =", value, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_ytd_bm1 <>", value, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_ytd_bm1 >", value, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_ytd_bm1 >=", value, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_ytd_bm1 <", value, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_ytd_bm1 <=", value, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_ytd_bm1 in", values, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_ytd_bm1 not in", values, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_ytd_bm1 between", value1, value2, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumYtdBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_ytd_bm1 not between", value1, value2, "retCumYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNull() {
            addCriterion("ret_incep is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNotNull() {
            addCriterion("ret_incep is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepEqualTo(BigDecimal value) {
            addCriterion("ret_incep =", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotEqualTo(BigDecimal value) {
            addCriterion("ret_incep <>", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThan(BigDecimal value) {
            addCriterion("ret_incep >", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep >=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThan(BigDecimal value) {
            addCriterion("ret_incep <", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep <=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepIn(List<BigDecimal> values) {
            addCriterion("ret_incep in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotIn(List<BigDecimal> values) {
            addCriterion("ret_incep not in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep not between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepIsNull() {
            addCriterion("ret_cum_incep is null");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepIsNotNull() {
            addCriterion("ret_cum_incep is not null");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepEqualTo(BigDecimal value) {
            addCriterion("ret_cum_incep =", value, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepNotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_incep <>", value, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepGreaterThan(BigDecimal value) {
            addCriterion("ret_cum_incep >", value, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_incep >=", value, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepLessThan(BigDecimal value) {
            addCriterion("ret_cum_incep <", value, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_incep <=", value, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepIn(List<BigDecimal> values) {
            addCriterion("ret_cum_incep in", values, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepNotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_incep not in", values, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_incep between", value1, value2, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_incep not between", value1, value2, "retCumIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1IsNull() {
            addCriterion("ret_incep_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1IsNotNull() {
            addCriterion("ret_incep_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1EqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1 =", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1 <>", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_incep_bm1 >", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1 >=", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1LessThan(BigDecimal value) {
            addCriterion("ret_incep_bm1 <", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1 <=", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1In(List<BigDecimal> values) {
            addCriterion("ret_incep_bm1 in", values, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_incep_bm1 not in", values, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_bm1 between", value1, value2, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_bm1 not between", value1, value2, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1IsNull() {
            addCriterion("ret_cum_incep_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1IsNotNull() {
            addCriterion("ret_cum_incep_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1EqualTo(BigDecimal value) {
            addCriterion("ret_cum_incep_bm1 =", value, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_cum_incep_bm1 <>", value, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_cum_incep_bm1 >", value, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_incep_bm1 >=", value, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1LessThan(BigDecimal value) {
            addCriterion("ret_cum_incep_bm1 <", value, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_cum_incep_bm1 <=", value, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1In(List<BigDecimal> values) {
            addCriterion("ret_cum_incep_bm1 in", values, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_cum_incep_bm1 not in", values, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_incep_bm1 between", value1, value2, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetCumIncepBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_cum_incep_bm1 not between", value1, value2, "retCumIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIsNull() {
            addCriterion("ret_incep_a is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIsNotNull() {
            addCriterion("ret_incep_a is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepAEqualTo(BigDecimal value) {
            addCriterion("ret_incep_a =", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotEqualTo(BigDecimal value) {
            addCriterion("ret_incep_a <>", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAGreaterThan(BigDecimal value) {
            addCriterion("ret_incep_a >", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_a >=", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepALessThan(BigDecimal value) {
            addCriterion("ret_incep_a <", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_a <=", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIn(List<BigDecimal> values) {
            addCriterion("ret_incep_a in", values, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotIn(List<BigDecimal> values) {
            addCriterion("ret_incep_a not in", values, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_a between", value1, value2, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_a not between", value1, value2, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AIsNull() {
            addCriterion("ret_incep_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AIsNotNull() {
            addCriterion("ret_incep_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1_a =", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1_a <>", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_incep_bm1_a >", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1_a >=", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ALessThan(BigDecimal value) {
            addCriterion("ret_incep_bm1_a <", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1_a <=", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_incep_bm1_a in", values, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_incep_bm1_a not in", values, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_bm1_a between", value1, value2, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_bm1_a not between", value1, value2, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}