package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TxFundRateMappingExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TxFundRateMappingExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueIsNull() {
            addCriterion("initial_unit_value is null");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueIsNotNull() {
            addCriterion("initial_unit_value is not null");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueEqualTo(String value) {
            addCriterion("initial_unit_value =", value, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueNotEqualTo(String value) {
            addCriterion("initial_unit_value <>", value, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueGreaterThan(String value) {
            addCriterion("initial_unit_value >", value, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueGreaterThanOrEqualTo(String value) {
            addCriterion("initial_unit_value >=", value, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueLessThan(String value) {
            addCriterion("initial_unit_value <", value, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueLessThanOrEqualTo(String value) {
            addCriterion("initial_unit_value <=", value, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueLike(String value) {
            addCriterion("initial_unit_value like", value, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueNotLike(String value) {
            addCriterion("initial_unit_value not like", value, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueIn(List<String> values) {
            addCriterion("initial_unit_value in", values, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueNotIn(List<String> values) {
            addCriterion("initial_unit_value not in", values, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueBetween(String value1, String value2) {
            addCriterion("initial_unit_value between", value1, value2, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialUnitValueNotBetween(String value1, String value2) {
            addCriterion("initial_unit_value not between", value1, value2, "initialUnitValue");
            return (Criteria) this;
        }

        public Criteria andInitialSizeIsNull() {
            addCriterion("initial_size is null");
            return (Criteria) this;
        }

        public Criteria andInitialSizeIsNotNull() {
            addCriterion("initial_size is not null");
            return (Criteria) this;
        }

        public Criteria andInitialSizeEqualTo(BigDecimal value) {
            addCriterion("initial_size =", value, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeNotEqualTo(BigDecimal value) {
            addCriterion("initial_size <>", value, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeGreaterThan(BigDecimal value) {
            addCriterion("initial_size >", value, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("initial_size >=", value, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeLessThan(BigDecimal value) {
            addCriterion("initial_size <", value, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("initial_size <=", value, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeIn(List<BigDecimal> values) {
            addCriterion("initial_size in", values, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeNotIn(List<BigDecimal> values) {
            addCriterion("initial_size not in", values, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("initial_size between", value1, value2, "initialSize");
            return (Criteria) this;
        }

        public Criteria andInitialSizeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("initial_size not between", value1, value2, "initialSize");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIsNull() {
            addCriterion("min_investment_share is null");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIsNotNull() {
            addCriterion("min_investment_share is not null");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareEqualTo(BigDecimal value) {
            addCriterion("min_investment_share =", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotEqualTo(BigDecimal value) {
            addCriterion("min_investment_share <>", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareGreaterThan(BigDecimal value) {
            addCriterion("min_investment_share >", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("min_investment_share >=", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareLessThan(BigDecimal value) {
            addCriterion("min_investment_share <", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("min_investment_share <=", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIn(List<BigDecimal> values) {
            addCriterion("min_investment_share in", values, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotIn(List<BigDecimal> values) {
            addCriterion("min_investment_share not in", values, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("min_investment_share between", value1, value2, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("min_investment_share not between", value1, value2, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIsNull() {
            addCriterion("subsequent_investment_share is null");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIsNotNull() {
            addCriterion("subsequent_investment_share is not null");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share =", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share <>", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareGreaterThan(BigDecimal value) {
            addCriterion("subsequent_investment_share >", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share >=", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareLessThan(BigDecimal value) {
            addCriterion("subsequent_investment_share <", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share <=", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIn(List<BigDecimal> values) {
            addCriterion("subsequent_investment_share in", values, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotIn(List<BigDecimal> values) {
            addCriterion("subsequent_investment_share not in", values, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subsequent_investment_share between", value1, value2, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subsequent_investment_share not between", value1, value2, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIsNull() {
            addCriterion("subscription_fee is null");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIsNotNull() {
            addCriterion("subscription_fee is not null");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeEqualTo(BigDecimal value) {
            addCriterion("subscription_fee =", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotEqualTo(BigDecimal value) {
            addCriterion("subscription_fee <>", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeGreaterThan(BigDecimal value) {
            addCriterion("subscription_fee >", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("subscription_fee >=", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeLessThan(BigDecimal value) {
            addCriterion("subscription_fee <", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("subscription_fee <=", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIn(List<BigDecimal> values) {
            addCriterion("subscription_fee in", values, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotIn(List<BigDecimal> values) {
            addCriterion("subscription_fee not in", values, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subscription_fee between", value1, value2, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subscription_fee not between", value1, value2, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteIsNull() {
            addCriterion("subscription_fee_note is null");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteIsNotNull() {
            addCriterion("subscription_fee_note is not null");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteEqualTo(String value) {
            addCriterion("subscription_fee_note =", value, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteNotEqualTo(String value) {
            addCriterion("subscription_fee_note <>", value, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteGreaterThan(String value) {
            addCriterion("subscription_fee_note >", value, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteGreaterThanOrEqualTo(String value) {
            addCriterion("subscription_fee_note >=", value, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteLessThan(String value) {
            addCriterion("subscription_fee_note <", value, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteLessThanOrEqualTo(String value) {
            addCriterion("subscription_fee_note <=", value, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteLike(String value) {
            addCriterion("subscription_fee_note like", value, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteNotLike(String value) {
            addCriterion("subscription_fee_note not like", value, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteIn(List<String> values) {
            addCriterion("subscription_fee_note in", values, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteNotIn(List<String> values) {
            addCriterion("subscription_fee_note not in", values, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteBetween(String value1, String value2) {
            addCriterion("subscription_fee_note between", value1, value2, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNoteNotBetween(String value1, String value2) {
            addCriterion("subscription_fee_note not between", value1, value2, "subscriptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIsNull() {
            addCriterion("redemption_fee is null");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIsNotNull() {
            addCriterion("redemption_fee is not null");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeEqualTo(BigDecimal value) {
            addCriterion("redemption_fee =", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotEqualTo(BigDecimal value) {
            addCriterion("redemption_fee <>", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeGreaterThan(BigDecimal value) {
            addCriterion("redemption_fee >", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("redemption_fee >=", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeLessThan(BigDecimal value) {
            addCriterion("redemption_fee <", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("redemption_fee <=", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIn(List<BigDecimal> values) {
            addCriterion("redemption_fee in", values, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotIn(List<BigDecimal> values) {
            addCriterion("redemption_fee not in", values, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("redemption_fee between", value1, value2, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("redemption_fee not between", value1, value2, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteIsNull() {
            addCriterion("redemption_fee_note is null");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteIsNotNull() {
            addCriterion("redemption_fee_note is not null");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteEqualTo(String value) {
            addCriterion("redemption_fee_note =", value, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteNotEqualTo(String value) {
            addCriterion("redemption_fee_note <>", value, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteGreaterThan(String value) {
            addCriterion("redemption_fee_note >", value, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteGreaterThanOrEqualTo(String value) {
            addCriterion("redemption_fee_note >=", value, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteLessThan(String value) {
            addCriterion("redemption_fee_note <", value, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteLessThanOrEqualTo(String value) {
            addCriterion("redemption_fee_note <=", value, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteLike(String value) {
            addCriterion("redemption_fee_note like", value, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteNotLike(String value) {
            addCriterion("redemption_fee_note not like", value, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteIn(List<String> values) {
            addCriterion("redemption_fee_note in", values, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteNotIn(List<String> values) {
            addCriterion("redemption_fee_note not in", values, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteBetween(String value1, String value2) {
            addCriterion("redemption_fee_note between", value1, value2, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNoteNotBetween(String value1, String value2) {
            addCriterion("redemption_fee_note not between", value1, value2, "redemptionFeeNote");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyIsNull() {
            addCriterion("managementfee_deduction_frequency is null");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyIsNotNull() {
            addCriterion("managementfee_deduction_frequency is not null");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyEqualTo(String value) {
            addCriterion("managementfee_deduction_frequency =", value, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyNotEqualTo(String value) {
            addCriterion("managementfee_deduction_frequency <>", value, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyGreaterThan(String value) {
            addCriterion("managementfee_deduction_frequency >", value, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyGreaterThanOrEqualTo(String value) {
            addCriterion("managementfee_deduction_frequency >=", value, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyLessThan(String value) {
            addCriterion("managementfee_deduction_frequency <", value, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyLessThanOrEqualTo(String value) {
            addCriterion("managementfee_deduction_frequency <=", value, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyLike(String value) {
            addCriterion("managementfee_deduction_frequency like", value, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyNotLike(String value) {
            addCriterion("managementfee_deduction_frequency not like", value, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyIn(List<String> values) {
            addCriterion("managementfee_deduction_frequency in", values, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyNotIn(List<String> values) {
            addCriterion("managementfee_deduction_frequency not in", values, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyBetween(String value1, String value2) {
            addCriterion("managementfee_deduction_frequency between", value1, value2, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeDeductionFrequencyNotBetween(String value1, String value2) {
            addCriterion("managementfee_deduction_frequency not between", value1, value2, "managementfeeDeductionFrequency");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultIsNull() {
            addCriterion("managementfee_consult is null");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultIsNotNull() {
            addCriterion("managementfee_consult is not null");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultEqualTo(BigDecimal value) {
            addCriterion("managementfee_consult =", value, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultNotEqualTo(BigDecimal value) {
            addCriterion("managementfee_consult <>", value, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultGreaterThan(BigDecimal value) {
            addCriterion("managementfee_consult >", value, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("managementfee_consult >=", value, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultLessThan(BigDecimal value) {
            addCriterion("managementfee_consult <", value, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultLessThanOrEqualTo(BigDecimal value) {
            addCriterion("managementfee_consult <=", value, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultIn(List<BigDecimal> values) {
            addCriterion("managementfee_consult in", values, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultNotIn(List<BigDecimal> values) {
            addCriterion("managementfee_consult not in", values, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("managementfee_consult between", value1, value2, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeConsultNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("managementfee_consult not between", value1, value2, "managementfeeConsult");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustIsNull() {
            addCriterion("managementfee_trust is null");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustIsNotNull() {
            addCriterion("managementfee_trust is not null");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustEqualTo(BigDecimal value) {
            addCriterion("managementfee_trust =", value, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustNotEqualTo(BigDecimal value) {
            addCriterion("managementfee_trust <>", value, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustGreaterThan(BigDecimal value) {
            addCriterion("managementfee_trust >", value, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("managementfee_trust >=", value, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustLessThan(BigDecimal value) {
            addCriterion("managementfee_trust <", value, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustLessThanOrEqualTo(BigDecimal value) {
            addCriterion("managementfee_trust <=", value, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustIn(List<BigDecimal> values) {
            addCriterion("managementfee_trust in", values, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustNotIn(List<BigDecimal> values) {
            addCriterion("managementfee_trust not in", values, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("managementfee_trust between", value1, value2, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeTrustNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("managementfee_trust not between", value1, value2, "managementfeeTrust");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankIsNull() {
            addCriterion("managementfee_bank is null");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankIsNotNull() {
            addCriterion("managementfee_bank is not null");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankEqualTo(BigDecimal value) {
            addCriterion("managementfee_bank =", value, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankNotEqualTo(BigDecimal value) {
            addCriterion("managementfee_bank <>", value, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankGreaterThan(BigDecimal value) {
            addCriterion("managementfee_bank >", value, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("managementfee_bank >=", value, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankLessThan(BigDecimal value) {
            addCriterion("managementfee_bank <", value, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankLessThanOrEqualTo(BigDecimal value) {
            addCriterion("managementfee_bank <=", value, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankIn(List<BigDecimal> values) {
            addCriterion("managementfee_bank in", values, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankNotIn(List<BigDecimal> values) {
            addCriterion("managementfee_bank not in", values, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("managementfee_bank between", value1, value2, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andManagementfeeBankNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("managementfee_bank not between", value1, value2, "managementfeeBank");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIsNull() {
            addCriterion("performance_fee is null");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIsNotNull() {
            addCriterion("performance_fee is not null");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeEqualTo(BigDecimal value) {
            addCriterion("performance_fee =", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotEqualTo(BigDecimal value) {
            addCriterion("performance_fee <>", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeGreaterThan(BigDecimal value) {
            addCriterion("performance_fee >", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("performance_fee >=", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeLessThan(BigDecimal value) {
            addCriterion("performance_fee <", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("performance_fee <=", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIn(List<BigDecimal> values) {
            addCriterion("performance_fee in", values, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotIn(List<BigDecimal> values) {
            addCriterion("performance_fee not in", values, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("performance_fee between", value1, value2, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("performance_fee not between", value1, value2, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodIsNull() {
            addCriterion("performance_fee_deduction_method is null");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodIsNotNull() {
            addCriterion("performance_fee_deduction_method is not null");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodEqualTo(Integer value) {
            addCriterion("performance_fee_deduction_method =", value, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodNotEqualTo(Integer value) {
            addCriterion("performance_fee_deduction_method <>", value, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodGreaterThan(Integer value) {
            addCriterion("performance_fee_deduction_method >", value, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodGreaterThanOrEqualTo(Integer value) {
            addCriterion("performance_fee_deduction_method >=", value, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodLessThan(Integer value) {
            addCriterion("performance_fee_deduction_method <", value, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodLessThanOrEqualTo(Integer value) {
            addCriterion("performance_fee_deduction_method <=", value, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodIn(List<Integer> values) {
            addCriterion("performance_fee_deduction_method in", values, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodNotIn(List<Integer> values) {
            addCriterion("performance_fee_deduction_method not in", values, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodBetween(Integer value1, Integer value2) {
            addCriterion("performance_fee_deduction_method between", value1, value2, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeDeductionMethodNotBetween(Integer value1, Integer value2) {
            addCriterion("performance_fee_deduction_method not between", value1, value2, "performanceFeeDeductionMethod");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteIsNull() {
            addCriterion("other_fee_note is null");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteIsNotNull() {
            addCriterion("other_fee_note is not null");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteEqualTo(String value) {
            addCriterion("other_fee_note =", value, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteNotEqualTo(String value) {
            addCriterion("other_fee_note <>", value, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteGreaterThan(String value) {
            addCriterion("other_fee_note >", value, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteGreaterThanOrEqualTo(String value) {
            addCriterion("other_fee_note >=", value, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteLessThan(String value) {
            addCriterion("other_fee_note <", value, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteLessThanOrEqualTo(String value) {
            addCriterion("other_fee_note <=", value, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteLike(String value) {
            addCriterion("other_fee_note like", value, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteNotLike(String value) {
            addCriterion("other_fee_note not like", value, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteIn(List<String> values) {
            addCriterion("other_fee_note in", values, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteNotIn(List<String> values) {
            addCriterion("other_fee_note not in", values, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteBetween(String value1, String value2) {
            addCriterion("other_fee_note between", value1, value2, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andOtherFeeNoteNotBetween(String value1, String value2) {
            addCriterion("other_fee_note not between", value1, value2, "otherFeeNote");
            return (Criteria) this;
        }

        public Criteria andGuardLineIsNull() {
            addCriterion("guard_line is null");
            return (Criteria) this;
        }

        public Criteria andGuardLineIsNotNull() {
            addCriterion("guard_line is not null");
            return (Criteria) this;
        }

        public Criteria andGuardLineEqualTo(BigDecimal value) {
            addCriterion("guard_line =", value, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineNotEqualTo(BigDecimal value) {
            addCriterion("guard_line <>", value, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineGreaterThan(BigDecimal value) {
            addCriterion("guard_line >", value, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("guard_line >=", value, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineLessThan(BigDecimal value) {
            addCriterion("guard_line <", value, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineLessThanOrEqualTo(BigDecimal value) {
            addCriterion("guard_line <=", value, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineIn(List<BigDecimal> values) {
            addCriterion("guard_line in", values, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineNotIn(List<BigDecimal> values) {
            addCriterion("guard_line not in", values, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("guard_line between", value1, value2, "guardLine");
            return (Criteria) this;
        }

        public Criteria andGuardLineNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("guard_line not between", value1, value2, "guardLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineIsNull() {
            addCriterion("stop_loss_line is null");
            return (Criteria) this;
        }

        public Criteria andStopLossLineIsNotNull() {
            addCriterion("stop_loss_line is not null");
            return (Criteria) this;
        }

        public Criteria andStopLossLineEqualTo(BigDecimal value) {
            addCriterion("stop_loss_line =", value, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineNotEqualTo(BigDecimal value) {
            addCriterion("stop_loss_line <>", value, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineGreaterThan(BigDecimal value) {
            addCriterion("stop_loss_line >", value, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stop_loss_line >=", value, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineLessThan(BigDecimal value) {
            addCriterion("stop_loss_line <", value, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stop_loss_line <=", value, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineIn(List<BigDecimal> values) {
            addCriterion("stop_loss_line in", values, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineNotIn(List<BigDecimal> values) {
            addCriterion("stop_loss_line not in", values, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stop_loss_line between", value1, value2, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andStopLossLineNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stop_loss_line not between", value1, value2, "stopLossLine");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesIsNull() {
            addCriterion("return_guarantees is null");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesIsNotNull() {
            addCriterion("return_guarantees is not null");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesEqualTo(BigDecimal value) {
            addCriterion("return_guarantees =", value, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesNotEqualTo(BigDecimal value) {
            addCriterion("return_guarantees <>", value, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesGreaterThan(BigDecimal value) {
            addCriterion("return_guarantees >", value, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("return_guarantees >=", value, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesLessThan(BigDecimal value) {
            addCriterion("return_guarantees <", value, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesLessThanOrEqualTo(BigDecimal value) {
            addCriterion("return_guarantees <=", value, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesIn(List<BigDecimal> values) {
            addCriterion("return_guarantees in", values, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesNotIn(List<BigDecimal> values) {
            addCriterion("return_guarantees not in", values, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("return_guarantees between", value1, value2, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andReturnGuaranteesNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("return_guarantees not between", value1, value2, "returnGuarantees");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnIsNull() {
            addCriterion("expected_return is null");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnIsNotNull() {
            addCriterion("expected_return is not null");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnEqualTo(BigDecimal value) {
            addCriterion("expected_return =", value, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnNotEqualTo(BigDecimal value) {
            addCriterion("expected_return <>", value, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnGreaterThan(BigDecimal value) {
            addCriterion("expected_return >", value, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("expected_return >=", value, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnLessThan(BigDecimal value) {
            addCriterion("expected_return <", value, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnLessThanOrEqualTo(BigDecimal value) {
            addCriterion("expected_return <=", value, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnIn(List<BigDecimal> values) {
            addCriterion("expected_return in", values, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnNotIn(List<BigDecimal> values) {
            addCriterion("expected_return not in", values, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("expected_return between", value1, value2, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andExpectedReturnNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("expected_return not between", value1, value2, "expectedReturn");
            return (Criteria) this;
        }

        public Criteria andHurdleRateIsNull() {
            addCriterion("hurdle_rate is null");
            return (Criteria) this;
        }

        public Criteria andHurdleRateIsNotNull() {
            addCriterion("hurdle_rate is not null");
            return (Criteria) this;
        }

        public Criteria andHurdleRateEqualTo(BigDecimal value) {
            addCriterion("hurdle_rate =", value, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateNotEqualTo(BigDecimal value) {
            addCriterion("hurdle_rate <>", value, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateGreaterThan(BigDecimal value) {
            addCriterion("hurdle_rate >", value, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("hurdle_rate >=", value, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateLessThan(BigDecimal value) {
            addCriterion("hurdle_rate <", value, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("hurdle_rate <=", value, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateIn(List<BigDecimal> values) {
            addCriterion("hurdle_rate in", values, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateNotIn(List<BigDecimal> values) {
            addCriterion("hurdle_rate not in", values, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hurdle_rate between", value1, value2, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andHurdleRateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hurdle_rate not between", value1, value2, "hurdleRate");
            return (Criteria) this;
        }

        public Criteria andLeverageIsNull() {
            addCriterion("leverage is null");
            return (Criteria) this;
        }

        public Criteria andLeverageIsNotNull() {
            addCriterion("leverage is not null");
            return (Criteria) this;
        }

        public Criteria andLeverageEqualTo(String value) {
            addCriterion("leverage =", value, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageNotEqualTo(String value) {
            addCriterion("leverage <>", value, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageGreaterThan(String value) {
            addCriterion("leverage >", value, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageGreaterThanOrEqualTo(String value) {
            addCriterion("leverage >=", value, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageLessThan(String value) {
            addCriterion("leverage <", value, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageLessThanOrEqualTo(String value) {
            addCriterion("leverage <=", value, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageLike(String value) {
            addCriterion("leverage like", value, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageNotLike(String value) {
            addCriterion("leverage not like", value, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageIn(List<String> values) {
            addCriterion("leverage in", values, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageNotIn(List<String> values) {
            addCriterion("leverage not in", values, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageBetween(String value1, String value2) {
            addCriterion("leverage between", value1, value2, "leverage");
            return (Criteria) this;
        }

        public Criteria andLeverageNotBetween(String value1, String value2) {
            addCriterion("leverage not between", value1, value2, "leverage");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetIsNull() {
            addCriterion("manager_participate_asset is null");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetIsNotNull() {
            addCriterion("manager_participate_asset is not null");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetEqualTo(String value) {
            addCriterion("manager_participate_asset =", value, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetNotEqualTo(String value) {
            addCriterion("manager_participate_asset <>", value, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetGreaterThan(String value) {
            addCriterion("manager_participate_asset >", value, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetGreaterThanOrEqualTo(String value) {
            addCriterion("manager_participate_asset >=", value, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetLessThan(String value) {
            addCriterion("manager_participate_asset <", value, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetLessThanOrEqualTo(String value) {
            addCriterion("manager_participate_asset <=", value, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetLike(String value) {
            addCriterion("manager_participate_asset like", value, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetNotLike(String value) {
            addCriterion("manager_participate_asset not like", value, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetIn(List<String> values) {
            addCriterion("manager_participate_asset in", values, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetNotIn(List<String> values) {
            addCriterion("manager_participate_asset not in", values, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetBetween(String value1, String value2) {
            addCriterion("manager_participate_asset between", value1, value2, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andManagerParticipateAssetNotBetween(String value1, String value2) {
            addCriterion("manager_participate_asset not between", value1, value2, "managerParticipateAsset");
            return (Criteria) this;
        }

        public Criteria andPosteriorIsNull() {
            addCriterion("posterior is null");
            return (Criteria) this;
        }

        public Criteria andPosteriorIsNotNull() {
            addCriterion("posterior is not null");
            return (Criteria) this;
        }

        public Criteria andPosteriorEqualTo(BigDecimal value) {
            addCriterion("posterior =", value, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorNotEqualTo(BigDecimal value) {
            addCriterion("posterior <>", value, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorGreaterThan(BigDecimal value) {
            addCriterion("posterior >", value, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("posterior >=", value, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorLessThan(BigDecimal value) {
            addCriterion("posterior <", value, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorLessThanOrEqualTo(BigDecimal value) {
            addCriterion("posterior <=", value, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorIn(List<BigDecimal> values) {
            addCriterion("posterior in", values, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorNotIn(List<BigDecimal> values) {
            addCriterion("posterior not in", values, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("posterior between", value1, value2, "posterior");
            return (Criteria) this;
        }

        public Criteria andPosteriorNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("posterior not between", value1, value2, "posterior");
            return (Criteria) this;
        }

        public Criteria andIntermediateIsNull() {
            addCriterion("intermediate is null");
            return (Criteria) this;
        }

        public Criteria andIntermediateIsNotNull() {
            addCriterion("intermediate is not null");
            return (Criteria) this;
        }

        public Criteria andIntermediateEqualTo(BigDecimal value) {
            addCriterion("intermediate =", value, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateNotEqualTo(BigDecimal value) {
            addCriterion("intermediate <>", value, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateGreaterThan(BigDecimal value) {
            addCriterion("intermediate >", value, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("intermediate >=", value, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateLessThan(BigDecimal value) {
            addCriterion("intermediate <", value, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateLessThanOrEqualTo(BigDecimal value) {
            addCriterion("intermediate <=", value, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateIn(List<BigDecimal> values) {
            addCriterion("intermediate in", values, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateNotIn(List<BigDecimal> values) {
            addCriterion("intermediate not in", values, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("intermediate between", value1, value2, "intermediate");
            return (Criteria) this;
        }

        public Criteria andIntermediateNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("intermediate not between", value1, value2, "intermediate");
            return (Criteria) this;
        }

        public Criteria andPriorityIsNull() {
            addCriterion("priority is null");
            return (Criteria) this;
        }

        public Criteria andPriorityIsNotNull() {
            addCriterion("priority is not null");
            return (Criteria) this;
        }

        public Criteria andPriorityEqualTo(BigDecimal value) {
            addCriterion("priority =", value, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityNotEqualTo(BigDecimal value) {
            addCriterion("priority <>", value, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityGreaterThan(BigDecimal value) {
            addCriterion("priority >", value, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("priority >=", value, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityLessThan(BigDecimal value) {
            addCriterion("priority <", value, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityLessThanOrEqualTo(BigDecimal value) {
            addCriterion("priority <=", value, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityIn(List<BigDecimal> values) {
            addCriterion("priority in", values, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityNotIn(List<BigDecimal> values) {
            addCriterion("priority not in", values, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("priority between", value1, value2, "priority");
            return (Criteria) this;
        }

        public Criteria andPriorityNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("priority not between", value1, value2, "priority");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeIsNull() {
            addCriterion("outsourcing_fee is null");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeIsNotNull() {
            addCriterion("outsourcing_fee is not null");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeEqualTo(BigDecimal value) {
            addCriterion("outsourcing_fee =", value, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeNotEqualTo(BigDecimal value) {
            addCriterion("outsourcing_fee <>", value, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeGreaterThan(BigDecimal value) {
            addCriterion("outsourcing_fee >", value, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("outsourcing_fee >=", value, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeLessThan(BigDecimal value) {
            addCriterion("outsourcing_fee <", value, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("outsourcing_fee <=", value, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeIn(List<BigDecimal> values) {
            addCriterion("outsourcing_fee in", values, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeNotIn(List<BigDecimal> values) {
            addCriterion("outsourcing_fee not in", values, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outsourcing_fee between", value1, value2, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andOutsourcingFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outsourcing_fee not between", value1, value2, "outsourcingFee");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}