package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class TxIndexBasic {
    private Integer indexId;

    private String indexCode;

    private String indexName;

    private Date announceDate;

    private Date startDate;

    private Date endDate;

    private Integer sectorId;

    private String sectorName;

    private Integer publisherId;

    private String publisherName;

    private String outerCode;

    private String indexFullname;

    private String categoryId;

    private String categoryName;

    private String typeId;

    private String typeName;

    private Date benchmarkDate;

    private BigDecimal benchmark;

    private String weightMethod;

    private String weightDesc;

    private BigDecimal weightPrice;

    private String selectionMethod;

    private String dataSource;

    private Integer status;

    private String statusExplain;

    private Long sSeq;

    private Long sRowVersion;

    private Date sUpdateTime;

    private Short sDataState;

    private String ps;
}