package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
    * 基金持股行业分布
    */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class TxIndustryDistribution {
    /**
    * 基金代码
    */
    private Integer fundCode;

    /**
    * 报告开始日期
    */
    private Date startDate;

    /**
    * 报告截止日期
    */
    private Date endDate;

    /**
    * 行业代码
    */
    private String industryCode;

    /**
    * 行业名称
    */
    private String industryName;

    /**
    * 市值
    */
    private BigDecimal marketValue;

    /**
    * 占基金净值比例
    */
    private BigDecimal proportion;
}