package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TxTop10StockExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TxTop10StockExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andSRowVersionIsNull() {
            addCriterion("s_row_version is null");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIsNotNull() {
            addCriterion("s_row_version is not null");
            return (Criteria) this;
        }

        public Criteria andSRowVersionEqualTo(Long value) {
            addCriterion("s_row_version =", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotEqualTo(Long value) {
            addCriterion("s_row_version <>", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionGreaterThan(Long value) {
            addCriterion("s_row_version >", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionGreaterThanOrEqualTo(Long value) {
            addCriterion("s_row_version >=", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionLessThan(Long value) {
            addCriterion("s_row_version <", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionLessThanOrEqualTo(Long value) {
            addCriterion("s_row_version <=", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIn(List<Long> values) {
            addCriterion("s_row_version in", values, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotIn(List<Long> values) {
            addCriterion("s_row_version not in", values, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionBetween(Long value1, Long value2) {
            addCriterion("s_row_version between", value1, value2, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotBetween(Long value1, Long value2) {
            addCriterion("s_row_version not between", value1, value2, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(Integer value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(Integer value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(Integer value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(Integer value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(Integer value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<Integer> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<Integer> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(Integer value1, Integer value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(Integer value1, Integer value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundCodeIsNull() {
            addCriterion("fund_code is null");
            return (Criteria) this;
        }

        public Criteria andFundCodeIsNotNull() {
            addCriterion("fund_code is not null");
            return (Criteria) this;
        }

        public Criteria andFundCodeEqualTo(Integer value) {
            addCriterion("fund_code =", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotEqualTo(Integer value) {
            addCriterion("fund_code <>", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeGreaterThan(Integer value) {
            addCriterion("fund_code >", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeGreaterThanOrEqualTo(Integer value) {
            addCriterion("fund_code >=", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeLessThan(Integer value) {
            addCriterion("fund_code <", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeLessThanOrEqualTo(Integer value) {
            addCriterion("fund_code <=", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeIn(List<Integer> values) {
            addCriterion("fund_code in", values, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotIn(List<Integer> values) {
            addCriterion("fund_code not in", values, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeBetween(Integer value1, Integer value2) {
            addCriterion("fund_code between", value1, value2, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotBetween(Integer value1, Integer value2) {
            addCriterion("fund_code not between", value1, value2, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIsNull() {
            addCriterion("fund_short_name is null");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIsNotNull() {
            addCriterion("fund_short_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundShortNameEqualTo(String value) {
            addCriterion("fund_short_name =", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotEqualTo(String value) {
            addCriterion("fund_short_name <>", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameGreaterThan(String value) {
            addCriterion("fund_short_name >", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_short_name >=", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLessThan(String value) {
            addCriterion("fund_short_name <", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLessThanOrEqualTo(String value) {
            addCriterion("fund_short_name <=", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLike(String value) {
            addCriterion("fund_short_name like", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotLike(String value) {
            addCriterion("fund_short_name not like", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIn(List<String> values) {
            addCriterion("fund_short_name in", values, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotIn(List<String> values) {
            addCriterion("fund_short_name not in", values, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameBetween(String value1, String value2) {
            addCriterion("fund_short_name between", value1, value2, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotBetween(String value1, String value2) {
            addCriterion("fund_short_name not between", value1, value2, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andReportIdIsNull() {
            addCriterion("report_id is null");
            return (Criteria) this;
        }

        public Criteria andReportIdIsNotNull() {
            addCriterion("report_id is not null");
            return (Criteria) this;
        }

        public Criteria andReportIdEqualTo(Integer value) {
            addCriterion("report_id =", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotEqualTo(Integer value) {
            addCriterion("report_id <>", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdGreaterThan(Integer value) {
            addCriterion("report_id >", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("report_id >=", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdLessThan(Integer value) {
            addCriterion("report_id <", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdLessThanOrEqualTo(Integer value) {
            addCriterion("report_id <=", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdIn(List<Integer> values) {
            addCriterion("report_id in", values, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotIn(List<Integer> values) {
            addCriterion("report_id not in", values, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdBetween(Integer value1, Integer value2) {
            addCriterion("report_id between", value1, value2, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotBetween(Integer value1, Integer value2) {
            addCriterion("report_id not between", value1, value2, "reportId");
            return (Criteria) this;
        }

        public Criteria andAnnDateIsNull() {
            addCriterion("ann_date is null");
            return (Criteria) this;
        }

        public Criteria andAnnDateIsNotNull() {
            addCriterion("ann_date is not null");
            return (Criteria) this;
        }

        public Criteria andAnnDateEqualTo(Date value) {
            addCriterionForJDBCDate("ann_date =", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("ann_date <>", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateGreaterThan(Date value) {
            addCriterionForJDBCDate("ann_date >", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("ann_date >=", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateLessThan(Date value) {
            addCriterionForJDBCDate("ann_date <", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("ann_date <=", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateIn(List<Date> values) {
            addCriterionForJDBCDate("ann_date in", values, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("ann_date not in", values, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("ann_date between", value1, value2, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("ann_date not between", value1, value2, "annDate");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNull() {
            addCriterion("start_date is null");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNotNull() {
            addCriterion("start_date is not null");
            return (Criteria) this;
        }

        public Criteria andStartDateEqualTo(Date value) {
            addCriterionForJDBCDate("start_date =", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("start_date <>", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThan(Date value) {
            addCriterionForJDBCDate("start_date >", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("start_date >=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThan(Date value) {
            addCriterionForJDBCDate("start_date <", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("start_date <=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateIn(List<Date> values) {
            addCriterionForJDBCDate("start_date in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("start_date not in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("start_date between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("start_date not between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("end_date is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("end_date is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("end_date =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("end_date >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(Date value) {
            addCriterionForJDBCDate("end_date <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("end_date in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("end_date not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andIsNewIsNull() {
            addCriterion("is_new is null");
            return (Criteria) this;
        }

        public Criteria andIsNewIsNotNull() {
            addCriterion("is_new is not null");
            return (Criteria) this;
        }

        public Criteria andIsNewEqualTo(Integer value) {
            addCriterion("is_new =", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewNotEqualTo(Integer value) {
            addCriterion("is_new <>", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewGreaterThan(Integer value) {
            addCriterion("is_new >", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_new >=", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewLessThan(Integer value) {
            addCriterion("is_new <", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewLessThanOrEqualTo(Integer value) {
            addCriterion("is_new <=", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewIn(List<Integer> values) {
            addCriterion("is_new in", values, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewNotIn(List<Integer> values) {
            addCriterion("is_new not in", values, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewBetween(Integer value1, Integer value2) {
            addCriterion("is_new between", value1, value2, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewNotBetween(Integer value1, Integer value2) {
            addCriterion("is_new not between", value1, value2, "isNew");
            return (Criteria) this;
        }

        public Criteria andTypeIdIsNull() {
            addCriterion("type_id is null");
            return (Criteria) this;
        }

        public Criteria andTypeIdIsNotNull() {
            addCriterion("type_id is not null");
            return (Criteria) this;
        }

        public Criteria andTypeIdEqualTo(Integer value) {
            addCriterion("type_id =", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdNotEqualTo(Integer value) {
            addCriterion("type_id <>", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdGreaterThan(Integer value) {
            addCriterion("type_id >", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("type_id >=", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdLessThan(Integer value) {
            addCriterion("type_id <", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdLessThanOrEqualTo(Integer value) {
            addCriterion("type_id <=", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdIn(List<Integer> values) {
            addCriterion("type_id in", values, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdNotIn(List<Integer> values) {
            addCriterion("type_id not in", values, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdBetween(Integer value1, Integer value2) {
            addCriterion("type_id between", value1, value2, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdNotBetween(Integer value1, Integer value2) {
            addCriterion("type_id not between", value1, value2, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeNameIsNull() {
            addCriterion("type_name is null");
            return (Criteria) this;
        }

        public Criteria andTypeNameIsNotNull() {
            addCriterion("type_name is not null");
            return (Criteria) this;
        }

        public Criteria andTypeNameEqualTo(String value) {
            addCriterion("type_name =", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotEqualTo(String value) {
            addCriterion("type_name <>", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameGreaterThan(String value) {
            addCriterion("type_name >", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameGreaterThanOrEqualTo(String value) {
            addCriterion("type_name >=", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLessThan(String value) {
            addCriterion("type_name <", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLessThanOrEqualTo(String value) {
            addCriterion("type_name <=", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLike(String value) {
            addCriterion("type_name like", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotLike(String value) {
            addCriterion("type_name not like", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameIn(List<String> values) {
            addCriterion("type_name in", values, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotIn(List<String> values) {
            addCriterion("type_name not in", values, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameBetween(String value1, String value2) {
            addCriterion("type_name between", value1, value2, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotBetween(String value1, String value2) {
            addCriterion("type_name not between", value1, value2, "typeName");
            return (Criteria) this;
        }

        public Criteria andNoIsNull() {
            addCriterion("`no` is null");
            return (Criteria) this;
        }

        public Criteria andNoIsNotNull() {
            addCriterion("`no` is not null");
            return (Criteria) this;
        }

        public Criteria andNoEqualTo(Integer value) {
            addCriterion("`no` =", value, "no");
            return (Criteria) this;
        }

        public Criteria andNoNotEqualTo(Integer value) {
            addCriterion("`no` <>", value, "no");
            return (Criteria) this;
        }

        public Criteria andNoGreaterThan(Integer value) {
            addCriterion("`no` >", value, "no");
            return (Criteria) this;
        }

        public Criteria andNoGreaterThanOrEqualTo(Integer value) {
            addCriterion("`no` >=", value, "no");
            return (Criteria) this;
        }

        public Criteria andNoLessThan(Integer value) {
            addCriterion("`no` <", value, "no");
            return (Criteria) this;
        }

        public Criteria andNoLessThanOrEqualTo(Integer value) {
            addCriterion("`no` <=", value, "no");
            return (Criteria) this;
        }

        public Criteria andNoIn(List<Integer> values) {
            addCriterion("`no` in", values, "no");
            return (Criteria) this;
        }

        public Criteria andNoNotIn(List<Integer> values) {
            addCriterion("`no` not in", values, "no");
            return (Criteria) this;
        }

        public Criteria andNoBetween(Integer value1, Integer value2) {
            addCriterion("`no` between", value1, value2, "no");
            return (Criteria) this;
        }

        public Criteria andNoNotBetween(Integer value1, Integer value2) {
            addCriterion("`no` not between", value1, value2, "no");
            return (Criteria) this;
        }

        public Criteria andStockCodeIsNull() {
            addCriterion("stock_code is null");
            return (Criteria) this;
        }

        public Criteria andStockCodeIsNotNull() {
            addCriterion("stock_code is not null");
            return (Criteria) this;
        }

        public Criteria andStockCodeEqualTo(Integer value) {
            addCriterion("stock_code =", value, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeNotEqualTo(Integer value) {
            addCriterion("stock_code <>", value, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeGreaterThan(Integer value) {
            addCriterion("stock_code >", value, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeGreaterThanOrEqualTo(Integer value) {
            addCriterion("stock_code >=", value, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeLessThan(Integer value) {
            addCriterion("stock_code <", value, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeLessThanOrEqualTo(Integer value) {
            addCriterion("stock_code <=", value, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeIn(List<Integer> values) {
            addCriterion("stock_code in", values, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeNotIn(List<Integer> values) {
            addCriterion("stock_code not in", values, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeBetween(Integer value1, Integer value2) {
            addCriterion("stock_code between", value1, value2, "stockCode");
            return (Criteria) this;
        }

        public Criteria andStockCodeNotBetween(Integer value1, Integer value2) {
            addCriterion("stock_code not between", value1, value2, "stockCode");
            return (Criteria) this;
        }

        public Criteria andHoldShareIsNull() {
            addCriterion("hold_share is null");
            return (Criteria) this;
        }

        public Criteria andHoldShareIsNotNull() {
            addCriterion("hold_share is not null");
            return (Criteria) this;
        }

        public Criteria andHoldShareEqualTo(BigDecimal value) {
            addCriterion("hold_share =", value, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareNotEqualTo(BigDecimal value) {
            addCriterion("hold_share <>", value, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareGreaterThan(BigDecimal value) {
            addCriterion("hold_share >", value, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("hold_share >=", value, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareLessThan(BigDecimal value) {
            addCriterion("hold_share <", value, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("hold_share <=", value, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareIn(List<BigDecimal> values) {
            addCriterion("hold_share in", values, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareNotIn(List<BigDecimal> values) {
            addCriterion("hold_share not in", values, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hold_share between", value1, value2, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hold_share not between", value1, value2, "holdShare");
            return (Criteria) this;
        }

        public Criteria andHoldValueIsNull() {
            addCriterion("hold_value is null");
            return (Criteria) this;
        }

        public Criteria andHoldValueIsNotNull() {
            addCriterion("hold_value is not null");
            return (Criteria) this;
        }

        public Criteria andHoldValueEqualTo(BigDecimal value) {
            addCriterion("hold_value =", value, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueNotEqualTo(BigDecimal value) {
            addCriterion("hold_value <>", value, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueGreaterThan(BigDecimal value) {
            addCriterion("hold_value >", value, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("hold_value >=", value, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueLessThan(BigDecimal value) {
            addCriterion("hold_value <", value, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("hold_value <=", value, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueIn(List<BigDecimal> values) {
            addCriterion("hold_value in", values, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueNotIn(List<BigDecimal> values) {
            addCriterion("hold_value not in", values, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hold_value between", value1, value2, "holdValue");
            return (Criteria) this;
        }

        public Criteria andHoldValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hold_value not between", value1, value2, "holdValue");
            return (Criteria) this;
        }

        public Criteria andValueRankIsNull() {
            addCriterion("value_rank is null");
            return (Criteria) this;
        }

        public Criteria andValueRankIsNotNull() {
            addCriterion("value_rank is not null");
            return (Criteria) this;
        }

        public Criteria andValueRankEqualTo(Integer value) {
            addCriterion("value_rank =", value, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankNotEqualTo(Integer value) {
            addCriterion("value_rank <>", value, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankGreaterThan(Integer value) {
            addCriterion("value_rank >", value, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankGreaterThanOrEqualTo(Integer value) {
            addCriterion("value_rank >=", value, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankLessThan(Integer value) {
            addCriterion("value_rank <", value, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankLessThanOrEqualTo(Integer value) {
            addCriterion("value_rank <=", value, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankIn(List<Integer> values) {
            addCriterion("value_rank in", values, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankNotIn(List<Integer> values) {
            addCriterion("value_rank not in", values, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankBetween(Integer value1, Integer value2) {
            addCriterion("value_rank between", value1, value2, "valueRank");
            return (Criteria) this;
        }

        public Criteria andValueRankNotBetween(Integer value1, Integer value2) {
            addCriterion("value_rank not between", value1, value2, "valueRank");
            return (Criteria) this;
        }

        public Criteria andNetRatioIsNull() {
            addCriterion("net_ratio is null");
            return (Criteria) this;
        }

        public Criteria andNetRatioIsNotNull() {
            addCriterion("net_ratio is not null");
            return (Criteria) this;
        }

        public Criteria andNetRatioEqualTo(BigDecimal value) {
            addCriterion("net_ratio =", value, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioNotEqualTo(BigDecimal value) {
            addCriterion("net_ratio <>", value, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioGreaterThan(BigDecimal value) {
            addCriterion("net_ratio >", value, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("net_ratio >=", value, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioLessThan(BigDecimal value) {
            addCriterion("net_ratio <", value, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioLessThanOrEqualTo(BigDecimal value) {
            addCriterion("net_ratio <=", value, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioIn(List<BigDecimal> values) {
            addCriterion("net_ratio in", values, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioNotIn(List<BigDecimal> values) {
            addCriterion("net_ratio not in", values, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("net_ratio between", value1, value2, "netRatio");
            return (Criteria) this;
        }

        public Criteria andNetRatioNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("net_ratio not between", value1, value2, "netRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioIsNull() {
            addCriterion("share_ratio is null");
            return (Criteria) this;
        }

        public Criteria andShareRatioIsNotNull() {
            addCriterion("share_ratio is not null");
            return (Criteria) this;
        }

        public Criteria andShareRatioEqualTo(BigDecimal value) {
            addCriterion("share_ratio =", value, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioNotEqualTo(BigDecimal value) {
            addCriterion("share_ratio <>", value, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioGreaterThan(BigDecimal value) {
            addCriterion("share_ratio >", value, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("share_ratio >=", value, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioLessThan(BigDecimal value) {
            addCriterion("share_ratio <", value, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioLessThanOrEqualTo(BigDecimal value) {
            addCriterion("share_ratio <=", value, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioIn(List<BigDecimal> values) {
            addCriterion("share_ratio in", values, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioNotIn(List<BigDecimal> values) {
            addCriterion("share_ratio not in", values, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("share_ratio between", value1, value2, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andShareRatioNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("share_ratio not between", value1, value2, "shareRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioIsNull() {
            addCriterion("value_ratio is null");
            return (Criteria) this;
        }

        public Criteria andValueRatioIsNotNull() {
            addCriterion("value_ratio is not null");
            return (Criteria) this;
        }

        public Criteria andValueRatioEqualTo(BigDecimal value) {
            addCriterion("value_ratio =", value, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioNotEqualTo(BigDecimal value) {
            addCriterion("value_ratio <>", value, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioGreaterThan(BigDecimal value) {
            addCriterion("value_ratio >", value, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("value_ratio >=", value, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioLessThan(BigDecimal value) {
            addCriterion("value_ratio <", value, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioLessThanOrEqualTo(BigDecimal value) {
            addCriterion("value_ratio <=", value, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioIn(List<BigDecimal> values) {
            addCriterion("value_ratio in", values, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioNotIn(List<BigDecimal> values) {
            addCriterion("value_ratio not in", values, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("value_ratio between", value1, value2, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andValueRatioNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("value_ratio not between", value1, value2, "valueRatio");
            return (Criteria) this;
        }

        public Criteria andUnnameIsNull() {
            addCriterion("unname is null");
            return (Criteria) this;
        }

        public Criteria andUnnameIsNotNull() {
            addCriterion("unname is not null");
            return (Criteria) this;
        }

        public Criteria andUnnameEqualTo(Integer value) {
            addCriterion("unname =", value, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameNotEqualTo(Integer value) {
            addCriterion("unname <>", value, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameGreaterThan(Integer value) {
            addCriterion("unname >", value, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameGreaterThanOrEqualTo(Integer value) {
            addCriterion("unname >=", value, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameLessThan(Integer value) {
            addCriterion("unname <", value, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameLessThanOrEqualTo(Integer value) {
            addCriterion("unname <=", value, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameIn(List<Integer> values) {
            addCriterion("unname in", values, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameNotIn(List<Integer> values) {
            addCriterion("unname not in", values, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameBetween(Integer value1, Integer value2) {
            addCriterion("unname between", value1, value2, "unname");
            return (Criteria) this;
        }

        public Criteria andUnnameNotBetween(Integer value1, Integer value2) {
            addCriterion("unname not between", value1, value2, "unname");
            return (Criteria) this;
        }

        public Criteria andStockNameIsNull() {
            addCriterion("stock_name is null");
            return (Criteria) this;
        }

        public Criteria andStockNameIsNotNull() {
            addCriterion("stock_name is not null");
            return (Criteria) this;
        }

        public Criteria andStockNameEqualTo(String value) {
            addCriterion("stock_name =", value, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameNotEqualTo(String value) {
            addCriterion("stock_name <>", value, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameGreaterThan(String value) {
            addCriterion("stock_name >", value, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameGreaterThanOrEqualTo(String value) {
            addCriterion("stock_name >=", value, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameLessThan(String value) {
            addCriterion("stock_name <", value, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameLessThanOrEqualTo(String value) {
            addCriterion("stock_name <=", value, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameLike(String value) {
            addCriterion("stock_name like", value, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameNotLike(String value) {
            addCriterion("stock_name not like", value, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameIn(List<String> values) {
            addCriterion("stock_name in", values, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameNotIn(List<String> values) {
            addCriterion("stock_name not in", values, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameBetween(String value1, String value2) {
            addCriterion("stock_name between", value1, value2, "stockName");
            return (Criteria) this;
        }

        public Criteria andStockNameNotBetween(String value1, String value2) {
            addCriterion("stock_name not between", value1, value2, "stockName");
            return (Criteria) this;
        }

        public Criteria andSSegIsNull() {
            addCriterion("s_seg is null");
            return (Criteria) this;
        }

        public Criteria andSSegIsNotNull() {
            addCriterion("s_seg is not null");
            return (Criteria) this;
        }

        public Criteria andSSegEqualTo(Long value) {
            addCriterion("s_seg =", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegNotEqualTo(Long value) {
            addCriterion("s_seg <>", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegGreaterThan(Long value) {
            addCriterion("s_seg >", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegGreaterThanOrEqualTo(Long value) {
            addCriterion("s_seg >=", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegLessThan(Long value) {
            addCriterion("s_seg <", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegLessThanOrEqualTo(Long value) {
            addCriterion("s_seg <=", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegIn(List<Long> values) {
            addCriterion("s_seg in", values, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegNotIn(List<Long> values) {
            addCriterion("s_seg not in", values, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegBetween(Long value1, Long value2) {
            addCriterion("s_seg between", value1, value2, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegNotBetween(Long value1, Long value2) {
            addCriterion("s_seg not between", value1, value2, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIsNull() {
            addCriterion("s_update_time is null");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIsNotNull() {
            addCriterion("s_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeEqualTo(Date value) {
            addCriterion("s_update_time =", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotEqualTo(Date value) {
            addCriterion("s_update_time <>", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeGreaterThan(Date value) {
            addCriterion("s_update_time >", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("s_update_time >=", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeLessThan(Date value) {
            addCriterion("s_update_time <", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("s_update_time <=", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIn(List<Date> values) {
            addCriterion("s_update_time in", values, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotIn(List<Date> values) {
            addCriterion("s_update_time not in", values, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("s_update_time between", value1, value2, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("s_update_time not between", value1, value2, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSDataStateIsNull() {
            addCriterion("s_data_state is null");
            return (Criteria) this;
        }

        public Criteria andSDataStateIsNotNull() {
            addCriterion("s_data_state is not null");
            return (Criteria) this;
        }

        public Criteria andSDataStateEqualTo(Integer value) {
            addCriterion("s_data_state =", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotEqualTo(Integer value) {
            addCriterion("s_data_state <>", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateGreaterThan(Integer value) {
            addCriterion("s_data_state >", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateGreaterThanOrEqualTo(Integer value) {
            addCriterion("s_data_state >=", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateLessThan(Integer value) {
            addCriterion("s_data_state <", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateLessThanOrEqualTo(Integer value) {
            addCriterion("s_data_state <=", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateIn(List<Integer> values) {
            addCriterion("s_data_state in", values, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotIn(List<Integer> values) {
            addCriterion("s_data_state not in", values, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateBetween(Integer value1, Integer value2) {
            addCriterion("s_data_state between", value1, value2, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotBetween(Integer value1, Integer value2) {
            addCriterion("s_data_state not between", value1, value2, "sDataState");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}