package com.tanpu.fund.enums;

import lombok.Getter;

/**
 * @author: zhoupeng
 * @email: zhoupeng_08@163.com
 */
@Getter
public enum FilterTypeEnum {
    /**
     * 近1个月
     */
    NEAR_1_MONTH("1", "近1个月"),
    /**
     * 近3个月
     */
    NEAR_3_MONTH("2", "近3个月"),
    /**
     * 近6个月
     */
    NEAR_6_MONTH("3", "近6个月"),
    /**
     * 近1年
     */
    NEAR_1_YEAR("4", "近1年"),

    /**
     * 自定义
     */
    CUSTOMR("98", "自定义"),
    /**
     * 成立以来
     */
    SINCE_ESTABLISHED("99", "成立以来"),
    ;


    private String code;

    private String value;

    FilterTypeEnum(String code, String value) {
        this.code = code;
        this.value = value;
    }
}
