package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.CompanyTnaPersonnel;
import com.tanpu.fund.entity.generator.CompanyTnaPersonnelExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface CompanyTnaPersonnelMapper {
    long countByExample(CompanyTnaPersonnelExample example);

    int deleteByExample(CompanyTnaPersonnelExample example);

    int deleteByPrimaryKey(String id);

    int insert(CompanyTnaPersonnel record);

    int insertOrUpdate(CompanyTnaPersonnel record);

    int insertOrUpdateSelective(CompanyTnaPersonnel record);

    int insertSelective(CompanyTnaPersonnel record);

    List<CompanyTnaPersonnel> selectByExample(CompanyTnaPersonnelExample example);

    CompanyTnaPersonnel selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") CompanyTnaPersonnel record, @Param("example") CompanyTnaPersonnelExample example);

    int updateByExample(@Param("record") CompanyTnaPersonnel record, @Param("example") CompanyTnaPersonnelExample example);

    int updateByPrimaryKeySelective(CompanyTnaPersonnel record);

    int updateByPrimaryKey(CompanyTnaPersonnel record);

    int updateBatch(List<CompanyTnaPersonnel> list);

    int updateBatchSelective(List<CompanyTnaPersonnel> list);

    int batchInsert(@Param("list") List<CompanyTnaPersonnel> list);
}