package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundDistribution;
import com.tanpu.fund.entity.generator.FundDistributionExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundDistributionMapper {
    long countByExample(FundDistributionExample example);

    int deleteByExample(FundDistributionExample example);

    int deleteByPrimaryKey(String id);

    int insert(FundDistribution record);

    int insertOrUpdate(FundDistribution record);

    int insertOrUpdateSelective(FundDistribution record);

    int insertSelective(FundDistribution record);

    List<FundDistribution> selectByExample(FundDistributionExample example);

    FundDistribution selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") FundDistribution record, @Param("example") FundDistributionExample example);

    int updateByExample(@Param("record") FundDistribution record, @Param("example") FundDistributionExample example);

    int updateByPrimaryKeySelective(FundDistribution record);

    int updateByPrimaryKey(FundDistribution record);

    int updateBatch(List<FundDistribution> list);

    int updateBatchSelective(List<FundDistribution> list);

    int batchInsert(@Param("list") List<FundDistribution> list);
}