package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundInfoCompanyInfo;
import com.tanpu.fund.entity.generator.FundInfoCompanyInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundInfoCompanyInfoMapper {
    long countByExample(FundInfoCompanyInfoExample example);

    int deleteByExample(FundInfoCompanyInfoExample example);

    int insert(FundInfoCompanyInfo record);

    int insertOrUpdate(FundInfoCompanyInfo record);

    int insertOrUpdateSelective(FundInfoCompanyInfo record);

    int insertSelective(FundInfoCompanyInfo record);

    List<FundInfoCompanyInfo> selectByExample(FundInfoCompanyInfoExample example);

    int updateByExampleSelective(@Param("record") FundInfoCompanyInfo record, @Param("example") FundInfoCompanyInfoExample example);

    int updateByExample(@Param("record") FundInfoCompanyInfo record, @Param("example") FundInfoCompanyInfoExample example);

    int batchInsert(@Param("list") List<FundInfoCompanyInfo> list);
}