package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundInfo;
import com.tanpu.fund.entity.generator.FundInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundInfoMapper {
    long countByExample(FundInfoExample example);

    int deleteByExample(FundInfoExample example);

    int deleteByPrimaryKey(String id);

    int insert(FundInfo record);

    int insertOrUpdate(FundInfo record);

    int insertOrUpdateSelective(FundInfo record);

    int insertOrUpdateWithBLOBs(FundInfo record);

    int insertSelective(FundInfo record);

    List<FundInfo> selectByExampleWithBLOBs(FundInfoExample example);

    List<FundInfo> selectByExample(FundInfoExample example);

    FundInfo selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") FundInfo record, @Param("example") FundInfoExample example);

    int updateByExampleWithBLOBs(@Param("record") FundInfo record, @Param("example") FundInfoExample example);

    int updateByExample(@Param("record") FundInfo record, @Param("example") FundInfoExample example);

    int updateByPrimaryKeySelective(FundInfo record);

    int updateByPrimaryKeyWithBLOBs(FundInfo record);

    int updateByPrimaryKey(FundInfo record);

    int updateBatch(List<FundInfo> list);

    int updateBatchSelective(List<FundInfo> list);

    int batchInsert(@Param("list") List<FundInfo> list);
}