package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundManagerMapping1;
import com.tanpu.fund.entity.generator.FundManagerMapping1Example;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundManagerMapping1Mapper {
    long countByExample(FundManagerMapping1Example example);

    int deleteByExample(FundManagerMapping1Example example);

    int deleteByPrimaryKey(String id);

    int insert(FundManagerMapping1 record);

    int insertOrUpdate(FundManagerMapping1 record);

    int insertOrUpdateSelective(FundManagerMapping1 record);

    int insertSelective(FundManagerMapping1 record);

    List<FundManagerMapping1> selectByExample(FundManagerMapping1Example example);

    FundManagerMapping1 selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") FundManagerMapping1 record, @Param("example") FundManagerMapping1Example example);

    int updateByExample(@Param("record") FundManagerMapping1 record, @Param("example") FundManagerMapping1Example example);

    int updateByPrimaryKeySelective(FundManagerMapping1 record);

    int updateByPrimaryKey(FundManagerMapping1 record);

    int updateBatch(List<FundManagerMapping1> list);

    int updateBatchSelective(List<FundManagerMapping1> list);

    int batchInsert(@Param("list") List<FundManagerMapping1> list);
}