package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundManagerMapping;
import com.tanpu.fund.entity.generator.FundManagerMappingExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundManagerMappingMapper {
    long countByExample(FundManagerMappingExample example);

    int deleteByExample(FundManagerMappingExample example);

    int deleteByPrimaryKey(String id);

    int insert(FundManagerMapping record);

    int insertOrUpdate(FundManagerMapping record);

    int insertOrUpdateSelective(FundManagerMapping record);

    int insertSelective(FundManagerMapping record);

    List<FundManagerMapping> selectByExample(FundManagerMappingExample example);

    FundManagerMapping selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") FundManagerMapping record, @Param("example") FundManagerMappingExample example);

    int updateByExample(@Param("record") FundManagerMapping record, @Param("example") FundManagerMappingExample example);

    int updateByPrimaryKeySelective(FundManagerMapping record);

    int updateByPrimaryKey(FundManagerMapping record);

    int updateBatch(List<FundManagerMapping> list);

    int updateBatchSelective(List<FundManagerMapping> list);

    int batchInsert(@Param("list") List<FundManagerMapping> list);
}