package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundMarketIndexes;
import com.tanpu.fund.entity.generator.FundMarketIndexesExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundMarketIndexesMapper {
    long countByExample(FundMarketIndexesExample example);

    int deleteByExample(FundMarketIndexesExample example);

    int deleteByPrimaryKey(String id);

    int insert(FundMarketIndexes record);

    int insertOrUpdate(FundMarketIndexes record);

    int insertOrUpdateSelective(FundMarketIndexes record);

    int insertSelective(FundMarketIndexes record);

    List<FundMarketIndexes> selectByExample(FundMarketIndexesExample example);

    FundMarketIndexes selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") FundMarketIndexes record, @Param("example") FundMarketIndexesExample example);

    int updateByExample(@Param("record") FundMarketIndexes record, @Param("example") FundMarketIndexesExample example);

    int updateByPrimaryKeySelective(FundMarketIndexes record);

    int updateByPrimaryKey(FundMarketIndexes record);

    int updateBatch(List<FundMarketIndexes> list);

    int updateBatchSelective(List<FundMarketIndexes> list);

    int batchInsert(@Param("list") List<FundMarketIndexes> list);
}