package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundNav;
import com.tanpu.fund.entity.generator.FundNavExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundNavMapper {
    long countByExample(FundNavExample example);

    int deleteByExample(FundNavExample example);

    int deleteByPrimaryKey(String id);

    int insert(FundNav record);

    int insertOrUpdate(FundNav record);

    int insertOrUpdateSelective(FundNav record);

    int insertSelective(FundNav record);

    List<FundNav> selectByExample(FundNavExample example);

    FundNav selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") FundNav record, @Param("example") FundNavExample example);

    int updateByExample(@Param("record") FundNav record, @Param("example") FundNavExample example);

    int updateByPrimaryKeySelective(FundNav record);

    int updateByPrimaryKey(FundNav record);

    int updateBatch(List<FundNav> list);

    int updateBatchSelective(List<FundNav> list);

    int batchInsert(@Param("list") List<FundNav> list);
}