package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundRiskStats;
import com.tanpu.fund.entity.generator.FundRiskStatsExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundRiskStatsMapper {
    long countByExample(FundRiskStatsExample example);

    int deleteByExample(FundRiskStatsExample example);

    int deleteByPrimaryKey(String id);

    int insert(FundRiskStats record);

    int insertOrUpdate(FundRiskStats record);

    int insertOrUpdateSelective(FundRiskStats record);

    int insertSelective(FundRiskStats record);

    List<FundRiskStats> selectByExample(FundRiskStatsExample example);

    FundRiskStats selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") FundRiskStats record, @Param("example") FundRiskStatsExample example);

    int updateByExample(@Param("record") FundRiskStats record, @Param("example") FundRiskStatsExample example);

    int updateByPrimaryKeySelective(FundRiskStats record);

    int updateByPrimaryKey(FundRiskStats record);

    int updateBatch(List<FundRiskStats> list);

    int updateBatchSelective(List<FundRiskStats> list);

    int batchInsert(@Param("list") List<FundRiskStats> list);
}