package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IfaImportedFundNav;
import com.tanpu.fund.entity.generator.IfaImportedFundNavExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IfaImportedFundNavMapper {
    long countByExample(IfaImportedFundNavExample example);

    int deleteByExample(IfaImportedFundNavExample example);

    int deleteByPrimaryKey(Long id);

    int insert(IfaImportedFundNav record);

    int insertOrUpdate(IfaImportedFundNav record);

    int insertOrUpdateSelective(IfaImportedFundNav record);

    int insertSelective(IfaImportedFundNav record);

    List<IfaImportedFundNav> selectByExample(IfaImportedFundNavExample example);

    IfaImportedFundNav selectByPrimaryKey(Long id);

    int updateByExampleSelective(@Param("record") IfaImportedFundNav record, @Param("example") IfaImportedFundNavExample example);

    int updateByExample(@Param("record") IfaImportedFundNav record, @Param("example") IfaImportedFundNavExample example);

    int updateByPrimaryKeySelective(IfaImportedFundNav record);

    int updateByPrimaryKey(IfaImportedFundNav record);

    int updateBatch(List<IfaImportedFundNav> list);

    int updateBatchSelective(List<IfaImportedFundNav> list);

    int batchInsert(@Param("list") List<IfaImportedFundNav> list);
}
