package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IndexBasic;
import com.tanpu.fund.entity.generator.IndexBasicExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IndexBasicMapper {
    long countByExample(IndexBasicExample example);

    int deleteByExample(IndexBasicExample example);

    int insert(IndexBasic record);

    int insertOrUpdate(IndexBasic record);

    int insertOrUpdateSelective(IndexBasic record);

    int insertOrUpdateWithBLOBs(IndexBasic record);

    int insertSelective(IndexBasic record);

    List<IndexBasic> selectByExampleWithBLOBs(IndexBasicExample example);

    List<IndexBasic> selectByExample(IndexBasicExample example);

    int updateByExampleSelective(@Param("record") IndexBasic record, @Param("example") IndexBasicExample example);

    int updateByExampleWithBLOBs(@Param("record") IndexBasic record, @Param("example") IndexBasicExample example);

    int updateByExample(@Param("record") IndexBasic record, @Param("example") IndexBasicExample example);

    int batchInsert(@Param("list") List<IndexBasic> list);
}