package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IndexCount;
import com.tanpu.fund.entity.generator.IndexCountExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IndexCountMapper {
    long countByExample(IndexCountExample example);

    int deleteByExample(IndexCountExample example);

    int deleteByPrimaryKey(String id);

    int insert(IndexCount record);

    int insertOrUpdate(IndexCount record);

    int insertOrUpdateSelective(IndexCount record);

    int insertSelective(IndexCount record);

    List<IndexCount> selectByExample(IndexCountExample example);

    IndexCount selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") IndexCount record, @Param("example") IndexCountExample example);

    int updateByExample(@Param("record") IndexCount record, @Param("example") IndexCountExample example);

    int updateByPrimaryKeySelective(IndexCount record);

    int updateByPrimaryKey(IndexCount record);

    int updateBatch(List<IndexCount> list);

    int updateBatchSelective(List<IndexCount> list);

    int batchInsert(@Param("list") List<IndexCount> list);
}