package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IndexMonthly;
import com.tanpu.fund.entity.generator.IndexMonthlyExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IndexMonthlyMapper {
    long countByExample(IndexMonthlyExample example);

    int deleteByExample(IndexMonthlyExample example);

    int insert(IndexMonthly record);

    int insertOrUpdate(IndexMonthly record);

    int insertOrUpdateSelective(IndexMonthly record);

    int insertSelective(IndexMonthly record);

    List<IndexMonthly> selectByExample(IndexMonthlyExample example);

    int updateByExampleSelective(@Param("record") IndexMonthly record, @Param("example") IndexMonthlyExample example);

    int updateByExample(@Param("record") IndexMonthly record, @Param("example") IndexMonthlyExample example);

    int batchInsert(@Param("list") List<IndexMonthly> list);
}