package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.NewFundRank;
import com.tanpu.fund.entity.generator.NewFundRankExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface NewFundRankMapper {
    long countByExample(NewFundRankExample example);

    int deleteByExample(NewFundRankExample example);

    int deleteByPrimaryKey(String fundId);

    int insert(NewFundRank record);

    int insertOrUpdate(NewFundRank record);

    int insertOrUpdateSelective(NewFundRank record);

    int insertOrUpdateWithBLOBs(NewFundRank record);

    int insertSelective(NewFundRank record);

    List<NewFundRank> selectByExampleWithBLOBs(NewFundRankExample example);

    List<NewFundRank> selectByExample(NewFundRankExample example);

    NewFundRank selectByPrimaryKey(String fundId);

    int updateByExampleSelective(@Param("record") NewFundRank record, @Param("example") NewFundRankExample example);

    int updateByExampleWithBLOBs(@Param("record") NewFundRank record, @Param("example") NewFundRankExample example);

    int updateByExample(@Param("record") NewFundRank record, @Param("example") NewFundRankExample example);

    int updateByPrimaryKeySelective(NewFundRank record);

    int updateByPrimaryKeyWithBLOBs(NewFundRank record);

    int updateByPrimaryKey(NewFundRank record);

    int updateBatch(List<NewFundRank> list);

    int updateBatchSelective(List<NewFundRank> list);

    int batchInsert(@Param("list") List<NewFundRank> list);
}