package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.PersonCompanyPositionMapping;
import com.tanpu.fund.entity.generator.PersonCompanyPositionMappingExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface PersonCompanyPositionMappingMapper {
    long countByExample(PersonCompanyPositionMappingExample example);

    int deleteByExample(PersonCompanyPositionMappingExample example);

    int deleteByPrimaryKey(String id);

    int insert(PersonCompanyPositionMapping record);

    int insertOrUpdate(PersonCompanyPositionMapping record);

    int insertOrUpdateSelective(PersonCompanyPositionMapping record);

    int insertSelective(PersonCompanyPositionMapping record);

    List<PersonCompanyPositionMapping> selectByExample(PersonCompanyPositionMappingExample example);

    PersonCompanyPositionMapping selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") PersonCompanyPositionMapping record, @Param("example") PersonCompanyPositionMappingExample example);

    int updateByExample(@Param("record") PersonCompanyPositionMapping record, @Param("example") PersonCompanyPositionMappingExample example);

    int updateByPrimaryKeySelective(PersonCompanyPositionMapping record);

    int updateByPrimaryKey(PersonCompanyPositionMapping record);

    int updateBatch(List<PersonCompanyPositionMapping> list);

    int updateBatchSelective(List<PersonCompanyPositionMapping> list);

    int batchInsert(@Param("list") List<PersonCompanyPositionMapping> list);
}