package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.PublicFundManager;
import com.tanpu.fund.entity.generator.PublicFundManagerExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface PublicFundManagerMapper {
    long countByExample(PublicFundManagerExample example);

    int deleteByExample(PublicFundManagerExample example);

    int deleteByPrimaryKey(@Param("tsCode") String tsCode, @Param("annDate") String annDate, @Param("name") String name, @Param("endDate") String endDate);

    int insert(PublicFundManager record);

    int insertOrUpdate(PublicFundManager record);

    int insertOrUpdateSelective(PublicFundManager record);

    int insertSelective(PublicFundManager record);

    List<PublicFundManager> selectByExample(PublicFundManagerExample example);

    PublicFundManager selectByPrimaryKey(@Param("tsCode") String tsCode, @Param("annDate") String annDate, @Param("name") String name, @Param("endDate") String endDate);

    int updateByExampleSelective(@Param("record") PublicFundManager record, @Param("example") PublicFundManagerExample example);

    int updateByExample(@Param("record") PublicFundManager record, @Param("example") PublicFundManagerExample example);

    int updateByPrimaryKeySelective(PublicFundManager record);

    int updateByPrimaryKey(PublicFundManager record);

    int updateBatch(List<PublicFundManager> list);

    int updateBatchSelective(List<PublicFundManager> list);

    int batchInsert(@Param("list") List<PublicFundManager> list);
}