package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TampFundInfoView;
import com.tanpu.fund.entity.generator.TampFundInfoViewExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface TampFundInfoViewMapper {
    long countByExample(TampFundInfoViewExample example);

    int deleteByExample(TampFundInfoViewExample example);

    int insert(TampFundInfoView record);

    int insertOrUpdate(TampFundInfoView record);

    int insertOrUpdateSelective(TampFundInfoView record);

    int insertSelective(TampFundInfoView record);

    List<TampFundInfoView> selectByExample(TampFundInfoViewExample example);

    int updateByExampleSelective(@Param("record") TampFundInfoView record, @Param("example") TampFundInfoViewExample example);

    int updateByExample(@Param("record") TampFundInfoView record, @Param("example") TampFundInfoViewExample example);

    int batchInsert(@Param("list") List<TampFundInfoView> list);
}