package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundManagerMapping;
import com.tanpu.fund.entity.generator.TxFundManagerMappingExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundManagerMappingMapper {
    long countByExample(TxFundManagerMappingExample example);

    int deleteByExample(TxFundManagerMappingExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundManagerMapping record);

    int insertOrUpdate(TxFundManagerMapping record);

    int insertOrUpdateSelective(TxFundManagerMapping record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundManagerMapping record);

    List<TxFundManagerMapping> selectByExample(TxFundManagerMappingExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxFundManagerMapping selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxFundManagerMapping record, @Param("example") TxFundManagerMappingExample example);

    int updateByExample(@Param("record") TxFundManagerMapping record, @Param("example") TxFundManagerMappingExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundManagerMapping record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundManagerMapping record);

    int updateBatch(List<TxFundManagerMapping> list);

    int batchInsert(@Param("list") List<TxFundManagerMapping> list);
}