package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundNav;
import com.tanpu.fund.entity.generator.TxFundNavExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundNavMapper {
    long countByExample(TxFundNavExample example);

    int deleteByExample(TxFundNavExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundNav record);

    int insertOrUpdate(TxFundNav record);

    int insertOrUpdateSelective(TxFundNav record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundNav record);

    List<TxFundNav> selectByExample(TxFundNavExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxFundNav selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxFundNav record, @Param("example") TxFundNavExample example);

    int updateByExample(@Param("record") TxFundNav record, @Param("example") TxFundNavExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundNav record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundNav record);

    int updateBatch(List<TxFundNav> list);

    int batchInsert(@Param("list") List<TxFundNav> list);
}