package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxTop10Stock;
import com.tanpu.fund.entity.generator.TxTop10StockExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxTop10StockMapper {
    long countByExample(TxTop10StockExample example);

    int deleteByExample(TxTop10StockExample example);

    /**
     * delete by primary key
     * @param sRowVersion primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(Long sRowVersion);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxTop10Stock record);

    int insertOrUpdate(TxTop10Stock record);

    int insertOrUpdateSelective(TxTop10Stock record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxTop10Stock record);

    List<TxTop10Stock> selectByExample(TxTop10StockExample example);

    /**
     * select by primary key
     * @param sRowVersion primary key
     * @return object by primary key
     */
    TxTop10Stock selectByPrimaryKey(Long sRowVersion);

    int updateByExampleSelective(@Param("record") TxTop10Stock record, @Param("example") TxTop10StockExample example);

    int updateByExample(@Param("record") TxTop10Stock record, @Param("example") TxTop10StockExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxTop10Stock record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxTop10Stock record);

    int updateBatch(List<TxTop10Stock> list);

    int batchInsert(@Param("list") List<TxTop10Stock> list);
}