package com.tanpu.fund.utils;

import java.util.List;
import java.util.Set;

public class SqlUtils {

    /**
     * List<String> 转字符串 逗号分割且元素加引号
     *
     * @param list
     * @return
     */
    public static String toInStr(List<String> list) {
        StringBuffer str = new StringBuffer();
        for (int i=0; i< list.size(); i++) {
            if(i==0) {
                str.append("'").append(list.get(i)).append("'");
            } else {
                str.append(",").append("'").append(list.get(i)).append("'");
            }
        }
        return str.toString();
    }

    /**
     * List<Integer> 转字符串 逗号分割且元素加引号
     *
     * @param list
     * @return
     */
    public static String toStr(List<Integer> list) {
        StringBuffer str = new StringBuffer();
        for (int i=0; i< list.size(); i++) {
            if(i==0) {
                str.append(list.get(i));
            } else {
                str.append(",").append(list.get(i));
            }
        }
        return str.toString();
    }

    /**
     * Set<String> 转字符串 逗号分割且元素加引号
     *
     * @param list
     * @return
     */
    public static String toInStr(Set<String> list) {
        StringBuffer str = new StringBuffer();
        int i=0;
        for (String item:list) {
            if(i==0) {
                str.append("'").append(item).append("'");
            } else {
                str.append(",").append("'").append(item).append("'");
            }
            i++;
        }
        return str.toString();
    }
}
