//package com.tanpu.product.config.elastic.autoconfigure;
//
//import com.dangdang.ddframe.job.reg.zookeeper.ZookeeperConfiguration;
//import com.dangdang.ddframe.job.reg.zookeeper.ZookeeperRegistryCenter;
//import com.tanpu.product.config.elastic.parse.ElasticJobConfParser;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.boot.context.properties.EnableConfigurationProperties;
//import org.springframework.context.annotation.Bean;
//import org.springframework.context.annotation.Conditional;
//import org.springframework.context.annotation.Configuration;
//
///**
// * 任务自动配置
// *
// * @author yinjihuan
// * @about http://cxytiandi.com/about
// */
//@Configuration
//@Conditional(ElasticCondition.class)
//@EnableConfigurationProperties(ZookeeperProperties.class)
//public class ElasticJobParserAutoConfiguration {
//
//    @Autowired
//    private ZookeeperProperties zookeeperProperties;
//
//    /**
//     * 初始化Zookeeper注册中心
//     *
//     * @return
//     */
//    @Bean(initMethod = "init")
//    public ZookeeperRegistryCenter zookeeperRegistryCenter() {
//        ZookeeperConfiguration zkConfig = new ZookeeperConfiguration(zookeeperProperties.getServerLists(),
//                zookeeperProperties.getNamespace());
//        zkConfig.setBaseSleepTimeMilliseconds(zookeeperProperties.getBaseSleepTimeMilliseconds());
//        zkConfig.setConnectionTimeoutMilliseconds(zookeeperProperties.getConnectionTimeoutMilliseconds());
//        zkConfig.setDigest(zookeeperProperties.getDigest());
//        zkConfig.setMaxRetries(zookeeperProperties.getMaxRetries());
//        zkConfig.setMaxSleepTimeMilliseconds(zookeeperProperties.getMaxSleepTimeMilliseconds());
//        zkConfig.setSessionTimeoutMilliseconds(zookeeperProperties.getSessionTimeoutMilliseconds());
//        return new ZookeeperRegistryCenter(zkConfig);
//    }
//
//    /**
//     * 任务解析类
//     */
//    @Bean
//    public ElasticJobConfParser elasticJobConfParser() {
//        return new ElasticJobConfParser();
//    }
//
//}