package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class CompanyTnaPersonnelExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public CompanyTnaPersonnelExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(String value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(String value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(String value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(String value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(String value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(String value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLike(String value) {
            addCriterion("company_id like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotLike(String value) {
            addCriterion("company_id not like", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<String> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<String> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(String value1, String value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(String value1, String value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andStatDateIsNull() {
            addCriterion("stat_date is null");
            return (Criteria) this;
        }

        public Criteria andStatDateIsNotNull() {
            addCriterion("stat_date is not null");
            return (Criteria) this;
        }

        public Criteria andStatDateEqualTo(Date value) {
            addCriterionForJDBCDate("stat_date =", value, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("stat_date <>", value, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateGreaterThan(Date value) {
            addCriterionForJDBCDate("stat_date >", value, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("stat_date >=", value, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateLessThan(Date value) {
            addCriterionForJDBCDate("stat_date <", value, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("stat_date <=", value, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateIn(List<Date> values) {
            addCriterionForJDBCDate("stat_date in", values, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("stat_date not in", values, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("stat_date between", value1, value2, "statDate");
            return (Criteria) this;
        }

        public Criteria andStatDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("stat_date not between", value1, value2, "statDate");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeIsNull() {
            addCriterion("trust_fund_asset_size is null");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeIsNotNull() {
            addCriterion("trust_fund_asset_size is not null");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeEqualTo(BigDecimal value) {
            addCriterion("trust_fund_asset_size =", value, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeNotEqualTo(BigDecimal value) {
            addCriterion("trust_fund_asset_size <>", value, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeGreaterThan(BigDecimal value) {
            addCriterion("trust_fund_asset_size >", value, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("trust_fund_asset_size >=", value, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeLessThan(BigDecimal value) {
            addCriterion("trust_fund_asset_size <", value, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("trust_fund_asset_size <=", value, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeIn(List<BigDecimal> values) {
            addCriterion("trust_fund_asset_size in", values, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeNotIn(List<BigDecimal> values) {
            addCriterion("trust_fund_asset_size not in", values, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("trust_fund_asset_size between", value1, value2, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andTrustFundAssetSizeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("trust_fund_asset_size not between", value1, value2, "trustFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeIsNull() {
            addCriterion("special_account_asset_size is null");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeIsNotNull() {
            addCriterion("special_account_asset_size is not null");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeEqualTo(BigDecimal value) {
            addCriterion("special_account_asset_size =", value, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeNotEqualTo(BigDecimal value) {
            addCriterion("special_account_asset_size <>", value, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeGreaterThan(BigDecimal value) {
            addCriterion("special_account_asset_size >", value, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("special_account_asset_size >=", value, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeLessThan(BigDecimal value) {
            addCriterion("special_account_asset_size <", value, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("special_account_asset_size <=", value, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeIn(List<BigDecimal> values) {
            addCriterion("special_account_asset_size in", values, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeNotIn(List<BigDecimal> values) {
            addCriterion("special_account_asset_size not in", values, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("special_account_asset_size between", value1, value2, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andSpecialAccountAssetSizeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("special_account_asset_size not between", value1, value2, "specialAccountAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeIsNull() {
            addCriterion("ltdco_fund_asset_size is null");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeIsNotNull() {
            addCriterion("ltdco_fund_asset_size is not null");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeEqualTo(BigDecimal value) {
            addCriterion("ltdco_fund_asset_size =", value, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeNotEqualTo(BigDecimal value) {
            addCriterion("ltdco_fund_asset_size <>", value, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeGreaterThan(BigDecimal value) {
            addCriterion("ltdco_fund_asset_size >", value, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ltdco_fund_asset_size >=", value, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeLessThan(BigDecimal value) {
            addCriterion("ltdco_fund_asset_size <", value, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ltdco_fund_asset_size <=", value, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeIn(List<BigDecimal> values) {
            addCriterion("ltdco_fund_asset_size in", values, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeNotIn(List<BigDecimal> values) {
            addCriterion("ltdco_fund_asset_size not in", values, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ltdco_fund_asset_size between", value1, value2, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andLtdcoFundAssetSizeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ltdco_fund_asset_size not between", value1, value2, "ltdcoFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeIsNull() {
            addCriterion("offshore_fund_asset_size is null");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeIsNotNull() {
            addCriterion("offshore_fund_asset_size is not null");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeEqualTo(BigDecimal value) {
            addCriterion("offshore_fund_asset_size =", value, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeNotEqualTo(BigDecimal value) {
            addCriterion("offshore_fund_asset_size <>", value, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeGreaterThan(BigDecimal value) {
            addCriterion("offshore_fund_asset_size >", value, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("offshore_fund_asset_size >=", value, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeLessThan(BigDecimal value) {
            addCriterion("offshore_fund_asset_size <", value, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("offshore_fund_asset_size <=", value, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeIn(List<BigDecimal> values) {
            addCriterion("offshore_fund_asset_size in", values, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeNotIn(List<BigDecimal> values) {
            addCriterion("offshore_fund_asset_size not in", values, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("offshore_fund_asset_size between", value1, value2, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andOffshoreFundAssetSizeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("offshore_fund_asset_size not between", value1, value2, "offshoreFundAssetSize");
            return (Criteria) this;
        }

        public Criteria andFundNumIsNull() {
            addCriterion("fund_num is null");
            return (Criteria) this;
        }

        public Criteria andFundNumIsNotNull() {
            addCriterion("fund_num is not null");
            return (Criteria) this;
        }

        public Criteria andFundNumEqualTo(Integer value) {
            addCriterion("fund_num =", value, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumNotEqualTo(Integer value) {
            addCriterion("fund_num <>", value, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumGreaterThan(Integer value) {
            addCriterion("fund_num >", value, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("fund_num >=", value, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumLessThan(Integer value) {
            addCriterion("fund_num <", value, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumLessThanOrEqualTo(Integer value) {
            addCriterion("fund_num <=", value, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumIn(List<Integer> values) {
            addCriterion("fund_num in", values, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumNotIn(List<Integer> values) {
            addCriterion("fund_num not in", values, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumBetween(Integer value1, Integer value2) {
            addCriterion("fund_num between", value1, value2, "fundNum");
            return (Criteria) this;
        }

        public Criteria andFundNumNotBetween(Integer value1, Integer value2) {
            addCriterion("fund_num not between", value1, value2, "fundNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumIsNull() {
            addCriterion("staff_num is null");
            return (Criteria) this;
        }

        public Criteria andStaffNumIsNotNull() {
            addCriterion("staff_num is not null");
            return (Criteria) this;
        }

        public Criteria andStaffNumEqualTo(Integer value) {
            addCriterion("staff_num =", value, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumNotEqualTo(Integer value) {
            addCriterion("staff_num <>", value, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumGreaterThan(Integer value) {
            addCriterion("staff_num >", value, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("staff_num >=", value, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumLessThan(Integer value) {
            addCriterion("staff_num <", value, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumLessThanOrEqualTo(Integer value) {
            addCriterion("staff_num <=", value, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumIn(List<Integer> values) {
            addCriterion("staff_num in", values, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumNotIn(List<Integer> values) {
            addCriterion("staff_num not in", values, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumBetween(Integer value1, Integer value2) {
            addCriterion("staff_num between", value1, value2, "staffNum");
            return (Criteria) this;
        }

        public Criteria andStaffNumNotBetween(Integer value1, Integer value2) {
            addCriterion("staff_num not between", value1, value2, "staffNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumIsNull() {
            addCriterion("analyst_num is null");
            return (Criteria) this;
        }

        public Criteria andAnalystNumIsNotNull() {
            addCriterion("analyst_num is not null");
            return (Criteria) this;
        }

        public Criteria andAnalystNumEqualTo(Integer value) {
            addCriterion("analyst_num =", value, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumNotEqualTo(Integer value) {
            addCriterion("analyst_num <>", value, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumGreaterThan(Integer value) {
            addCriterion("analyst_num >", value, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumGreaterThanOrEqualTo(Integer value) {
            addCriterion("analyst_num >=", value, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumLessThan(Integer value) {
            addCriterion("analyst_num <", value, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumLessThanOrEqualTo(Integer value) {
            addCriterion("analyst_num <=", value, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumIn(List<Integer> values) {
            addCriterion("analyst_num in", values, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumNotIn(List<Integer> values) {
            addCriterion("analyst_num not in", values, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumBetween(Integer value1, Integer value2) {
            addCriterion("analyst_num between", value1, value2, "analystNum");
            return (Criteria) this;
        }

        public Criteria andAnalystNumNotBetween(Integer value1, Integer value2) {
            addCriterion("analyst_num not between", value1, value2, "analystNum");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeIsNull() {
            addCriterion("total_asset_size is null");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeIsNotNull() {
            addCriterion("total_asset_size is not null");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeEqualTo(BigDecimal value) {
            addCriterion("total_asset_size =", value, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeNotEqualTo(BigDecimal value) {
            addCriterion("total_asset_size <>", value, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeGreaterThan(BigDecimal value) {
            addCriterion("total_asset_size >", value, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_asset_size >=", value, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeLessThan(BigDecimal value) {
            addCriterion("total_asset_size <", value, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_asset_size <=", value, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeIn(List<BigDecimal> values) {
            addCriterion("total_asset_size in", values, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeNotIn(List<BigDecimal> values) {
            addCriterion("total_asset_size not in", values, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_asset_size between", value1, value2, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andTotalAssetSizeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_asset_size not between", value1, value2, "totalAssetSize");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}