package com.tanpu.fund.entity.generator;

import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class FundCompanyInfo {
    private String companyId;

    private String pCompanyI;

    private String companyName;

    private String companySho;

    private String companyEng;

    private Integer companyTyp;

    private Date establishD;

    private String organizatio;

    private String creditCode;

    private Integer hasConsult;

    private Integer domicileId;

    private String companyAdd;

    private String companyAdd1;

    private String city;

    private String province;

    private String country;

    private String regCity;

    private String regProvinc;

    private String regCountry;

    private String contactPho;

    private String postCode;

    private String fax;

    private String email;

    private String website;

    private Double registered;

    private Integer offshoreFu;

    private Integer companySta;

    private Integer baseCurren;

    private String registerNu;

    private Integer registerSt;

    private Date registerDa;

    private Integer isMember;

    private Date joinDate;

    private Integer memberType;

    private String fundCatego;

    private String businessTy;

    private Integer natureBusi;

    private Double capitalPai;

    private String registerNu1;

    private String logo;

    private Integer isvisible;

    private Integer isvalid;

    private Date updatetime;

    private Double paidCapita;

    private Integer companyAss;

    private Double fundscale;

    private String legalRepre;

    private String isQualify;

    private String getQualify;

    private Integer employeeCn;

    private String integrityI;

    private String specialTip;

    private String amacLink;

    private Date createtime;

    private String legalOpini;

    /**
     * 机构id
     */
    private String orgId;

    private String companyPro;

    private String philosopy;

    private String representat;
}