package com.tanpu.fund.entity.generator;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class FundInfoPersonnelInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public FundInfoPersonnelInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateIsNull() {
            addCriterion("management_start_date is null");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateIsNotNull() {
            addCriterion("management_start_date is not null");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateEqualTo(Date value) {
            addCriterionForJDBCDate("management_start_date =", value, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("management_start_date <>", value, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateGreaterThan(Date value) {
            addCriterionForJDBCDate("management_start_date >", value, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("management_start_date >=", value, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateLessThan(Date value) {
            addCriterionForJDBCDate("management_start_date <", value, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("management_start_date <=", value, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateIn(List<Date> values) {
            addCriterionForJDBCDate("management_start_date in", values, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("management_start_date not in", values, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("management_start_date between", value1, value2, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementStartDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("management_start_date not between", value1, value2, "managementStartDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateIsNull() {
            addCriterion("management_end_date is null");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateIsNotNull() {
            addCriterion("management_end_date is not null");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("management_end_date =", value, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("management_end_date <>", value, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("management_end_date >", value, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("management_end_date >=", value, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateLessThan(Date value) {
            addCriterionForJDBCDate("management_end_date <", value, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("management_end_date <=", value, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("management_end_date in", values, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("management_end_date not in", values, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("management_end_date between", value1, value2, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andManagementEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("management_end_date not between", value1, value2, "managementEndDate");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdIsNull() {
            addCriterion("fund_manager_id is null");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdIsNotNull() {
            addCriterion("fund_manager_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdEqualTo(String value) {
            addCriterion("fund_manager_id =", value, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdNotEqualTo(String value) {
            addCriterion("fund_manager_id <>", value, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdGreaterThan(String value) {
            addCriterion("fund_manager_id >", value, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_manager_id >=", value, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdLessThan(String value) {
            addCriterion("fund_manager_id <", value, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdLessThanOrEqualTo(String value) {
            addCriterion("fund_manager_id <=", value, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdLike(String value) {
            addCriterion("fund_manager_id like", value, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdNotLike(String value) {
            addCriterion("fund_manager_id not like", value, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdIn(List<String> values) {
            addCriterion("fund_manager_id in", values, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdNotIn(List<String> values) {
            addCriterion("fund_manager_id not in", values, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdBetween(String value1, String value2) {
            addCriterion("fund_manager_id between", value1, value2, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andFundManagerIdNotBetween(String value1, String value2) {
            addCriterion("fund_manager_id not between", value1, value2, "fundManagerId");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameIsNull() {
            addCriterion("personnel_name is null");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameIsNotNull() {
            addCriterion("personnel_name is not null");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameEqualTo(String value) {
            addCriterion("personnel_name =", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameNotEqualTo(String value) {
            addCriterion("personnel_name <>", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameGreaterThan(String value) {
            addCriterion("personnel_name >", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameGreaterThanOrEqualTo(String value) {
            addCriterion("personnel_name >=", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameLessThan(String value) {
            addCriterion("personnel_name <", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameLessThanOrEqualTo(String value) {
            addCriterion("personnel_name <=", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameLike(String value) {
            addCriterion("personnel_name like", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameNotLike(String value) {
            addCriterion("personnel_name not like", value, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameIn(List<String> values) {
            addCriterion("personnel_name in", values, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameNotIn(List<String> values) {
            addCriterion("personnel_name not in", values, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameBetween(String value1, String value2) {
            addCriterion("personnel_name between", value1, value2, "personnelName");
            return (Criteria) this;
        }

        public Criteria andPersonnelNameNotBetween(String value1, String value2) {
            addCriterion("personnel_name not between", value1, value2, "personnelName");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}