package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class IfaImportedFundInfoExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public IfaImportedFundInfoExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNull() {
            addCriterion("fund_name is null");
            return (Criteria) this;
        }

        public Criteria andFundNameIsNotNull() {
            addCriterion("fund_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundNameEqualTo(String value) {
            addCriterion("fund_name =", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotEqualTo(String value) {
            addCriterion("fund_name <>", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThan(String value) {
            addCriterion("fund_name >", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_name >=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThan(String value) {
            addCriterion("fund_name <", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLessThanOrEqualTo(String value) {
            addCriterion("fund_name <=", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameLike(String value) {
            addCriterion("fund_name like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotLike(String value) {
            addCriterion("fund_name not like", value, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameIn(List<String> values) {
            addCriterion("fund_name in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotIn(List<String> values) {
            addCriterion("fund_name not in", values, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameBetween(String value1, String value2) {
            addCriterion("fund_name between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andFundNameNotBetween(String value1, String value2) {
            addCriterion("fund_name not between", value1, value2, "fundName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNull() {
            addCriterion("substrategy is null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIsNotNull() {
            addCriterion("substrategy is not null");
            return (Criteria) this;
        }

        public Criteria andSubstrategyEqualTo(Integer value) {
            addCriterion("substrategy =", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotEqualTo(Integer value) {
            addCriterion("substrategy <>", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThan(Integer value) {
            addCriterion("substrategy >", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyGreaterThanOrEqualTo(Integer value) {
            addCriterion("substrategy >=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThan(Integer value) {
            addCriterion("substrategy <", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyLessThanOrEqualTo(Integer value) {
            addCriterion("substrategy <=", value, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyIn(List<Integer> values) {
            addCriterion("substrategy in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotIn(List<Integer> values) {
            addCriterion("substrategy not in", values, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyBetween(Integer value1, Integer value2) {
            addCriterion("substrategy between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andSubstrategyNotBetween(Integer value1, Integer value2) {
            addCriterion("substrategy not between", value1, value2, "substrategy");
            return (Criteria) this;
        }

        public Criteria andStrategyIsNull() {
            addCriterion("strategy is null");
            return (Criteria) this;
        }

        public Criteria andStrategyIsNotNull() {
            addCriterion("strategy is not null");
            return (Criteria) this;
        }

        public Criteria andStrategyEqualTo(Integer value) {
            addCriterion("strategy =", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotEqualTo(Integer value) {
            addCriterion("strategy <>", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyGreaterThan(Integer value) {
            addCriterion("strategy >", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyGreaterThanOrEqualTo(Integer value) {
            addCriterion("strategy >=", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyLessThan(Integer value) {
            addCriterion("strategy <", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyLessThanOrEqualTo(Integer value) {
            addCriterion("strategy <=", value, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyIn(List<Integer> values) {
            addCriterion("strategy in", values, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotIn(List<Integer> values) {
            addCriterion("strategy not in", values, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyBetween(Integer value1, Integer value2) {
            addCriterion("strategy between", value1, value2, "strategy");
            return (Criteria) this;
        }

        public Criteria andStrategyNotBetween(Integer value1, Integer value2) {
            addCriterion("strategy not between", value1, value2, "strategy");
            return (Criteria) this;
        }

        public Criteria andManageNameIsNull() {
            addCriterion("manage_name is null");
            return (Criteria) this;
        }

        public Criteria andManageNameIsNotNull() {
            addCriterion("manage_name is not null");
            return (Criteria) this;
        }

        public Criteria andManageNameEqualTo(String value) {
            addCriterion("manage_name =", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameNotEqualTo(String value) {
            addCriterion("manage_name <>", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameGreaterThan(String value) {
            addCriterion("manage_name >", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameGreaterThanOrEqualTo(String value) {
            addCriterion("manage_name >=", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameLessThan(String value) {
            addCriterion("manage_name <", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameLessThanOrEqualTo(String value) {
            addCriterion("manage_name <=", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameLike(String value) {
            addCriterion("manage_name like", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameNotLike(String value) {
            addCriterion("manage_name not like", value, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameIn(List<String> values) {
            addCriterion("manage_name in", values, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameNotIn(List<String> values) {
            addCriterion("manage_name not in", values, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameBetween(String value1, String value2) {
            addCriterion("manage_name between", value1, value2, "manageName");
            return (Criteria) this;
        }

        public Criteria andManageNameNotBetween(String value1, String value2) {
            addCriterion("manage_name not between", value1, value2, "manageName");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIsNull() {
            addCriterion("risk_level is null");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIsNotNull() {
            addCriterion("risk_level is not null");
            return (Criteria) this;
        }

        public Criteria andRiskLevelEqualTo(String value) {
            addCriterion("risk_level =", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotEqualTo(String value) {
            addCriterion("risk_level <>", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelGreaterThan(String value) {
            addCriterion("risk_level >", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelGreaterThanOrEqualTo(String value) {
            addCriterion("risk_level >=", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLessThan(String value) {
            addCriterion("risk_level <", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLessThanOrEqualTo(String value) {
            addCriterion("risk_level <=", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelLike(String value) {
            addCriterion("risk_level like", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotLike(String value) {
            addCriterion("risk_level not like", value, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelIn(List<String> values) {
            addCriterion("risk_level in", values, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotIn(List<String> values) {
            addCriterion("risk_level not in", values, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelBetween(String value1, String value2) {
            addCriterion("risk_level between", value1, value2, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andRiskLevelNotBetween(String value1, String value2) {
            addCriterion("risk_level not between", value1, value2, "riskLevel");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIsNull() {
            addCriterion("inception_date is null");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIsNotNull() {
            addCriterion("inception_date is not null");
            return (Criteria) this;
        }

        public Criteria andInceptionDateEqualTo(Date value) {
            addCriterion("inception_date =", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotEqualTo(Date value) {
            addCriterion("inception_date <>", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateGreaterThan(Date value) {
            addCriterion("inception_date >", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateGreaterThanOrEqualTo(Date value) {
            addCriterion("inception_date >=", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateLessThan(Date value) {
            addCriterion("inception_date <", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateLessThanOrEqualTo(Date value) {
            addCriterion("inception_date <=", value, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateIn(List<Date> values) {
            addCriterion("inception_date in", values, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotIn(List<Date> values) {
            addCriterion("inception_date not in", values, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateBetween(Date value1, Date value2) {
            addCriterion("inception_date between", value1, value2, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andInceptionDateNotBetween(Date value1, Date value2) {
            addCriterion("inception_date not between", value1, value2, "inceptionDate");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIsNull() {
            addCriterion("register_number is null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIsNotNull() {
            addCriterion("register_number is not null");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberEqualTo(String value) {
            addCriterion("register_number =", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotEqualTo(String value) {
            addCriterion("register_number <>", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberGreaterThan(String value) {
            addCriterion("register_number >", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberGreaterThanOrEqualTo(String value) {
            addCriterion("register_number >=", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLessThan(String value) {
            addCriterion("register_number <", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLessThanOrEqualTo(String value) {
            addCriterion("register_number <=", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberLike(String value) {
            addCriterion("register_number like", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotLike(String value) {
            addCriterion("register_number not like", value, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberIn(List<String> values) {
            addCriterion("register_number in", values, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotIn(List<String> values) {
            addCriterion("register_number not in", values, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberBetween(String value1, String value2) {
            addCriterion("register_number between", value1, value2, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andRegisterNumberNotBetween(String value1, String value2) {
            addCriterion("register_number not between", value1, value2, "registerNumber");
            return (Criteria) this;
        }

        public Criteria andOpenDayIsNull() {
            addCriterion("open_day is null");
            return (Criteria) this;
        }

        public Criteria andOpenDayIsNotNull() {
            addCriterion("open_day is not null");
            return (Criteria) this;
        }

        public Criteria andOpenDayEqualTo(String value) {
            addCriterion("open_day =", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotEqualTo(String value) {
            addCriterion("open_day <>", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayGreaterThan(String value) {
            addCriterion("open_day >", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayGreaterThanOrEqualTo(String value) {
            addCriterion("open_day >=", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLessThan(String value) {
            addCriterion("open_day <", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLessThanOrEqualTo(String value) {
            addCriterion("open_day <=", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayLike(String value) {
            addCriterion("open_day like", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotLike(String value) {
            addCriterion("open_day not like", value, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayIn(List<String> values) {
            addCriterion("open_day in", values, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotIn(List<String> values) {
            addCriterion("open_day not in", values, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayBetween(String value1, String value2) {
            addCriterion("open_day between", value1, value2, "openDay");
            return (Criteria) this;
        }

        public Criteria andOpenDayNotBetween(String value1, String value2) {
            addCriterion("open_day not between", value1, value2, "openDay");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIsNull() {
            addCriterion("min_investment_share is null");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIsNotNull() {
            addCriterion("min_investment_share is not null");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareEqualTo(BigDecimal value) {
            addCriterion("min_investment_share =", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotEqualTo(BigDecimal value) {
            addCriterion("min_investment_share <>", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareGreaterThan(BigDecimal value) {
            addCriterion("min_investment_share >", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("min_investment_share >=", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareLessThan(BigDecimal value) {
            addCriterion("min_investment_share <", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("min_investment_share <=", value, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareIn(List<BigDecimal> values) {
            addCriterion("min_investment_share in", values, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotIn(List<BigDecimal> values) {
            addCriterion("min_investment_share not in", values, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("min_investment_share between", value1, value2, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andMinInvestmentShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("min_investment_share not between", value1, value2, "minInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIsNull() {
            addCriterion("subsequent_investment_share is null");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIsNotNull() {
            addCriterion("subsequent_investment_share is not null");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share =", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share <>", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareGreaterThan(BigDecimal value) {
            addCriterion("subsequent_investment_share >", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share >=", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareLessThan(BigDecimal value) {
            addCriterion("subsequent_investment_share <", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("subsequent_investment_share <=", value, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareIn(List<BigDecimal> values) {
            addCriterion("subsequent_investment_share in", values, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotIn(List<BigDecimal> values) {
            addCriterion("subsequent_investment_share not in", values, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subsequent_investment_share between", value1, value2, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubsequentInvestmentShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subsequent_investment_share not between", value1, value2, "subsequentInvestmentShare");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIsNull() {
            addCriterion("subscription_fee is null");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIsNotNull() {
            addCriterion("subscription_fee is not null");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeEqualTo(BigDecimal value) {
            addCriterion("subscription_fee =", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotEqualTo(BigDecimal value) {
            addCriterion("subscription_fee <>", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeGreaterThan(BigDecimal value) {
            addCriterion("subscription_fee >", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("subscription_fee >=", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeLessThan(BigDecimal value) {
            addCriterion("subscription_fee <", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("subscription_fee <=", value, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeIn(List<BigDecimal> values) {
            addCriterion("subscription_fee in", values, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotIn(List<BigDecimal> values) {
            addCriterion("subscription_fee not in", values, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subscription_fee between", value1, value2, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andSubscriptionFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("subscription_fee not between", value1, value2, "subscriptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIsNull() {
            addCriterion("redemption_fee is null");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIsNotNull() {
            addCriterion("redemption_fee is not null");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeEqualTo(BigDecimal value) {
            addCriterion("redemption_fee =", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotEqualTo(BigDecimal value) {
            addCriterion("redemption_fee <>", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeGreaterThan(BigDecimal value) {
            addCriterion("redemption_fee >", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("redemption_fee >=", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeLessThan(BigDecimal value) {
            addCriterion("redemption_fee <", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("redemption_fee <=", value, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeIn(List<BigDecimal> values) {
            addCriterion("redemption_fee in", values, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotIn(List<BigDecimal> values) {
            addCriterion("redemption_fee not in", values, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("redemption_fee between", value1, value2, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andRedemptionFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("redemption_fee not between", value1, value2, "redemptionFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeIsNull() {
            addCriterion("management_fee is null");
            return (Criteria) this;
        }

        public Criteria andManagementFeeIsNotNull() {
            addCriterion("management_fee is not null");
            return (Criteria) this;
        }

        public Criteria andManagementFeeEqualTo(BigDecimal value) {
            addCriterion("management_fee =", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeNotEqualTo(BigDecimal value) {
            addCriterion("management_fee <>", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeGreaterThan(BigDecimal value) {
            addCriterion("management_fee >", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("management_fee >=", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeLessThan(BigDecimal value) {
            addCriterion("management_fee <", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("management_fee <=", value, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeIn(List<BigDecimal> values) {
            addCriterion("management_fee in", values, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeNotIn(List<BigDecimal> values) {
            addCriterion("management_fee not in", values, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("management_fee between", value1, value2, "managementFee");
            return (Criteria) this;
        }

        public Criteria andManagementFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("management_fee not between", value1, value2, "managementFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIsNull() {
            addCriterion("performance_fee is null");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIsNotNull() {
            addCriterion("performance_fee is not null");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeEqualTo(BigDecimal value) {
            addCriterion("performance_fee =", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotEqualTo(BigDecimal value) {
            addCriterion("performance_fee <>", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeGreaterThan(BigDecimal value) {
            addCriterion("performance_fee >", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("performance_fee >=", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeLessThan(BigDecimal value) {
            addCriterion("performance_fee <", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeLessThanOrEqualTo(BigDecimal value) {
            addCriterion("performance_fee <=", value, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeIn(List<BigDecimal> values) {
            addCriterion("performance_fee in", values, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotIn(List<BigDecimal> values) {
            addCriterion("performance_fee not in", values, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("performance_fee between", value1, value2, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceFeeNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("performance_fee not between", value1, value2, "performanceFee");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodIsNull() {
            addCriterion("performance_calculate_method is null");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodIsNotNull() {
            addCriterion("performance_calculate_method is not null");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodEqualTo(String value) {
            addCriterion("performance_calculate_method =", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodNotEqualTo(String value) {
            addCriterion("performance_calculate_method <>", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodGreaterThan(String value) {
            addCriterion("performance_calculate_method >", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodGreaterThanOrEqualTo(String value) {
            addCriterion("performance_calculate_method >=", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodLessThan(String value) {
            addCriterion("performance_calculate_method <", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodLessThanOrEqualTo(String value) {
            addCriterion("performance_calculate_method <=", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodLike(String value) {
            addCriterion("performance_calculate_method like", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodNotLike(String value) {
            addCriterion("performance_calculate_method not like", value, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodIn(List<String> values) {
            addCriterion("performance_calculate_method in", values, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodNotIn(List<String> values) {
            addCriterion("performance_calculate_method not in", values, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodBetween(String value1, String value2) {
            addCriterion("performance_calculate_method between", value1, value2, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andPerformanceCalculateMethodNotBetween(String value1, String value2) {
            addCriterion("performance_calculate_method not between", value1, value2, "performanceCalculateMethod");
            return (Criteria) this;
        }

        public Criteria andIfaIdIsNull() {
            addCriterion("ifa_id is null");
            return (Criteria) this;
        }

        public Criteria andIfaIdIsNotNull() {
            addCriterion("ifa_id is not null");
            return (Criteria) this;
        }

        public Criteria andIfaIdEqualTo(String value) {
            addCriterion("ifa_id =", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdNotEqualTo(String value) {
            addCriterion("ifa_id <>", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdGreaterThan(String value) {
            addCriterion("ifa_id >", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdGreaterThanOrEqualTo(String value) {
            addCriterion("ifa_id >=", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdLessThan(String value) {
            addCriterion("ifa_id <", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdLessThanOrEqualTo(String value) {
            addCriterion("ifa_id <=", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdLike(String value) {
            addCriterion("ifa_id like", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdNotLike(String value) {
            addCriterion("ifa_id not like", value, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdIn(List<String> values) {
            addCriterion("ifa_id in", values, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdNotIn(List<String> values) {
            addCriterion("ifa_id not in", values, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdBetween(String value1, String value2) {
            addCriterion("ifa_id between", value1, value2, "ifaId");
            return (Criteria) this;
        }

        public Criteria andIfaIdNotBetween(String value1, String value2) {
            addCriterion("ifa_id not between", value1, value2, "ifaId");
            return (Criteria) this;
        }

        public Criteria andHasNavIsNull() {
            addCriterion("has_nav is null");
            return (Criteria) this;
        }

        public Criteria andHasNavIsNotNull() {
            addCriterion("has_nav is not null");
            return (Criteria) this;
        }

        public Criteria andHasNavEqualTo(Integer value) {
            addCriterion("has_nav =", value, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavNotEqualTo(Integer value) {
            addCriterion("has_nav <>", value, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavGreaterThan(Integer value) {
            addCriterion("has_nav >", value, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavGreaterThanOrEqualTo(Integer value) {
            addCriterion("has_nav >=", value, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavLessThan(Integer value) {
            addCriterion("has_nav <", value, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavLessThanOrEqualTo(Integer value) {
            addCriterion("has_nav <=", value, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavIn(List<Integer> values) {
            addCriterion("has_nav in", values, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavNotIn(List<Integer> values) {
            addCriterion("has_nav not in", values, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavBetween(Integer value1, Integer value2) {
            addCriterion("has_nav between", value1, value2, "hasNav");
            return (Criteria) this;
        }

        public Criteria andHasNavNotBetween(Integer value1, Integer value2) {
            addCriterion("has_nav not between", value1, value2, "hasNav");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNull() {
            addCriterion("create_by is null");
            return (Criteria) this;
        }

        public Criteria andCreateByIsNotNull() {
            addCriterion("create_by is not null");
            return (Criteria) this;
        }

        public Criteria andCreateByEqualTo(String value) {
            addCriterion("create_by =", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotEqualTo(String value) {
            addCriterion("create_by <>", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThan(String value) {
            addCriterion("create_by >", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByGreaterThanOrEqualTo(String value) {
            addCriterion("create_by >=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThan(String value) {
            addCriterion("create_by <", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLessThanOrEqualTo(String value) {
            addCriterion("create_by <=", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByLike(String value) {
            addCriterion("create_by like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotLike(String value) {
            addCriterion("create_by not like", value, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByIn(List<String> values) {
            addCriterion("create_by in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotIn(List<String> values) {
            addCriterion("create_by not in", values, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByBetween(String value1, String value2) {
            addCriterion("create_by between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andCreateByNotBetween(String value1, String value2) {
            addCriterion("create_by not between", value1, value2, "createBy");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNull() {
            addCriterion("update_by is null");
            return (Criteria) this;
        }

        public Criteria andUpdateByIsNotNull() {
            addCriterion("update_by is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateByEqualTo(String value) {
            addCriterion("update_by =", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotEqualTo(String value) {
            addCriterion("update_by <>", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThan(String value) {
            addCriterion("update_by >", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByGreaterThanOrEqualTo(String value) {
            addCriterion("update_by >=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThan(String value) {
            addCriterion("update_by <", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLessThanOrEqualTo(String value) {
            addCriterion("update_by <=", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByLike(String value) {
            addCriterion("update_by like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotLike(String value) {
            addCriterion("update_by not like", value, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByIn(List<String> values) {
            addCriterion("update_by in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotIn(List<String> values) {
            addCriterion("update_by not in", values, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByBetween(String value1, String value2) {
            addCriterion("update_by between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andUpdateByNotBetween(String value1, String value2) {
            addCriterion("update_by not between", value1, value2, "updateBy");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyIsNull() {
            addCriterion("nav_frequency is null");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyIsNotNull() {
            addCriterion("nav_frequency is not null");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyEqualTo(Integer value) {
            addCriterion("nav_frequency =", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyNotEqualTo(Integer value) {
            addCriterion("nav_frequency <>", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyGreaterThan(Integer value) {
            addCriterion("nav_frequency >", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyGreaterThanOrEqualTo(Integer value) {
            addCriterion("nav_frequency >=", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyLessThan(Integer value) {
            addCriterion("nav_frequency <", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyLessThanOrEqualTo(Integer value) {
            addCriterion("nav_frequency <=", value, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyIn(List<Integer> values) {
            addCriterion("nav_frequency in", values, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyNotIn(List<Integer> values) {
            addCriterion("nav_frequency not in", values, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyBetween(Integer value1, Integer value2) {
            addCriterion("nav_frequency between", value1, value2, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andNavFrequencyNotBetween(Integer value1, Integer value2) {
            addCriterion("nav_frequency not between", value1, value2, "navFrequency");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}