package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.Date;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class IfaImportedFundInfoView12 {
    private String id;

    private Integer type;

    private String fundName;

    private String fundShortName;

    private String companyName;

    private Integer substrategy;

    private Integer strategy;

    private String manageName;

    private String riskLevel;

    private Date inceptionDate;

    private String registerNumber;

    private String openDay;

    private BigDecimal minInvestmentShare;

    private BigDecimal subsequentInvestmentShare;

    private BigDecimal subscriptionFee;

    private BigDecimal redemptionFee;

    private BigDecimal managementFee;

    private BigDecimal performanceFee;

    private String performanceCalculateMethod;

    private String ifaId;

    private Integer deleteTag;

    private Date createTime;

    private Date priceDate;

    private BigDecimal netNav;

    private BigDecimal cumulativeNav;

    private BigDecimal ret1w;

    private BigDecimal ret1m;

    private BigDecimal ret6m;

    private BigDecimal ret1y;

    private BigDecimal retIncep;

    private BigDecimal sharperatioIncep;

    private BigDecimal sharperatio1y;

    private BigDecimal sharperatio2y;

    private BigDecimal sharperatio3y;

    private BigDecimal sharperatio4y;

    private BigDecimal sharperatio5y;

    private BigDecimal stddev1y;

    private BigDecimal stddev2y;

    private BigDecimal stddev3y;

    private BigDecimal stddev4y;

    private BigDecimal stddev5y;

    private BigDecimal stddevIncep;

    private BigDecimal maxdrawdown1y;

    private BigDecimal maxdrawdown2y;

    private BigDecimal maxdrawdown3y;

    private BigDecimal maxdrawdown4y;

    private BigDecimal maxdrawdown5y;

    private BigDecimal maxdrawdownIncep;

    private Double zScore;
}