package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
public class IndexCountExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public IndexCountExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIndexIdIsNull() {
            addCriterion("index_id is null");
            return (Criteria) this;
        }

        public Criteria andIndexIdIsNotNull() {
            addCriterion("index_id is not null");
            return (Criteria) this;
        }

        public Criteria andIndexIdEqualTo(String value) {
            addCriterion("index_id =", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotEqualTo(String value) {
            addCriterion("index_id <>", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdGreaterThan(String value) {
            addCriterion("index_id >", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdGreaterThanOrEqualTo(String value) {
            addCriterion("index_id >=", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdLessThan(String value) {
            addCriterion("index_id <", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdLessThanOrEqualTo(String value) {
            addCriterion("index_id <=", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdLike(String value) {
            addCriterion("index_id like", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotLike(String value) {
            addCriterion("index_id not like", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdIn(List<String> values) {
            addCriterion("index_id in", values, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotIn(List<String> values) {
            addCriterion("index_id not in", values, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdBetween(String value1, String value2) {
            addCriterion("index_id between", value1, value2, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotBetween(String value1, String value2) {
            addCriterion("index_id not between", value1, value2, "indexId");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("end_date is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("end_date is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("end_date =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("end_date >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(Date value) {
            addCriterionForJDBCDate("end_date <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("end_date in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("end_date not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNull() {
            addCriterion("price_date is null");
            return (Criteria) this;
        }

        public Criteria andPriceDateIsNotNull() {
            addCriterion("price_date is not null");
            return (Criteria) this;
        }

        public Criteria andPriceDateEqualTo(Date value) {
            addCriterionForJDBCDate("price_date =", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <>", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThan(Date value) {
            addCriterionForJDBCDate("price_date >", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date >=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThan(Date value) {
            addCriterionForJDBCDate("price_date <", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("price_date <=", value, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateIn(List<Date> values) {
            addCriterionForJDBCDate("price_date in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("price_date not in", values, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andPriceDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("price_date not between", value1, value2, "priceDate");
            return (Criteria) this;
        }

        public Criteria andCloseIsNull() {
            addCriterion("`close` is null");
            return (Criteria) this;
        }

        public Criteria andCloseIsNotNull() {
            addCriterion("`close` is not null");
            return (Criteria) this;
        }

        public Criteria andCloseEqualTo(BigDecimal value) {
            addCriterion("`close` =", value, "close");
            return (Criteria) this;
        }

        public Criteria andCloseNotEqualTo(BigDecimal value) {
            addCriterion("`close` <>", value, "close");
            return (Criteria) this;
        }

        public Criteria andCloseGreaterThan(BigDecimal value) {
            addCriterion("`close` >", value, "close");
            return (Criteria) this;
        }

        public Criteria andCloseGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("`close` >=", value, "close");
            return (Criteria) this;
        }

        public Criteria andCloseLessThan(BigDecimal value) {
            addCriterion("`close` <", value, "close");
            return (Criteria) this;
        }

        public Criteria andCloseLessThanOrEqualTo(BigDecimal value) {
            addCriterion("`close` <=", value, "close");
            return (Criteria) this;
        }

        public Criteria andCloseIn(List<BigDecimal> values) {
            addCriterion("`close` in", values, "close");
            return (Criteria) this;
        }

        public Criteria andCloseNotIn(List<BigDecimal> values) {
            addCriterion("`close` not in", values, "close");
            return (Criteria) this;
        }

        public Criteria andCloseBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("`close` between", value1, value2, "close");
            return (Criteria) this;
        }

        public Criteria andCloseNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("`close` not between", value1, value2, "close");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNull() {
            addCriterion("cumulative_nav is null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIsNotNull() {
            addCriterion("cumulative_nav is not null");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav =", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav <>", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThan(BigDecimal value) {
            addCriterion("cumulative_nav >", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav >=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThan(BigDecimal value) {
            addCriterion("cumulative_nav <", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavLessThanOrEqualTo(BigDecimal value) {
            addCriterion("cumulative_nav <=", value, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavIn(List<BigDecimal> values) {
            addCriterion("cumulative_nav in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotIn(List<BigDecimal> values) {
            addCriterion("cumulative_nav not in", values, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cumulative_nav between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andCumulativeNavNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("cumulative_nav not between", value1, value2, "cumulativeNav");
            return (Criteria) this;
        }

        public Criteria andRet1dayIsNull() {
            addCriterion("ret_1day is null");
            return (Criteria) this;
        }

        public Criteria andRet1dayIsNotNull() {
            addCriterion("ret_1day is not null");
            return (Criteria) this;
        }

        public Criteria andRet1dayEqualTo(BigDecimal value) {
            addCriterion("ret_1day =", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayNotEqualTo(BigDecimal value) {
            addCriterion("ret_1day <>", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayGreaterThan(BigDecimal value) {
            addCriterion("ret_1day >", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1day >=", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayLessThan(BigDecimal value) {
            addCriterion("ret_1day <", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1day <=", value, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayIn(List<BigDecimal> values) {
            addCriterion("ret_1day in", values, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayNotIn(List<BigDecimal> values) {
            addCriterion("ret_1day not in", values, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1day between", value1, value2, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1day not between", value1, value2, "ret1day");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1IsNull() {
            addCriterion("ret_1day_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1IsNotNull() {
            addCriterion("ret_1day_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1EqualTo(BigDecimal value) {
            addCriterion("ret_1day_bm1 =", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_1day_bm1 <>", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_1day_bm1 >", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1day_bm1 >=", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1LessThan(BigDecimal value) {
            addCriterion("ret_1day_bm1 <", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1day_bm1 <=", value, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1In(List<BigDecimal> values) {
            addCriterion("ret_1day_bm1 in", values, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_1day_bm1 not in", values, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1day_bm1 between", value1, value2, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1dayBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1day_bm1 not between", value1, value2, "ret1dayBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wIsNull() {
            addCriterion("ret_1w is null");
            return (Criteria) this;
        }

        public Criteria andRet1wIsNotNull() {
            addCriterion("ret_1w is not null");
            return (Criteria) this;
        }

        public Criteria andRet1wEqualTo(BigDecimal value) {
            addCriterion("ret_1w =", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotEqualTo(BigDecimal value) {
            addCriterion("ret_1w <>", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wGreaterThan(BigDecimal value) {
            addCriterion("ret_1w >", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w >=", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wLessThan(BigDecimal value) {
            addCriterion("ret_1w <", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w <=", value, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wIn(List<BigDecimal> values) {
            addCriterion("ret_1w in", values, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotIn(List<BigDecimal> values) {
            addCriterion("ret_1w not in", values, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w between", value1, value2, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w not between", value1, value2, "ret1w");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1IsNull() {
            addCriterion("ret_1w_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1IsNotNull() {
            addCriterion("ret_1w_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1EqualTo(BigDecimal value) {
            addCriterion("ret_1w_bm1 =", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_1w_bm1 <>", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_1w_bm1 >", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w_bm1 >=", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1LessThan(BigDecimal value) {
            addCriterion("ret_1w_bm1 <", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1w_bm1 <=", value, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1In(List<BigDecimal> values) {
            addCriterion("ret_1w_bm1 in", values, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_1w_bm1 not in", values, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w_bm1 between", value1, value2, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1wBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1w_bm1 not between", value1, value2, "ret1wBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNull() {
            addCriterion("ret_1m is null");
            return (Criteria) this;
        }

        public Criteria andRet1mIsNotNull() {
            addCriterion("ret_1m is not null");
            return (Criteria) this;
        }

        public Criteria andRet1mEqualTo(BigDecimal value) {
            addCriterion("ret_1m =", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotEqualTo(BigDecimal value) {
            addCriterion("ret_1m <>", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThan(BigDecimal value) {
            addCriterion("ret_1m >", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m >=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThan(BigDecimal value) {
            addCriterion("ret_1m <", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m <=", value, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mIn(List<BigDecimal> values) {
            addCriterion("ret_1m in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotIn(List<BigDecimal> values) {
            addCriterion("ret_1m not in", values, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m not between", value1, value2, "ret1m");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1IsNull() {
            addCriterion("ret_1m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1IsNotNull() {
            addCriterion("ret_1m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_1m_bm1 =", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_1m_bm1 <>", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_1m_bm1 >", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m_bm1 >=", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1LessThan(BigDecimal value) {
            addCriterion("ret_1m_bm1 <", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1m_bm1 <=", value, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1In(List<BigDecimal> values) {
            addCriterion("ret_1m_bm1 in", values, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_1m_bm1 not in", values, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m_bm1 between", value1, value2, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1m_bm1 not between", value1, value2, "ret1mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mIsNull() {
            addCriterion("ret_3m is null");
            return (Criteria) this;
        }

        public Criteria andRet3mIsNotNull() {
            addCriterion("ret_3m is not null");
            return (Criteria) this;
        }

        public Criteria andRet3mEqualTo(BigDecimal value) {
            addCriterion("ret_3m =", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotEqualTo(BigDecimal value) {
            addCriterion("ret_3m <>", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mGreaterThan(BigDecimal value) {
            addCriterion("ret_3m >", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3m >=", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mLessThan(BigDecimal value) {
            addCriterion("ret_3m <", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3m <=", value, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mIn(List<BigDecimal> values) {
            addCriterion("ret_3m in", values, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotIn(List<BigDecimal> values) {
            addCriterion("ret_3m not in", values, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3m between", value1, value2, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3m not between", value1, value2, "ret3m");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1IsNull() {
            addCriterion("ret_3m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1IsNotNull() {
            addCriterion("ret_3m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_3m_bm1 =", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_3m_bm1 <>", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_3m_bm1 >", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3m_bm1 >=", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1LessThan(BigDecimal value) {
            addCriterion("ret_3m_bm1 <", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3m_bm1 <=", value, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1In(List<BigDecimal> values) {
            addCriterion("ret_3m_bm1 in", values, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_3m_bm1 not in", values, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3m_bm1 between", value1, value2, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet3mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3m_bm1 not between", value1, value2, "ret3mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNull() {
            addCriterion("ret_6m is null");
            return (Criteria) this;
        }

        public Criteria andRet6mIsNotNull() {
            addCriterion("ret_6m is not null");
            return (Criteria) this;
        }

        public Criteria andRet6mEqualTo(BigDecimal value) {
            addCriterion("ret_6m =", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotEqualTo(BigDecimal value) {
            addCriterion("ret_6m <>", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThan(BigDecimal value) {
            addCriterion("ret_6m >", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m >=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThan(BigDecimal value) {
            addCriterion("ret_6m <", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m <=", value, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mIn(List<BigDecimal> values) {
            addCriterion("ret_6m in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotIn(List<BigDecimal> values) {
            addCriterion("ret_6m not in", values, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m not between", value1, value2, "ret6m");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1IsNull() {
            addCriterion("ret_6m_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1IsNotNull() {
            addCriterion("ret_6m_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1EqualTo(BigDecimal value) {
            addCriterion("ret_6m_bm1 =", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_6m_bm1 <>", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_6m_bm1 >", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m_bm1 >=", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1LessThan(BigDecimal value) {
            addCriterion("ret_6m_bm1 <", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_6m_bm1 <=", value, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1In(List<BigDecimal> values) {
            addCriterion("ret_6m_bm1 in", values, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_6m_bm1 not in", values, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m_bm1 between", value1, value2, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet6mBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_6m_bm1 not between", value1, value2, "ret6mBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNull() {
            addCriterion("ret_1y is null");
            return (Criteria) this;
        }

        public Criteria andRet1yIsNotNull() {
            addCriterion("ret_1y is not null");
            return (Criteria) this;
        }

        public Criteria andRet1yEqualTo(BigDecimal value) {
            addCriterion("ret_1y =", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotEqualTo(BigDecimal value) {
            addCriterion("ret_1y <>", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThan(BigDecimal value) {
            addCriterion("ret_1y >", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y >=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThan(BigDecimal value) {
            addCriterion("ret_1y <", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y <=", value, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yIn(List<BigDecimal> values) {
            addCriterion("ret_1y in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotIn(List<BigDecimal> values) {
            addCriterion("ret_1y not in", values, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y not between", value1, value2, "ret1y");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1IsNull() {
            addCriterion("ret_1y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1IsNotNull() {
            addCriterion("ret_1y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_1y_bm1 =", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_1y_bm1 <>", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_1y_bm1 >", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y_bm1 >=", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1LessThan(BigDecimal value) {
            addCriterion("ret_1y_bm1 <", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_1y_bm1 <=", value, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1In(List<BigDecimal> values) {
            addCriterion("ret_1y_bm1 in", values, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_1y_bm1 not in", values, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y_bm1 between", value1, value2, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet1yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_1y_bm1 not between", value1, value2, "ret1yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yIsNull() {
            addCriterion("ret_2y is null");
            return (Criteria) this;
        }

        public Criteria andRet2yIsNotNull() {
            addCriterion("ret_2y is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yEqualTo(BigDecimal value) {
            addCriterion("ret_2y =", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotEqualTo(BigDecimal value) {
            addCriterion("ret_2y <>", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yGreaterThan(BigDecimal value) {
            addCriterion("ret_2y >", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y >=", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yLessThan(BigDecimal value) {
            addCriterion("ret_2y <", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y <=", value, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yIn(List<BigDecimal> values) {
            addCriterion("ret_2y in", values, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotIn(List<BigDecimal> values) {
            addCriterion("ret_2y not in", values, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y between", value1, value2, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y not between", value1, value2, "ret2y");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1IsNull() {
            addCriterion("ret_2y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1IsNotNull() {
            addCriterion("ret_2y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1 =", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1 <>", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_2y_bm1 >", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1 >=", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1LessThan(BigDecimal value) {
            addCriterion("ret_2y_bm1 <", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1 <=", value, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1In(List<BigDecimal> values) {
            addCriterion("ret_2y_bm1 in", values, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_2y_bm1 not in", values, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_bm1 between", value1, value2, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_bm1 not between", value1, value2, "ret2yBm1");
            return (Criteria) this;
        }

        public Criteria andRet2yAIsNull() {
            addCriterion("ret_2y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet2yAIsNotNull() {
            addCriterion("ret_2y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yAEqualTo(BigDecimal value) {
            addCriterion("ret_2y_a =", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotEqualTo(BigDecimal value) {
            addCriterion("ret_2y_a <>", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAGreaterThan(BigDecimal value) {
            addCriterion("ret_2y_a >", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_a >=", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yALessThan(BigDecimal value) {
            addCriterion("ret_2y_a <", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_a <=", value, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yAIn(List<BigDecimal> values) {
            addCriterion("ret_2y_a in", values, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotIn(List<BigDecimal> values) {
            addCriterion("ret_2y_a not in", values, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_a between", value1, value2, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_a not between", value1, value2, "ret2yA");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AIsNull() {
            addCriterion("ret_2y_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AIsNotNull() {
            addCriterion("ret_2y_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1_a =", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1_a <>", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_2y_bm1_a >", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1_a >=", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ALessThan(BigDecimal value) {
            addCriterion("ret_2y_bm1_a <", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_2y_bm1_a <=", value, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_2y_bm1_a in", values, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_2y_bm1_a not in", values, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_bm1_a between", value1, value2, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet2yBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_2y_bm1_a not between", value1, value2, "ret2yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yIsNull() {
            addCriterion("ret_3y is null");
            return (Criteria) this;
        }

        public Criteria andRet3yIsNotNull() {
            addCriterion("ret_3y is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yEqualTo(BigDecimal value) {
            addCriterion("ret_3y =", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotEqualTo(BigDecimal value) {
            addCriterion("ret_3y <>", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yGreaterThan(BigDecimal value) {
            addCriterion("ret_3y >", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y >=", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yLessThan(BigDecimal value) {
            addCriterion("ret_3y <", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y <=", value, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yIn(List<BigDecimal> values) {
            addCriterion("ret_3y in", values, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotIn(List<BigDecimal> values) {
            addCriterion("ret_3y not in", values, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y between", value1, value2, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y not between", value1, value2, "ret3y");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1IsNull() {
            addCriterion("ret_3y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1IsNotNull() {
            addCriterion("ret_3y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1 =", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1 <>", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_3y_bm1 >", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1 >=", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1LessThan(BigDecimal value) {
            addCriterion("ret_3y_bm1 <", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1 <=", value, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1In(List<BigDecimal> values) {
            addCriterion("ret_3y_bm1 in", values, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_3y_bm1 not in", values, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_bm1 between", value1, value2, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_bm1 not between", value1, value2, "ret3yBm1");
            return (Criteria) this;
        }

        public Criteria andRet3yAIsNull() {
            addCriterion("ret_3y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet3yAIsNotNull() {
            addCriterion("ret_3y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yAEqualTo(BigDecimal value) {
            addCriterion("ret_3y_a =", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotEqualTo(BigDecimal value) {
            addCriterion("ret_3y_a <>", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAGreaterThan(BigDecimal value) {
            addCriterion("ret_3y_a >", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_a >=", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yALessThan(BigDecimal value) {
            addCriterion("ret_3y_a <", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_a <=", value, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yAIn(List<BigDecimal> values) {
            addCriterion("ret_3y_a in", values, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotIn(List<BigDecimal> values) {
            addCriterion("ret_3y_a not in", values, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_a between", value1, value2, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_a not between", value1, value2, "ret3yA");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AIsNull() {
            addCriterion("ret_3y_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AIsNotNull() {
            addCriterion("ret_3y_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1_a =", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1_a <>", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_3y_bm1_a >", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1_a >=", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ALessThan(BigDecimal value) {
            addCriterion("ret_3y_bm1_a <", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_3y_bm1_a <=", value, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_3y_bm1_a in", values, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_3y_bm1_a not in", values, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_bm1_a between", value1, value2, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet3yBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_3y_bm1_a not between", value1, value2, "ret3yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yIsNull() {
            addCriterion("ret_4y is null");
            return (Criteria) this;
        }

        public Criteria andRet4yIsNotNull() {
            addCriterion("ret_4y is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yEqualTo(BigDecimal value) {
            addCriterion("ret_4y =", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotEqualTo(BigDecimal value) {
            addCriterion("ret_4y <>", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yGreaterThan(BigDecimal value) {
            addCriterion("ret_4y >", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y >=", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yLessThan(BigDecimal value) {
            addCriterion("ret_4y <", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y <=", value, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yIn(List<BigDecimal> values) {
            addCriterion("ret_4y in", values, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotIn(List<BigDecimal> values) {
            addCriterion("ret_4y not in", values, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y between", value1, value2, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y not between", value1, value2, "ret4y");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1IsNull() {
            addCriterion("ret_4y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1IsNotNull() {
            addCriterion("ret_4y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1 =", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1 <>", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_4y_bm1 >", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1 >=", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1LessThan(BigDecimal value) {
            addCriterion("ret_4y_bm1 <", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1 <=", value, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1In(List<BigDecimal> values) {
            addCriterion("ret_4y_bm1 in", values, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_4y_bm1 not in", values, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_bm1 between", value1, value2, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_bm1 not between", value1, value2, "ret4yBm1");
            return (Criteria) this;
        }

        public Criteria andRet4yAIsNull() {
            addCriterion("ret_4y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet4yAIsNotNull() {
            addCriterion("ret_4y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yAEqualTo(BigDecimal value) {
            addCriterion("ret_4y_a =", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotEqualTo(BigDecimal value) {
            addCriterion("ret_4y_a <>", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAGreaterThan(BigDecimal value) {
            addCriterion("ret_4y_a >", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_a >=", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yALessThan(BigDecimal value) {
            addCriterion("ret_4y_a <", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_a <=", value, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yAIn(List<BigDecimal> values) {
            addCriterion("ret_4y_a in", values, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotIn(List<BigDecimal> values) {
            addCriterion("ret_4y_a not in", values, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_a between", value1, value2, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_a not between", value1, value2, "ret4yA");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AIsNull() {
            addCriterion("ret_4y_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AIsNotNull() {
            addCriterion("ret_4y_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1_a =", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1_a <>", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_4y_bm1_a >", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1_a >=", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ALessThan(BigDecimal value) {
            addCriterion("ret_4y_bm1_a <", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_4y_bm1_a <=", value, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_4y_bm1_a in", values, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_4y_bm1_a not in", values, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_bm1_a between", value1, value2, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet4yBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_4y_bm1_a not between", value1, value2, "ret4yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yIsNull() {
            addCriterion("ret_5y is null");
            return (Criteria) this;
        }

        public Criteria andRet5yIsNotNull() {
            addCriterion("ret_5y is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yEqualTo(BigDecimal value) {
            addCriterion("ret_5y =", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotEqualTo(BigDecimal value) {
            addCriterion("ret_5y <>", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yGreaterThan(BigDecimal value) {
            addCriterion("ret_5y >", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y >=", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yLessThan(BigDecimal value) {
            addCriterion("ret_5y <", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y <=", value, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yIn(List<BigDecimal> values) {
            addCriterion("ret_5y in", values, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotIn(List<BigDecimal> values) {
            addCriterion("ret_5y not in", values, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y between", value1, value2, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y not between", value1, value2, "ret5y");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1IsNull() {
            addCriterion("ret_5y_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1IsNotNull() {
            addCriterion("ret_5y_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1EqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1 =", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1 <>", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_5y_bm1 >", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1 >=", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1LessThan(BigDecimal value) {
            addCriterion("ret_5y_bm1 <", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1 <=", value, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1In(List<BigDecimal> values) {
            addCriterion("ret_5y_bm1 in", values, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_5y_bm1 not in", values, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_bm1 between", value1, value2, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_bm1 not between", value1, value2, "ret5yBm1");
            return (Criteria) this;
        }

        public Criteria andRet5yAIsNull() {
            addCriterion("ret_5y_a is null");
            return (Criteria) this;
        }

        public Criteria andRet5yAIsNotNull() {
            addCriterion("ret_5y_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yAEqualTo(BigDecimal value) {
            addCriterion("ret_5y_a =", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotEqualTo(BigDecimal value) {
            addCriterion("ret_5y_a <>", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAGreaterThan(BigDecimal value) {
            addCriterion("ret_5y_a >", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_a >=", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yALessThan(BigDecimal value) {
            addCriterion("ret_5y_a <", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_a <=", value, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yAIn(List<BigDecimal> values) {
            addCriterion("ret_5y_a in", values, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotIn(List<BigDecimal> values) {
            addCriterion("ret_5y_a not in", values, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_a between", value1, value2, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_a not between", value1, value2, "ret5yA");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AIsNull() {
            addCriterion("ret_5y_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AIsNotNull() {
            addCriterion("ret_5y_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1_a =", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1_a <>", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_5y_bm1_a >", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1_a >=", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ALessThan(BigDecimal value) {
            addCriterion("ret_5y_bm1_a <", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_5y_bm1_a <=", value, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_5y_bm1_a in", values, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_5y_bm1_a not in", values, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_bm1_a between", value1, value2, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRet5yBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_5y_bm1_a not between", value1, value2, "ret5yBm1A");
            return (Criteria) this;
        }

        public Criteria andRetYtdIsNull() {
            addCriterion("ret_ytd is null");
            return (Criteria) this;
        }

        public Criteria andRetYtdIsNotNull() {
            addCriterion("ret_ytd is not null");
            return (Criteria) this;
        }

        public Criteria andRetYtdEqualTo(BigDecimal value) {
            addCriterion("ret_ytd =", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotEqualTo(BigDecimal value) {
            addCriterion("ret_ytd <>", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdGreaterThan(BigDecimal value) {
            addCriterion("ret_ytd >", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_ytd >=", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdLessThan(BigDecimal value) {
            addCriterion("ret_ytd <", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_ytd <=", value, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdIn(List<BigDecimal> values) {
            addCriterion("ret_ytd in", values, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotIn(List<BigDecimal> values) {
            addCriterion("ret_ytd not in", values, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_ytd between", value1, value2, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_ytd not between", value1, value2, "retYtd");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1IsNull() {
            addCriterion("ret_ytd_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1IsNotNull() {
            addCriterion("ret_ytd_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1EqualTo(BigDecimal value) {
            addCriterion("ret_ytd_bm1 =", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_ytd_bm1 <>", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_ytd_bm1 >", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_ytd_bm1 >=", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1LessThan(BigDecimal value) {
            addCriterion("ret_ytd_bm1 <", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_ytd_bm1 <=", value, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1In(List<BigDecimal> values) {
            addCriterion("ret_ytd_bm1 in", values, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_ytd_bm1 not in", values, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_ytd_bm1 between", value1, value2, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetYtdBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_ytd_bm1 not between", value1, value2, "retYtdBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNull() {
            addCriterion("ret_incep is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepIsNotNull() {
            addCriterion("ret_incep is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepEqualTo(BigDecimal value) {
            addCriterion("ret_incep =", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotEqualTo(BigDecimal value) {
            addCriterion("ret_incep <>", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThan(BigDecimal value) {
            addCriterion("ret_incep >", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep >=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThan(BigDecimal value) {
            addCriterion("ret_incep <", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep <=", value, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepIn(List<BigDecimal> values) {
            addCriterion("ret_incep in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotIn(List<BigDecimal> values) {
            addCriterion("ret_incep not in", values, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep not between", value1, value2, "retIncep");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1IsNull() {
            addCriterion("ret_incep_bm1 is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1IsNotNull() {
            addCriterion("ret_incep_bm1 is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1EqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1 =", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1NotEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1 <>", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1GreaterThan(BigDecimal value) {
            addCriterion("ret_incep_bm1 >", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1GreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1 >=", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1LessThan(BigDecimal value) {
            addCriterion("ret_incep_bm1 <", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1LessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1 <=", value, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1In(List<BigDecimal> values) {
            addCriterion("ret_incep_bm1 in", values, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1NotIn(List<BigDecimal> values) {
            addCriterion("ret_incep_bm1 not in", values, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1Between(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_bm1 between", value1, value2, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1NotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_bm1 not between", value1, value2, "retIncepBm1");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIsNull() {
            addCriterion("ret_incep_a is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIsNotNull() {
            addCriterion("ret_incep_a is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepAEqualTo(BigDecimal value) {
            addCriterion("ret_incep_a =", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotEqualTo(BigDecimal value) {
            addCriterion("ret_incep_a <>", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAGreaterThan(BigDecimal value) {
            addCriterion("ret_incep_a >", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_a >=", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepALessThan(BigDecimal value) {
            addCriterion("ret_incep_a <", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_a <=", value, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepAIn(List<BigDecimal> values) {
            addCriterion("ret_incep_a in", values, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotIn(List<BigDecimal> values) {
            addCriterion("ret_incep_a not in", values, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_a between", value1, value2, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_a not between", value1, value2, "retIncepA");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AIsNull() {
            addCriterion("ret_incep_bm1_a is null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AIsNotNull() {
            addCriterion("ret_incep_bm1_a is not null");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1_a =", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ANotEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1_a <>", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AGreaterThan(BigDecimal value) {
            addCriterion("ret_incep_bm1_a >", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1_a >=", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ALessThan(BigDecimal value) {
            addCriterion("ret_incep_bm1_a <", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ALessThanOrEqualTo(BigDecimal value) {
            addCriterion("ret_incep_bm1_a <=", value, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1AIn(List<BigDecimal> values) {
            addCriterion("ret_incep_bm1_a in", values, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ANotIn(List<BigDecimal> values) {
            addCriterion("ret_incep_bm1_a not in", values, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ABetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_bm1_a between", value1, value2, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andRetIncepBm1ANotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("ret_incep_bm1_a not between", value1, value2, "retIncepBm1A");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIsNull() {
            addCriterion("sharperatio_1y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIsNotNull() {
            addCriterion("sharperatio_1y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y =", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y <>", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_1y >", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y >=", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yLessThan(BigDecimal value) {
            addCriterion("sharperatio_1y <", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_1y <=", value, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_1y in", values, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_1y not in", values, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_1y between", value1, value2, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_1y not between", value1, value2, "sharperatio1y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIsNull() {
            addCriterion("sharperatio_2y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIsNotNull() {
            addCriterion("sharperatio_2y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y =", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y <>", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_2y >", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y >=", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yLessThan(BigDecimal value) {
            addCriterion("sharperatio_2y <", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_2y <=", value, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_2y in", values, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_2y not in", values, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_2y between", value1, value2, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_2y not between", value1, value2, "sharperatio2y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIsNull() {
            addCriterion("sharperatio_3y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIsNotNull() {
            addCriterion("sharperatio_3y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y =", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y <>", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_3y >", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y >=", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yLessThan(BigDecimal value) {
            addCriterion("sharperatio_3y <", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_3y <=", value, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_3y in", values, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_3y not in", values, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_3y between", value1, value2, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_3y not between", value1, value2, "sharperatio3y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIsNull() {
            addCriterion("sharperatio_4y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIsNotNull() {
            addCriterion("sharperatio_4y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y =", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y <>", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_4y >", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y >=", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yLessThan(BigDecimal value) {
            addCriterion("sharperatio_4y <", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_4y <=", value, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_4y in", values, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_4y not in", values, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_4y between", value1, value2, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_4y not between", value1, value2, "sharperatio4y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIsNull() {
            addCriterion("sharperatio_5y is null");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIsNotNull() {
            addCriterion("sharperatio_5y is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y =", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y <>", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_5y >", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y >=", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yLessThan(BigDecimal value) {
            addCriterion("sharperatio_5y <", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_5y <=", value, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yIn(List<BigDecimal> values) {
            addCriterion("sharperatio_5y in", values, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_5y not in", values, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_5y between", value1, value2, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatio5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_5y not between", value1, value2, "sharperatio5y");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIsNull() {
            addCriterion("sharperatio_incep is null");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIsNotNull() {
            addCriterion("sharperatio_incep is not null");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep =", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep <>", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepGreaterThan(BigDecimal value) {
            addCriterion("sharperatio_incep >", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep >=", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepLessThan(BigDecimal value) {
            addCriterion("sharperatio_incep <", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("sharperatio_incep <=", value, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepIn(List<BigDecimal> values) {
            addCriterion("sharperatio_incep in", values, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotIn(List<BigDecimal> values) {
            addCriterion("sharperatio_incep not in", values, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_incep between", value1, value2, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andSharperatioIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("sharperatio_incep not between", value1, value2, "sharperatioIncep");
            return (Criteria) this;
        }

        public Criteria andStddev1yIsNull() {
            addCriterion("stddev_1y is null");
            return (Criteria) this;
        }

        public Criteria andStddev1yIsNotNull() {
            addCriterion("stddev_1y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev1yEqualTo(BigDecimal value) {
            addCriterion("stddev_1y =", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_1y <>", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yGreaterThan(BigDecimal value) {
            addCriterion("stddev_1y >", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_1y >=", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yLessThan(BigDecimal value) {
            addCriterion("stddev_1y <", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_1y <=", value, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yIn(List<BigDecimal> values) {
            addCriterion("stddev_1y in", values, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_1y not in", values, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_1y between", value1, value2, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_1y not between", value1, value2, "stddev1y");
            return (Criteria) this;
        }

        public Criteria andStddev2yIsNull() {
            addCriterion("stddev_2y is null");
            return (Criteria) this;
        }

        public Criteria andStddev2yIsNotNull() {
            addCriterion("stddev_2y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev2yEqualTo(BigDecimal value) {
            addCriterion("stddev_2y =", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_2y <>", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yGreaterThan(BigDecimal value) {
            addCriterion("stddev_2y >", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_2y >=", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yLessThan(BigDecimal value) {
            addCriterion("stddev_2y <", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_2y <=", value, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yIn(List<BigDecimal> values) {
            addCriterion("stddev_2y in", values, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_2y not in", values, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_2y between", value1, value2, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_2y not between", value1, value2, "stddev2y");
            return (Criteria) this;
        }

        public Criteria andStddev3yIsNull() {
            addCriterion("stddev_3y is null");
            return (Criteria) this;
        }

        public Criteria andStddev3yIsNotNull() {
            addCriterion("stddev_3y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev3yEqualTo(BigDecimal value) {
            addCriterion("stddev_3y =", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_3y <>", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yGreaterThan(BigDecimal value) {
            addCriterion("stddev_3y >", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_3y >=", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yLessThan(BigDecimal value) {
            addCriterion("stddev_3y <", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_3y <=", value, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yIn(List<BigDecimal> values) {
            addCriterion("stddev_3y in", values, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_3y not in", values, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_3y between", value1, value2, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_3y not between", value1, value2, "stddev3y");
            return (Criteria) this;
        }

        public Criteria andStddev4yIsNull() {
            addCriterion("stddev_4y is null");
            return (Criteria) this;
        }

        public Criteria andStddev4yIsNotNull() {
            addCriterion("stddev_4y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev4yEqualTo(BigDecimal value) {
            addCriterion("stddev_4y =", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_4y <>", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yGreaterThan(BigDecimal value) {
            addCriterion("stddev_4y >", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_4y >=", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yLessThan(BigDecimal value) {
            addCriterion("stddev_4y <", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_4y <=", value, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yIn(List<BigDecimal> values) {
            addCriterion("stddev_4y in", values, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_4y not in", values, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_4y between", value1, value2, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_4y not between", value1, value2, "stddev4y");
            return (Criteria) this;
        }

        public Criteria andStddev5yIsNull() {
            addCriterion("stddev_5y is null");
            return (Criteria) this;
        }

        public Criteria andStddev5yIsNotNull() {
            addCriterion("stddev_5y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev5yEqualTo(BigDecimal value) {
            addCriterion("stddev_5y =", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_5y <>", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yGreaterThan(BigDecimal value) {
            addCriterion("stddev_5y >", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_5y >=", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yLessThan(BigDecimal value) {
            addCriterion("stddev_5y <", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_5y <=", value, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yIn(List<BigDecimal> values) {
            addCriterion("stddev_5y in", values, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_5y not in", values, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_5y between", value1, value2, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_5y not between", value1, value2, "stddev5y");
            return (Criteria) this;
        }

        public Criteria andStddev10yIsNull() {
            addCriterion("stddev_10y is null");
            return (Criteria) this;
        }

        public Criteria andStddev10yIsNotNull() {
            addCriterion("stddev_10y is not null");
            return (Criteria) this;
        }

        public Criteria andStddev10yEqualTo(BigDecimal value) {
            addCriterion("stddev_10y =", value, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yNotEqualTo(BigDecimal value) {
            addCriterion("stddev_10y <>", value, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yGreaterThan(BigDecimal value) {
            addCriterion("stddev_10y >", value, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_10y >=", value, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yLessThan(BigDecimal value) {
            addCriterion("stddev_10y <", value, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_10y <=", value, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yIn(List<BigDecimal> values) {
            addCriterion("stddev_10y in", values, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yNotIn(List<BigDecimal> values) {
            addCriterion("stddev_10y not in", values, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_10y between", value1, value2, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddev10yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_10y not between", value1, value2, "stddev10y");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIsNull() {
            addCriterion("stddev_incep is null");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIsNotNull() {
            addCriterion("stddev_incep is not null");
            return (Criteria) this;
        }

        public Criteria andStddevIncepEqualTo(BigDecimal value) {
            addCriterion("stddev_incep =", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotEqualTo(BigDecimal value) {
            addCriterion("stddev_incep <>", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepGreaterThan(BigDecimal value) {
            addCriterion("stddev_incep >", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_incep >=", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepLessThan(BigDecimal value) {
            addCriterion("stddev_incep <", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_incep <=", value, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepIn(List<BigDecimal> values) {
            addCriterion("stddev_incep in", values, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotIn(List<BigDecimal> values) {
            addCriterion("stddev_incep not in", values, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_incep between", value1, value2, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_incep not between", value1, value2, "stddevIncep");
            return (Criteria) this;
        }

        public Criteria andStddevYtdIsNull() {
            addCriterion("stddev_ytd is null");
            return (Criteria) this;
        }

        public Criteria andStddevYtdIsNotNull() {
            addCriterion("stddev_ytd is not null");
            return (Criteria) this;
        }

        public Criteria andStddevYtdEqualTo(BigDecimal value) {
            addCriterion("stddev_ytd =", value, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdNotEqualTo(BigDecimal value) {
            addCriterion("stddev_ytd <>", value, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdGreaterThan(BigDecimal value) {
            addCriterion("stddev_ytd >", value, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_ytd >=", value, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdLessThan(BigDecimal value) {
            addCriterion("stddev_ytd <", value, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stddev_ytd <=", value, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdIn(List<BigDecimal> values) {
            addCriterion("stddev_ytd in", values, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdNotIn(List<BigDecimal> values) {
            addCriterion("stddev_ytd not in", values, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_ytd between", value1, value2, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andStddevYtdNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stddev_ytd not between", value1, value2, "stddevYtd");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIsNull() {
            addCriterion("maxdrawdown_1y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIsNotNull() {
            addCriterion("maxdrawdown_1y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y =", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y <>", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_1y >", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y >=", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_1y <", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_1y <=", value, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_1y in", values, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_1y not in", values, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_1y between", value1, value2, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown1yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_1y not between", value1, value2, "maxdrawdown1y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIsNull() {
            addCriterion("maxdrawdown_2y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIsNotNull() {
            addCriterion("maxdrawdown_2y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y =", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y <>", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_2y >", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y >=", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_2y <", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_2y <=", value, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_2y in", values, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_2y not in", values, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_2y between", value1, value2, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown2yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_2y not between", value1, value2, "maxdrawdown2y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIsNull() {
            addCriterion("maxdrawdown_3y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIsNotNull() {
            addCriterion("maxdrawdown_3y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y =", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y <>", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_3y >", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y >=", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_3y <", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_3y <=", value, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_3y in", values, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_3y not in", values, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_3y between", value1, value2, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown3yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_3y not between", value1, value2, "maxdrawdown3y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIsNull() {
            addCriterion("maxdrawdown_4y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIsNotNull() {
            addCriterion("maxdrawdown_4y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y =", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y <>", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_4y >", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y >=", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_4y <", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_4y <=", value, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_4y in", values, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_4y not in", values, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_4y between", value1, value2, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown4yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_4y not between", value1, value2, "maxdrawdown4y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIsNull() {
            addCriterion("maxdrawdown_5y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIsNotNull() {
            addCriterion("maxdrawdown_5y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y =", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y <>", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_5y >", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y >=", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_5y <", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_5y <=", value, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_5y in", values, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_5y not in", values, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_5y between", value1, value2, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown5yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_5y not between", value1, value2, "maxdrawdown5y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yIsNull() {
            addCriterion("maxdrawdown_10y is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yIsNotNull() {
            addCriterion("maxdrawdown_10y is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_10y =", value, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_10y <>", value, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_10y >", value, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_10y >=", value, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_10y <", value, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_10y <=", value, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_10y in", values, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_10y not in", values, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_10y between", value1, value2, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdown10yNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_10y not between", value1, value2, "maxdrawdown10y");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIsNull() {
            addCriterion("maxdrawdown_incep is null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIsNotNull() {
            addCriterion("maxdrawdown_incep is not null");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep =", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep <>", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepGreaterThan(BigDecimal value) {
            addCriterion("maxdrawdown_incep >", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep >=", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepLessThan(BigDecimal value) {
            addCriterion("maxdrawdown_incep <", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepLessThanOrEqualTo(BigDecimal value) {
            addCriterion("maxdrawdown_incep <=", value, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_incep in", values, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotIn(List<BigDecimal> values) {
            addCriterion("maxdrawdown_incep not in", values, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_incep between", value1, value2, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andMaxdrawdownIncepNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("maxdrawdown_incep not between", value1, value2, "maxdrawdownIncep");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNull() {
            addCriterion("delete_tag is null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIsNotNull() {
            addCriterion("delete_tag is not null");
            return (Criteria) this;
        }

        public Criteria andDeleteTagEqualTo(Integer value) {
            addCriterion("delete_tag =", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotEqualTo(Integer value) {
            addCriterion("delete_tag <>", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThan(Integer value) {
            addCriterion("delete_tag >", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delete_tag >=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThan(Integer value) {
            addCriterion("delete_tag <", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagLessThanOrEqualTo(Integer value) {
            addCriterion("delete_tag <=", value, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagIn(List<Integer> values) {
            addCriterion("delete_tag in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotIn(List<Integer> values) {
            addCriterion("delete_tag not in", values, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andDeleteTagNotBetween(Integer value1, Integer value2) {
            addCriterion("delete_tag not between", value1, value2, "deleteTag");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}