package com.tanpu.fund.entity.generator;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class NewFundRank {
    private String fundId;

    private Long index;

    private Double rangeReturn;

    private Double annualReturn;

    private Double maxDrawdown;

    private Double volatility;

    private Double sortinoRatio;

    private Double downsideRisk;

    private Long substrategy;

    private Double annualReturnRank;

    private Double downsideRiskRank;

    private Double maxDrawdownRank;

    private Double sharpRatioRank;

    private Double zScore;

    private String sharpRatio;

    private String manager;
}