package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TxFundComScaleExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TxFundComScaleExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andSRowVersionIsNull() {
            addCriterion("S_ROW_VERSION is null");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIsNotNull() {
            addCriterion("S_ROW_VERSION is not null");
            return (Criteria) this;
        }

        public Criteria andSRowVersionEqualTo(Long value) {
            addCriterion("S_ROW_VERSION =", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotEqualTo(Long value) {
            addCriterion("S_ROW_VERSION <>", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionGreaterThan(Long value) {
            addCriterion("S_ROW_VERSION >", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionGreaterThanOrEqualTo(Long value) {
            addCriterion("S_ROW_VERSION >=", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionLessThan(Long value) {
            addCriterion("S_ROW_VERSION <", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionLessThanOrEqualTo(Long value) {
            addCriterion("S_ROW_VERSION <=", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIn(List<Long> values) {
            addCriterion("S_ROW_VERSION in", values, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotIn(List<Long> values) {
            addCriterion("S_ROW_VERSION not in", values, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionBetween(Long value1, Long value2) {
            addCriterion("S_ROW_VERSION between", value1, value2, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotBetween(Long value1, Long value2) {
            addCriterion("S_ROW_VERSION not between", value1, value2, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNull() {
            addCriterion("company_id is null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIsNotNull() {
            addCriterion("company_id is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyIdEqualTo(Integer value) {
            addCriterion("company_id =", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotEqualTo(Integer value) {
            addCriterion("company_id <>", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThan(Integer value) {
            addCriterion("company_id >", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("company_id >=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThan(Integer value) {
            addCriterion("company_id <", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdLessThanOrEqualTo(Integer value) {
            addCriterion("company_id <=", value, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdIn(List<Integer> values) {
            addCriterion("company_id in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotIn(List<Integer> values) {
            addCriterion("company_id not in", values, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdBetween(Integer value1, Integer value2) {
            addCriterion("company_id between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyIdNotBetween(Integer value1, Integer value2) {
            addCriterion("company_id not between", value1, value2, "companyId");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNull() {
            addCriterion("company_name is null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIsNotNull() {
            addCriterion("company_name is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyNameEqualTo(String value) {
            addCriterion("company_name =", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotEqualTo(String value) {
            addCriterion("company_name <>", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThan(String value) {
            addCriterion("company_name >", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameGreaterThanOrEqualTo(String value) {
            addCriterion("company_name >=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThan(String value) {
            addCriterion("company_name <", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLessThanOrEqualTo(String value) {
            addCriterion("company_name <=", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameLike(String value) {
            addCriterion("company_name like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotLike(String value) {
            addCriterion("company_name not like", value, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameIn(List<String> values) {
            addCriterion("company_name in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotIn(List<String> values) {
            addCriterion("company_name not in", values, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameBetween(String value1, String value2) {
            addCriterion("company_name between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyNameNotBetween(String value1, String value2) {
            addCriterion("company_name not between", value1, value2, "companyName");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeIsNull() {
            addCriterion("company_type is null");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeIsNotNull() {
            addCriterion("company_type is not null");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeEqualTo(String value) {
            addCriterion("company_type =", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeNotEqualTo(String value) {
            addCriterion("company_type <>", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeGreaterThan(String value) {
            addCriterion("company_type >", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeGreaterThanOrEqualTo(String value) {
            addCriterion("company_type >=", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeLessThan(String value) {
            addCriterion("company_type <", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeLessThanOrEqualTo(String value) {
            addCriterion("company_type <=", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeLike(String value) {
            addCriterion("company_type like", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeNotLike(String value) {
            addCriterion("company_type not like", value, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeIn(List<String> values) {
            addCriterion("company_type in", values, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeNotIn(List<String> values) {
            addCriterion("company_type not in", values, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeBetween(String value1, String value2) {
            addCriterion("company_type between", value1, value2, "companyType");
            return (Criteria) this;
        }

        public Criteria andCompanyTypeNotBetween(String value1, String value2) {
            addCriterion("company_type not between", value1, value2, "companyType");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateIsNull() {
            addCriterion("announce_date is null");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateIsNotNull() {
            addCriterion("announce_date is not null");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateEqualTo(Date value) {
            addCriterionForJDBCDate("announce_date =", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("announce_date <>", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateGreaterThan(Date value) {
            addCriterionForJDBCDate("announce_date >", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("announce_date >=", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateLessThan(Date value) {
            addCriterionForJDBCDate("announce_date <", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("announce_date <=", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateIn(List<Date> values) {
            addCriterionForJDBCDate("announce_date in", values, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("announce_date not in", values, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("announce_date between", value1, value2, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("announce_date not between", value1, value2, "announceDate");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalIsNull() {
            addCriterion("close_capital is null");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalIsNotNull() {
            addCriterion("close_capital is not null");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalEqualTo(BigDecimal value) {
            addCriterion("close_capital =", value, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalNotEqualTo(BigDecimal value) {
            addCriterion("close_capital <>", value, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalGreaterThan(BigDecimal value) {
            addCriterion("close_capital >", value, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("close_capital >=", value, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalLessThan(BigDecimal value) {
            addCriterion("close_capital <", value, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("close_capital <=", value, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalIn(List<BigDecimal> values) {
            addCriterion("close_capital in", values, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalNotIn(List<BigDecimal> values) {
            addCriterion("close_capital not in", values, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("close_capital between", value1, value2, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andCloseCapitalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("close_capital not between", value1, value2, "closeCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalIsNull() {
            addCriterion("open_capital is null");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalIsNotNull() {
            addCriterion("open_capital is not null");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalEqualTo(BigDecimal value) {
            addCriterion("open_capital =", value, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalNotEqualTo(BigDecimal value) {
            addCriterion("open_capital <>", value, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalGreaterThan(BigDecimal value) {
            addCriterion("open_capital >", value, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("open_capital >=", value, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalLessThan(BigDecimal value) {
            addCriterion("open_capital <", value, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("open_capital <=", value, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalIn(List<BigDecimal> values) {
            addCriterion("open_capital in", values, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalNotIn(List<BigDecimal> values) {
            addCriterion("open_capital not in", values, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("open_capital between", value1, value2, "openCapital");
            return (Criteria) this;
        }

        public Criteria andOpenCapitalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("open_capital not between", value1, value2, "openCapital");
            return (Criteria) this;
        }

        public Criteria andCloseShareIsNull() {
            addCriterion("close_share is null");
            return (Criteria) this;
        }

        public Criteria andCloseShareIsNotNull() {
            addCriterion("close_share is not null");
            return (Criteria) this;
        }

        public Criteria andCloseShareEqualTo(BigDecimal value) {
            addCriterion("close_share =", value, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareNotEqualTo(BigDecimal value) {
            addCriterion("close_share <>", value, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareGreaterThan(BigDecimal value) {
            addCriterion("close_share >", value, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("close_share >=", value, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareLessThan(BigDecimal value) {
            addCriterion("close_share <", value, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("close_share <=", value, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareIn(List<BigDecimal> values) {
            addCriterion("close_share in", values, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareNotIn(List<BigDecimal> values) {
            addCriterion("close_share not in", values, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("close_share between", value1, value2, "closeShare");
            return (Criteria) this;
        }

        public Criteria andCloseShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("close_share not between", value1, value2, "closeShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareIsNull() {
            addCriterion("open_share is null");
            return (Criteria) this;
        }

        public Criteria andOpenShareIsNotNull() {
            addCriterion("open_share is not null");
            return (Criteria) this;
        }

        public Criteria andOpenShareEqualTo(BigDecimal value) {
            addCriterion("open_share =", value, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareNotEqualTo(BigDecimal value) {
            addCriterion("open_share <>", value, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareGreaterThan(BigDecimal value) {
            addCriterion("open_share >", value, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("open_share >=", value, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareLessThan(BigDecimal value) {
            addCriterion("open_share <", value, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareLessThanOrEqualTo(BigDecimal value) {
            addCriterion("open_share <=", value, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareIn(List<BigDecimal> values) {
            addCriterion("open_share in", values, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareNotIn(List<BigDecimal> values) {
            addCriterion("open_share not in", values, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("open_share between", value1, value2, "openShare");
            return (Criteria) this;
        }

        public Criteria andOpenShareNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("open_share not between", value1, value2, "openShare");
            return (Criteria) this;
        }

        public Criteria andCapitalIsNull() {
            addCriterion("capital is null");
            return (Criteria) this;
        }

        public Criteria andCapitalIsNotNull() {
            addCriterion("capital is not null");
            return (Criteria) this;
        }

        public Criteria andCapitalEqualTo(BigDecimal value) {
            addCriterion("capital =", value, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalNotEqualTo(BigDecimal value) {
            addCriterion("capital <>", value, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalGreaterThan(BigDecimal value) {
            addCriterion("capital >", value, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("capital >=", value, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalLessThan(BigDecimal value) {
            addCriterion("capital <", value, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalLessThanOrEqualTo(BigDecimal value) {
            addCriterion("capital <=", value, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalIn(List<BigDecimal> values) {
            addCriterion("capital in", values, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalNotIn(List<BigDecimal> values) {
            addCriterion("capital not in", values, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("capital between", value1, value2, "capital");
            return (Criteria) this;
        }

        public Criteria andCapitalNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("capital not between", value1, value2, "capital");
            return (Criteria) this;
        }

        public Criteria andCloseCountIsNull() {
            addCriterion("close_count is null");
            return (Criteria) this;
        }

        public Criteria andCloseCountIsNotNull() {
            addCriterion("close_count is not null");
            return (Criteria) this;
        }

        public Criteria andCloseCountEqualTo(Integer value) {
            addCriterion("close_count =", value, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountNotEqualTo(Integer value) {
            addCriterion("close_count <>", value, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountGreaterThan(Integer value) {
            addCriterion("close_count >", value, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("close_count >=", value, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountLessThan(Integer value) {
            addCriterion("close_count <", value, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountLessThanOrEqualTo(Integer value) {
            addCriterion("close_count <=", value, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountIn(List<Integer> values) {
            addCriterion("close_count in", values, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountNotIn(List<Integer> values) {
            addCriterion("close_count not in", values, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountBetween(Integer value1, Integer value2) {
            addCriterion("close_count between", value1, value2, "closeCount");
            return (Criteria) this;
        }

        public Criteria andCloseCountNotBetween(Integer value1, Integer value2) {
            addCriterion("close_count not between", value1, value2, "closeCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountIsNull() {
            addCriterion("open_count is null");
            return (Criteria) this;
        }

        public Criteria andOpenCountIsNotNull() {
            addCriterion("open_count is not null");
            return (Criteria) this;
        }

        public Criteria andOpenCountEqualTo(Integer value) {
            addCriterion("open_count =", value, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountNotEqualTo(Integer value) {
            addCriterion("open_count <>", value, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountGreaterThan(Integer value) {
            addCriterion("open_count >", value, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("open_count >=", value, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountLessThan(Integer value) {
            addCriterion("open_count <", value, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountLessThanOrEqualTo(Integer value) {
            addCriterion("open_count <=", value, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountIn(List<Integer> values) {
            addCriterion("open_count in", values, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountNotIn(List<Integer> values) {
            addCriterion("open_count not in", values, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountBetween(Integer value1, Integer value2) {
            addCriterion("open_count between", value1, value2, "openCount");
            return (Criteria) this;
        }

        public Criteria andOpenCountNotBetween(Integer value1, Integer value2) {
            addCriterion("open_count not between", value1, value2, "openCount");
            return (Criteria) this;
        }

        public Criteria andCountIsNull() {
            addCriterion("`count` is null");
            return (Criteria) this;
        }

        public Criteria andCountIsNotNull() {
            addCriterion("`count` is not null");
            return (Criteria) this;
        }

        public Criteria andCountEqualTo(Integer value) {
            addCriterion("`count` =", value, "count");
            return (Criteria) this;
        }

        public Criteria andCountNotEqualTo(Integer value) {
            addCriterion("`count` <>", value, "count");
            return (Criteria) this;
        }

        public Criteria andCountGreaterThan(Integer value) {
            addCriterion("`count` >", value, "count");
            return (Criteria) this;
        }

        public Criteria andCountGreaterThanOrEqualTo(Integer value) {
            addCriterion("`count` >=", value, "count");
            return (Criteria) this;
        }

        public Criteria andCountLessThan(Integer value) {
            addCriterion("`count` <", value, "count");
            return (Criteria) this;
        }

        public Criteria andCountLessThanOrEqualTo(Integer value) {
            addCriterion("`count` <=", value, "count");
            return (Criteria) this;
        }

        public Criteria andCountIn(List<Integer> values) {
            addCriterion("`count` in", values, "count");
            return (Criteria) this;
        }

        public Criteria andCountNotIn(List<Integer> values) {
            addCriterion("`count` not in", values, "count");
            return (Criteria) this;
        }

        public Criteria andCountBetween(Integer value1, Integer value2) {
            addCriterion("`count` between", value1, value2, "count");
            return (Criteria) this;
        }

        public Criteria andCountNotBetween(Integer value1, Integer value2) {
            addCriterion("`count` not between", value1, value2, "count");
            return (Criteria) this;
        }

        public Criteria andSSeqIsNull() {
            addCriterion("S_SEQ is null");
            return (Criteria) this;
        }

        public Criteria andSSeqIsNotNull() {
            addCriterion("S_SEQ is not null");
            return (Criteria) this;
        }

        public Criteria andSSeqEqualTo(Long value) {
            addCriterion("S_SEQ =", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqNotEqualTo(Long value) {
            addCriterion("S_SEQ <>", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqGreaterThan(Long value) {
            addCriterion("S_SEQ >", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqGreaterThanOrEqualTo(Long value) {
            addCriterion("S_SEQ >=", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqLessThan(Long value) {
            addCriterion("S_SEQ <", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqLessThanOrEqualTo(Long value) {
            addCriterion("S_SEQ <=", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqIn(List<Long> values) {
            addCriterion("S_SEQ in", values, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqNotIn(List<Long> values) {
            addCriterion("S_SEQ not in", values, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqBetween(Long value1, Long value2) {
            addCriterion("S_SEQ between", value1, value2, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqNotBetween(Long value1, Long value2) {
            addCriterion("S_SEQ not between", value1, value2, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIsNull() {
            addCriterion("S_UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIsNotNull() {
            addCriterion("S_UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME =", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME <>", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeGreaterThan(Date value) {
            addCriterion("S_UPDATE_TIME >", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME >=", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeLessThan(Date value) {
            addCriterion("S_UPDATE_TIME <", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME <=", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIn(List<Date> values) {
            addCriterion("S_UPDATE_TIME in", values, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotIn(List<Date> values) {
            addCriterion("S_UPDATE_TIME not in", values, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("S_UPDATE_TIME between", value1, value2, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("S_UPDATE_TIME not between", value1, value2, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSDataStateIsNull() {
            addCriterion("S_DATA_STATE is null");
            return (Criteria) this;
        }

        public Criteria andSDataStateIsNotNull() {
            addCriterion("S_DATA_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andSDataStateEqualTo(Short value) {
            addCriterion("S_DATA_STATE =", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotEqualTo(Short value) {
            addCriterion("S_DATA_STATE <>", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateGreaterThan(Short value) {
            addCriterion("S_DATA_STATE >", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateGreaterThanOrEqualTo(Short value) {
            addCriterion("S_DATA_STATE >=", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateLessThan(Short value) {
            addCriterion("S_DATA_STATE <", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateLessThanOrEqualTo(Short value) {
            addCriterion("S_DATA_STATE <=", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateIn(List<Short> values) {
            addCriterion("S_DATA_STATE in", values, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotIn(List<Short> values) {
            addCriterion("S_DATA_STATE not in", values, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateBetween(Short value1, Short value2) {
            addCriterion("S_DATA_STATE between", value1, value2, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotBetween(Short value1, Short value2) {
            addCriterion("S_DATA_STATE not between", value1, value2, "sDataState");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}