package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TxFundPortfolioExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TxFundPortfolioExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andFundIdIsNull() {
            addCriterion("fund_id is null");
            return (Criteria) this;
        }

        public Criteria andFundIdIsNotNull() {
            addCriterion("fund_id is not null");
            return (Criteria) this;
        }

        public Criteria andFundIdEqualTo(String value) {
            addCriterion("fund_id =", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotEqualTo(String value) {
            addCriterion("fund_id <>", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThan(String value) {
            addCriterion("fund_id >", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdGreaterThanOrEqualTo(String value) {
            addCriterion("fund_id >=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThan(String value) {
            addCriterion("fund_id <", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLessThanOrEqualTo(String value) {
            addCriterion("fund_id <=", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdLike(String value) {
            addCriterion("fund_id like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotLike(String value) {
            addCriterion("fund_id not like", value, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdIn(List<String> values) {
            addCriterion("fund_id in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotIn(List<String> values) {
            addCriterion("fund_id not in", values, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdBetween(String value1, String value2) {
            addCriterion("fund_id between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundIdNotBetween(String value1, String value2) {
            addCriterion("fund_id not between", value1, value2, "fundId");
            return (Criteria) this;
        }

        public Criteria andFundCodeIsNull() {
            addCriterion("fund_code is null");
            return (Criteria) this;
        }

        public Criteria andFundCodeIsNotNull() {
            addCriterion("fund_code is not null");
            return (Criteria) this;
        }

        public Criteria andFundCodeEqualTo(String value) {
            addCriterion("fund_code =", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotEqualTo(String value) {
            addCriterion("fund_code <>", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeGreaterThan(String value) {
            addCriterion("fund_code >", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeGreaterThanOrEqualTo(String value) {
            addCriterion("fund_code >=", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeLessThan(String value) {
            addCriterion("fund_code <", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeLessThanOrEqualTo(String value) {
            addCriterion("fund_code <=", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeLike(String value) {
            addCriterion("fund_code like", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotLike(String value) {
            addCriterion("fund_code not like", value, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeIn(List<String> values) {
            addCriterion("fund_code in", values, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotIn(List<String> values) {
            addCriterion("fund_code not in", values, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeBetween(String value1, String value2) {
            addCriterion("fund_code between", value1, value2, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundCodeNotBetween(String value1, String value2) {
            addCriterion("fund_code not between", value1, value2, "fundCode");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIsNull() {
            addCriterion("fund_short_name is null");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIsNotNull() {
            addCriterion("fund_short_name is not null");
            return (Criteria) this;
        }

        public Criteria andFundShortNameEqualTo(String value) {
            addCriterion("fund_short_name =", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotEqualTo(String value) {
            addCriterion("fund_short_name <>", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameGreaterThan(String value) {
            addCriterion("fund_short_name >", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameGreaterThanOrEqualTo(String value) {
            addCriterion("fund_short_name >=", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLessThan(String value) {
            addCriterion("fund_short_name <", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLessThanOrEqualTo(String value) {
            addCriterion("fund_short_name <=", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameLike(String value) {
            addCriterion("fund_short_name like", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotLike(String value) {
            addCriterion("fund_short_name not like", value, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameIn(List<String> values) {
            addCriterion("fund_short_name in", values, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotIn(List<String> values) {
            addCriterion("fund_short_name not in", values, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameBetween(String value1, String value2) {
            addCriterion("fund_short_name between", value1, value2, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andFundShortNameNotBetween(String value1, String value2) {
            addCriterion("fund_short_name not between", value1, value2, "fundShortName");
            return (Criteria) this;
        }

        public Criteria andReportIdIsNull() {
            addCriterion("report_id is null");
            return (Criteria) this;
        }

        public Criteria andReportIdIsNotNull() {
            addCriterion("report_id is not null");
            return (Criteria) this;
        }

        public Criteria andReportIdEqualTo(String value) {
            addCriterion("report_id =", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotEqualTo(String value) {
            addCriterion("report_id <>", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdGreaterThan(String value) {
            addCriterion("report_id >", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdGreaterThanOrEqualTo(String value) {
            addCriterion("report_id >=", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdLessThan(String value) {
            addCriterion("report_id <", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdLessThanOrEqualTo(String value) {
            addCriterion("report_id <=", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdLike(String value) {
            addCriterion("report_id like", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotLike(String value) {
            addCriterion("report_id not like", value, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdIn(List<String> values) {
            addCriterion("report_id in", values, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotIn(List<String> values) {
            addCriterion("report_id not in", values, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdBetween(String value1, String value2) {
            addCriterion("report_id between", value1, value2, "reportId");
            return (Criteria) this;
        }

        public Criteria andReportIdNotBetween(String value1, String value2) {
            addCriterion("report_id not between", value1, value2, "reportId");
            return (Criteria) this;
        }

        public Criteria andAnnDateIsNull() {
            addCriterion("ann_date is null");
            return (Criteria) this;
        }

        public Criteria andAnnDateIsNotNull() {
            addCriterion("ann_date is not null");
            return (Criteria) this;
        }

        public Criteria andAnnDateEqualTo(Date value) {
            addCriterionForJDBCDate("ann_date =", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("ann_date <>", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateGreaterThan(Date value) {
            addCriterionForJDBCDate("ann_date >", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("ann_date >=", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateLessThan(Date value) {
            addCriterionForJDBCDate("ann_date <", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("ann_date <=", value, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateIn(List<Date> values) {
            addCriterionForJDBCDate("ann_date in", values, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("ann_date not in", values, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("ann_date between", value1, value2, "annDate");
            return (Criteria) this;
        }

        public Criteria andAnnDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("ann_date not between", value1, value2, "annDate");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNull() {
            addCriterion("start_date is null");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNotNull() {
            addCriterion("start_date is not null");
            return (Criteria) this;
        }

        public Criteria andStartDateEqualTo(Date value) {
            addCriterionForJDBCDate("start_date =", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("start_date <>", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThan(Date value) {
            addCriterionForJDBCDate("start_date >", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("start_date >=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThan(Date value) {
            addCriterionForJDBCDate("start_date <", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("start_date <=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateIn(List<Date> values) {
            addCriterionForJDBCDate("start_date in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("start_date not in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("start_date between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("start_date not between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("end_date is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("end_date is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("end_date =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("end_date >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(Date value) {
            addCriterionForJDBCDate("end_date <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("end_date in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("end_date not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andIsNewIsNull() {
            addCriterion("is_new is null");
            return (Criteria) this;
        }

        public Criteria andIsNewIsNotNull() {
            addCriterion("is_new is not null");
            return (Criteria) this;
        }

        public Criteria andIsNewEqualTo(Integer value) {
            addCriterion("is_new =", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewNotEqualTo(Integer value) {
            addCriterion("is_new <>", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewGreaterThan(Integer value) {
            addCriterion("is_new >", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewGreaterThanOrEqualTo(Integer value) {
            addCriterion("is_new >=", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewLessThan(Integer value) {
            addCriterion("is_new <", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewLessThanOrEqualTo(Integer value) {
            addCriterion("is_new <=", value, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewIn(List<Integer> values) {
            addCriterion("is_new in", values, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewNotIn(List<Integer> values) {
            addCriterion("is_new not in", values, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewBetween(Integer value1, Integer value2) {
            addCriterion("is_new between", value1, value2, "isNew");
            return (Criteria) this;
        }

        public Criteria andIsNewNotBetween(Integer value1, Integer value2) {
            addCriterion("is_new not between", value1, value2, "isNew");
            return (Criteria) this;
        }

        public Criteria andStockValueIsNull() {
            addCriterion("stock_value is null");
            return (Criteria) this;
        }

        public Criteria andStockValueIsNotNull() {
            addCriterion("stock_value is not null");
            return (Criteria) this;
        }

        public Criteria andStockValueEqualTo(BigDecimal value) {
            addCriterion("stock_value =", value, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueNotEqualTo(BigDecimal value) {
            addCriterion("stock_value <>", value, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueGreaterThan(BigDecimal value) {
            addCriterion("stock_value >", value, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("stock_value >=", value, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueLessThan(BigDecimal value) {
            addCriterion("stock_value <", value, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("stock_value <=", value, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueIn(List<BigDecimal> values) {
            addCriterion("stock_value in", values, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueNotIn(List<BigDecimal> values) {
            addCriterion("stock_value not in", values, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stock_value between", value1, value2, "stockValue");
            return (Criteria) this;
        }

        public Criteria andStockValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("stock_value not between", value1, value2, "stockValue");
            return (Criteria) this;
        }

        public Criteria andBondValueIsNull() {
            addCriterion("bond_value is null");
            return (Criteria) this;
        }

        public Criteria andBondValueIsNotNull() {
            addCriterion("bond_value is not null");
            return (Criteria) this;
        }

        public Criteria andBondValueEqualTo(BigDecimal value) {
            addCriterion("bond_value =", value, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueNotEqualTo(BigDecimal value) {
            addCriterion("bond_value <>", value, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueGreaterThan(BigDecimal value) {
            addCriterion("bond_value >", value, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("bond_value >=", value, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueLessThan(BigDecimal value) {
            addCriterion("bond_value <", value, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("bond_value <=", value, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueIn(List<BigDecimal> values) {
            addCriterion("bond_value in", values, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueNotIn(List<BigDecimal> values) {
            addCriterion("bond_value not in", values, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("bond_value between", value1, value2, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBondValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("bond_value not between", value1, value2, "bondValue");
            return (Criteria) this;
        }

        public Criteria andBankValueIsNull() {
            addCriterion("bank_value is null");
            return (Criteria) this;
        }

        public Criteria andBankValueIsNotNull() {
            addCriterion("bank_value is not null");
            return (Criteria) this;
        }

        public Criteria andBankValueEqualTo(BigDecimal value) {
            addCriterion("bank_value =", value, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueNotEqualTo(BigDecimal value) {
            addCriterion("bank_value <>", value, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueGreaterThan(BigDecimal value) {
            addCriterion("bank_value >", value, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("bank_value >=", value, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueLessThan(BigDecimal value) {
            addCriterion("bank_value <", value, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("bank_value <=", value, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueIn(List<BigDecimal> values) {
            addCriterion("bank_value in", values, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueNotIn(List<BigDecimal> values) {
            addCriterion("bank_value not in", values, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("bank_value between", value1, value2, "bankValue");
            return (Criteria) this;
        }

        public Criteria andBankValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("bank_value not between", value1, value2, "bankValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueIsNull() {
            addCriterion("other_value is null");
            return (Criteria) this;
        }

        public Criteria andOtherValueIsNotNull() {
            addCriterion("other_value is not null");
            return (Criteria) this;
        }

        public Criteria andOtherValueEqualTo(BigDecimal value) {
            addCriterion("other_value =", value, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueNotEqualTo(BigDecimal value) {
            addCriterion("other_value <>", value, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueGreaterThan(BigDecimal value) {
            addCriterion("other_value >", value, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("other_value >=", value, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueLessThan(BigDecimal value) {
            addCriterion("other_value <", value, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("other_value <=", value, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueIn(List<BigDecimal> values) {
            addCriterion("other_value in", values, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueNotIn(List<BigDecimal> values) {
            addCriterion("other_value not in", values, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("other_value between", value1, value2, "otherValue");
            return (Criteria) this;
        }

        public Criteria andOtherValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("other_value not between", value1, value2, "otherValue");
            return (Criteria) this;
        }

        public Criteria andReturnSaleIsNull() {
            addCriterion("return_sale is null");
            return (Criteria) this;
        }

        public Criteria andReturnSaleIsNotNull() {
            addCriterion("return_sale is not null");
            return (Criteria) this;
        }

        public Criteria andReturnSaleEqualTo(BigDecimal value) {
            addCriterion("return_sale =", value, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleNotEqualTo(BigDecimal value) {
            addCriterion("return_sale <>", value, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleGreaterThan(BigDecimal value) {
            addCriterion("return_sale >", value, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("return_sale >=", value, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleLessThan(BigDecimal value) {
            addCriterion("return_sale <", value, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleLessThanOrEqualTo(BigDecimal value) {
            addCriterion("return_sale <=", value, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleIn(List<BigDecimal> values) {
            addCriterion("return_sale in", values, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleNotIn(List<BigDecimal> values) {
            addCriterion("return_sale not in", values, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("return_sale between", value1, value2, "returnSale");
            return (Criteria) this;
        }

        public Criteria andReturnSaleNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("return_sale not between", value1, value2, "returnSale");
            return (Criteria) this;
        }

        public Criteria andSettlementIsNull() {
            addCriterion("settlement is null");
            return (Criteria) this;
        }

        public Criteria andSettlementIsNotNull() {
            addCriterion("settlement is not null");
            return (Criteria) this;
        }

        public Criteria andSettlementEqualTo(BigDecimal value) {
            addCriterion("settlement =", value, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementNotEqualTo(BigDecimal value) {
            addCriterion("settlement <>", value, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementGreaterThan(BigDecimal value) {
            addCriterion("settlement >", value, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("settlement >=", value, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementLessThan(BigDecimal value) {
            addCriterion("settlement <", value, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementLessThanOrEqualTo(BigDecimal value) {
            addCriterion("settlement <=", value, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementIn(List<BigDecimal> values) {
            addCriterion("settlement in", values, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementNotIn(List<BigDecimal> values) {
            addCriterion("settlement not in", values, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("settlement between", value1, value2, "settlement");
            return (Criteria) this;
        }

        public Criteria andSettlementNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("settlement not between", value1, value2, "settlement");
            return (Criteria) this;
        }

        public Criteria andDerInvestIsNull() {
            addCriterion("der_invest is null");
            return (Criteria) this;
        }

        public Criteria andDerInvestIsNotNull() {
            addCriterion("der_invest is not null");
            return (Criteria) this;
        }

        public Criteria andDerInvestEqualTo(BigDecimal value) {
            addCriterion("der_invest =", value, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestNotEqualTo(BigDecimal value) {
            addCriterion("der_invest <>", value, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestGreaterThan(BigDecimal value) {
            addCriterion("der_invest >", value, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("der_invest >=", value, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestLessThan(BigDecimal value) {
            addCriterion("der_invest <", value, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestLessThanOrEqualTo(BigDecimal value) {
            addCriterion("der_invest <=", value, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestIn(List<BigDecimal> values) {
            addCriterion("der_invest in", values, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestNotIn(List<BigDecimal> values) {
            addCriterion("der_invest not in", values, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("der_invest between", value1, value2, "derInvest");
            return (Criteria) this;
        }

        public Criteria andDerInvestNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("der_invest not between", value1, value2, "derInvest");
            return (Criteria) this;
        }

        public Criteria andTotalValueIsNull() {
            addCriterion("total_value is null");
            return (Criteria) this;
        }

        public Criteria andTotalValueIsNotNull() {
            addCriterion("total_value is not null");
            return (Criteria) this;
        }

        public Criteria andTotalValueEqualTo(BigDecimal value) {
            addCriterion("total_value =", value, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueNotEqualTo(BigDecimal value) {
            addCriterion("total_value <>", value, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueGreaterThan(BigDecimal value) {
            addCriterion("total_value >", value, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("total_value >=", value, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueLessThan(BigDecimal value) {
            addCriterion("total_value <", value, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("total_value <=", value, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueIn(List<BigDecimal> values) {
            addCriterion("total_value in", values, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueNotIn(List<BigDecimal> values) {
            addCriterion("total_value not in", values, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_value between", value1, value2, "totalValue");
            return (Criteria) this;
        }

        public Criteria andTotalValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("total_value not between", value1, value2, "totalValue");
            return (Criteria) this;
        }

        public Criteria andNetValueIsNull() {
            addCriterion("net_value is null");
            return (Criteria) this;
        }

        public Criteria andNetValueIsNotNull() {
            addCriterion("net_value is not null");
            return (Criteria) this;
        }

        public Criteria andNetValueEqualTo(BigDecimal value) {
            addCriterion("net_value =", value, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueNotEqualTo(BigDecimal value) {
            addCriterion("net_value <>", value, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueGreaterThan(BigDecimal value) {
            addCriterion("net_value >", value, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("net_value >=", value, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueLessThan(BigDecimal value) {
            addCriterion("net_value <", value, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueLessThanOrEqualTo(BigDecimal value) {
            addCriterion("net_value <=", value, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueIn(List<BigDecimal> values) {
            addCriterion("net_value in", values, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueNotIn(List<BigDecimal> values) {
            addCriterion("net_value not in", values, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("net_value between", value1, value2, "netValue");
            return (Criteria) this;
        }

        public Criteria andNetValueNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("net_value not between", value1, value2, "netValue");
            return (Criteria) this;
        }

        public Criteria andAssetBackIsNull() {
            addCriterion("asset_back is null");
            return (Criteria) this;
        }

        public Criteria andAssetBackIsNotNull() {
            addCriterion("asset_back is not null");
            return (Criteria) this;
        }

        public Criteria andAssetBackEqualTo(BigDecimal value) {
            addCriterion("asset_back =", value, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackNotEqualTo(BigDecimal value) {
            addCriterion("asset_back <>", value, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackGreaterThan(BigDecimal value) {
            addCriterion("asset_back >", value, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("asset_back >=", value, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackLessThan(BigDecimal value) {
            addCriterion("asset_back <", value, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackLessThanOrEqualTo(BigDecimal value) {
            addCriterion("asset_back <=", value, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackIn(List<BigDecimal> values) {
            addCriterion("asset_back in", values, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackNotIn(List<BigDecimal> values) {
            addCriterion("asset_back not in", values, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("asset_back between", value1, value2, "assetBack");
            return (Criteria) this;
        }

        public Criteria andAssetBackNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("asset_back not between", value1, value2, "assetBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackIsNull() {
            addCriterion("active_back is null");
            return (Criteria) this;
        }

        public Criteria andActiveBackIsNotNull() {
            addCriterion("active_back is not null");
            return (Criteria) this;
        }

        public Criteria andActiveBackEqualTo(BigDecimal value) {
            addCriterion("active_back =", value, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackNotEqualTo(BigDecimal value) {
            addCriterion("active_back <>", value, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackGreaterThan(BigDecimal value) {
            addCriterion("active_back >", value, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("active_back >=", value, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackLessThan(BigDecimal value) {
            addCriterion("active_back <", value, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackLessThanOrEqualTo(BigDecimal value) {
            addCriterion("active_back <=", value, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackIn(List<BigDecimal> values) {
            addCriterion("active_back in", values, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackNotIn(List<BigDecimal> values) {
            addCriterion("active_back not in", values, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("active_back between", value1, value2, "activeBack");
            return (Criteria) this;
        }

        public Criteria andActiveBackNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("active_back not between", value1, value2, "activeBack");
            return (Criteria) this;
        }

        public Criteria andIndexInvestIsNull() {
            addCriterion("index_invest is null");
            return (Criteria) this;
        }

        public Criteria andIndexInvestIsNotNull() {
            addCriterion("index_invest is not null");
            return (Criteria) this;
        }

        public Criteria andIndexInvestEqualTo(BigDecimal value) {
            addCriterion("index_invest =", value, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestNotEqualTo(BigDecimal value) {
            addCriterion("index_invest <>", value, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestGreaterThan(BigDecimal value) {
            addCriterion("index_invest >", value, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("index_invest >=", value, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestLessThan(BigDecimal value) {
            addCriterion("index_invest <", value, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestLessThanOrEqualTo(BigDecimal value) {
            addCriterion("index_invest <=", value, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestIn(List<BigDecimal> values) {
            addCriterion("index_invest in", values, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestNotIn(List<BigDecimal> values) {
            addCriterion("index_invest not in", values, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("index_invest between", value1, value2, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andIndexInvestNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("index_invest not between", value1, value2, "indexInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestIsNull() {
            addCriterion("fund_invest is null");
            return (Criteria) this;
        }

        public Criteria andFundInvestIsNotNull() {
            addCriterion("fund_invest is not null");
            return (Criteria) this;
        }

        public Criteria andFundInvestEqualTo(BigDecimal value) {
            addCriterion("fund_invest =", value, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestNotEqualTo(BigDecimal value) {
            addCriterion("fund_invest <>", value, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestGreaterThan(BigDecimal value) {
            addCriterion("fund_invest >", value, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("fund_invest >=", value, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestLessThan(BigDecimal value) {
            addCriterion("fund_invest <", value, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestLessThanOrEqualTo(BigDecimal value) {
            addCriterion("fund_invest <=", value, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestIn(List<BigDecimal> values) {
            addCriterion("fund_invest in", values, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestNotIn(List<BigDecimal> values) {
            addCriterion("fund_invest not in", values, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fund_invest between", value1, value2, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andFundInvestNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("fund_invest not between", value1, value2, "fundInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestIsNull() {
            addCriterion("metal_invest is null");
            return (Criteria) this;
        }

        public Criteria andMetalInvestIsNotNull() {
            addCriterion("metal_invest is not null");
            return (Criteria) this;
        }

        public Criteria andMetalInvestEqualTo(BigDecimal value) {
            addCriterion("metal_invest =", value, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestNotEqualTo(BigDecimal value) {
            addCriterion("metal_invest <>", value, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestGreaterThan(BigDecimal value) {
            addCriterion("metal_invest >", value, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("metal_invest >=", value, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestLessThan(BigDecimal value) {
            addCriterion("metal_invest <", value, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestLessThanOrEqualTo(BigDecimal value) {
            addCriterion("metal_invest <=", value, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestIn(List<BigDecimal> values) {
            addCriterion("metal_invest in", values, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestNotIn(List<BigDecimal> values) {
            addCriterion("metal_invest not in", values, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("metal_invest between", value1, value2, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andMetalInvestNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("metal_invest not between", value1, value2, "metalInvest");
            return (Criteria) this;
        }

        public Criteria andHkStockIsNull() {
            addCriterion("hk_stock is null");
            return (Criteria) this;
        }

        public Criteria andHkStockIsNotNull() {
            addCriterion("hk_stock is not null");
            return (Criteria) this;
        }

        public Criteria andHkStockEqualTo(BigDecimal value) {
            addCriterion("hk_stock =", value, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockNotEqualTo(BigDecimal value) {
            addCriterion("hk_stock <>", value, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockGreaterThan(BigDecimal value) {
            addCriterion("hk_stock >", value, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("hk_stock >=", value, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockLessThan(BigDecimal value) {
            addCriterion("hk_stock <", value, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockLessThanOrEqualTo(BigDecimal value) {
            addCriterion("hk_stock <=", value, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockIn(List<BigDecimal> values) {
            addCriterion("hk_stock in", values, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockNotIn(List<BigDecimal> values) {
            addCriterion("hk_stock not in", values, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hk_stock between", value1, value2, "hkStock");
            return (Criteria) this;
        }

        public Criteria andHkStockNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("hk_stock not between", value1, value2, "hkStock");
            return (Criteria) this;
        }

        public Criteria andSSegIsNull() {
            addCriterion("S_SEG is null");
            return (Criteria) this;
        }

        public Criteria andSSegIsNotNull() {
            addCriterion("S_SEG is not null");
            return (Criteria) this;
        }

        public Criteria andSSegEqualTo(Long value) {
            addCriterion("S_SEG =", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegNotEqualTo(Long value) {
            addCriterion("S_SEG <>", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegGreaterThan(Long value) {
            addCriterion("S_SEG >", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegGreaterThanOrEqualTo(Long value) {
            addCriterion("S_SEG >=", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegLessThan(Long value) {
            addCriterion("S_SEG <", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegLessThanOrEqualTo(Long value) {
            addCriterion("S_SEG <=", value, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegIn(List<Long> values) {
            addCriterion("S_SEG in", values, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegNotIn(List<Long> values) {
            addCriterion("S_SEG not in", values, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegBetween(Long value1, Long value2) {
            addCriterion("S_SEG between", value1, value2, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSSegNotBetween(Long value1, Long value2) {
            addCriterion("S_SEG not between", value1, value2, "sSeg");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIsNull() {
            addCriterion("S_ROW_VERSION is null");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIsNotNull() {
            addCriterion("S_ROW_VERSION is not null");
            return (Criteria) this;
        }

        public Criteria andSRowVersionEqualTo(Long value) {
            addCriterion("S_ROW_VERSION =", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotEqualTo(Long value) {
            addCriterion("S_ROW_VERSION <>", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionGreaterThan(Long value) {
            addCriterion("S_ROW_VERSION >", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionGreaterThanOrEqualTo(Long value) {
            addCriterion("S_ROW_VERSION >=", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionLessThan(Long value) {
            addCriterion("S_ROW_VERSION <", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionLessThanOrEqualTo(Long value) {
            addCriterion("S_ROW_VERSION <=", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIn(List<Long> values) {
            addCriterion("S_ROW_VERSION in", values, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotIn(List<Long> values) {
            addCriterion("S_ROW_VERSION not in", values, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionBetween(Long value1, Long value2) {
            addCriterion("S_ROW_VERSION between", value1, value2, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotBetween(Long value1, Long value2) {
            addCriterion("S_ROW_VERSION not between", value1, value2, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIsNull() {
            addCriterion("S_UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIsNotNull() {
            addCriterion("S_UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME =", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME <>", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeGreaterThan(Date value) {
            addCriterion("S_UPDATE_TIME >", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME >=", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeLessThan(Date value) {
            addCriterion("S_UPDATE_TIME <", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME <=", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIn(List<Date> values) {
            addCriterion("S_UPDATE_TIME in", values, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotIn(List<Date> values) {
            addCriterion("S_UPDATE_TIME not in", values, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("S_UPDATE_TIME between", value1, value2, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("S_UPDATE_TIME not between", value1, value2, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSDataStateIsNull() {
            addCriterion("S_DATA_STATE is null");
            return (Criteria) this;
        }

        public Criteria andSDataStateIsNotNull() {
            addCriterion("S_DATA_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andSDataStateEqualTo(Short value) {
            addCriterion("S_DATA_STATE =", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotEqualTo(Short value) {
            addCriterion("S_DATA_STATE <>", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateGreaterThan(Short value) {
            addCriterion("S_DATA_STATE >", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateGreaterThanOrEqualTo(Short value) {
            addCriterion("S_DATA_STATE >=", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateLessThan(Short value) {
            addCriterion("S_DATA_STATE <", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateLessThanOrEqualTo(Short value) {
            addCriterion("S_DATA_STATE <=", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateIn(List<Short> values) {
            addCriterion("S_DATA_STATE in", values, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotIn(List<Short> values) {
            addCriterion("S_DATA_STATE not in", values, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateBetween(Short value1, Short value2) {
            addCriterion("S_DATA_STATE between", value1, value2, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotBetween(Short value1, Short value2) {
            addCriterion("S_DATA_STATE not between", value1, value2, "sDataState");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}