package com.tanpu.fund.entity.generator;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class TxIndexBasicExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public TxIndexBasicExample() {
        oredCriteria = new ArrayList<>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIndexIdIsNull() {
            addCriterion("index_id is null");
            return (Criteria) this;
        }

        public Criteria andIndexIdIsNotNull() {
            addCriterion("index_id is not null");
            return (Criteria) this;
        }

        public Criteria andIndexIdEqualTo(Integer value) {
            addCriterion("index_id =", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotEqualTo(Integer value) {
            addCriterion("index_id <>", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdGreaterThan(Integer value) {
            addCriterion("index_id >", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("index_id >=", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdLessThan(Integer value) {
            addCriterion("index_id <", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdLessThanOrEqualTo(Integer value) {
            addCriterion("index_id <=", value, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdIn(List<Integer> values) {
            addCriterion("index_id in", values, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotIn(List<Integer> values) {
            addCriterion("index_id not in", values, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdBetween(Integer value1, Integer value2) {
            addCriterion("index_id between", value1, value2, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexIdNotBetween(Integer value1, Integer value2) {
            addCriterion("index_id not between", value1, value2, "indexId");
            return (Criteria) this;
        }

        public Criteria andIndexCodeIsNull() {
            addCriterion("index_code is null");
            return (Criteria) this;
        }

        public Criteria andIndexCodeIsNotNull() {
            addCriterion("index_code is not null");
            return (Criteria) this;
        }

        public Criteria andIndexCodeEqualTo(String value) {
            addCriterion("index_code =", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeNotEqualTo(String value) {
            addCriterion("index_code <>", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeGreaterThan(String value) {
            addCriterion("index_code >", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeGreaterThanOrEqualTo(String value) {
            addCriterion("index_code >=", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeLessThan(String value) {
            addCriterion("index_code <", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeLessThanOrEqualTo(String value) {
            addCriterion("index_code <=", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeLike(String value) {
            addCriterion("index_code like", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeNotLike(String value) {
            addCriterion("index_code not like", value, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeIn(List<String> values) {
            addCriterion("index_code in", values, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeNotIn(List<String> values) {
            addCriterion("index_code not in", values, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeBetween(String value1, String value2) {
            addCriterion("index_code between", value1, value2, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexCodeNotBetween(String value1, String value2) {
            addCriterion("index_code not between", value1, value2, "indexCode");
            return (Criteria) this;
        }

        public Criteria andIndexNameIsNull() {
            addCriterion("index_name is null");
            return (Criteria) this;
        }

        public Criteria andIndexNameIsNotNull() {
            addCriterion("index_name is not null");
            return (Criteria) this;
        }

        public Criteria andIndexNameEqualTo(String value) {
            addCriterion("index_name =", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameNotEqualTo(String value) {
            addCriterion("index_name <>", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameGreaterThan(String value) {
            addCriterion("index_name >", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameGreaterThanOrEqualTo(String value) {
            addCriterion("index_name >=", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameLessThan(String value) {
            addCriterion("index_name <", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameLessThanOrEqualTo(String value) {
            addCriterion("index_name <=", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameLike(String value) {
            addCriterion("index_name like", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameNotLike(String value) {
            addCriterion("index_name not like", value, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameIn(List<String> values) {
            addCriterion("index_name in", values, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameNotIn(List<String> values) {
            addCriterion("index_name not in", values, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameBetween(String value1, String value2) {
            addCriterion("index_name between", value1, value2, "indexName");
            return (Criteria) this;
        }

        public Criteria andIndexNameNotBetween(String value1, String value2) {
            addCriterion("index_name not between", value1, value2, "indexName");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateIsNull() {
            addCriterion("announce_date is null");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateIsNotNull() {
            addCriterion("announce_date is not null");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateEqualTo(Date value) {
            addCriterionForJDBCDate("announce_date =", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("announce_date <>", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateGreaterThan(Date value) {
            addCriterionForJDBCDate("announce_date >", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("announce_date >=", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateLessThan(Date value) {
            addCriterionForJDBCDate("announce_date <", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("announce_date <=", value, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateIn(List<Date> values) {
            addCriterionForJDBCDate("announce_date in", values, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("announce_date not in", values, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("announce_date between", value1, value2, "announceDate");
            return (Criteria) this;
        }

        public Criteria andAnnounceDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("announce_date not between", value1, value2, "announceDate");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNull() {
            addCriterion("start_date is null");
            return (Criteria) this;
        }

        public Criteria andStartDateIsNotNull() {
            addCriterion("start_date is not null");
            return (Criteria) this;
        }

        public Criteria andStartDateEqualTo(Date value) {
            addCriterionForJDBCDate("start_date =", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("start_date <>", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThan(Date value) {
            addCriterionForJDBCDate("start_date >", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("start_date >=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThan(Date value) {
            addCriterionForJDBCDate("start_date <", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("start_date <=", value, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateIn(List<Date> values) {
            addCriterionForJDBCDate("start_date in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("start_date not in", values, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("start_date between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andStartDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("start_date not between", value1, value2, "startDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNull() {
            addCriterion("end_date is null");
            return (Criteria) this;
        }

        public Criteria andEndDateIsNotNull() {
            addCriterion("end_date is not null");
            return (Criteria) this;
        }

        public Criteria andEndDateEqualTo(Date value) {
            addCriterionForJDBCDate("end_date =", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <>", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThan(Date value) {
            addCriterionForJDBCDate("end_date >", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date >=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThan(Date value) {
            addCriterionForJDBCDate("end_date <", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("end_date <=", value, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateIn(List<Date> values) {
            addCriterionForJDBCDate("end_date in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("end_date not in", values, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andEndDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("end_date not between", value1, value2, "endDate");
            return (Criteria) this;
        }

        public Criteria andSectorIdIsNull() {
            addCriterion("sector_id is null");
            return (Criteria) this;
        }

        public Criteria andSectorIdIsNotNull() {
            addCriterion("sector_id is not null");
            return (Criteria) this;
        }

        public Criteria andSectorIdEqualTo(Integer value) {
            addCriterion("sector_id =", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdNotEqualTo(Integer value) {
            addCriterion("sector_id <>", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdGreaterThan(Integer value) {
            addCriterion("sector_id >", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("sector_id >=", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdLessThan(Integer value) {
            addCriterion("sector_id <", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdLessThanOrEqualTo(Integer value) {
            addCriterion("sector_id <=", value, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdIn(List<Integer> values) {
            addCriterion("sector_id in", values, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdNotIn(List<Integer> values) {
            addCriterion("sector_id not in", values, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdBetween(Integer value1, Integer value2) {
            addCriterion("sector_id between", value1, value2, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorIdNotBetween(Integer value1, Integer value2) {
            addCriterion("sector_id not between", value1, value2, "sectorId");
            return (Criteria) this;
        }

        public Criteria andSectorNameIsNull() {
            addCriterion("sector_name is null");
            return (Criteria) this;
        }

        public Criteria andSectorNameIsNotNull() {
            addCriterion("sector_name is not null");
            return (Criteria) this;
        }

        public Criteria andSectorNameEqualTo(String value) {
            addCriterion("sector_name =", value, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameNotEqualTo(String value) {
            addCriterion("sector_name <>", value, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameGreaterThan(String value) {
            addCriterion("sector_name >", value, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameGreaterThanOrEqualTo(String value) {
            addCriterion("sector_name >=", value, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameLessThan(String value) {
            addCriterion("sector_name <", value, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameLessThanOrEqualTo(String value) {
            addCriterion("sector_name <=", value, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameLike(String value) {
            addCriterion("sector_name like", value, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameNotLike(String value) {
            addCriterion("sector_name not like", value, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameIn(List<String> values) {
            addCriterion("sector_name in", values, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameNotIn(List<String> values) {
            addCriterion("sector_name not in", values, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameBetween(String value1, String value2) {
            addCriterion("sector_name between", value1, value2, "sectorName");
            return (Criteria) this;
        }

        public Criteria andSectorNameNotBetween(String value1, String value2) {
            addCriterion("sector_name not between", value1, value2, "sectorName");
            return (Criteria) this;
        }

        public Criteria andPublisherIdIsNull() {
            addCriterion("publisher_id is null");
            return (Criteria) this;
        }

        public Criteria andPublisherIdIsNotNull() {
            addCriterion("publisher_id is not null");
            return (Criteria) this;
        }

        public Criteria andPublisherIdEqualTo(Integer value) {
            addCriterion("publisher_id =", value, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdNotEqualTo(Integer value) {
            addCriterion("publisher_id <>", value, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdGreaterThan(Integer value) {
            addCriterion("publisher_id >", value, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdGreaterThanOrEqualTo(Integer value) {
            addCriterion("publisher_id >=", value, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdLessThan(Integer value) {
            addCriterion("publisher_id <", value, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdLessThanOrEqualTo(Integer value) {
            addCriterion("publisher_id <=", value, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdIn(List<Integer> values) {
            addCriterion("publisher_id in", values, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdNotIn(List<Integer> values) {
            addCriterion("publisher_id not in", values, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdBetween(Integer value1, Integer value2) {
            addCriterion("publisher_id between", value1, value2, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherIdNotBetween(Integer value1, Integer value2) {
            addCriterion("publisher_id not between", value1, value2, "publisherId");
            return (Criteria) this;
        }

        public Criteria andPublisherNameIsNull() {
            addCriterion("publisher_name is null");
            return (Criteria) this;
        }

        public Criteria andPublisherNameIsNotNull() {
            addCriterion("publisher_name is not null");
            return (Criteria) this;
        }

        public Criteria andPublisherNameEqualTo(String value) {
            addCriterion("publisher_name =", value, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameNotEqualTo(String value) {
            addCriterion("publisher_name <>", value, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameGreaterThan(String value) {
            addCriterion("publisher_name >", value, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameGreaterThanOrEqualTo(String value) {
            addCriterion("publisher_name >=", value, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameLessThan(String value) {
            addCriterion("publisher_name <", value, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameLessThanOrEqualTo(String value) {
            addCriterion("publisher_name <=", value, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameLike(String value) {
            addCriterion("publisher_name like", value, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameNotLike(String value) {
            addCriterion("publisher_name not like", value, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameIn(List<String> values) {
            addCriterion("publisher_name in", values, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameNotIn(List<String> values) {
            addCriterion("publisher_name not in", values, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameBetween(String value1, String value2) {
            addCriterion("publisher_name between", value1, value2, "publisherName");
            return (Criteria) this;
        }

        public Criteria andPublisherNameNotBetween(String value1, String value2) {
            addCriterion("publisher_name not between", value1, value2, "publisherName");
            return (Criteria) this;
        }

        public Criteria andOuterCodeIsNull() {
            addCriterion("outer_code is null");
            return (Criteria) this;
        }

        public Criteria andOuterCodeIsNotNull() {
            addCriterion("outer_code is not null");
            return (Criteria) this;
        }

        public Criteria andOuterCodeEqualTo(String value) {
            addCriterion("outer_code =", value, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeNotEqualTo(String value) {
            addCriterion("outer_code <>", value, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeGreaterThan(String value) {
            addCriterion("outer_code >", value, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeGreaterThanOrEqualTo(String value) {
            addCriterion("outer_code >=", value, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeLessThan(String value) {
            addCriterion("outer_code <", value, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeLessThanOrEqualTo(String value) {
            addCriterion("outer_code <=", value, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeLike(String value) {
            addCriterion("outer_code like", value, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeNotLike(String value) {
            addCriterion("outer_code not like", value, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeIn(List<String> values) {
            addCriterion("outer_code in", values, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeNotIn(List<String> values) {
            addCriterion("outer_code not in", values, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeBetween(String value1, String value2) {
            addCriterion("outer_code between", value1, value2, "outerCode");
            return (Criteria) this;
        }

        public Criteria andOuterCodeNotBetween(String value1, String value2) {
            addCriterion("outer_code not between", value1, value2, "outerCode");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameIsNull() {
            addCriterion("index_fullname is null");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameIsNotNull() {
            addCriterion("index_fullname is not null");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameEqualTo(String value) {
            addCriterion("index_fullname =", value, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameNotEqualTo(String value) {
            addCriterion("index_fullname <>", value, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameGreaterThan(String value) {
            addCriterion("index_fullname >", value, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameGreaterThanOrEqualTo(String value) {
            addCriterion("index_fullname >=", value, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameLessThan(String value) {
            addCriterion("index_fullname <", value, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameLessThanOrEqualTo(String value) {
            addCriterion("index_fullname <=", value, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameLike(String value) {
            addCriterion("index_fullname like", value, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameNotLike(String value) {
            addCriterion("index_fullname not like", value, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameIn(List<String> values) {
            addCriterion("index_fullname in", values, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameNotIn(List<String> values) {
            addCriterion("index_fullname not in", values, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameBetween(String value1, String value2) {
            addCriterion("index_fullname between", value1, value2, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andIndexFullnameNotBetween(String value1, String value2) {
            addCriterion("index_fullname not between", value1, value2, "indexFullname");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIsNull() {
            addCriterion("category_id is null");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIsNotNull() {
            addCriterion("category_id is not null");
            return (Criteria) this;
        }

        public Criteria andCategoryIdEqualTo(String value) {
            addCriterion("category_id =", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotEqualTo(String value) {
            addCriterion("category_id <>", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdGreaterThan(String value) {
            addCriterion("category_id >", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdGreaterThanOrEqualTo(String value) {
            addCriterion("category_id >=", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdLessThan(String value) {
            addCriterion("category_id <", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdLessThanOrEqualTo(String value) {
            addCriterion("category_id <=", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdLike(String value) {
            addCriterion("category_id like", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotLike(String value) {
            addCriterion("category_id not like", value, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdIn(List<String> values) {
            addCriterion("category_id in", values, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotIn(List<String> values) {
            addCriterion("category_id not in", values, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdBetween(String value1, String value2) {
            addCriterion("category_id between", value1, value2, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryIdNotBetween(String value1, String value2) {
            addCriterion("category_id not between", value1, value2, "categoryId");
            return (Criteria) this;
        }

        public Criteria andCategoryNameIsNull() {
            addCriterion("category_name is null");
            return (Criteria) this;
        }

        public Criteria andCategoryNameIsNotNull() {
            addCriterion("category_name is not null");
            return (Criteria) this;
        }

        public Criteria andCategoryNameEqualTo(String value) {
            addCriterion("category_name =", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameNotEqualTo(String value) {
            addCriterion("category_name <>", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameGreaterThan(String value) {
            addCriterion("category_name >", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameGreaterThanOrEqualTo(String value) {
            addCriterion("category_name >=", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameLessThan(String value) {
            addCriterion("category_name <", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameLessThanOrEqualTo(String value) {
            addCriterion("category_name <=", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameLike(String value) {
            addCriterion("category_name like", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameNotLike(String value) {
            addCriterion("category_name not like", value, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameIn(List<String> values) {
            addCriterion("category_name in", values, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameNotIn(List<String> values) {
            addCriterion("category_name not in", values, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameBetween(String value1, String value2) {
            addCriterion("category_name between", value1, value2, "categoryName");
            return (Criteria) this;
        }

        public Criteria andCategoryNameNotBetween(String value1, String value2) {
            addCriterion("category_name not between", value1, value2, "categoryName");
            return (Criteria) this;
        }

        public Criteria andTypeIdIsNull() {
            addCriterion("type_id is null");
            return (Criteria) this;
        }

        public Criteria andTypeIdIsNotNull() {
            addCriterion("type_id is not null");
            return (Criteria) this;
        }

        public Criteria andTypeIdEqualTo(String value) {
            addCriterion("type_id =", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdNotEqualTo(String value) {
            addCriterion("type_id <>", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdGreaterThan(String value) {
            addCriterion("type_id >", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdGreaterThanOrEqualTo(String value) {
            addCriterion("type_id >=", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdLessThan(String value) {
            addCriterion("type_id <", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdLessThanOrEqualTo(String value) {
            addCriterion("type_id <=", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdLike(String value) {
            addCriterion("type_id like", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdNotLike(String value) {
            addCriterion("type_id not like", value, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdIn(List<String> values) {
            addCriterion("type_id in", values, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdNotIn(List<String> values) {
            addCriterion("type_id not in", values, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdBetween(String value1, String value2) {
            addCriterion("type_id between", value1, value2, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeIdNotBetween(String value1, String value2) {
            addCriterion("type_id not between", value1, value2, "typeId");
            return (Criteria) this;
        }

        public Criteria andTypeNameIsNull() {
            addCriterion("type_name is null");
            return (Criteria) this;
        }

        public Criteria andTypeNameIsNotNull() {
            addCriterion("type_name is not null");
            return (Criteria) this;
        }

        public Criteria andTypeNameEqualTo(String value) {
            addCriterion("type_name =", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotEqualTo(String value) {
            addCriterion("type_name <>", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameGreaterThan(String value) {
            addCriterion("type_name >", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameGreaterThanOrEqualTo(String value) {
            addCriterion("type_name >=", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLessThan(String value) {
            addCriterion("type_name <", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLessThanOrEqualTo(String value) {
            addCriterion("type_name <=", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameLike(String value) {
            addCriterion("type_name like", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotLike(String value) {
            addCriterion("type_name not like", value, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameIn(List<String> values) {
            addCriterion("type_name in", values, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotIn(List<String> values) {
            addCriterion("type_name not in", values, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameBetween(String value1, String value2) {
            addCriterion("type_name between", value1, value2, "typeName");
            return (Criteria) this;
        }

        public Criteria andTypeNameNotBetween(String value1, String value2) {
            addCriterion("type_name not between", value1, value2, "typeName");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateIsNull() {
            addCriterion("benchmark_date is null");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateIsNotNull() {
            addCriterion("benchmark_date is not null");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateEqualTo(Date value) {
            addCriterionForJDBCDate("benchmark_date =", value, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("benchmark_date <>", value, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateGreaterThan(Date value) {
            addCriterionForJDBCDate("benchmark_date >", value, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("benchmark_date >=", value, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateLessThan(Date value) {
            addCriterionForJDBCDate("benchmark_date <", value, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("benchmark_date <=", value, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateIn(List<Date> values) {
            addCriterionForJDBCDate("benchmark_date in", values, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("benchmark_date not in", values, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("benchmark_date between", value1, value2, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("benchmark_date not between", value1, value2, "benchmarkDate");
            return (Criteria) this;
        }

        public Criteria andBenchmarkIsNull() {
            addCriterion("benchmark is null");
            return (Criteria) this;
        }

        public Criteria andBenchmarkIsNotNull() {
            addCriterion("benchmark is not null");
            return (Criteria) this;
        }

        public Criteria andBenchmarkEqualTo(BigDecimal value) {
            addCriterion("benchmark =", value, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkNotEqualTo(BigDecimal value) {
            addCriterion("benchmark <>", value, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkGreaterThan(BigDecimal value) {
            addCriterion("benchmark >", value, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("benchmark >=", value, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkLessThan(BigDecimal value) {
            addCriterion("benchmark <", value, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkLessThanOrEqualTo(BigDecimal value) {
            addCriterion("benchmark <=", value, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkIn(List<BigDecimal> values) {
            addCriterion("benchmark in", values, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkNotIn(List<BigDecimal> values) {
            addCriterion("benchmark not in", values, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("benchmark between", value1, value2, "benchmark");
            return (Criteria) this;
        }

        public Criteria andBenchmarkNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("benchmark not between", value1, value2, "benchmark");
            return (Criteria) this;
        }

        public Criteria andWeightMethodIsNull() {
            addCriterion("weight_method is null");
            return (Criteria) this;
        }

        public Criteria andWeightMethodIsNotNull() {
            addCriterion("weight_method is not null");
            return (Criteria) this;
        }

        public Criteria andWeightMethodEqualTo(String value) {
            addCriterion("weight_method =", value, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodNotEqualTo(String value) {
            addCriterion("weight_method <>", value, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodGreaterThan(String value) {
            addCriterion("weight_method >", value, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodGreaterThanOrEqualTo(String value) {
            addCriterion("weight_method >=", value, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodLessThan(String value) {
            addCriterion("weight_method <", value, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodLessThanOrEqualTo(String value) {
            addCriterion("weight_method <=", value, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodLike(String value) {
            addCriterion("weight_method like", value, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodNotLike(String value) {
            addCriterion("weight_method not like", value, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodIn(List<String> values) {
            addCriterion("weight_method in", values, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodNotIn(List<String> values) {
            addCriterion("weight_method not in", values, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodBetween(String value1, String value2) {
            addCriterion("weight_method between", value1, value2, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightMethodNotBetween(String value1, String value2) {
            addCriterion("weight_method not between", value1, value2, "weightMethod");
            return (Criteria) this;
        }

        public Criteria andWeightDescIsNull() {
            addCriterion("weight_desc is null");
            return (Criteria) this;
        }

        public Criteria andWeightDescIsNotNull() {
            addCriterion("weight_desc is not null");
            return (Criteria) this;
        }

        public Criteria andWeightDescEqualTo(String value) {
            addCriterion("weight_desc =", value, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescNotEqualTo(String value) {
            addCriterion("weight_desc <>", value, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescGreaterThan(String value) {
            addCriterion("weight_desc >", value, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescGreaterThanOrEqualTo(String value) {
            addCriterion("weight_desc >=", value, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescLessThan(String value) {
            addCriterion("weight_desc <", value, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescLessThanOrEqualTo(String value) {
            addCriterion("weight_desc <=", value, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescLike(String value) {
            addCriterion("weight_desc like", value, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescNotLike(String value) {
            addCriterion("weight_desc not like", value, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescIn(List<String> values) {
            addCriterion("weight_desc in", values, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescNotIn(List<String> values) {
            addCriterion("weight_desc not in", values, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescBetween(String value1, String value2) {
            addCriterion("weight_desc between", value1, value2, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightDescNotBetween(String value1, String value2) {
            addCriterion("weight_desc not between", value1, value2, "weightDesc");
            return (Criteria) this;
        }

        public Criteria andWeightPriceIsNull() {
            addCriterion("weight_price is null");
            return (Criteria) this;
        }

        public Criteria andWeightPriceIsNotNull() {
            addCriterion("weight_price is not null");
            return (Criteria) this;
        }

        public Criteria andWeightPriceEqualTo(BigDecimal value) {
            addCriterion("weight_price =", value, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceNotEqualTo(BigDecimal value) {
            addCriterion("weight_price <>", value, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceGreaterThan(BigDecimal value) {
            addCriterion("weight_price >", value, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("weight_price >=", value, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceLessThan(BigDecimal value) {
            addCriterion("weight_price <", value, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("weight_price <=", value, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceIn(List<BigDecimal> values) {
            addCriterion("weight_price in", values, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceNotIn(List<BigDecimal> values) {
            addCriterion("weight_price not in", values, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("weight_price between", value1, value2, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andWeightPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("weight_price not between", value1, value2, "weightPrice");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodIsNull() {
            addCriterion("selection_method is null");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodIsNotNull() {
            addCriterion("selection_method is not null");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodEqualTo(String value) {
            addCriterion("selection_method =", value, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodNotEqualTo(String value) {
            addCriterion("selection_method <>", value, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodGreaterThan(String value) {
            addCriterion("selection_method >", value, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodGreaterThanOrEqualTo(String value) {
            addCriterion("selection_method >=", value, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodLessThan(String value) {
            addCriterion("selection_method <", value, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodLessThanOrEqualTo(String value) {
            addCriterion("selection_method <=", value, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodLike(String value) {
            addCriterion("selection_method like", value, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodNotLike(String value) {
            addCriterion("selection_method not like", value, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodIn(List<String> values) {
            addCriterion("selection_method in", values, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodNotIn(List<String> values) {
            addCriterion("selection_method not in", values, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodBetween(String value1, String value2) {
            addCriterion("selection_method between", value1, value2, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andSelectionMethodNotBetween(String value1, String value2) {
            addCriterion("selection_method not between", value1, value2, "selectionMethod");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("`status` is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("`status` is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("`status` =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("`status` <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("`status` >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("`status` >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("`status` <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("`status` <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("`status` in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("`status` not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("`status` between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("`status` not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusExplainIsNull() {
            addCriterion("status_explain is null");
            return (Criteria) this;
        }

        public Criteria andStatusExplainIsNotNull() {
            addCriterion("status_explain is not null");
            return (Criteria) this;
        }

        public Criteria andStatusExplainEqualTo(String value) {
            addCriterion("status_explain =", value, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainNotEqualTo(String value) {
            addCriterion("status_explain <>", value, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainGreaterThan(String value) {
            addCriterion("status_explain >", value, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainGreaterThanOrEqualTo(String value) {
            addCriterion("status_explain >=", value, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainLessThan(String value) {
            addCriterion("status_explain <", value, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainLessThanOrEqualTo(String value) {
            addCriterion("status_explain <=", value, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainLike(String value) {
            addCriterion("status_explain like", value, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainNotLike(String value) {
            addCriterion("status_explain not like", value, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainIn(List<String> values) {
            addCriterion("status_explain in", values, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainNotIn(List<String> values) {
            addCriterion("status_explain not in", values, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainBetween(String value1, String value2) {
            addCriterion("status_explain between", value1, value2, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andStatusExplainNotBetween(String value1, String value2) {
            addCriterion("status_explain not between", value1, value2, "statusExplain");
            return (Criteria) this;
        }

        public Criteria andSSeqIsNull() {
            addCriterion("S_SEQ is null");
            return (Criteria) this;
        }

        public Criteria andSSeqIsNotNull() {
            addCriterion("S_SEQ is not null");
            return (Criteria) this;
        }

        public Criteria andSSeqEqualTo(Long value) {
            addCriterion("S_SEQ =", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqNotEqualTo(Long value) {
            addCriterion("S_SEQ <>", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqGreaterThan(Long value) {
            addCriterion("S_SEQ >", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqGreaterThanOrEqualTo(Long value) {
            addCriterion("S_SEQ >=", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqLessThan(Long value) {
            addCriterion("S_SEQ <", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqLessThanOrEqualTo(Long value) {
            addCriterion("S_SEQ <=", value, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqIn(List<Long> values) {
            addCriterion("S_SEQ in", values, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqNotIn(List<Long> values) {
            addCriterion("S_SEQ not in", values, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqBetween(Long value1, Long value2) {
            addCriterion("S_SEQ between", value1, value2, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSSeqNotBetween(Long value1, Long value2) {
            addCriterion("S_SEQ not between", value1, value2, "sSeq");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIsNull() {
            addCriterion("S_ROW_VERSION is null");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIsNotNull() {
            addCriterion("S_ROW_VERSION is not null");
            return (Criteria) this;
        }

        public Criteria andSRowVersionEqualTo(Long value) {
            addCriterion("S_ROW_VERSION =", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotEqualTo(Long value) {
            addCriterion("S_ROW_VERSION <>", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionGreaterThan(Long value) {
            addCriterion("S_ROW_VERSION >", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionGreaterThanOrEqualTo(Long value) {
            addCriterion("S_ROW_VERSION >=", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionLessThan(Long value) {
            addCriterion("S_ROW_VERSION <", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionLessThanOrEqualTo(Long value) {
            addCriterion("S_ROW_VERSION <=", value, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionIn(List<Long> values) {
            addCriterion("S_ROW_VERSION in", values, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotIn(List<Long> values) {
            addCriterion("S_ROW_VERSION not in", values, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionBetween(Long value1, Long value2) {
            addCriterion("S_ROW_VERSION between", value1, value2, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSRowVersionNotBetween(Long value1, Long value2) {
            addCriterion("S_ROW_VERSION not between", value1, value2, "sRowVersion");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIsNull() {
            addCriterion("S_UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIsNotNull() {
            addCriterion("S_UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME =", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME <>", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeGreaterThan(Date value) {
            addCriterion("S_UPDATE_TIME >", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME >=", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeLessThan(Date value) {
            addCriterion("S_UPDATE_TIME <", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("S_UPDATE_TIME <=", value, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeIn(List<Date> values) {
            addCriterion("S_UPDATE_TIME in", values, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotIn(List<Date> values) {
            addCriterion("S_UPDATE_TIME not in", values, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("S_UPDATE_TIME between", value1, value2, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("S_UPDATE_TIME not between", value1, value2, "sUpdateTime");
            return (Criteria) this;
        }

        public Criteria andSDataStateIsNull() {
            addCriterion("S_DATA_STATE is null");
            return (Criteria) this;
        }

        public Criteria andSDataStateIsNotNull() {
            addCriterion("S_DATA_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andSDataStateEqualTo(Short value) {
            addCriterion("S_DATA_STATE =", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotEqualTo(Short value) {
            addCriterion("S_DATA_STATE <>", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateGreaterThan(Short value) {
            addCriterion("S_DATA_STATE >", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateGreaterThanOrEqualTo(Short value) {
            addCriterion("S_DATA_STATE >=", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateLessThan(Short value) {
            addCriterion("S_DATA_STATE <", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateLessThanOrEqualTo(Short value) {
            addCriterion("S_DATA_STATE <=", value, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateIn(List<Short> values) {
            addCriterion("S_DATA_STATE in", values, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotIn(List<Short> values) {
            addCriterion("S_DATA_STATE not in", values, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateBetween(Short value1, Short value2) {
            addCriterion("S_DATA_STATE between", value1, value2, "sDataState");
            return (Criteria) this;
        }

        public Criteria andSDataStateNotBetween(Short value1, Short value2) {
            addCriterion("S_DATA_STATE not between", value1, value2, "sDataState");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}