package com.tanpu.fund.enums;

import org.apache.commons.lang3.StringUtils;

/**
 * 产品披露频率
 */
public enum ProDisFreEnums {
    Day(1, "天"),
    Week(2, "周"),
    HalfMonth(3, "半月"),
    Month(4, "月"),
    Quarter(5, "季");

    private Integer type;
    private String name;

    ProDisFreEnums(Integer type, String name) {
        this.type = type;
        this.name = name;
    }

    public Integer getType() {
        return type;
    }

    public String getName() {
        return name;
    }

    public static Integer Type(String name) {
        ProDisFreEnums[] types = values();
        for (ProDisFreEnums p : types) {
            if (StringUtils.equals(name, p.getName())) {
                return p.getType();
            }
        }
        return null;
    }
}
