package com.tanpu.fund.enums;

/**
 * 基金运行状态
 */
public enum ProStatusEnums {
    RAISING(1, "募集中"),
    OPENING(2, "开放运行"),
    CLOSE(3, "封闭运行"),
    ADVANCECLEAR(4, "提前清算"),
    EXPIRECLEAR(5, "到期清算"),
    RELEASEFAIL(6, "发行失败"),
    CHANGEMANGER(7, "更换管理人"),
    OTHER(-1, "其它");

    private int type;
    private String name;

    ProStatusEnums(int type, String name){
        this.type = type;
        this.name = name;
    }

    public int getType() {
        return type;
    }

    public String getName() {
        return name;
    }
}
