package com.tanpu.fund.feign.product;

import com.tanpu.common.model.tanpuroom.Type;
import com.tanpu.common.resp.CommonResp;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

//@FeignClient(value = "service-product", url = "http://127.0.0.1:8194/product")
@FeignClient(value = "service-product", path = "/product")
public interface FeignForProduct {

    @ApiOperation("获取私募产品列表（只返回产品名称）")
    @GetMapping("/get/fund/info/simple")
    CommonResp<List<Type>> getSimpleFundList(@RequestParam("list") List<String> list);

}
