package com.tanpu.fund.job.model;

import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;

@Data
public class FundAnnualRate {
    /**
     * 基金ID
     */
    private String fundId;

    /**
     * 开始日期
     */
    private Date startDate;

    /**
     * 截止日期
     */
    private Date endDate;

    /**
     * 年华波动率
     */
    private BigDecimal annualRate;

}
