package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundCompanyInfo;
import com.tanpu.fund.entity.generator.FundCompanyInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundCompanyInfoMapper {
    long countByExample(FundCompanyInfoExample example);

    int deleteByExample(FundCompanyInfoExample example);

    int deleteByPrimaryKey(String companyId);

    int insert(FundCompanyInfo record);

    int insertOrUpdate(FundCompanyInfo record);

    int insertOrUpdateSelective(FundCompanyInfo record);

    int insertOrUpdateWithBLOBs(FundCompanyInfo record);

    int insertSelective(FundCompanyInfo record);

    List<FundCompanyInfo> selectByExampleWithBLOBs(FundCompanyInfoExample example);

    List<FundCompanyInfo> selectByExample(FundCompanyInfoExample example);

    FundCompanyInfo selectByPrimaryKey(String companyId);

    int updateByExampleSelective(@Param("record") FundCompanyInfo record, @Param("example") FundCompanyInfoExample example);

    int updateByExampleWithBLOBs(@Param("record") FundCompanyInfo record, @Param("example") FundCompanyInfoExample example);

    int updateByExample(@Param("record") FundCompanyInfo record, @Param("example") FundCompanyInfoExample example);

    int updateByPrimaryKeySelective(FundCompanyInfo record);

    int updateByPrimaryKeyWithBLOBs(FundCompanyInfo record);

    int updateByPrimaryKey(FundCompanyInfo record);

    int updateBatch(List<FundCompanyInfo> list);

    int updateBatchSelective(List<FundCompanyInfo> list);

    int batchInsert(@Param("list") List<FundCompanyInfo> list);
}