package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundInfoPerformanceCompanyView;
import com.tanpu.fund.entity.generator.FundInfoPerformanceCompanyViewExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundInfoPerformanceCompanyViewMapper {
    long countByExample(FundInfoPerformanceCompanyViewExample example);

    int deleteByExample(FundInfoPerformanceCompanyViewExample example);

    int insert(FundInfoPerformanceCompanyView record);

    int insertOrUpdate(FundInfoPerformanceCompanyView record);

    int insertOrUpdateSelective(FundInfoPerformanceCompanyView record);

    int insertSelective(FundInfoPerformanceCompanyView record);

    List<FundInfoPerformanceCompanyView> selectByExample(FundInfoPerformanceCompanyViewExample example);

    int updateByExampleSelective(@Param("record") FundInfoPerformanceCompanyView record, @Param("example") FundInfoPerformanceCompanyViewExample example);

    int updateByExample(@Param("record") FundInfoPerformanceCompanyView record, @Param("example") FundInfoPerformanceCompanyViewExample example);

    int batchInsert(@Param("list") List<FundInfoPerformanceCompanyView> list);
}