package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundInfoPerformanceOld;
import com.tanpu.fund.entity.generator.FundInfoPerformanceOldExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundInfoPerformanceOldMapper {
    long countByExample(FundInfoPerformanceOldExample example);

    int deleteByExample(FundInfoPerformanceOldExample example);

    int insert(FundInfoPerformanceOld record);

    int insertOrUpdate(FundInfoPerformanceOld record);

    int insertOrUpdateSelective(FundInfoPerformanceOld record);

    int insertSelective(FundInfoPerformanceOld record);

    List<FundInfoPerformanceOld> selectByExample(FundInfoPerformanceOldExample example);

    int updateByExampleSelective(@Param("record") FundInfoPerformanceOld record, @Param("example") FundInfoPerformanceOldExample example);

    int updateByExample(@Param("record") FundInfoPerformanceOld record, @Param("example") FundInfoPerformanceOldExample example);

    int batchInsert(@Param("list") List<FundInfoPerformanceOld> list);
}