package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundInfoPersonnelInfo;
import com.tanpu.fund.entity.generator.FundInfoPersonnelInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundInfoPersonnelInfoMapper {
    long countByExample(FundInfoPersonnelInfoExample example);

    int deleteByExample(FundInfoPersonnelInfoExample example);

    int insert(FundInfoPersonnelInfo record);

    int insertOrUpdate(FundInfoPersonnelInfo record);

    int insertOrUpdateSelective(FundInfoPersonnelInfo record);

    int insertSelective(FundInfoPersonnelInfo record);

    List<FundInfoPersonnelInfo> selectByExample(FundInfoPersonnelInfoExample example);

    int updateByExampleSelective(@Param("record") FundInfoPersonnelInfo record, @Param("example") FundInfoPersonnelInfoExample example);

    int updateByExample(@Param("record") FundInfoPersonnelInfo record, @Param("example") FundInfoPersonnelInfoExample example);

    int batchInsert(@Param("list") List<FundInfoPersonnelInfo> list);
}