package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundInfoView;
import com.tanpu.fund.entity.generator.FundInfoViewExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundInfoViewMapper {
    long countByExample(FundInfoViewExample example);

    int deleteByExample(FundInfoViewExample example);

    int insert(FundInfoView record);

    int insertOrUpdate(FundInfoView record);

    int insertOrUpdateSelective(FundInfoView record);

    int insertSelective(FundInfoView record);

    List<FundInfoView> selectByExample(FundInfoViewExample example);

    int updateByExampleSelective(@Param("record") FundInfoView record, @Param("example") FundInfoViewExample example);

    int updateByExample(@Param("record") FundInfoView record, @Param("example") FundInfoViewExample example);

    int batchInsert(@Param("list") List<FundInfoView> list);
}