package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundPersonnelInfo;
import com.tanpu.fund.entity.generator.FundPersonnelInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundPersonnelInfoMapper {
    long countByExample(FundPersonnelInfoExample example);

    int deleteByExample(FundPersonnelInfoExample example);

    int deleteByPrimaryKey(String personnelId);

    int insert(FundPersonnelInfo record);

    int insertOrUpdate(FundPersonnelInfo record);

    int insertOrUpdateSelective(FundPersonnelInfo record);

    int insertOrUpdateWithBLOBs(FundPersonnelInfo record);

    int insertSelective(FundPersonnelInfo record);

    List<FundPersonnelInfo> selectByExampleWithBLOBs(FundPersonnelInfoExample example);

    List<FundPersonnelInfo> selectByExample(FundPersonnelInfoExample example);

    FundPersonnelInfo selectByPrimaryKey(String personnelId);

    int updateByExampleSelective(@Param("record") FundPersonnelInfo record, @Param("example") FundPersonnelInfoExample example);

    int updateByExampleWithBLOBs(@Param("record") FundPersonnelInfo record, @Param("example") FundPersonnelInfoExample example);

    int updateByExample(@Param("record") FundPersonnelInfo record, @Param("example") FundPersonnelInfoExample example);

    int updateByPrimaryKeySelective(FundPersonnelInfo record);

    int updateByPrimaryKeyWithBLOBs(FundPersonnelInfo record);

    int updateByPrimaryKey(FundPersonnelInfo record);

    int updateBatch(List<FundPersonnelInfo> list);

    int updateBatchSelective(List<FundPersonnelInfo> list);

    int batchInsert(@Param("list") List<FundPersonnelInfo> list);
}