package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.FundRateMapping;
import com.tanpu.fund.entity.generator.FundRateMappingExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface FundRateMappingMapper {
    long countByExample(FundRateMappingExample example);

    int deleteByExample(FundRateMappingExample example);

    int deleteByPrimaryKey(String fundId);

    int insert(FundRateMapping record);

    int insertOrUpdate(FundRateMapping record);

    int insertOrUpdateSelective(FundRateMapping record);

    int insertOrUpdateWithBLOBs(FundRateMapping record);

    int insertSelective(FundRateMapping record);

    List<FundRateMapping> selectByExampleWithBLOBs(FundRateMappingExample example);

    List<FundRateMapping> selectByExample(FundRateMappingExample example);

    FundRateMapping selectByPrimaryKey(String fundId);

    int updateByExampleSelective(@Param("record") FundRateMapping record, @Param("example") FundRateMappingExample example);

    int updateByExampleWithBLOBs(@Param("record") FundRateMapping record, @Param("example") FundRateMappingExample example);

    int updateByExample(@Param("record") FundRateMapping record, @Param("example") FundRateMappingExample example);

    int updateByPrimaryKeySelective(FundRateMapping record);

    int updateByPrimaryKeyWithBLOBs(FundRateMapping record);

    int updateByPrimaryKey(FundRateMapping record);

    int updateBatch(List<FundRateMapping> list);

    int updateBatchSelective(List<FundRateMapping> list);

    int batchInsert(@Param("list") List<FundRateMapping> list);
}