package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IfaImportedFundCount;
import com.tanpu.fund.entity.generator.IfaImportedFundCountExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IfaImportedFundCountMapper {
    long countByExample(IfaImportedFundCountExample example);

    int deleteByExample(IfaImportedFundCountExample example);

    int deleteByPrimaryKey(String id);

    int insert(IfaImportedFundCount record);

    int insertOrUpdate(IfaImportedFundCount record);

    int insertOrUpdateSelective(IfaImportedFundCount record);

    int insertSelective(IfaImportedFundCount record);

    List<IfaImportedFundCount> selectByExample(IfaImportedFundCountExample example);

    IfaImportedFundCount selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") IfaImportedFundCount record, @Param("example") IfaImportedFundCountExample example);

    int updateByExample(@Param("record") IfaImportedFundCount record, @Param("example") IfaImportedFundCountExample example);

    int updateByPrimaryKeySelective(IfaImportedFundCount record);

    int updateByPrimaryKey(IfaImportedFundCount record);

    int updateBatch(List<IfaImportedFundCount> list);

    int updateBatchSelective(List<IfaImportedFundCount> list);

    int batchInsert(@Param("list") List<IfaImportedFundCount> list);
}