package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IfaImportedFundInfo;
import com.tanpu.fund.entity.generator.IfaImportedFundInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IfaImportedFundInfoMapper {
    long countByExample(IfaImportedFundInfoExample example);

    int deleteByExample(IfaImportedFundInfoExample example);

    int deleteByPrimaryKey(String id);

    int insert(IfaImportedFundInfo record);

    int insertOrUpdate(IfaImportedFundInfo record);

    int insertOrUpdateSelective(IfaImportedFundInfo record);

    int insertSelective(IfaImportedFundInfo record);

    List<IfaImportedFundInfo> selectByExample(IfaImportedFundInfoExample example);

    IfaImportedFundInfo selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") IfaImportedFundInfo record, @Param("example") IfaImportedFundInfoExample example);

    int updateByExample(@Param("record") IfaImportedFundInfo record, @Param("example") IfaImportedFundInfoExample example);

    int updateByPrimaryKeySelective(IfaImportedFundInfo record);

    int updateByPrimaryKey(IfaImportedFundInfo record);

    int updateBatch(List<IfaImportedFundInfo> list);

    int updateBatchSelective(List<IfaImportedFundInfo> list);

    int batchInsert(@Param("list") List<IfaImportedFundInfo> list);
}