package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IfaImportedFundInfoView;
import com.tanpu.fund.entity.generator.IfaImportedFundInfoViewExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IfaImportedFundInfoViewMapper {
    long countByExample(IfaImportedFundInfoViewExample example);

    int deleteByExample(IfaImportedFundInfoViewExample example);

    int insert(IfaImportedFundInfoView record);

    int insertOrUpdate(IfaImportedFundInfoView record);

    int insertOrUpdateSelective(IfaImportedFundInfoView record);

    int insertSelective(IfaImportedFundInfoView record);

    List<IfaImportedFundInfoView> selectByExample(IfaImportedFundInfoViewExample example);

    int updateByExampleSelective(@Param("record") IfaImportedFundInfoView record, @Param("example") IfaImportedFundInfoViewExample example);

    int updateByExample(@Param("record") IfaImportedFundInfoView record, @Param("example") IfaImportedFundInfoViewExample example);

    int batchInsert(@Param("list") List<IfaImportedFundInfoView> list);
}