package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IfaImportedFundRank;
import com.tanpu.fund.entity.generator.IfaImportedFundRankExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IfaImportedFundRankMapper {
    long countByExample(IfaImportedFundRankExample example);

    int deleteByExample(IfaImportedFundRankExample example);

    int deleteByPrimaryKey(String fundId);

    int insert(IfaImportedFundRank record);

    int insertOrUpdate(IfaImportedFundRank record);

    int insertOrUpdateSelective(IfaImportedFundRank record);

    int insertOrUpdateWithBLOBs(IfaImportedFundRank record);

    int insertSelective(IfaImportedFundRank record);

    List<IfaImportedFundRank> selectByExampleWithBLOBs(IfaImportedFundRankExample example);

    List<IfaImportedFundRank> selectByExample(IfaImportedFundRankExample example);

    IfaImportedFundRank selectByPrimaryKey(String fundId);

    int updateByExampleSelective(@Param("record") IfaImportedFundRank record, @Param("example") IfaImportedFundRankExample example);

    int updateByExampleWithBLOBs(@Param("record") IfaImportedFundRank record, @Param("example") IfaImportedFundRankExample example);

    int updateByExample(@Param("record") IfaImportedFundRank record, @Param("example") IfaImportedFundRankExample example);

    int updateByPrimaryKeySelective(IfaImportedFundRank record);

    int updateByPrimaryKeyWithBLOBs(IfaImportedFundRank record);

    int updateByPrimaryKey(IfaImportedFundRank record);

    int updateBatch(List<IfaImportedFundRank> list);

    int updateBatchSelective(List<IfaImportedFundRank> list);

    int batchInsert(@Param("list") List<IfaImportedFundRank> list);
}