package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IndexDaily;
import com.tanpu.fund.entity.generator.IndexDailyExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IndexDailyMapper {
    long countByExample(IndexDailyExample example);

    int deleteByExample(IndexDailyExample example);

    int insert(IndexDaily record);

    int insertOrUpdate(IndexDaily record);

    int insertOrUpdateSelective(IndexDaily record);

    int insertOrUpdateWithBLOBs(IndexDaily record);

    int insertSelective(IndexDaily record);

    List<IndexDaily> selectByExampleWithBLOBs(IndexDailyExample example);

    List<IndexDaily> selectByExample(IndexDailyExample example);

    int updateByExampleSelective(@Param("record") IndexDaily record, @Param("example") IndexDailyExample example);

    int updateByExampleWithBLOBs(@Param("record") IndexDaily record, @Param("example") IndexDailyExample example);

    int updateByExample(@Param("record") IndexDaily record, @Param("example") IndexDailyExample example);

    int batchInsert(@Param("list") List<IndexDaily> list);
}