package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.IndexesProfile;
import com.tanpu.fund.entity.generator.IndexesProfileExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface IndexesProfileMapper {
    long countByExample(IndexesProfileExample example);

    int deleteByExample(IndexesProfileExample example);

    int deleteByPrimaryKey(String id);

    int insert(IndexesProfile record);

    int insertOrUpdate(IndexesProfile record);

    int insertOrUpdateSelective(IndexesProfile record);

    int insertSelective(IndexesProfile record);

    List<IndexesProfile> selectByExample(IndexesProfileExample example);

    IndexesProfile selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") IndexesProfile record, @Param("example") IndexesProfileExample example);

    int updateByExample(@Param("record") IndexesProfile record, @Param("example") IndexesProfileExample example);

    int updateByPrimaryKeySelective(IndexesProfile record);

    int updateByPrimaryKey(IndexesProfile record);

    int updateBatch(List<IndexesProfile> list);

    int updateBatchSelective(List<IndexesProfile> list);

    int batchInsert(@Param("list") List<IndexesProfile> list);
}