package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.PersonnelInfo;
import com.tanpu.fund.entity.generator.PersonnelInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

/**
 * @author: zhoupeng
 * <p>
 * =========================================
 * =========================================
 * ========                         ========
 * =======   ==========   =======    =======
 * ======        =====    ==   ====   ======
 * =====        =====     ==    ===    =====
 * =====       =====      ==   ===     =====
 * =====      =====       == ===       =====
 * ======    ==========   ==          ======
 * =======                           =======
 * =========================================
 * =========================================
 * <p>
 * @email: zhoupeng_08@163.com
 */
@Mapper
public interface PersonnelInfoMapper {
    long countByExample(PersonnelInfoExample example);

    int deleteByExample(PersonnelInfoExample example);

    int deleteByPrimaryKey(String id);

    int insert(PersonnelInfo record);

    int insertOrUpdate(PersonnelInfo record);

    int insertOrUpdateSelective(PersonnelInfo record);

    int insertOrUpdateWithBLOBs(PersonnelInfo record);

    int insertSelective(PersonnelInfo record);

    List<PersonnelInfo> selectByExampleWithBLOBs(PersonnelInfoExample example);

    List<PersonnelInfo> selectByExample(PersonnelInfoExample example);

    PersonnelInfo selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") PersonnelInfo record, @Param("example") PersonnelInfoExample example);

    int updateByExampleWithBLOBs(@Param("record") PersonnelInfo record, @Param("example") PersonnelInfoExample example);

    int updateByExample(@Param("record") PersonnelInfo record, @Param("example") PersonnelInfoExample example);

    int updateByPrimaryKeySelective(PersonnelInfo record);

    int updateByPrimaryKeyWithBLOBs(PersonnelInfo record);

    int updateByPrimaryKey(PersonnelInfo record);

    int updateBatch(List<PersonnelInfo> list);

    int updateBatchSelective(List<PersonnelInfo> list);

    int batchInsert(@Param("list") List<PersonnelInfo> list);
}