package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxCompanyInfo;
import com.tanpu.fund.entity.generator.TxCompanyInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxCompanyInfoMapper {
    long countByExample(TxCompanyInfoExample example);

    int deleteByExample(TxCompanyInfoExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxCompanyInfo record);

    int insertOrUpdate(TxCompanyInfo record);

    int insertOrUpdateSelective(TxCompanyInfo record);

    int insertOrUpdateWithBLOBs(TxCompanyInfo record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxCompanyInfo record);

    List<TxCompanyInfo> selectByExampleWithBLOBs(TxCompanyInfoExample example);

    List<TxCompanyInfo> selectByExample(TxCompanyInfoExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxCompanyInfo selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxCompanyInfo record, @Param("example") TxCompanyInfoExample example);

    int updateByExampleWithBLOBs(@Param("record") TxCompanyInfo record, @Param("example") TxCompanyInfoExample example);

    int updateByExample(@Param("record") TxCompanyInfo record, @Param("example") TxCompanyInfoExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxCompanyInfo record);

    int updateByPrimaryKeyWithBLOBs(TxCompanyInfo record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxCompanyInfo record);

    int updateBatch(List<TxCompanyInfo> list);

    int batchInsert(@Param("list") List<TxCompanyInfo> list);
}