package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundComScale;
import com.tanpu.fund.entity.generator.TxFundComScaleExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundComScaleMapper {
    long countByExample(TxFundComScaleExample example);

    int deleteByExample(TxFundComScaleExample example);

    /**
     * delete by primary key
     * @param sRowVersion primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(Long sRowVersion);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundComScale record);

    int insertOrUpdate(TxFundComScale record);

    int insertOrUpdateSelective(TxFundComScale record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundComScale record);

    List<TxFundComScale> selectByExample(TxFundComScaleExample example);

    /**
     * select by primary key
     * @param sRowVersion primary key
     * @return object by primary key
     */
    TxFundComScale selectByPrimaryKey(Long sRowVersion);

    int updateByExampleSelective(@Param("record") TxFundComScale record, @Param("example") TxFundComScaleExample example);

    int updateByExample(@Param("record") TxFundComScale record, @Param("example") TxFundComScaleExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundComScale record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundComScale record);

    int updateBatch(List<TxFundComScale> list);

    int batchInsert(@Param("list") List<TxFundComScale> list);
}