package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundCount;
import com.tanpu.fund.entity.generator.TxFundCountExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundCountMapper {
    long countByExample(TxFundCountExample example);

    int deleteByExample(TxFundCountExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundCount record);

    int insertOrUpdate(TxFundCount record);

    int insertOrUpdateSelective(TxFundCount record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundCount record);

    List<TxFundCount> selectByExample(TxFundCountExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxFundCount selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxFundCount record, @Param("example") TxFundCountExample example);

    int updateByExample(@Param("record") TxFundCount record, @Param("example") TxFundCountExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundCount record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundCount record);

    int updateBatch(List<TxFundCount> list);

    int batchInsert(@Param("list") List<TxFundCount> list);
}