package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundDistribution;
import com.tanpu.fund.entity.generator.TxFundDistributionExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundDistributionMapper {
    long countByExample(TxFundDistributionExample example);

    int deleteByExample(TxFundDistributionExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundDistribution record);

    int insertOrUpdate(TxFundDistribution record);

    int insertOrUpdateSelective(TxFundDistribution record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundDistribution record);

    List<TxFundDistribution> selectByExample(TxFundDistributionExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxFundDistribution selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxFundDistribution record, @Param("example") TxFundDistributionExample example);

    int updateByExample(@Param("record") TxFundDistribution record, @Param("example") TxFundDistributionExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundDistribution record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundDistribution record);

    int updateBatch(List<TxFundDistribution> list);

    int batchInsert(@Param("list") List<TxFundDistribution> list);
}