package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundInfo;
import com.tanpu.fund.entity.generator.TxFundInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundInfoMapper {
    long countByExample(TxFundInfoExample example);

    int deleteByExample(TxFundInfoExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundInfo record);

    int insertOrUpdate(TxFundInfo record);

    int insertOrUpdateSelective(TxFundInfo record);

    int insertOrUpdateWithBLOBs(TxFundInfo record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundInfo record);

    List<TxFundInfo> selectByExampleWithBLOBs(TxFundInfoExample example);

    List<TxFundInfo> selectByExample(TxFundInfoExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxFundInfo selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxFundInfo record, @Param("example") TxFundInfoExample example);

    int updateByExampleWithBLOBs(@Param("record") TxFundInfo record, @Param("example") TxFundInfoExample example);

    int updateByExample(@Param("record") TxFundInfo record, @Param("example") TxFundInfoExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundInfo record);

    int updateByPrimaryKeyWithBLOBs(TxFundInfo record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundInfo record);

    int updateBatch(List<TxFundInfo> list);

    int batchInsert(@Param("list") List<TxFundInfo> list);
}