package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundMarketIndexes;
import com.tanpu.fund.entity.generator.TxFundMarketIndexesExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundMarketIndexesMapper {
    long countByExample(TxFundMarketIndexesExample example);

    int deleteByExample(TxFundMarketIndexesExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundMarketIndexes record);

    int insertOrUpdate(TxFundMarketIndexes record);

    int insertOrUpdateSelective(TxFundMarketIndexes record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundMarketIndexes record);

    List<TxFundMarketIndexes> selectByExample(TxFundMarketIndexesExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxFundMarketIndexes selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxFundMarketIndexes record, @Param("example") TxFundMarketIndexesExample example);

    int updateByExample(@Param("record") TxFundMarketIndexes record, @Param("example") TxFundMarketIndexesExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundMarketIndexes record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundMarketIndexes record);

    int updateBatch(List<TxFundMarketIndexes> list);

    int batchInsert(@Param("list") List<TxFundMarketIndexes> list);
}