package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundPerformance;
import com.tanpu.fund.entity.generator.TxFundPerformanceExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundPerformanceMapper {
    long countByExample(TxFundPerformanceExample example);

    int deleteByExample(TxFundPerformanceExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundPerformance record);

    int insertOrUpdate(TxFundPerformance record);

    int insertOrUpdateSelective(TxFundPerformance record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundPerformance record);

    List<TxFundPerformance> selectByExample(TxFundPerformanceExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxFundPerformance selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxFundPerformance record, @Param("example") TxFundPerformanceExample example);

    int updateByExample(@Param("record") TxFundPerformance record, @Param("example") TxFundPerformanceExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundPerformance record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundPerformance record);

    int updateBatch(List<TxFundPerformance> list);

    int batchInsert(@Param("list") List<TxFundPerformance> list);
}