package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxFundRiskStats;
import com.tanpu.fund.entity.generator.TxFundRiskStatsExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxFundRiskStatsMapper {
    long countByExample(TxFundRiskStatsExample example);

    int deleteByExample(TxFundRiskStatsExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxFundRiskStats record);

    int insertOrUpdate(TxFundRiskStats record);

    int insertOrUpdateSelective(TxFundRiskStats record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxFundRiskStats record);

    List<TxFundRiskStats> selectByExample(TxFundRiskStatsExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxFundRiskStats selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxFundRiskStats record, @Param("example") TxFundRiskStatsExample example);

    int updateByExample(@Param("record") TxFundRiskStats record, @Param("example") TxFundRiskStatsExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxFundRiskStats record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxFundRiskStats record);

    int updateBatch(List<TxFundRiskStats> list);

    int batchInsert(@Param("list") List<TxFundRiskStats> list);
}