package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxIndexBasic;
import com.tanpu.fund.entity.generator.TxIndexBasicExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxIndexBasicMapper {
    long countByExample(TxIndexBasicExample example);

    int deleteByExample(TxIndexBasicExample example);

    /**
     * delete by primary key
     * @param indexId primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(Integer indexId);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxIndexBasic record);

    int insertOrUpdate(TxIndexBasic record);

    int insertOrUpdateSelective(TxIndexBasic record);

    int insertOrUpdateWithBLOBs(TxIndexBasic record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxIndexBasic record);

    List<TxIndexBasic> selectByExampleWithBLOBs(TxIndexBasicExample example);

    List<TxIndexBasic> selectByExample(TxIndexBasicExample example);

    /**
     * select by primary key
     * @param indexId primary key
     * @return object by primary key
     */
    TxIndexBasic selectByPrimaryKey(Integer indexId);

    int updateByExampleSelective(@Param("record") TxIndexBasic record, @Param("example") TxIndexBasicExample example);

    int updateByExampleWithBLOBs(@Param("record") TxIndexBasic record, @Param("example") TxIndexBasicExample example);

    int updateByExample(@Param("record") TxIndexBasic record, @Param("example") TxIndexBasicExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxIndexBasic record);

    int updateByPrimaryKeyWithBLOBs(TxIndexBasic record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxIndexBasic record);

    int updateBatch(List<TxIndexBasic> list);

    int batchInsert(@Param("list") List<TxIndexBasic> list);
}