package com.tanpu.fund.mapper.generator;

import com.tanpu.fund.entity.generator.TxPersonnelInfo;
import com.tanpu.fund.entity.generator.TxPersonnelInfoExample;
import java.util.List;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

@Mapper
public interface TxPersonnelInfoMapper {
    long countByExample(TxPersonnelInfoExample example);

    int deleteByExample(TxPersonnelInfoExample example);

    /**
     * delete by primary key
     * @param id primaryKey
     * @return deleteCount
     */
    int deleteByPrimaryKey(String id);

    /**
     * insert record to table
     * @param record the record
     * @return insert count
     */
    int insert(TxPersonnelInfo record);

    int insertOrUpdate(TxPersonnelInfo record);

    int insertOrUpdateSelective(TxPersonnelInfo record);

    int insertOrUpdateWithBLOBs(TxPersonnelInfo record);

    /**
     * insert record to table selective
     * @param record the record
     * @return insert count
     */
    int insertSelective(TxPersonnelInfo record);

    List<TxPersonnelInfo> selectByExampleWithBLOBs(TxPersonnelInfoExample example);

    List<TxPersonnelInfo> selectByExample(TxPersonnelInfoExample example);

    /**
     * select by primary key
     * @param id primary key
     * @return object by primary key
     */
    TxPersonnelInfo selectByPrimaryKey(String id);

    int updateByExampleSelective(@Param("record") TxPersonnelInfo record, @Param("example") TxPersonnelInfoExample example);

    int updateByExampleWithBLOBs(@Param("record") TxPersonnelInfo record, @Param("example") TxPersonnelInfoExample example);

    int updateByExample(@Param("record") TxPersonnelInfo record, @Param("example") TxPersonnelInfoExample example);

    /**
     * update record selective
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKeySelective(TxPersonnelInfo record);

    int updateByPrimaryKeyWithBLOBs(TxPersonnelInfo record);

    /**
     * update record
     * @param record the updated record
     * @return update count
     */
    int updateByPrimaryKey(TxPersonnelInfo record);

    int updateBatch(List<TxPersonnelInfo> list);

    int batchInsert(@Param("list") List<TxPersonnelInfo> list);
}